// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/batch/v1/batch.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fbatch_2fv1_2fbatch_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fbatch_2fv1_2fbatch_2eproto__INCLUDED

#include "google/cloud/batch/v1/batch.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace cloud {
namespace batch {
namespace v1 {

// Google Batch Service.
// The service manages user submitted batch jobs and allocates Google Compute
// Engine VM instances to run the jobs.
class BatchService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.batch.v1.BatchService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Create a Job.
    virtual ::grpc::Status CreateJob(::grpc::ClientContext* context, const ::google::cloud::batch::v1::CreateJobRequest& request, ::google::cloud::batch::v1::Job* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::batch::v1::Job>> AsyncCreateJob(::grpc::ClientContext* context, const ::google::cloud::batch::v1::CreateJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::batch::v1::Job>>(AsyncCreateJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::batch::v1::Job>> PrepareAsyncCreateJob(::grpc::ClientContext* context, const ::google::cloud::batch::v1::CreateJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::batch::v1::Job>>(PrepareAsyncCreateJobRaw(context, request, cq));
    }
    // Get a Job specified by its resource name.
    virtual ::grpc::Status GetJob(::grpc::ClientContext* context, const ::google::cloud::batch::v1::GetJobRequest& request, ::google::cloud::batch::v1::Job* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::batch::v1::Job>> AsyncGetJob(::grpc::ClientContext* context, const ::google::cloud::batch::v1::GetJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::batch::v1::Job>>(AsyncGetJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::batch::v1::Job>> PrepareAsyncGetJob(::grpc::ClientContext* context, const ::google::cloud::batch::v1::GetJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::batch::v1::Job>>(PrepareAsyncGetJobRaw(context, request, cq));
    }
    // Delete a Job.
    virtual ::grpc::Status DeleteJob(::grpc::ClientContext* context, const ::google::cloud::batch::v1::DeleteJobRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteJob(::grpc::ClientContext* context, const ::google::cloud::batch::v1::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteJob(::grpc::ClientContext* context, const ::google::cloud::batch::v1::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteJobRaw(context, request, cq));
    }
    // List all Jobs for a project within a region.
    virtual ::grpc::Status ListJobs(::grpc::ClientContext* context, const ::google::cloud::batch::v1::ListJobsRequest& request, ::google::cloud::batch::v1::ListJobsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::batch::v1::ListJobsResponse>> AsyncListJobs(::grpc::ClientContext* context, const ::google::cloud::batch::v1::ListJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::batch::v1::ListJobsResponse>>(AsyncListJobsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::batch::v1::ListJobsResponse>> PrepareAsyncListJobs(::grpc::ClientContext* context, const ::google::cloud::batch::v1::ListJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::batch::v1::ListJobsResponse>>(PrepareAsyncListJobsRaw(context, request, cq));
    }
    // Return a single Task.
    virtual ::grpc::Status GetTask(::grpc::ClientContext* context, const ::google::cloud::batch::v1::GetTaskRequest& request, ::google::cloud::batch::v1::Task* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::batch::v1::Task>> AsyncGetTask(::grpc::ClientContext* context, const ::google::cloud::batch::v1::GetTaskRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::batch::v1::Task>>(AsyncGetTaskRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::batch::v1::Task>> PrepareAsyncGetTask(::grpc::ClientContext* context, const ::google::cloud::batch::v1::GetTaskRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::batch::v1::Task>>(PrepareAsyncGetTaskRaw(context, request, cq));
    }
    // List Tasks associated with a job.
    virtual ::grpc::Status ListTasks(::grpc::ClientContext* context, const ::google::cloud::batch::v1::ListTasksRequest& request, ::google::cloud::batch::v1::ListTasksResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::batch::v1::ListTasksResponse>> AsyncListTasks(::grpc::ClientContext* context, const ::google::cloud::batch::v1::ListTasksRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::batch::v1::ListTasksResponse>>(AsyncListTasksRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::batch::v1::ListTasksResponse>> PrepareAsyncListTasks(::grpc::ClientContext* context, const ::google::cloud::batch::v1::ListTasksRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::batch::v1::ListTasksResponse>>(PrepareAsyncListTasksRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Create a Job.
      virtual void CreateJob(::grpc::ClientContext* context, const ::google::cloud::batch::v1::CreateJobRequest* request, ::google::cloud::batch::v1::Job* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateJob(::grpc::ClientContext* context, const ::google::cloud::batch::v1::CreateJobRequest* request, ::google::cloud::batch::v1::Job* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Get a Job specified by its resource name.
      virtual void GetJob(::grpc::ClientContext* context, const ::google::cloud::batch::v1::GetJobRequest* request, ::google::cloud::batch::v1::Job* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetJob(::grpc::ClientContext* context, const ::google::cloud::batch::v1::GetJobRequest* request, ::google::cloud::batch::v1::Job* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Delete a Job.
      virtual void DeleteJob(::grpc::ClientContext* context, const ::google::cloud::batch::v1::DeleteJobRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteJob(::grpc::ClientContext* context, const ::google::cloud::batch::v1::DeleteJobRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // List all Jobs for a project within a region.
      virtual void ListJobs(::grpc::ClientContext* context, const ::google::cloud::batch::v1::ListJobsRequest* request, ::google::cloud::batch::v1::ListJobsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListJobs(::grpc::ClientContext* context, const ::google::cloud::batch::v1::ListJobsRequest* request, ::google::cloud::batch::v1::ListJobsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Return a single Task.
      virtual void GetTask(::grpc::ClientContext* context, const ::google::cloud::batch::v1::GetTaskRequest* request, ::google::cloud::batch::v1::Task* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetTask(::grpc::ClientContext* context, const ::google::cloud::batch::v1::GetTaskRequest* request, ::google::cloud::batch::v1::Task* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // List Tasks associated with a job.
      virtual void ListTasks(::grpc::ClientContext* context, const ::google::cloud::batch::v1::ListTasksRequest* request, ::google::cloud::batch::v1::ListTasksResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListTasks(::grpc::ClientContext* context, const ::google::cloud::batch::v1::ListTasksRequest* request, ::google::cloud::batch::v1::ListTasksResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::batch::v1::Job>* AsyncCreateJobRaw(::grpc::ClientContext* context, const ::google::cloud::batch::v1::CreateJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::batch::v1::Job>* PrepareAsyncCreateJobRaw(::grpc::ClientContext* context, const ::google::cloud::batch::v1::CreateJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::batch::v1::Job>* AsyncGetJobRaw(::grpc::ClientContext* context, const ::google::cloud::batch::v1::GetJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::batch::v1::Job>* PrepareAsyncGetJobRaw(::grpc::ClientContext* context, const ::google::cloud::batch::v1::GetJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteJobRaw(::grpc::ClientContext* context, const ::google::cloud::batch::v1::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteJobRaw(::grpc::ClientContext* context, const ::google::cloud::batch::v1::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::batch::v1::ListJobsResponse>* AsyncListJobsRaw(::grpc::ClientContext* context, const ::google::cloud::batch::v1::ListJobsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::batch::v1::ListJobsResponse>* PrepareAsyncListJobsRaw(::grpc::ClientContext* context, const ::google::cloud::batch::v1::ListJobsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::batch::v1::Task>* AsyncGetTaskRaw(::grpc::ClientContext* context, const ::google::cloud::batch::v1::GetTaskRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::batch::v1::Task>* PrepareAsyncGetTaskRaw(::grpc::ClientContext* context, const ::google::cloud::batch::v1::GetTaskRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::batch::v1::ListTasksResponse>* AsyncListTasksRaw(::grpc::ClientContext* context, const ::google::cloud::batch::v1::ListTasksRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::batch::v1::ListTasksResponse>* PrepareAsyncListTasksRaw(::grpc::ClientContext* context, const ::google::cloud::batch::v1::ListTasksRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CreateJob(::grpc::ClientContext* context, const ::google::cloud::batch::v1::CreateJobRequest& request, ::google::cloud::batch::v1::Job* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::batch::v1::Job>> AsyncCreateJob(::grpc::ClientContext* context, const ::google::cloud::batch::v1::CreateJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::batch::v1::Job>>(AsyncCreateJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::batch::v1::Job>> PrepareAsyncCreateJob(::grpc::ClientContext* context, const ::google::cloud::batch::v1::CreateJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::batch::v1::Job>>(PrepareAsyncCreateJobRaw(context, request, cq));
    }
    ::grpc::Status GetJob(::grpc::ClientContext* context, const ::google::cloud::batch::v1::GetJobRequest& request, ::google::cloud::batch::v1::Job* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::batch::v1::Job>> AsyncGetJob(::grpc::ClientContext* context, const ::google::cloud::batch::v1::GetJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::batch::v1::Job>>(AsyncGetJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::batch::v1::Job>> PrepareAsyncGetJob(::grpc::ClientContext* context, const ::google::cloud::batch::v1::GetJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::batch::v1::Job>>(PrepareAsyncGetJobRaw(context, request, cq));
    }
    ::grpc::Status DeleteJob(::grpc::ClientContext* context, const ::google::cloud::batch::v1::DeleteJobRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteJob(::grpc::ClientContext* context, const ::google::cloud::batch::v1::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteJob(::grpc::ClientContext* context, const ::google::cloud::batch::v1::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteJobRaw(context, request, cq));
    }
    ::grpc::Status ListJobs(::grpc::ClientContext* context, const ::google::cloud::batch::v1::ListJobsRequest& request, ::google::cloud::batch::v1::ListJobsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::batch::v1::ListJobsResponse>> AsyncListJobs(::grpc::ClientContext* context, const ::google::cloud::batch::v1::ListJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::batch::v1::ListJobsResponse>>(AsyncListJobsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::batch::v1::ListJobsResponse>> PrepareAsyncListJobs(::grpc::ClientContext* context, const ::google::cloud::batch::v1::ListJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::batch::v1::ListJobsResponse>>(PrepareAsyncListJobsRaw(context, request, cq));
    }
    ::grpc::Status GetTask(::grpc::ClientContext* context, const ::google::cloud::batch::v1::GetTaskRequest& request, ::google::cloud::batch::v1::Task* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::batch::v1::Task>> AsyncGetTask(::grpc::ClientContext* context, const ::google::cloud::batch::v1::GetTaskRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::batch::v1::Task>>(AsyncGetTaskRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::batch::v1::Task>> PrepareAsyncGetTask(::grpc::ClientContext* context, const ::google::cloud::batch::v1::GetTaskRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::batch::v1::Task>>(PrepareAsyncGetTaskRaw(context, request, cq));
    }
    ::grpc::Status ListTasks(::grpc::ClientContext* context, const ::google::cloud::batch::v1::ListTasksRequest& request, ::google::cloud::batch::v1::ListTasksResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::batch::v1::ListTasksResponse>> AsyncListTasks(::grpc::ClientContext* context, const ::google::cloud::batch::v1::ListTasksRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::batch::v1::ListTasksResponse>>(AsyncListTasksRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::batch::v1::ListTasksResponse>> PrepareAsyncListTasks(::grpc::ClientContext* context, const ::google::cloud::batch::v1::ListTasksRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::batch::v1::ListTasksResponse>>(PrepareAsyncListTasksRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CreateJob(::grpc::ClientContext* context, const ::google::cloud::batch::v1::CreateJobRequest* request, ::google::cloud::batch::v1::Job* response, std::function<void(::grpc::Status)>) override;
      void CreateJob(::grpc::ClientContext* context, const ::google::cloud::batch::v1::CreateJobRequest* request, ::google::cloud::batch::v1::Job* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetJob(::grpc::ClientContext* context, const ::google::cloud::batch::v1::GetJobRequest* request, ::google::cloud::batch::v1::Job* response, std::function<void(::grpc::Status)>) override;
      void GetJob(::grpc::ClientContext* context, const ::google::cloud::batch::v1::GetJobRequest* request, ::google::cloud::batch::v1::Job* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteJob(::grpc::ClientContext* context, const ::google::cloud::batch::v1::DeleteJobRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteJob(::grpc::ClientContext* context, const ::google::cloud::batch::v1::DeleteJobRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListJobs(::grpc::ClientContext* context, const ::google::cloud::batch::v1::ListJobsRequest* request, ::google::cloud::batch::v1::ListJobsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListJobs(::grpc::ClientContext* context, const ::google::cloud::batch::v1::ListJobsRequest* request, ::google::cloud::batch::v1::ListJobsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetTask(::grpc::ClientContext* context, const ::google::cloud::batch::v1::GetTaskRequest* request, ::google::cloud::batch::v1::Task* response, std::function<void(::grpc::Status)>) override;
      void GetTask(::grpc::ClientContext* context, const ::google::cloud::batch::v1::GetTaskRequest* request, ::google::cloud::batch::v1::Task* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListTasks(::grpc::ClientContext* context, const ::google::cloud::batch::v1::ListTasksRequest* request, ::google::cloud::batch::v1::ListTasksResponse* response, std::function<void(::grpc::Status)>) override;
      void ListTasks(::grpc::ClientContext* context, const ::google::cloud::batch::v1::ListTasksRequest* request, ::google::cloud::batch::v1::ListTasksResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::batch::v1::Job>* AsyncCreateJobRaw(::grpc::ClientContext* context, const ::google::cloud::batch::v1::CreateJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::batch::v1::Job>* PrepareAsyncCreateJobRaw(::grpc::ClientContext* context, const ::google::cloud::batch::v1::CreateJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::batch::v1::Job>* AsyncGetJobRaw(::grpc::ClientContext* context, const ::google::cloud::batch::v1::GetJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::batch::v1::Job>* PrepareAsyncGetJobRaw(::grpc::ClientContext* context, const ::google::cloud::batch::v1::GetJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteJobRaw(::grpc::ClientContext* context, const ::google::cloud::batch::v1::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteJobRaw(::grpc::ClientContext* context, const ::google::cloud::batch::v1::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::batch::v1::ListJobsResponse>* AsyncListJobsRaw(::grpc::ClientContext* context, const ::google::cloud::batch::v1::ListJobsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::batch::v1::ListJobsResponse>* PrepareAsyncListJobsRaw(::grpc::ClientContext* context, const ::google::cloud::batch::v1::ListJobsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::batch::v1::Task>* AsyncGetTaskRaw(::grpc::ClientContext* context, const ::google::cloud::batch::v1::GetTaskRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::batch::v1::Task>* PrepareAsyncGetTaskRaw(::grpc::ClientContext* context, const ::google::cloud::batch::v1::GetTaskRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::batch::v1::ListTasksResponse>* AsyncListTasksRaw(::grpc::ClientContext* context, const ::google::cloud::batch::v1::ListTasksRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::batch::v1::ListTasksResponse>* PrepareAsyncListTasksRaw(::grpc::ClientContext* context, const ::google::cloud::batch::v1::ListTasksRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CreateJob_;
    const ::grpc::internal::RpcMethod rpcmethod_GetJob_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteJob_;
    const ::grpc::internal::RpcMethod rpcmethod_ListJobs_;
    const ::grpc::internal::RpcMethod rpcmethod_GetTask_;
    const ::grpc::internal::RpcMethod rpcmethod_ListTasks_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Create a Job.
    virtual ::grpc::Status CreateJob(::grpc::ServerContext* context, const ::google::cloud::batch::v1::CreateJobRequest* request, ::google::cloud::batch::v1::Job* response);
    // Get a Job specified by its resource name.
    virtual ::grpc::Status GetJob(::grpc::ServerContext* context, const ::google::cloud::batch::v1::GetJobRequest* request, ::google::cloud::batch::v1::Job* response);
    // Delete a Job.
    virtual ::grpc::Status DeleteJob(::grpc::ServerContext* context, const ::google::cloud::batch::v1::DeleteJobRequest* request, ::google::longrunning::Operation* response);
    // List all Jobs for a project within a region.
    virtual ::grpc::Status ListJobs(::grpc::ServerContext* context, const ::google::cloud::batch::v1::ListJobsRequest* request, ::google::cloud::batch::v1::ListJobsResponse* response);
    // Return a single Task.
    virtual ::grpc::Status GetTask(::grpc::ServerContext* context, const ::google::cloud::batch::v1::GetTaskRequest* request, ::google::cloud::batch::v1::Task* response);
    // List Tasks associated with a job.
    virtual ::grpc::Status ListTasks(::grpc::ServerContext* context, const ::google::cloud::batch::v1::ListTasksRequest* request, ::google::cloud::batch::v1::ListTasksResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateJob() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CreateJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateJob(::grpc::ServerContext* /*context*/, const ::google::cloud::batch::v1::CreateJobRequest* /*request*/, ::google::cloud::batch::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateJob(::grpc::ServerContext* context, ::google::cloud::batch::v1::CreateJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::batch::v1::Job>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetJob() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJob(::grpc::ServerContext* /*context*/, const ::google::cloud::batch::v1::GetJobRequest* /*request*/, ::google::cloud::batch::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetJob(::grpc::ServerContext* context, ::google::cloud::batch::v1::GetJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::batch::v1::Job>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteJob() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_DeleteJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteJob(::grpc::ServerContext* /*context*/, const ::google::cloud::batch::v1::DeleteJobRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteJob(::grpc::ServerContext* context, ::google::cloud::batch::v1::DeleteJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListJobs() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_ListJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::batch::v1::ListJobsRequest* /*request*/, ::google::cloud::batch::v1::ListJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListJobs(::grpc::ServerContext* context, ::google::cloud::batch::v1::ListJobsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::batch::v1::ListJobsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetTask : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetTask() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_GetTask() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTask(::grpc::ServerContext* /*context*/, const ::google::cloud::batch::v1::GetTaskRequest* /*request*/, ::google::cloud::batch::v1::Task* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetTask(::grpc::ServerContext* context, ::google::cloud::batch::v1::GetTaskRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::batch::v1::Task>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListTasks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListTasks() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_ListTasks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTasks(::grpc::ServerContext* /*context*/, const ::google::cloud::batch::v1::ListTasksRequest* /*request*/, ::google::cloud::batch::v1::ListTasksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListTasks(::grpc::ServerContext* context, ::google::cloud::batch::v1::ListTasksRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::batch::v1::ListTasksResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CreateJob<WithAsyncMethod_GetJob<WithAsyncMethod_DeleteJob<WithAsyncMethod_ListJobs<WithAsyncMethod_GetTask<WithAsyncMethod_ListTasks<Service > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CreateJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateJob() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::batch::v1::CreateJobRequest, ::google::cloud::batch::v1::Job>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::batch::v1::CreateJobRequest* request, ::google::cloud::batch::v1::Job* response) { return this->CreateJob(context, request, response); }));}
    void SetMessageAllocatorFor_CreateJob(
        ::grpc::MessageAllocator< ::google::cloud::batch::v1::CreateJobRequest, ::google::cloud::batch::v1::Job>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::batch::v1::CreateJobRequest, ::google::cloud::batch::v1::Job>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateJob(::grpc::ServerContext* /*context*/, const ::google::cloud::batch::v1::CreateJobRequest* /*request*/, ::google::cloud::batch::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::batch::v1::CreateJobRequest* /*request*/, ::google::cloud::batch::v1::Job* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetJob() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::batch::v1::GetJobRequest, ::google::cloud::batch::v1::Job>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::batch::v1::GetJobRequest* request, ::google::cloud::batch::v1::Job* response) { return this->GetJob(context, request, response); }));}
    void SetMessageAllocatorFor_GetJob(
        ::grpc::MessageAllocator< ::google::cloud::batch::v1::GetJobRequest, ::google::cloud::batch::v1::Job>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::batch::v1::GetJobRequest, ::google::cloud::batch::v1::Job>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJob(::grpc::ServerContext* /*context*/, const ::google::cloud::batch::v1::GetJobRequest* /*request*/, ::google::cloud::batch::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::batch::v1::GetJobRequest* /*request*/, ::google::cloud::batch::v1::Job* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteJob() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::batch::v1::DeleteJobRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::batch::v1::DeleteJobRequest* request, ::google::longrunning::Operation* response) { return this->DeleteJob(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteJob(
        ::grpc::MessageAllocator< ::google::cloud::batch::v1::DeleteJobRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::batch::v1::DeleteJobRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteJob(::grpc::ServerContext* /*context*/, const ::google::cloud::batch::v1::DeleteJobRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::batch::v1::DeleteJobRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListJobs() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::batch::v1::ListJobsRequest, ::google::cloud::batch::v1::ListJobsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::batch::v1::ListJobsRequest* request, ::google::cloud::batch::v1::ListJobsResponse* response) { return this->ListJobs(context, request, response); }));}
    void SetMessageAllocatorFor_ListJobs(
        ::grpc::MessageAllocator< ::google::cloud::batch::v1::ListJobsRequest, ::google::cloud::batch::v1::ListJobsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::batch::v1::ListJobsRequest, ::google::cloud::batch::v1::ListJobsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::batch::v1::ListJobsRequest* /*request*/, ::google::cloud::batch::v1::ListJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListJobs(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::batch::v1::ListJobsRequest* /*request*/, ::google::cloud::batch::v1::ListJobsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetTask : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetTask() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::batch::v1::GetTaskRequest, ::google::cloud::batch::v1::Task>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::batch::v1::GetTaskRequest* request, ::google::cloud::batch::v1::Task* response) { return this->GetTask(context, request, response); }));}
    void SetMessageAllocatorFor_GetTask(
        ::grpc::MessageAllocator< ::google::cloud::batch::v1::GetTaskRequest, ::google::cloud::batch::v1::Task>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::batch::v1::GetTaskRequest, ::google::cloud::batch::v1::Task>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetTask() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTask(::grpc::ServerContext* /*context*/, const ::google::cloud::batch::v1::GetTaskRequest* /*request*/, ::google::cloud::batch::v1::Task* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetTask(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::batch::v1::GetTaskRequest* /*request*/, ::google::cloud::batch::v1::Task* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListTasks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListTasks() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::batch::v1::ListTasksRequest, ::google::cloud::batch::v1::ListTasksResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::batch::v1::ListTasksRequest* request, ::google::cloud::batch::v1::ListTasksResponse* response) { return this->ListTasks(context, request, response); }));}
    void SetMessageAllocatorFor_ListTasks(
        ::grpc::MessageAllocator< ::google::cloud::batch::v1::ListTasksRequest, ::google::cloud::batch::v1::ListTasksResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::batch::v1::ListTasksRequest, ::google::cloud::batch::v1::ListTasksResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListTasks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTasks(::grpc::ServerContext* /*context*/, const ::google::cloud::batch::v1::ListTasksRequest* /*request*/, ::google::cloud::batch::v1::ListTasksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListTasks(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::batch::v1::ListTasksRequest* /*request*/, ::google::cloud::batch::v1::ListTasksResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CreateJob<WithCallbackMethod_GetJob<WithCallbackMethod_DeleteJob<WithCallbackMethod_ListJobs<WithCallbackMethod_GetTask<WithCallbackMethod_ListTasks<Service > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CreateJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateJob() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CreateJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateJob(::grpc::ServerContext* /*context*/, const ::google::cloud::batch::v1::CreateJobRequest* /*request*/, ::google::cloud::batch::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetJob() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJob(::grpc::ServerContext* /*context*/, const ::google::cloud::batch::v1::GetJobRequest* /*request*/, ::google::cloud::batch::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteJob() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_DeleteJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteJob(::grpc::ServerContext* /*context*/, const ::google::cloud::batch::v1::DeleteJobRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListJobs() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_ListJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::batch::v1::ListJobsRequest* /*request*/, ::google::cloud::batch::v1::ListJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetTask : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetTask() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_GetTask() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTask(::grpc::ServerContext* /*context*/, const ::google::cloud::batch::v1::GetTaskRequest* /*request*/, ::google::cloud::batch::v1::Task* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListTasks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListTasks() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_ListTasks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTasks(::grpc::ServerContext* /*context*/, const ::google::cloud::batch::v1::ListTasksRequest* /*request*/, ::google::cloud::batch::v1::ListTasksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateJob() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CreateJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateJob(::grpc::ServerContext* /*context*/, const ::google::cloud::batch::v1::CreateJobRequest* /*request*/, ::google::cloud::batch::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetJob() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJob(::grpc::ServerContext* /*context*/, const ::google::cloud::batch::v1::GetJobRequest* /*request*/, ::google::cloud::batch::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteJob() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_DeleteJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteJob(::grpc::ServerContext* /*context*/, const ::google::cloud::batch::v1::DeleteJobRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListJobs() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_ListJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::batch::v1::ListJobsRequest* /*request*/, ::google::cloud::batch::v1::ListJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListJobs(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetTask : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetTask() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_GetTask() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTask(::grpc::ServerContext* /*context*/, const ::google::cloud::batch::v1::GetTaskRequest* /*request*/, ::google::cloud::batch::v1::Task* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetTask(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListTasks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListTasks() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_ListTasks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTasks(::grpc::ServerContext* /*context*/, const ::google::cloud::batch::v1::ListTasksRequest* /*request*/, ::google::cloud::batch::v1::ListTasksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListTasks(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateJob() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateJob(::grpc::ServerContext* /*context*/, const ::google::cloud::batch::v1::CreateJobRequest* /*request*/, ::google::cloud::batch::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetJob() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJob(::grpc::ServerContext* /*context*/, const ::google::cloud::batch::v1::GetJobRequest* /*request*/, ::google::cloud::batch::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteJob() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteJob(::grpc::ServerContext* /*context*/, const ::google::cloud::batch::v1::DeleteJobRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListJobs() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListJobs(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::batch::v1::ListJobsRequest* /*request*/, ::google::cloud::batch::v1::ListJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListJobs(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetTask : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetTask() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetTask(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetTask() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTask(::grpc::ServerContext* /*context*/, const ::google::cloud::batch::v1::GetTaskRequest* /*request*/, ::google::cloud::batch::v1::Task* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetTask(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListTasks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListTasks() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListTasks(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListTasks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTasks(::grpc::ServerContext* /*context*/, const ::google::cloud::batch::v1::ListTasksRequest* /*request*/, ::google::cloud::batch::v1::ListTasksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListTasks(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateJob() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::batch::v1::CreateJobRequest, ::google::cloud::batch::v1::Job>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::batch::v1::CreateJobRequest, ::google::cloud::batch::v1::Job>* streamer) {
                       return this->StreamedCreateJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateJob(::grpc::ServerContext* /*context*/, const ::google::cloud::batch::v1::CreateJobRequest* /*request*/, ::google::cloud::batch::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::batch::v1::CreateJobRequest,::google::cloud::batch::v1::Job>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetJob() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::batch::v1::GetJobRequest, ::google::cloud::batch::v1::Job>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::batch::v1::GetJobRequest, ::google::cloud::batch::v1::Job>* streamer) {
                       return this->StreamedGetJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetJob(::grpc::ServerContext* /*context*/, const ::google::cloud::batch::v1::GetJobRequest* /*request*/, ::google::cloud::batch::v1::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::batch::v1::GetJobRequest,::google::cloud::batch::v1::Job>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteJob() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::batch::v1::DeleteJobRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::batch::v1::DeleteJobRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteJob(::grpc::ServerContext* /*context*/, const ::google::cloud::batch::v1::DeleteJobRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::batch::v1::DeleteJobRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListJobs() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::batch::v1::ListJobsRequest, ::google::cloud::batch::v1::ListJobsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::batch::v1::ListJobsRequest, ::google::cloud::batch::v1::ListJobsResponse>* streamer) {
                       return this->StreamedListJobs(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::batch::v1::ListJobsRequest* /*request*/, ::google::cloud::batch::v1::ListJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListJobs(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::batch::v1::ListJobsRequest,::google::cloud::batch::v1::ListJobsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetTask : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetTask() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::batch::v1::GetTaskRequest, ::google::cloud::batch::v1::Task>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::batch::v1::GetTaskRequest, ::google::cloud::batch::v1::Task>* streamer) {
                       return this->StreamedGetTask(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetTask() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetTask(::grpc::ServerContext* /*context*/, const ::google::cloud::batch::v1::GetTaskRequest* /*request*/, ::google::cloud::batch::v1::Task* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetTask(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::batch::v1::GetTaskRequest,::google::cloud::batch::v1::Task>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListTasks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListTasks() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::batch::v1::ListTasksRequest, ::google::cloud::batch::v1::ListTasksResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::batch::v1::ListTasksRequest, ::google::cloud::batch::v1::ListTasksResponse>* streamer) {
                       return this->StreamedListTasks(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListTasks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListTasks(::grpc::ServerContext* /*context*/, const ::google::cloud::batch::v1::ListTasksRequest* /*request*/, ::google::cloud::batch::v1::ListTasksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListTasks(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::batch::v1::ListTasksRequest,::google::cloud::batch::v1::ListTasksResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CreateJob<WithStreamedUnaryMethod_GetJob<WithStreamedUnaryMethod_DeleteJob<WithStreamedUnaryMethod_ListJobs<WithStreamedUnaryMethod_GetTask<WithStreamedUnaryMethod_ListTasks<Service > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CreateJob<WithStreamedUnaryMethod_GetJob<WithStreamedUnaryMethod_DeleteJob<WithStreamedUnaryMethod_ListJobs<WithStreamedUnaryMethod_GetTask<WithStreamedUnaryMethod_ListTasks<Service > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace batch
}  // namespace cloud
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fcloud_2fbatch_2fv1_2fbatch_2eproto__INCLUDED
