// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/beyondcorp/appconnectors/v1/app_connectors_service.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fbeyondcorp_2fappconnectors_2fv1_2fapp_5fconnectors_5fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fbeyondcorp_2fappconnectors_2fv1_2fapp_5fconnectors_5fservice_2eproto__INCLUDED

#include "google/cloud/beyondcorp/appconnectors/v1/app_connectors_service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace cloud {
namespace beyondcorp {
namespace appconnectors {
namespace v1 {

// API Overview:
//
// The `beyondcorp.googleapis.com` service implements the Google Cloud
// BeyondCorp API.
//
// Data Model:
//
// The AppConnectorsService exposes the following resource:
//
// * AppConnectors, named as follows:
//   `projects/{project_id}/locations/{location_id}/appConnectors/{app_connector_id}`.
//
// The AppConnectorsService provides methods to manage
// (create/read/update/delete) BeyondCorp AppConnectors.
class AppConnectorsService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.beyondcorp.appconnectors.v1.AppConnectorsService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists AppConnectors in a given project and location.
    virtual ::grpc::Status ListAppConnectors(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsRequest& request, ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsResponse>> AsyncListAppConnectors(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsResponse>>(AsyncListAppConnectorsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsResponse>> PrepareAsyncListAppConnectors(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsResponse>>(PrepareAsyncListAppConnectorsRaw(context, request, cq));
    }
    // Gets details of a single AppConnector.
    virtual ::grpc::Status GetAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::GetAppConnectorRequest& request, ::google::cloud::beyondcorp::appconnectors::v1::AppConnector* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appconnectors::v1::AppConnector>> AsyncGetAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::GetAppConnectorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appconnectors::v1::AppConnector>>(AsyncGetAppConnectorRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appconnectors::v1::AppConnector>> PrepareAsyncGetAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::GetAppConnectorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appconnectors::v1::AppConnector>>(PrepareAsyncGetAppConnectorRaw(context, request, cq));
    }
    // Creates a new AppConnector in a given project and location.
    virtual ::grpc::Status CreateAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::CreateAppConnectorRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::CreateAppConnectorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateAppConnectorRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::CreateAppConnectorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateAppConnectorRaw(context, request, cq));
    }
    // Updates the parameters of a single AppConnector.
    virtual ::grpc::Status UpdateAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::UpdateAppConnectorRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::UpdateAppConnectorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateAppConnectorRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::UpdateAppConnectorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateAppConnectorRaw(context, request, cq));
    }
    // Deletes a single AppConnector.
    virtual ::grpc::Status DeleteAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::DeleteAppConnectorRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::DeleteAppConnectorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteAppConnectorRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::DeleteAppConnectorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteAppConnectorRaw(context, request, cq));
    }
    // Report status for a given connector.
    virtual ::grpc::Status ReportStatus(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::ReportStatusRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncReportStatus(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::ReportStatusRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncReportStatusRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncReportStatus(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::ReportStatusRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncReportStatusRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists AppConnectors in a given project and location.
      virtual void ListAppConnectors(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsRequest* request, ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListAppConnectors(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsRequest* request, ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single AppConnector.
      virtual void GetAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::GetAppConnectorRequest* request, ::google::cloud::beyondcorp::appconnectors::v1::AppConnector* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::GetAppConnectorRequest* request, ::google::cloud::beyondcorp::appconnectors::v1::AppConnector* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new AppConnector in a given project and location.
      virtual void CreateAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::CreateAppConnectorRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::CreateAppConnectorRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the parameters of a single AppConnector.
      virtual void UpdateAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::UpdateAppConnectorRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::UpdateAppConnectorRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a single AppConnector.
      virtual void DeleteAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::DeleteAppConnectorRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::DeleteAppConnectorRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Report status for a given connector.
      virtual void ReportStatus(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::ReportStatusRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ReportStatus(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::ReportStatusRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsResponse>* AsyncListAppConnectorsRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsResponse>* PrepareAsyncListAppConnectorsRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appconnectors::v1::AppConnector>* AsyncGetAppConnectorRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::GetAppConnectorRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appconnectors::v1::AppConnector>* PrepareAsyncGetAppConnectorRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::GetAppConnectorRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateAppConnectorRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::CreateAppConnectorRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateAppConnectorRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::CreateAppConnectorRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateAppConnectorRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::UpdateAppConnectorRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateAppConnectorRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::UpdateAppConnectorRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteAppConnectorRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::DeleteAppConnectorRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteAppConnectorRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::DeleteAppConnectorRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncReportStatusRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::ReportStatusRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncReportStatusRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::ReportStatusRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListAppConnectors(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsRequest& request, ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsResponse>> AsyncListAppConnectors(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsResponse>>(AsyncListAppConnectorsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsResponse>> PrepareAsyncListAppConnectors(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsResponse>>(PrepareAsyncListAppConnectorsRaw(context, request, cq));
    }
    ::grpc::Status GetAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::GetAppConnectorRequest& request, ::google::cloud::beyondcorp::appconnectors::v1::AppConnector* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appconnectors::v1::AppConnector>> AsyncGetAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::GetAppConnectorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appconnectors::v1::AppConnector>>(AsyncGetAppConnectorRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appconnectors::v1::AppConnector>> PrepareAsyncGetAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::GetAppConnectorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appconnectors::v1::AppConnector>>(PrepareAsyncGetAppConnectorRaw(context, request, cq));
    }
    ::grpc::Status CreateAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::CreateAppConnectorRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::CreateAppConnectorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateAppConnectorRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::CreateAppConnectorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateAppConnectorRaw(context, request, cq));
    }
    ::grpc::Status UpdateAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::UpdateAppConnectorRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::UpdateAppConnectorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateAppConnectorRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::UpdateAppConnectorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateAppConnectorRaw(context, request, cq));
    }
    ::grpc::Status DeleteAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::DeleteAppConnectorRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::DeleteAppConnectorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteAppConnectorRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::DeleteAppConnectorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteAppConnectorRaw(context, request, cq));
    }
    ::grpc::Status ReportStatus(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::ReportStatusRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncReportStatus(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::ReportStatusRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncReportStatusRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncReportStatus(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::ReportStatusRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncReportStatusRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListAppConnectors(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsRequest* request, ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListAppConnectors(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsRequest* request, ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::GetAppConnectorRequest* request, ::google::cloud::beyondcorp::appconnectors::v1::AppConnector* response, std::function<void(::grpc::Status)>) override;
      void GetAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::GetAppConnectorRequest* request, ::google::cloud::beyondcorp::appconnectors::v1::AppConnector* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::CreateAppConnectorRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::CreateAppConnectorRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::UpdateAppConnectorRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::UpdateAppConnectorRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::DeleteAppConnectorRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteAppConnector(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::DeleteAppConnectorRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ReportStatus(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::ReportStatusRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ReportStatus(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::ReportStatusRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsResponse>* AsyncListAppConnectorsRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsResponse>* PrepareAsyncListAppConnectorsRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appconnectors::v1::AppConnector>* AsyncGetAppConnectorRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::GetAppConnectorRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appconnectors::v1::AppConnector>* PrepareAsyncGetAppConnectorRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::GetAppConnectorRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateAppConnectorRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::CreateAppConnectorRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateAppConnectorRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::CreateAppConnectorRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateAppConnectorRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::UpdateAppConnectorRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateAppConnectorRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::UpdateAppConnectorRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteAppConnectorRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::DeleteAppConnectorRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteAppConnectorRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::DeleteAppConnectorRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncReportStatusRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::ReportStatusRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncReportStatusRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::ReportStatusRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListAppConnectors_;
    const ::grpc::internal::RpcMethod rpcmethod_GetAppConnector_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateAppConnector_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateAppConnector_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteAppConnector_;
    const ::grpc::internal::RpcMethod rpcmethod_ReportStatus_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists AppConnectors in a given project and location.
    virtual ::grpc::Status ListAppConnectors(::grpc::ServerContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsRequest* request, ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsResponse* response);
    // Gets details of a single AppConnector.
    virtual ::grpc::Status GetAppConnector(::grpc::ServerContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::GetAppConnectorRequest* request, ::google::cloud::beyondcorp::appconnectors::v1::AppConnector* response);
    // Creates a new AppConnector in a given project and location.
    virtual ::grpc::Status CreateAppConnector(::grpc::ServerContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::CreateAppConnectorRequest* request, ::google::longrunning::Operation* response);
    // Updates the parameters of a single AppConnector.
    virtual ::grpc::Status UpdateAppConnector(::grpc::ServerContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::UpdateAppConnectorRequest* request, ::google::longrunning::Operation* response);
    // Deletes a single AppConnector.
    virtual ::grpc::Status DeleteAppConnector(::grpc::ServerContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::DeleteAppConnectorRequest* request, ::google::longrunning::Operation* response);
    // Report status for a given connector.
    virtual ::grpc::Status ReportStatus(::grpc::ServerContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::ReportStatusRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListAppConnectors : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListAppConnectors() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListAppConnectors() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAppConnectors(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsRequest* /*request*/, ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAppConnectors(::grpc::ServerContext* context, ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetAppConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetAppConnector() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetAppConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAppConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::GetAppConnectorRequest* /*request*/, ::google::cloud::beyondcorp::appconnectors::v1::AppConnector* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAppConnector(::grpc::ServerContext* context, ::google::cloud::beyondcorp::appconnectors::v1::GetAppConnectorRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::beyondcorp::appconnectors::v1::AppConnector>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateAppConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateAppConnector() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CreateAppConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAppConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::CreateAppConnectorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateAppConnector(::grpc::ServerContext* context, ::google::cloud::beyondcorp::appconnectors::v1::CreateAppConnectorRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateAppConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateAppConnector() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_UpdateAppConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAppConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::UpdateAppConnectorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateAppConnector(::grpc::ServerContext* context, ::google::cloud::beyondcorp::appconnectors::v1::UpdateAppConnectorRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteAppConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteAppConnector() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_DeleteAppConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAppConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::DeleteAppConnectorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteAppConnector(::grpc::ServerContext* context, ::google::cloud::beyondcorp::appconnectors::v1::DeleteAppConnectorRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ReportStatus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ReportStatus() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_ReportStatus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReportStatus(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::ReportStatusRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestReportStatus(::grpc::ServerContext* context, ::google::cloud::beyondcorp::appconnectors::v1::ReportStatusRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListAppConnectors<WithAsyncMethod_GetAppConnector<WithAsyncMethod_CreateAppConnector<WithAsyncMethod_UpdateAppConnector<WithAsyncMethod_DeleteAppConnector<WithAsyncMethod_ReportStatus<Service > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListAppConnectors : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListAppConnectors() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsRequest, ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsRequest* request, ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsResponse* response) { return this->ListAppConnectors(context, request, response); }));}
    void SetMessageAllocatorFor_ListAppConnectors(
        ::grpc::MessageAllocator< ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsRequest, ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsRequest, ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListAppConnectors() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAppConnectors(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsRequest* /*request*/, ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAppConnectors(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsRequest* /*request*/, ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetAppConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetAppConnector() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::beyondcorp::appconnectors::v1::GetAppConnectorRequest, ::google::cloud::beyondcorp::appconnectors::v1::AppConnector>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::GetAppConnectorRequest* request, ::google::cloud::beyondcorp::appconnectors::v1::AppConnector* response) { return this->GetAppConnector(context, request, response); }));}
    void SetMessageAllocatorFor_GetAppConnector(
        ::grpc::MessageAllocator< ::google::cloud::beyondcorp::appconnectors::v1::GetAppConnectorRequest, ::google::cloud::beyondcorp::appconnectors::v1::AppConnector>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::beyondcorp::appconnectors::v1::GetAppConnectorRequest, ::google::cloud::beyondcorp::appconnectors::v1::AppConnector>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetAppConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAppConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::GetAppConnectorRequest* /*request*/, ::google::cloud::beyondcorp::appconnectors::v1::AppConnector* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAppConnector(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::GetAppConnectorRequest* /*request*/, ::google::cloud::beyondcorp::appconnectors::v1::AppConnector* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateAppConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateAppConnector() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::beyondcorp::appconnectors::v1::CreateAppConnectorRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::CreateAppConnectorRequest* request, ::google::longrunning::Operation* response) { return this->CreateAppConnector(context, request, response); }));}
    void SetMessageAllocatorFor_CreateAppConnector(
        ::grpc::MessageAllocator< ::google::cloud::beyondcorp::appconnectors::v1::CreateAppConnectorRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::beyondcorp::appconnectors::v1::CreateAppConnectorRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateAppConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAppConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::CreateAppConnectorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateAppConnector(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::CreateAppConnectorRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateAppConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateAppConnector() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::beyondcorp::appconnectors::v1::UpdateAppConnectorRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::UpdateAppConnectorRequest* request, ::google::longrunning::Operation* response) { return this->UpdateAppConnector(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateAppConnector(
        ::grpc::MessageAllocator< ::google::cloud::beyondcorp::appconnectors::v1::UpdateAppConnectorRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::beyondcorp::appconnectors::v1::UpdateAppConnectorRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateAppConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAppConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::UpdateAppConnectorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateAppConnector(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::UpdateAppConnectorRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteAppConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteAppConnector() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::beyondcorp::appconnectors::v1::DeleteAppConnectorRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::DeleteAppConnectorRequest* request, ::google::longrunning::Operation* response) { return this->DeleteAppConnector(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteAppConnector(
        ::grpc::MessageAllocator< ::google::cloud::beyondcorp::appconnectors::v1::DeleteAppConnectorRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::beyondcorp::appconnectors::v1::DeleteAppConnectorRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteAppConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAppConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::DeleteAppConnectorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteAppConnector(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::DeleteAppConnectorRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ReportStatus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ReportStatus() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::beyondcorp::appconnectors::v1::ReportStatusRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::beyondcorp::appconnectors::v1::ReportStatusRequest* request, ::google::longrunning::Operation* response) { return this->ReportStatus(context, request, response); }));}
    void SetMessageAllocatorFor_ReportStatus(
        ::grpc::MessageAllocator< ::google::cloud::beyondcorp::appconnectors::v1::ReportStatusRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::beyondcorp::appconnectors::v1::ReportStatusRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ReportStatus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReportStatus(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::ReportStatusRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ReportStatus(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::ReportStatusRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListAppConnectors<WithCallbackMethod_GetAppConnector<WithCallbackMethod_CreateAppConnector<WithCallbackMethod_UpdateAppConnector<WithCallbackMethod_DeleteAppConnector<WithCallbackMethod_ReportStatus<Service > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListAppConnectors : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListAppConnectors() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListAppConnectors() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAppConnectors(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsRequest* /*request*/, ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetAppConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetAppConnector() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetAppConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAppConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::GetAppConnectorRequest* /*request*/, ::google::cloud::beyondcorp::appconnectors::v1::AppConnector* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateAppConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateAppConnector() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CreateAppConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAppConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::CreateAppConnectorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateAppConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateAppConnector() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_UpdateAppConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAppConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::UpdateAppConnectorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteAppConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteAppConnector() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_DeleteAppConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAppConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::DeleteAppConnectorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ReportStatus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ReportStatus() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_ReportStatus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReportStatus(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::ReportStatusRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListAppConnectors : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListAppConnectors() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListAppConnectors() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAppConnectors(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsRequest* /*request*/, ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAppConnectors(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetAppConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetAppConnector() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetAppConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAppConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::GetAppConnectorRequest* /*request*/, ::google::cloud::beyondcorp::appconnectors::v1::AppConnector* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAppConnector(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateAppConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateAppConnector() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CreateAppConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAppConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::CreateAppConnectorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateAppConnector(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateAppConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateAppConnector() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_UpdateAppConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAppConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::UpdateAppConnectorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateAppConnector(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteAppConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteAppConnector() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_DeleteAppConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAppConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::DeleteAppConnectorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteAppConnector(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ReportStatus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ReportStatus() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_ReportStatus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReportStatus(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::ReportStatusRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestReportStatus(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListAppConnectors : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListAppConnectors() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListAppConnectors(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListAppConnectors() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAppConnectors(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsRequest* /*request*/, ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAppConnectors(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetAppConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetAppConnector() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetAppConnector(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetAppConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAppConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::GetAppConnectorRequest* /*request*/, ::google::cloud::beyondcorp::appconnectors::v1::AppConnector* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAppConnector(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateAppConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateAppConnector() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateAppConnector(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateAppConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAppConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::CreateAppConnectorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateAppConnector(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateAppConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateAppConnector() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateAppConnector(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateAppConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAppConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::UpdateAppConnectorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateAppConnector(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteAppConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteAppConnector() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteAppConnector(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteAppConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAppConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::DeleteAppConnectorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteAppConnector(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ReportStatus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ReportStatus() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ReportStatus(context, request, response); }));
    }
    ~WithRawCallbackMethod_ReportStatus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReportStatus(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::ReportStatusRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ReportStatus(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListAppConnectors : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListAppConnectors() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsRequest, ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsRequest, ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsResponse>* streamer) {
                       return this->StreamedListAppConnectors(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListAppConnectors() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListAppConnectors(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsRequest* /*request*/, ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListAppConnectors(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsRequest,::google::cloud::beyondcorp::appconnectors::v1::ListAppConnectorsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetAppConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetAppConnector() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::beyondcorp::appconnectors::v1::GetAppConnectorRequest, ::google::cloud::beyondcorp::appconnectors::v1::AppConnector>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::beyondcorp::appconnectors::v1::GetAppConnectorRequest, ::google::cloud::beyondcorp::appconnectors::v1::AppConnector>* streamer) {
                       return this->StreamedGetAppConnector(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetAppConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetAppConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::GetAppConnectorRequest* /*request*/, ::google::cloud::beyondcorp::appconnectors::v1::AppConnector* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetAppConnector(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::beyondcorp::appconnectors::v1::GetAppConnectorRequest,::google::cloud::beyondcorp::appconnectors::v1::AppConnector>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateAppConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateAppConnector() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::beyondcorp::appconnectors::v1::CreateAppConnectorRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::beyondcorp::appconnectors::v1::CreateAppConnectorRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateAppConnector(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateAppConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateAppConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::CreateAppConnectorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateAppConnector(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::beyondcorp::appconnectors::v1::CreateAppConnectorRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateAppConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateAppConnector() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::beyondcorp::appconnectors::v1::UpdateAppConnectorRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::beyondcorp::appconnectors::v1::UpdateAppConnectorRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateAppConnector(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateAppConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateAppConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::UpdateAppConnectorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateAppConnector(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::beyondcorp::appconnectors::v1::UpdateAppConnectorRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteAppConnector : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteAppConnector() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::beyondcorp::appconnectors::v1::DeleteAppConnectorRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::beyondcorp::appconnectors::v1::DeleteAppConnectorRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteAppConnector(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteAppConnector() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteAppConnector(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::DeleteAppConnectorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteAppConnector(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::beyondcorp::appconnectors::v1::DeleteAppConnectorRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ReportStatus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ReportStatus() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::beyondcorp::appconnectors::v1::ReportStatusRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::beyondcorp::appconnectors::v1::ReportStatusRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedReportStatus(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ReportStatus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ReportStatus(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appconnectors::v1::ReportStatusRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedReportStatus(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::beyondcorp::appconnectors::v1::ReportStatusRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListAppConnectors<WithStreamedUnaryMethod_GetAppConnector<WithStreamedUnaryMethod_CreateAppConnector<WithStreamedUnaryMethod_UpdateAppConnector<WithStreamedUnaryMethod_DeleteAppConnector<WithStreamedUnaryMethod_ReportStatus<Service > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListAppConnectors<WithStreamedUnaryMethod_GetAppConnector<WithStreamedUnaryMethod_CreateAppConnector<WithStreamedUnaryMethod_UpdateAppConnector<WithStreamedUnaryMethod_DeleteAppConnector<WithStreamedUnaryMethod_ReportStatus<Service > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace appconnectors
}  // namespace beyondcorp
}  // namespace cloud
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fcloud_2fbeyondcorp_2fappconnectors_2fv1_2fapp_5fconnectors_5fservice_2eproto__INCLUDED
