// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/bigquery/v2/table.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fbigquery_2fv2_2ftable_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fbigquery_2fv2_2ftable_2eproto__INCLUDED

#include "google/cloud/bigquery/v2/table.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace cloud {
namespace bigquery {
namespace v2 {

// TableService provides methods for managing BigQuery tables and table-like
// entities such as views and snapshots.
class TableService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.bigquery.v2.TableService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Gets the specified table resource by table ID.
    // This method does not return the data in the table, it only returns the
    // table resource, which describes the structure of this table.
    virtual ::grpc::Status GetTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetTableRequest& request, ::google::cloud::bigquery::v2::Table* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::Table>> AsyncGetTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::Table>>(AsyncGetTableRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::Table>> PrepareAsyncGetTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::Table>>(PrepareAsyncGetTableRaw(context, request, cq));
    }
    // Creates a new, empty table in the dataset.
    virtual ::grpc::Status InsertTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::InsertTableRequest& request, ::google::cloud::bigquery::v2::Table* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::Table>> AsyncInsertTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::InsertTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::Table>>(AsyncInsertTableRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::Table>> PrepareAsyncInsertTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::InsertTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::Table>>(PrepareAsyncInsertTableRaw(context, request, cq));
    }
    // Updates information in an existing table. The update method replaces the
    // entire table resource, whereas the patch method only replaces fields that
    // are provided in the submitted table resource.
    // This method supports RFC5789 patch semantics.
    virtual ::grpc::Status PatchTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest& request, ::google::cloud::bigquery::v2::Table* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::Table>> AsyncPatchTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::Table>>(AsyncPatchTableRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::Table>> PrepareAsyncPatchTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::Table>>(PrepareAsyncPatchTableRaw(context, request, cq));
    }
    // Updates information in an existing table. The update method replaces the
    // entire Table resource, whereas the patch method only replaces fields that
    // are provided in the submitted Table resource.
    virtual ::grpc::Status UpdateTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest& request, ::google::cloud::bigquery::v2::Table* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::Table>> AsyncUpdateTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::Table>>(AsyncUpdateTableRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::Table>> PrepareAsyncUpdateTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::Table>>(PrepareAsyncUpdateTableRaw(context, request, cq));
    }
    // Deletes the table specified by tableId from the dataset.
    // If the table contains data, all the data will be deleted.
    virtual ::grpc::Status DeleteTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::DeleteTableRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::DeleteTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteTableRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::DeleteTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteTableRaw(context, request, cq));
    }
    // Lists all tables in the specified dataset. Requires the READER dataset
    // role.
    virtual ::grpc::Status ListTables(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::ListTablesRequest& request, ::google::cloud::bigquery::v2::TableList* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::TableList>> AsyncListTables(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::ListTablesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::TableList>>(AsyncListTablesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::TableList>> PrepareAsyncListTables(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::ListTablesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::TableList>>(PrepareAsyncListTablesRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Gets the specified table resource by table ID.
      // This method does not return the data in the table, it only returns the
      // table resource, which describes the structure of this table.
      virtual void GetTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetTableRequest* request, ::google::cloud::bigquery::v2::Table* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetTableRequest* request, ::google::cloud::bigquery::v2::Table* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new, empty table in the dataset.
      virtual void InsertTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::InsertTableRequest* request, ::google::cloud::bigquery::v2::Table* response, std::function<void(::grpc::Status)>) = 0;
      virtual void InsertTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::InsertTableRequest* request, ::google::cloud::bigquery::v2::Table* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates information in an existing table. The update method replaces the
      // entire table resource, whereas the patch method only replaces fields that
      // are provided in the submitted table resource.
      // This method supports RFC5789 patch semantics.
      virtual void PatchTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest* request, ::google::cloud::bigquery::v2::Table* response, std::function<void(::grpc::Status)>) = 0;
      virtual void PatchTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest* request, ::google::cloud::bigquery::v2::Table* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates information in an existing table. The update method replaces the
      // entire Table resource, whereas the patch method only replaces fields that
      // are provided in the submitted Table resource.
      virtual void UpdateTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest* request, ::google::cloud::bigquery::v2::Table* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest* request, ::google::cloud::bigquery::v2::Table* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes the table specified by tableId from the dataset.
      // If the table contains data, all the data will be deleted.
      virtual void DeleteTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::DeleteTableRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::DeleteTableRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists all tables in the specified dataset. Requires the READER dataset
      // role.
      virtual void ListTables(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::ListTablesRequest* request, ::google::cloud::bigquery::v2::TableList* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListTables(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::ListTablesRequest* request, ::google::cloud::bigquery::v2::TableList* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::Table>* AsyncGetTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetTableRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::Table>* PrepareAsyncGetTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetTableRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::Table>* AsyncInsertTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::InsertTableRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::Table>* PrepareAsyncInsertTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::InsertTableRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::Table>* AsyncPatchTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::Table>* PrepareAsyncPatchTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::Table>* AsyncUpdateTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::Table>* PrepareAsyncUpdateTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::DeleteTableRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::DeleteTableRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::TableList>* AsyncListTablesRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::ListTablesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::TableList>* PrepareAsyncListTablesRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::ListTablesRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status GetTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetTableRequest& request, ::google::cloud::bigquery::v2::Table* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::Table>> AsyncGetTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::Table>>(AsyncGetTableRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::Table>> PrepareAsyncGetTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::Table>>(PrepareAsyncGetTableRaw(context, request, cq));
    }
    ::grpc::Status InsertTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::InsertTableRequest& request, ::google::cloud::bigquery::v2::Table* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::Table>> AsyncInsertTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::InsertTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::Table>>(AsyncInsertTableRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::Table>> PrepareAsyncInsertTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::InsertTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::Table>>(PrepareAsyncInsertTableRaw(context, request, cq));
    }
    ::grpc::Status PatchTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest& request, ::google::cloud::bigquery::v2::Table* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::Table>> AsyncPatchTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::Table>>(AsyncPatchTableRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::Table>> PrepareAsyncPatchTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::Table>>(PrepareAsyncPatchTableRaw(context, request, cq));
    }
    ::grpc::Status UpdateTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest& request, ::google::cloud::bigquery::v2::Table* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::Table>> AsyncUpdateTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::Table>>(AsyncUpdateTableRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::Table>> PrepareAsyncUpdateTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::Table>>(PrepareAsyncUpdateTableRaw(context, request, cq));
    }
    ::grpc::Status DeleteTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::DeleteTableRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::DeleteTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteTableRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::DeleteTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteTableRaw(context, request, cq));
    }
    ::grpc::Status ListTables(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::ListTablesRequest& request, ::google::cloud::bigquery::v2::TableList* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::TableList>> AsyncListTables(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::ListTablesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::TableList>>(AsyncListTablesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::TableList>> PrepareAsyncListTables(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::ListTablesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::TableList>>(PrepareAsyncListTablesRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void GetTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetTableRequest* request, ::google::cloud::bigquery::v2::Table* response, std::function<void(::grpc::Status)>) override;
      void GetTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetTableRequest* request, ::google::cloud::bigquery::v2::Table* response, ::grpc::ClientUnaryReactor* reactor) override;
      void InsertTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::InsertTableRequest* request, ::google::cloud::bigquery::v2::Table* response, std::function<void(::grpc::Status)>) override;
      void InsertTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::InsertTableRequest* request, ::google::cloud::bigquery::v2::Table* response, ::grpc::ClientUnaryReactor* reactor) override;
      void PatchTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest* request, ::google::cloud::bigquery::v2::Table* response, std::function<void(::grpc::Status)>) override;
      void PatchTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest* request, ::google::cloud::bigquery::v2::Table* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest* request, ::google::cloud::bigquery::v2::Table* response, std::function<void(::grpc::Status)>) override;
      void UpdateTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest* request, ::google::cloud::bigquery::v2::Table* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::DeleteTableRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::DeleteTableRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListTables(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::ListTablesRequest* request, ::google::cloud::bigquery::v2::TableList* response, std::function<void(::grpc::Status)>) override;
      void ListTables(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::ListTablesRequest* request, ::google::cloud::bigquery::v2::TableList* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::Table>* AsyncGetTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetTableRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::Table>* PrepareAsyncGetTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetTableRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::Table>* AsyncInsertTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::InsertTableRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::Table>* PrepareAsyncInsertTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::InsertTableRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::Table>* AsyncPatchTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::Table>* PrepareAsyncPatchTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::Table>* AsyncUpdateTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::Table>* PrepareAsyncUpdateTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::DeleteTableRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::DeleteTableRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::TableList>* AsyncListTablesRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::ListTablesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::TableList>* PrepareAsyncListTablesRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::ListTablesRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_GetTable_;
    const ::grpc::internal::RpcMethod rpcmethod_InsertTable_;
    const ::grpc::internal::RpcMethod rpcmethod_PatchTable_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateTable_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteTable_;
    const ::grpc::internal::RpcMethod rpcmethod_ListTables_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Gets the specified table resource by table ID.
    // This method does not return the data in the table, it only returns the
    // table resource, which describes the structure of this table.
    virtual ::grpc::Status GetTable(::grpc::ServerContext* context, const ::google::cloud::bigquery::v2::GetTableRequest* request, ::google::cloud::bigquery::v2::Table* response);
    // Creates a new, empty table in the dataset.
    virtual ::grpc::Status InsertTable(::grpc::ServerContext* context, const ::google::cloud::bigquery::v2::InsertTableRequest* request, ::google::cloud::bigquery::v2::Table* response);
    // Updates information in an existing table. The update method replaces the
    // entire table resource, whereas the patch method only replaces fields that
    // are provided in the submitted table resource.
    // This method supports RFC5789 patch semantics.
    virtual ::grpc::Status PatchTable(::grpc::ServerContext* context, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest* request, ::google::cloud::bigquery::v2::Table* response);
    // Updates information in an existing table. The update method replaces the
    // entire Table resource, whereas the patch method only replaces fields that
    // are provided in the submitted Table resource.
    virtual ::grpc::Status UpdateTable(::grpc::ServerContext* context, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest* request, ::google::cloud::bigquery::v2::Table* response);
    // Deletes the table specified by tableId from the dataset.
    // If the table contains data, all the data will be deleted.
    virtual ::grpc::Status DeleteTable(::grpc::ServerContext* context, const ::google::cloud::bigquery::v2::DeleteTableRequest* request, ::google::protobuf::Empty* response);
    // Lists all tables in the specified dataset. Requires the READER dataset
    // role.
    virtual ::grpc::Status ListTables(::grpc::ServerContext* context, const ::google::cloud::bigquery::v2::ListTablesRequest* request, ::google::cloud::bigquery::v2::TableList* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_GetTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetTable() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_GetTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::GetTableRequest* /*request*/, ::google::cloud::bigquery::v2::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetTable(::grpc::ServerContext* context, ::google::cloud::bigquery::v2::GetTableRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::bigquery::v2::Table>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_InsertTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_InsertTable() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_InsertTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InsertTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::InsertTableRequest* /*request*/, ::google::cloud::bigquery::v2::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestInsertTable(::grpc::ServerContext* context, ::google::cloud::bigquery::v2::InsertTableRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::bigquery::v2::Table>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_PatchTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_PatchTable() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_PatchTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PatchTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest* /*request*/, ::google::cloud::bigquery::v2::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestPatchTable(::grpc::ServerContext* context, ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::bigquery::v2::Table>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateTable() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_UpdateTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest* /*request*/, ::google::cloud::bigquery::v2::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateTable(::grpc::ServerContext* context, ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::bigquery::v2::Table>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteTable() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_DeleteTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::DeleteTableRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteTable(::grpc::ServerContext* context, ::google::cloud::bigquery::v2::DeleteTableRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListTables : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListTables() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_ListTables() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTables(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::ListTablesRequest* /*request*/, ::google::cloud::bigquery::v2::TableList* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListTables(::grpc::ServerContext* context, ::google::cloud::bigquery::v2::ListTablesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::bigquery::v2::TableList>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_GetTable<WithAsyncMethod_InsertTable<WithAsyncMethod_PatchTable<WithAsyncMethod_UpdateTable<WithAsyncMethod_DeleteTable<WithAsyncMethod_ListTables<Service > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_GetTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetTable() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::v2::GetTableRequest, ::google::cloud::bigquery::v2::Table>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::bigquery::v2::GetTableRequest* request, ::google::cloud::bigquery::v2::Table* response) { return this->GetTable(context, request, response); }));}
    void SetMessageAllocatorFor_GetTable(
        ::grpc::MessageAllocator< ::google::cloud::bigquery::v2::GetTableRequest, ::google::cloud::bigquery::v2::Table>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::v2::GetTableRequest, ::google::cloud::bigquery::v2::Table>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::GetTableRequest* /*request*/, ::google::cloud::bigquery::v2::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetTable(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::bigquery::v2::GetTableRequest* /*request*/, ::google::cloud::bigquery::v2::Table* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_InsertTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_InsertTable() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::v2::InsertTableRequest, ::google::cloud::bigquery::v2::Table>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::bigquery::v2::InsertTableRequest* request, ::google::cloud::bigquery::v2::Table* response) { return this->InsertTable(context, request, response); }));}
    void SetMessageAllocatorFor_InsertTable(
        ::grpc::MessageAllocator< ::google::cloud::bigquery::v2::InsertTableRequest, ::google::cloud::bigquery::v2::Table>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::v2::InsertTableRequest, ::google::cloud::bigquery::v2::Table>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_InsertTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InsertTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::InsertTableRequest* /*request*/, ::google::cloud::bigquery::v2::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* InsertTable(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::bigquery::v2::InsertTableRequest* /*request*/, ::google::cloud::bigquery::v2::Table* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_PatchTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_PatchTable() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest, ::google::cloud::bigquery::v2::Table>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest* request, ::google::cloud::bigquery::v2::Table* response) { return this->PatchTable(context, request, response); }));}
    void SetMessageAllocatorFor_PatchTable(
        ::grpc::MessageAllocator< ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest, ::google::cloud::bigquery::v2::Table>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest, ::google::cloud::bigquery::v2::Table>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_PatchTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PatchTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest* /*request*/, ::google::cloud::bigquery::v2::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* PatchTable(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest* /*request*/, ::google::cloud::bigquery::v2::Table* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateTable() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest, ::google::cloud::bigquery::v2::Table>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest* request, ::google::cloud::bigquery::v2::Table* response) { return this->UpdateTable(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateTable(
        ::grpc::MessageAllocator< ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest, ::google::cloud::bigquery::v2::Table>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest, ::google::cloud::bigquery::v2::Table>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest* /*request*/, ::google::cloud::bigquery::v2::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateTable(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest* /*request*/, ::google::cloud::bigquery::v2::Table* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteTable() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::v2::DeleteTableRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::bigquery::v2::DeleteTableRequest* request, ::google::protobuf::Empty* response) { return this->DeleteTable(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteTable(
        ::grpc::MessageAllocator< ::google::cloud::bigquery::v2::DeleteTableRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::v2::DeleteTableRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::DeleteTableRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteTable(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::bigquery::v2::DeleteTableRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListTables : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListTables() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::v2::ListTablesRequest, ::google::cloud::bigquery::v2::TableList>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::bigquery::v2::ListTablesRequest* request, ::google::cloud::bigquery::v2::TableList* response) { return this->ListTables(context, request, response); }));}
    void SetMessageAllocatorFor_ListTables(
        ::grpc::MessageAllocator< ::google::cloud::bigquery::v2::ListTablesRequest, ::google::cloud::bigquery::v2::TableList>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::v2::ListTablesRequest, ::google::cloud::bigquery::v2::TableList>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListTables() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTables(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::ListTablesRequest* /*request*/, ::google::cloud::bigquery::v2::TableList* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListTables(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::bigquery::v2::ListTablesRequest* /*request*/, ::google::cloud::bigquery::v2::TableList* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_GetTable<WithCallbackMethod_InsertTable<WithCallbackMethod_PatchTable<WithCallbackMethod_UpdateTable<WithCallbackMethod_DeleteTable<WithCallbackMethod_ListTables<Service > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_GetTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetTable() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_GetTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::GetTableRequest* /*request*/, ::google::cloud::bigquery::v2::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_InsertTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_InsertTable() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_InsertTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InsertTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::InsertTableRequest* /*request*/, ::google::cloud::bigquery::v2::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_PatchTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_PatchTable() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_PatchTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PatchTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest* /*request*/, ::google::cloud::bigquery::v2::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateTable() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_UpdateTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest* /*request*/, ::google::cloud::bigquery::v2::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteTable() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_DeleteTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::DeleteTableRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListTables : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListTables() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_ListTables() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTables(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::ListTablesRequest* /*request*/, ::google::cloud::bigquery::v2::TableList* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetTable() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_GetTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::GetTableRequest* /*request*/, ::google::cloud::bigquery::v2::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetTable(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_InsertTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_InsertTable() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_InsertTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InsertTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::InsertTableRequest* /*request*/, ::google::cloud::bigquery::v2::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestInsertTable(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_PatchTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_PatchTable() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_PatchTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PatchTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest* /*request*/, ::google::cloud::bigquery::v2::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestPatchTable(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateTable() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_UpdateTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest* /*request*/, ::google::cloud::bigquery::v2::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateTable(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteTable() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_DeleteTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::DeleteTableRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteTable(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListTables : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListTables() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_ListTables() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTables(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::ListTablesRequest* /*request*/, ::google::cloud::bigquery::v2::TableList* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListTables(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetTable() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetTable(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::GetTableRequest* /*request*/, ::google::cloud::bigquery::v2::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetTable(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_InsertTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_InsertTable() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->InsertTable(context, request, response); }));
    }
    ~WithRawCallbackMethod_InsertTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InsertTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::InsertTableRequest* /*request*/, ::google::cloud::bigquery::v2::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* InsertTable(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_PatchTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_PatchTable() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->PatchTable(context, request, response); }));
    }
    ~WithRawCallbackMethod_PatchTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PatchTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest* /*request*/, ::google::cloud::bigquery::v2::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* PatchTable(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateTable() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateTable(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest* /*request*/, ::google::cloud::bigquery::v2::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateTable(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteTable() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteTable(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::DeleteTableRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteTable(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListTables : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListTables() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListTables(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListTables() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTables(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::ListTablesRequest* /*request*/, ::google::cloud::bigquery::v2::TableList* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListTables(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetTable() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::bigquery::v2::GetTableRequest, ::google::cloud::bigquery::v2::Table>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::bigquery::v2::GetTableRequest, ::google::cloud::bigquery::v2::Table>* streamer) {
                       return this->StreamedGetTable(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::GetTableRequest* /*request*/, ::google::cloud::bigquery::v2::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetTable(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::bigquery::v2::GetTableRequest,::google::cloud::bigquery::v2::Table>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_InsertTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_InsertTable() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::bigquery::v2::InsertTableRequest, ::google::cloud::bigquery::v2::Table>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::bigquery::v2::InsertTableRequest, ::google::cloud::bigquery::v2::Table>* streamer) {
                       return this->StreamedInsertTable(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_InsertTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status InsertTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::InsertTableRequest* /*request*/, ::google::cloud::bigquery::v2::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedInsertTable(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::bigquery::v2::InsertTableRequest,::google::cloud::bigquery::v2::Table>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_PatchTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_PatchTable() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest, ::google::cloud::bigquery::v2::Table>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest, ::google::cloud::bigquery::v2::Table>* streamer) {
                       return this->StreamedPatchTable(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_PatchTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status PatchTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest* /*request*/, ::google::cloud::bigquery::v2::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedPatchTable(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest,::google::cloud::bigquery::v2::Table>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateTable() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest, ::google::cloud::bigquery::v2::Table>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest, ::google::cloud::bigquery::v2::Table>* streamer) {
                       return this->StreamedUpdateTable(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest* /*request*/, ::google::cloud::bigquery::v2::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateTable(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::bigquery::v2::UpdateOrPatchTableRequest,::google::cloud::bigquery::v2::Table>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteTable() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::bigquery::v2::DeleteTableRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::bigquery::v2::DeleteTableRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteTable(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::DeleteTableRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteTable(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::bigquery::v2::DeleteTableRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListTables : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListTables() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::bigquery::v2::ListTablesRequest, ::google::cloud::bigquery::v2::TableList>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::bigquery::v2::ListTablesRequest, ::google::cloud::bigquery::v2::TableList>* streamer) {
                       return this->StreamedListTables(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListTables() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListTables(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::ListTablesRequest* /*request*/, ::google::cloud::bigquery::v2::TableList* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListTables(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::bigquery::v2::ListTablesRequest,::google::cloud::bigquery::v2::TableList>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_GetTable<WithStreamedUnaryMethod_InsertTable<WithStreamedUnaryMethod_PatchTable<WithStreamedUnaryMethod_UpdateTable<WithStreamedUnaryMethod_DeleteTable<WithStreamedUnaryMethod_ListTables<Service > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_GetTable<WithStreamedUnaryMethod_InsertTable<WithStreamedUnaryMethod_PatchTable<WithStreamedUnaryMethod_UpdateTable<WithStreamedUnaryMethod_DeleteTable<WithStreamedUnaryMethod_ListTables<Service > > > > > > StreamedService;
};

}  // namespace v2
}  // namespace bigquery
}  // namespace cloud
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fcloud_2fbigquery_2fv2_2ftable_2eproto__INCLUDED
