// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/datacatalog/v1/policytagmanager.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fdatacatalog_2fv1_2fpolicytagmanager_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fdatacatalog_2fv1_2fpolicytagmanager_2eproto__INCLUDED

#include "google/cloud/datacatalog/v1/policytagmanager.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace cloud {
namespace datacatalog {
namespace v1 {

// Policy Tag Manager API service allows you to manage your policy tags and
// taxonomies.
//
// Policy tags are used to tag BigQuery columns and apply additional access
// control policies. A taxonomy is a hierarchical grouping of policy tags that
// classify data along a common axis.
class PolicyTagManager final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.datacatalog.v1.PolicyTagManager";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Creates a taxonomy in a specified project.
    //
    // The taxonomy is initially empty, that is, it doesn't contain policy tags.
    virtual ::grpc::Status CreateTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTaxonomyRequest& request, ::google::cloud::datacatalog::v1::Taxonomy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Taxonomy>> AsyncCreateTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTaxonomyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Taxonomy>>(AsyncCreateTaxonomyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Taxonomy>> PrepareAsyncCreateTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTaxonomyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Taxonomy>>(PrepareAsyncCreateTaxonomyRaw(context, request, cq));
    }
    // Deletes a taxonomy, including all policy tags in this
    // taxonomy, their associated policies, and the policy tags references from
    // BigQuery columns.
    virtual ::grpc::Status DeleteTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTaxonomyRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTaxonomyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteTaxonomyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTaxonomyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteTaxonomyRaw(context, request, cq));
    }
    // Updates a taxonomy, including its display name,
    // description, and activated policy types.
    virtual ::grpc::Status UpdateTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTaxonomyRequest& request, ::google::cloud::datacatalog::v1::Taxonomy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Taxonomy>> AsyncUpdateTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTaxonomyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Taxonomy>>(AsyncUpdateTaxonomyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Taxonomy>> PrepareAsyncUpdateTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTaxonomyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Taxonomy>>(PrepareAsyncUpdateTaxonomyRaw(context, request, cq));
    }
    // Lists all taxonomies in a project in a particular location that you
    // have a permission to view.
    virtual ::grpc::Status ListTaxonomies(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListTaxonomiesRequest& request, ::google::cloud::datacatalog::v1::ListTaxonomiesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ListTaxonomiesResponse>> AsyncListTaxonomies(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListTaxonomiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ListTaxonomiesResponse>>(AsyncListTaxonomiesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ListTaxonomiesResponse>> PrepareAsyncListTaxonomies(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListTaxonomiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ListTaxonomiesResponse>>(PrepareAsyncListTaxonomiesRaw(context, request, cq));
    }
    // Gets a taxonomy.
    virtual ::grpc::Status GetTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetTaxonomyRequest& request, ::google::cloud::datacatalog::v1::Taxonomy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Taxonomy>> AsyncGetTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetTaxonomyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Taxonomy>>(AsyncGetTaxonomyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Taxonomy>> PrepareAsyncGetTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetTaxonomyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Taxonomy>>(PrepareAsyncGetTaxonomyRaw(context, request, cq));
    }
    // Creates a policy tag in a taxonomy.
    virtual ::grpc::Status CreatePolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreatePolicyTagRequest& request, ::google::cloud::datacatalog::v1::PolicyTag* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::PolicyTag>> AsyncCreatePolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreatePolicyTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::PolicyTag>>(AsyncCreatePolicyTagRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::PolicyTag>> PrepareAsyncCreatePolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreatePolicyTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::PolicyTag>>(PrepareAsyncCreatePolicyTagRaw(context, request, cq));
    }
    // Deletes a policy tag together with the following:
    //
    // * All of its descendant policy tags, if any
    // * Policies associated with the policy tag and its descendants
    // * References from BigQuery table schema of the policy tag and its
    //   descendants
    virtual ::grpc::Status DeletePolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeletePolicyTagRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeletePolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeletePolicyTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeletePolicyTagRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeletePolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeletePolicyTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeletePolicyTagRaw(context, request, cq));
    }
    // Updates a policy tag, including its display
    // name, description, and parent policy tag.
    virtual ::grpc::Status UpdatePolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdatePolicyTagRequest& request, ::google::cloud::datacatalog::v1::PolicyTag* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::PolicyTag>> AsyncUpdatePolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdatePolicyTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::PolicyTag>>(AsyncUpdatePolicyTagRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::PolicyTag>> PrepareAsyncUpdatePolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdatePolicyTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::PolicyTag>>(PrepareAsyncUpdatePolicyTagRaw(context, request, cq));
    }
    // Lists all policy tags in a taxonomy.
    virtual ::grpc::Status ListPolicyTags(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListPolicyTagsRequest& request, ::google::cloud::datacatalog::v1::ListPolicyTagsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ListPolicyTagsResponse>> AsyncListPolicyTags(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListPolicyTagsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ListPolicyTagsResponse>>(AsyncListPolicyTagsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ListPolicyTagsResponse>> PrepareAsyncListPolicyTags(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListPolicyTagsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ListPolicyTagsResponse>>(PrepareAsyncListPolicyTagsRaw(context, request, cq));
    }
    // Gets a policy tag.
    virtual ::grpc::Status GetPolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetPolicyTagRequest& request, ::google::cloud::datacatalog::v1::PolicyTag* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::PolicyTag>> AsyncGetPolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetPolicyTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::PolicyTag>>(AsyncGetPolicyTagRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::PolicyTag>> PrepareAsyncGetPolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetPolicyTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::PolicyTag>>(PrepareAsyncGetPolicyTagRaw(context, request, cq));
    }
    // Gets the IAM policy for a policy tag or a taxonomy.
    virtual ::grpc::Status GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::google::iam::v1::Policy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> AsyncGetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(AsyncGetIamPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> PrepareAsyncGetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(PrepareAsyncGetIamPolicyRaw(context, request, cq));
    }
    // Sets the IAM policy for a policy tag or a taxonomy.
    virtual ::grpc::Status SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::google::iam::v1::Policy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> AsyncSetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(AsyncSetIamPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> PrepareAsyncSetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(PrepareAsyncSetIamPolicyRaw(context, request, cq));
    }
    // Returns your permissions on a specified policy tag or
    // taxonomy.
    virtual ::grpc::Status TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::google::iam::v1::TestIamPermissionsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>> AsyncTestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>>(AsyncTestIamPermissionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>> PrepareAsyncTestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>>(PrepareAsyncTestIamPermissionsRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Creates a taxonomy in a specified project.
      //
      // The taxonomy is initially empty, that is, it doesn't contain policy tags.
      virtual void CreateTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTaxonomyRequest* request, ::google::cloud::datacatalog::v1::Taxonomy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTaxonomyRequest* request, ::google::cloud::datacatalog::v1::Taxonomy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a taxonomy, including all policy tags in this
      // taxonomy, their associated policies, and the policy tags references from
      // BigQuery columns.
      virtual void DeleteTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTaxonomyRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTaxonomyRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a taxonomy, including its display name,
      // description, and activated policy types.
      virtual void UpdateTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTaxonomyRequest* request, ::google::cloud::datacatalog::v1::Taxonomy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTaxonomyRequest* request, ::google::cloud::datacatalog::v1::Taxonomy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists all taxonomies in a project in a particular location that you
      // have a permission to view.
      virtual void ListTaxonomies(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListTaxonomiesRequest* request, ::google::cloud::datacatalog::v1::ListTaxonomiesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListTaxonomies(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListTaxonomiesRequest* request, ::google::cloud::datacatalog::v1::ListTaxonomiesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a taxonomy.
      virtual void GetTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetTaxonomyRequest* request, ::google::cloud::datacatalog::v1::Taxonomy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetTaxonomyRequest* request, ::google::cloud::datacatalog::v1::Taxonomy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a policy tag in a taxonomy.
      virtual void CreatePolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreatePolicyTagRequest* request, ::google::cloud::datacatalog::v1::PolicyTag* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreatePolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreatePolicyTagRequest* request, ::google::cloud::datacatalog::v1::PolicyTag* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a policy tag together with the following:
      //
      // * All of its descendant policy tags, if any
      // * Policies associated with the policy tag and its descendants
      // * References from BigQuery table schema of the policy tag and its
      //   descendants
      virtual void DeletePolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeletePolicyTagRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeletePolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeletePolicyTagRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a policy tag, including its display
      // name, description, and parent policy tag.
      virtual void UpdatePolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdatePolicyTagRequest* request, ::google::cloud::datacatalog::v1::PolicyTag* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdatePolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdatePolicyTagRequest* request, ::google::cloud::datacatalog::v1::PolicyTag* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists all policy tags in a taxonomy.
      virtual void ListPolicyTags(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListPolicyTagsRequest* request, ::google::cloud::datacatalog::v1::ListPolicyTagsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListPolicyTags(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListPolicyTagsRequest* request, ::google::cloud::datacatalog::v1::ListPolicyTagsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a policy tag.
      virtual void GetPolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetPolicyTagRequest* request, ::google::cloud::datacatalog::v1::PolicyTag* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetPolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetPolicyTagRequest* request, ::google::cloud::datacatalog::v1::PolicyTag* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the IAM policy for a policy tag or a taxonomy.
      virtual void GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Sets the IAM policy for a policy tag or a taxonomy.
      virtual void SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns your permissions on a specified policy tag or
      // taxonomy.
      virtual void TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Taxonomy>* AsyncCreateTaxonomyRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTaxonomyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Taxonomy>* PrepareAsyncCreateTaxonomyRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTaxonomyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteTaxonomyRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTaxonomyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteTaxonomyRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTaxonomyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Taxonomy>* AsyncUpdateTaxonomyRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTaxonomyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Taxonomy>* PrepareAsyncUpdateTaxonomyRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTaxonomyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ListTaxonomiesResponse>* AsyncListTaxonomiesRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListTaxonomiesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ListTaxonomiesResponse>* PrepareAsyncListTaxonomiesRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListTaxonomiesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Taxonomy>* AsyncGetTaxonomyRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetTaxonomyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Taxonomy>* PrepareAsyncGetTaxonomyRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetTaxonomyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::PolicyTag>* AsyncCreatePolicyTagRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreatePolicyTagRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::PolicyTag>* PrepareAsyncCreatePolicyTagRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreatePolicyTagRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeletePolicyTagRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeletePolicyTagRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeletePolicyTagRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeletePolicyTagRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::PolicyTag>* AsyncUpdatePolicyTagRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdatePolicyTagRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::PolicyTag>* PrepareAsyncUpdatePolicyTagRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdatePolicyTagRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ListPolicyTagsResponse>* AsyncListPolicyTagsRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListPolicyTagsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ListPolicyTagsResponse>* PrepareAsyncListPolicyTagsRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListPolicyTagsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::PolicyTag>* AsyncGetPolicyTagRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetPolicyTagRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::PolicyTag>* PrepareAsyncGetPolicyTagRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetPolicyTagRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* AsyncGetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* PrepareAsyncGetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* AsyncSetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* PrepareAsyncSetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>* AsyncTestIamPermissionsRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>* PrepareAsyncTestIamPermissionsRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CreateTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTaxonomyRequest& request, ::google::cloud::datacatalog::v1::Taxonomy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Taxonomy>> AsyncCreateTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTaxonomyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Taxonomy>>(AsyncCreateTaxonomyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Taxonomy>> PrepareAsyncCreateTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTaxonomyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Taxonomy>>(PrepareAsyncCreateTaxonomyRaw(context, request, cq));
    }
    ::grpc::Status DeleteTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTaxonomyRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTaxonomyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteTaxonomyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTaxonomyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteTaxonomyRaw(context, request, cq));
    }
    ::grpc::Status UpdateTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTaxonomyRequest& request, ::google::cloud::datacatalog::v1::Taxonomy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Taxonomy>> AsyncUpdateTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTaxonomyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Taxonomy>>(AsyncUpdateTaxonomyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Taxonomy>> PrepareAsyncUpdateTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTaxonomyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Taxonomy>>(PrepareAsyncUpdateTaxonomyRaw(context, request, cq));
    }
    ::grpc::Status ListTaxonomies(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListTaxonomiesRequest& request, ::google::cloud::datacatalog::v1::ListTaxonomiesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ListTaxonomiesResponse>> AsyncListTaxonomies(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListTaxonomiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ListTaxonomiesResponse>>(AsyncListTaxonomiesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ListTaxonomiesResponse>> PrepareAsyncListTaxonomies(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListTaxonomiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ListTaxonomiesResponse>>(PrepareAsyncListTaxonomiesRaw(context, request, cq));
    }
    ::grpc::Status GetTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetTaxonomyRequest& request, ::google::cloud::datacatalog::v1::Taxonomy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Taxonomy>> AsyncGetTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetTaxonomyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Taxonomy>>(AsyncGetTaxonomyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Taxonomy>> PrepareAsyncGetTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetTaxonomyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Taxonomy>>(PrepareAsyncGetTaxonomyRaw(context, request, cq));
    }
    ::grpc::Status CreatePolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreatePolicyTagRequest& request, ::google::cloud::datacatalog::v1::PolicyTag* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::PolicyTag>> AsyncCreatePolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreatePolicyTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::PolicyTag>>(AsyncCreatePolicyTagRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::PolicyTag>> PrepareAsyncCreatePolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreatePolicyTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::PolicyTag>>(PrepareAsyncCreatePolicyTagRaw(context, request, cq));
    }
    ::grpc::Status DeletePolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeletePolicyTagRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeletePolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeletePolicyTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeletePolicyTagRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeletePolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeletePolicyTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeletePolicyTagRaw(context, request, cq));
    }
    ::grpc::Status UpdatePolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdatePolicyTagRequest& request, ::google::cloud::datacatalog::v1::PolicyTag* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::PolicyTag>> AsyncUpdatePolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdatePolicyTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::PolicyTag>>(AsyncUpdatePolicyTagRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::PolicyTag>> PrepareAsyncUpdatePolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdatePolicyTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::PolicyTag>>(PrepareAsyncUpdatePolicyTagRaw(context, request, cq));
    }
    ::grpc::Status ListPolicyTags(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListPolicyTagsRequest& request, ::google::cloud::datacatalog::v1::ListPolicyTagsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ListPolicyTagsResponse>> AsyncListPolicyTags(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListPolicyTagsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ListPolicyTagsResponse>>(AsyncListPolicyTagsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ListPolicyTagsResponse>> PrepareAsyncListPolicyTags(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListPolicyTagsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ListPolicyTagsResponse>>(PrepareAsyncListPolicyTagsRaw(context, request, cq));
    }
    ::grpc::Status GetPolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetPolicyTagRequest& request, ::google::cloud::datacatalog::v1::PolicyTag* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::PolicyTag>> AsyncGetPolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetPolicyTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::PolicyTag>>(AsyncGetPolicyTagRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::PolicyTag>> PrepareAsyncGetPolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetPolicyTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::PolicyTag>>(PrepareAsyncGetPolicyTagRaw(context, request, cq));
    }
    ::grpc::Status GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::google::iam::v1::Policy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> AsyncGetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(AsyncGetIamPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> PrepareAsyncGetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(PrepareAsyncGetIamPolicyRaw(context, request, cq));
    }
    ::grpc::Status SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::google::iam::v1::Policy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> AsyncSetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(AsyncSetIamPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> PrepareAsyncSetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(PrepareAsyncSetIamPolicyRaw(context, request, cq));
    }
    ::grpc::Status TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::google::iam::v1::TestIamPermissionsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>> AsyncTestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>>(AsyncTestIamPermissionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>> PrepareAsyncTestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>>(PrepareAsyncTestIamPermissionsRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CreateTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTaxonomyRequest* request, ::google::cloud::datacatalog::v1::Taxonomy* response, std::function<void(::grpc::Status)>) override;
      void CreateTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTaxonomyRequest* request, ::google::cloud::datacatalog::v1::Taxonomy* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTaxonomyRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTaxonomyRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTaxonomyRequest* request, ::google::cloud::datacatalog::v1::Taxonomy* response, std::function<void(::grpc::Status)>) override;
      void UpdateTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTaxonomyRequest* request, ::google::cloud::datacatalog::v1::Taxonomy* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListTaxonomies(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListTaxonomiesRequest* request, ::google::cloud::datacatalog::v1::ListTaxonomiesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListTaxonomies(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListTaxonomiesRequest* request, ::google::cloud::datacatalog::v1::ListTaxonomiesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetTaxonomyRequest* request, ::google::cloud::datacatalog::v1::Taxonomy* response, std::function<void(::grpc::Status)>) override;
      void GetTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetTaxonomyRequest* request, ::google::cloud::datacatalog::v1::Taxonomy* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreatePolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreatePolicyTagRequest* request, ::google::cloud::datacatalog::v1::PolicyTag* response, std::function<void(::grpc::Status)>) override;
      void CreatePolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreatePolicyTagRequest* request, ::google::cloud::datacatalog::v1::PolicyTag* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeletePolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeletePolicyTagRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeletePolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeletePolicyTagRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdatePolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdatePolicyTagRequest* request, ::google::cloud::datacatalog::v1::PolicyTag* response, std::function<void(::grpc::Status)>) override;
      void UpdatePolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdatePolicyTagRequest* request, ::google::cloud::datacatalog::v1::PolicyTag* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListPolicyTags(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListPolicyTagsRequest* request, ::google::cloud::datacatalog::v1::ListPolicyTagsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListPolicyTags(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListPolicyTagsRequest* request, ::google::cloud::datacatalog::v1::ListPolicyTagsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetPolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetPolicyTagRequest* request, ::google::cloud::datacatalog::v1::PolicyTag* response, std::function<void(::grpc::Status)>) override;
      void GetPolicyTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetPolicyTagRequest* request, ::google::cloud::datacatalog::v1::PolicyTag* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) override;
      void GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) override;
      void SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) override;
      void SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) override;
      void TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, std::function<void(::grpc::Status)>) override;
      void TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Taxonomy>* AsyncCreateTaxonomyRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTaxonomyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Taxonomy>* PrepareAsyncCreateTaxonomyRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTaxonomyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteTaxonomyRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTaxonomyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteTaxonomyRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTaxonomyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Taxonomy>* AsyncUpdateTaxonomyRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTaxonomyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Taxonomy>* PrepareAsyncUpdateTaxonomyRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTaxonomyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ListTaxonomiesResponse>* AsyncListTaxonomiesRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListTaxonomiesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ListTaxonomiesResponse>* PrepareAsyncListTaxonomiesRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListTaxonomiesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Taxonomy>* AsyncGetTaxonomyRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetTaxonomyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Taxonomy>* PrepareAsyncGetTaxonomyRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetTaxonomyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::PolicyTag>* AsyncCreatePolicyTagRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreatePolicyTagRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::PolicyTag>* PrepareAsyncCreatePolicyTagRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreatePolicyTagRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeletePolicyTagRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeletePolicyTagRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeletePolicyTagRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeletePolicyTagRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::PolicyTag>* AsyncUpdatePolicyTagRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdatePolicyTagRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::PolicyTag>* PrepareAsyncUpdatePolicyTagRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdatePolicyTagRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ListPolicyTagsResponse>* AsyncListPolicyTagsRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListPolicyTagsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ListPolicyTagsResponse>* PrepareAsyncListPolicyTagsRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListPolicyTagsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::PolicyTag>* AsyncGetPolicyTagRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetPolicyTagRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::PolicyTag>* PrepareAsyncGetPolicyTagRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetPolicyTagRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* AsyncGetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* PrepareAsyncGetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* AsyncSetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* PrepareAsyncSetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>* AsyncTestIamPermissionsRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>* PrepareAsyncTestIamPermissionsRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CreateTaxonomy_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteTaxonomy_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateTaxonomy_;
    const ::grpc::internal::RpcMethod rpcmethod_ListTaxonomies_;
    const ::grpc::internal::RpcMethod rpcmethod_GetTaxonomy_;
    const ::grpc::internal::RpcMethod rpcmethod_CreatePolicyTag_;
    const ::grpc::internal::RpcMethod rpcmethod_DeletePolicyTag_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdatePolicyTag_;
    const ::grpc::internal::RpcMethod rpcmethod_ListPolicyTags_;
    const ::grpc::internal::RpcMethod rpcmethod_GetPolicyTag_;
    const ::grpc::internal::RpcMethod rpcmethod_GetIamPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_SetIamPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_TestIamPermissions_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Creates a taxonomy in a specified project.
    //
    // The taxonomy is initially empty, that is, it doesn't contain policy tags.
    virtual ::grpc::Status CreateTaxonomy(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::CreateTaxonomyRequest* request, ::google::cloud::datacatalog::v1::Taxonomy* response);
    // Deletes a taxonomy, including all policy tags in this
    // taxonomy, their associated policies, and the policy tags references from
    // BigQuery columns.
    virtual ::grpc::Status DeleteTaxonomy(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::DeleteTaxonomyRequest* request, ::google::protobuf::Empty* response);
    // Updates a taxonomy, including its display name,
    // description, and activated policy types.
    virtual ::grpc::Status UpdateTaxonomy(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::UpdateTaxonomyRequest* request, ::google::cloud::datacatalog::v1::Taxonomy* response);
    // Lists all taxonomies in a project in a particular location that you
    // have a permission to view.
    virtual ::grpc::Status ListTaxonomies(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::ListTaxonomiesRequest* request, ::google::cloud::datacatalog::v1::ListTaxonomiesResponse* response);
    // Gets a taxonomy.
    virtual ::grpc::Status GetTaxonomy(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::GetTaxonomyRequest* request, ::google::cloud::datacatalog::v1::Taxonomy* response);
    // Creates a policy tag in a taxonomy.
    virtual ::grpc::Status CreatePolicyTag(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::CreatePolicyTagRequest* request, ::google::cloud::datacatalog::v1::PolicyTag* response);
    // Deletes a policy tag together with the following:
    //
    // * All of its descendant policy tags, if any
    // * Policies associated with the policy tag and its descendants
    // * References from BigQuery table schema of the policy tag and its
    //   descendants
    virtual ::grpc::Status DeletePolicyTag(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::DeletePolicyTagRequest* request, ::google::protobuf::Empty* response);
    // Updates a policy tag, including its display
    // name, description, and parent policy tag.
    virtual ::grpc::Status UpdatePolicyTag(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::UpdatePolicyTagRequest* request, ::google::cloud::datacatalog::v1::PolicyTag* response);
    // Lists all policy tags in a taxonomy.
    virtual ::grpc::Status ListPolicyTags(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::ListPolicyTagsRequest* request, ::google::cloud::datacatalog::v1::ListPolicyTagsResponse* response);
    // Gets a policy tag.
    virtual ::grpc::Status GetPolicyTag(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::GetPolicyTagRequest* request, ::google::cloud::datacatalog::v1::PolicyTag* response);
    // Gets the IAM policy for a policy tag or a taxonomy.
    virtual ::grpc::Status GetIamPolicy(::grpc::ServerContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response);
    // Sets the IAM policy for a policy tag or a taxonomy.
    virtual ::grpc::Status SetIamPolicy(::grpc::ServerContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response);
    // Returns your permissions on a specified policy tag or
    // taxonomy.
    virtual ::grpc::Status TestIamPermissions(::grpc::ServerContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateTaxonomy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateTaxonomy() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CreateTaxonomy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTaxonomy(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateTaxonomyRequest* /*request*/, ::google::cloud::datacatalog::v1::Taxonomy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateTaxonomy(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::CreateTaxonomyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::v1::Taxonomy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteTaxonomy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteTaxonomy() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_DeleteTaxonomy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTaxonomy(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteTaxonomyRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteTaxonomy(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::DeleteTaxonomyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateTaxonomy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateTaxonomy() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_UpdateTaxonomy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTaxonomy(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateTaxonomyRequest* /*request*/, ::google::cloud::datacatalog::v1::Taxonomy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateTaxonomy(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::UpdateTaxonomyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::v1::Taxonomy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListTaxonomies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListTaxonomies() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_ListTaxonomies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTaxonomies(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ListTaxonomiesRequest* /*request*/, ::google::cloud::datacatalog::v1::ListTaxonomiesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListTaxonomies(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::ListTaxonomiesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::v1::ListTaxonomiesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetTaxonomy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetTaxonomy() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_GetTaxonomy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTaxonomy(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::GetTaxonomyRequest* /*request*/, ::google::cloud::datacatalog::v1::Taxonomy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetTaxonomy(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::GetTaxonomyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::v1::Taxonomy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreatePolicyTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreatePolicyTag() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_CreatePolicyTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePolicyTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreatePolicyTagRequest* /*request*/, ::google::cloud::datacatalog::v1::PolicyTag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreatePolicyTag(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::CreatePolicyTagRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::v1::PolicyTag>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeletePolicyTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeletePolicyTag() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_DeletePolicyTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePolicyTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeletePolicyTagRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeletePolicyTag(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::DeletePolicyTagRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdatePolicyTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdatePolicyTag() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_UpdatePolicyTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePolicyTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdatePolicyTagRequest* /*request*/, ::google::cloud::datacatalog::v1::PolicyTag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdatePolicyTag(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::UpdatePolicyTagRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::v1::PolicyTag>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListPolicyTags : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListPolicyTags() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_ListPolicyTags() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPolicyTags(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ListPolicyTagsRequest* /*request*/, ::google::cloud::datacatalog::v1::ListPolicyTagsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPolicyTags(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::ListPolicyTagsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::v1::ListPolicyTagsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetPolicyTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetPolicyTag() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_GetPolicyTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPolicyTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::GetPolicyTagRequest* /*request*/, ::google::cloud::datacatalog::v1::PolicyTag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetPolicyTag(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::GetPolicyTagRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::v1::PolicyTag>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetIamPolicy(::grpc::ServerContext* context, ::google::iam::v1::GetIamPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::iam::v1::Policy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSetIamPolicy(::grpc::ServerContext* context, ::google::iam::v1::SetIamPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::iam::v1::Policy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTestIamPermissions(::grpc::ServerContext* context, ::google::iam::v1::TestIamPermissionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::iam::v1::TestIamPermissionsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CreateTaxonomy<WithAsyncMethod_DeleteTaxonomy<WithAsyncMethod_UpdateTaxonomy<WithAsyncMethod_ListTaxonomies<WithAsyncMethod_GetTaxonomy<WithAsyncMethod_CreatePolicyTag<WithAsyncMethod_DeletePolicyTag<WithAsyncMethod_UpdatePolicyTag<WithAsyncMethod_ListPolicyTags<WithAsyncMethod_GetPolicyTag<WithAsyncMethod_GetIamPolicy<WithAsyncMethod_SetIamPolicy<WithAsyncMethod_TestIamPermissions<Service > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CreateTaxonomy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateTaxonomy() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::CreateTaxonomyRequest, ::google::cloud::datacatalog::v1::Taxonomy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::CreateTaxonomyRequest* request, ::google::cloud::datacatalog::v1::Taxonomy* response) { return this->CreateTaxonomy(context, request, response); }));}
    void SetMessageAllocatorFor_CreateTaxonomy(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::CreateTaxonomyRequest, ::google::cloud::datacatalog::v1::Taxonomy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::CreateTaxonomyRequest, ::google::cloud::datacatalog::v1::Taxonomy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateTaxonomy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTaxonomy(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateTaxonomyRequest* /*request*/, ::google::cloud::datacatalog::v1::Taxonomy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateTaxonomy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateTaxonomyRequest* /*request*/, ::google::cloud::datacatalog::v1::Taxonomy* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteTaxonomy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteTaxonomy() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::DeleteTaxonomyRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::DeleteTaxonomyRequest* request, ::google::protobuf::Empty* response) { return this->DeleteTaxonomy(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteTaxonomy(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::DeleteTaxonomyRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::DeleteTaxonomyRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteTaxonomy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTaxonomy(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteTaxonomyRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteTaxonomy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteTaxonomyRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateTaxonomy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateTaxonomy() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::UpdateTaxonomyRequest, ::google::cloud::datacatalog::v1::Taxonomy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::UpdateTaxonomyRequest* request, ::google::cloud::datacatalog::v1::Taxonomy* response) { return this->UpdateTaxonomy(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateTaxonomy(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::UpdateTaxonomyRequest, ::google::cloud::datacatalog::v1::Taxonomy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::UpdateTaxonomyRequest, ::google::cloud::datacatalog::v1::Taxonomy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateTaxonomy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTaxonomy(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateTaxonomyRequest* /*request*/, ::google::cloud::datacatalog::v1::Taxonomy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateTaxonomy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateTaxonomyRequest* /*request*/, ::google::cloud::datacatalog::v1::Taxonomy* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListTaxonomies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListTaxonomies() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::ListTaxonomiesRequest, ::google::cloud::datacatalog::v1::ListTaxonomiesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::ListTaxonomiesRequest* request, ::google::cloud::datacatalog::v1::ListTaxonomiesResponse* response) { return this->ListTaxonomies(context, request, response); }));}
    void SetMessageAllocatorFor_ListTaxonomies(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::ListTaxonomiesRequest, ::google::cloud::datacatalog::v1::ListTaxonomiesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::ListTaxonomiesRequest, ::google::cloud::datacatalog::v1::ListTaxonomiesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListTaxonomies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTaxonomies(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ListTaxonomiesRequest* /*request*/, ::google::cloud::datacatalog::v1::ListTaxonomiesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListTaxonomies(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ListTaxonomiesRequest* /*request*/, ::google::cloud::datacatalog::v1::ListTaxonomiesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetTaxonomy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetTaxonomy() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::GetTaxonomyRequest, ::google::cloud::datacatalog::v1::Taxonomy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::GetTaxonomyRequest* request, ::google::cloud::datacatalog::v1::Taxonomy* response) { return this->GetTaxonomy(context, request, response); }));}
    void SetMessageAllocatorFor_GetTaxonomy(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::GetTaxonomyRequest, ::google::cloud::datacatalog::v1::Taxonomy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::GetTaxonomyRequest, ::google::cloud::datacatalog::v1::Taxonomy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetTaxonomy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTaxonomy(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::GetTaxonomyRequest* /*request*/, ::google::cloud::datacatalog::v1::Taxonomy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetTaxonomy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::GetTaxonomyRequest* /*request*/, ::google::cloud::datacatalog::v1::Taxonomy* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreatePolicyTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreatePolicyTag() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::CreatePolicyTagRequest, ::google::cloud::datacatalog::v1::PolicyTag>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::CreatePolicyTagRequest* request, ::google::cloud::datacatalog::v1::PolicyTag* response) { return this->CreatePolicyTag(context, request, response); }));}
    void SetMessageAllocatorFor_CreatePolicyTag(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::CreatePolicyTagRequest, ::google::cloud::datacatalog::v1::PolicyTag>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::CreatePolicyTagRequest, ::google::cloud::datacatalog::v1::PolicyTag>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreatePolicyTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePolicyTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreatePolicyTagRequest* /*request*/, ::google::cloud::datacatalog::v1::PolicyTag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreatePolicyTag(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreatePolicyTagRequest* /*request*/, ::google::cloud::datacatalog::v1::PolicyTag* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeletePolicyTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeletePolicyTag() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::DeletePolicyTagRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::DeletePolicyTagRequest* request, ::google::protobuf::Empty* response) { return this->DeletePolicyTag(context, request, response); }));}
    void SetMessageAllocatorFor_DeletePolicyTag(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::DeletePolicyTagRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::DeletePolicyTagRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeletePolicyTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePolicyTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeletePolicyTagRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeletePolicyTag(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeletePolicyTagRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdatePolicyTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdatePolicyTag() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::UpdatePolicyTagRequest, ::google::cloud::datacatalog::v1::PolicyTag>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::UpdatePolicyTagRequest* request, ::google::cloud::datacatalog::v1::PolicyTag* response) { return this->UpdatePolicyTag(context, request, response); }));}
    void SetMessageAllocatorFor_UpdatePolicyTag(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::UpdatePolicyTagRequest, ::google::cloud::datacatalog::v1::PolicyTag>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::UpdatePolicyTagRequest, ::google::cloud::datacatalog::v1::PolicyTag>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdatePolicyTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePolicyTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdatePolicyTagRequest* /*request*/, ::google::cloud::datacatalog::v1::PolicyTag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdatePolicyTag(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdatePolicyTagRequest* /*request*/, ::google::cloud::datacatalog::v1::PolicyTag* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListPolicyTags : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListPolicyTags() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::ListPolicyTagsRequest, ::google::cloud::datacatalog::v1::ListPolicyTagsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::ListPolicyTagsRequest* request, ::google::cloud::datacatalog::v1::ListPolicyTagsResponse* response) { return this->ListPolicyTags(context, request, response); }));}
    void SetMessageAllocatorFor_ListPolicyTags(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::ListPolicyTagsRequest, ::google::cloud::datacatalog::v1::ListPolicyTagsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::ListPolicyTagsRequest, ::google::cloud::datacatalog::v1::ListPolicyTagsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListPolicyTags() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPolicyTags(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ListPolicyTagsRequest* /*request*/, ::google::cloud::datacatalog::v1::ListPolicyTagsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPolicyTags(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ListPolicyTagsRequest* /*request*/, ::google::cloud::datacatalog::v1::ListPolicyTagsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetPolicyTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetPolicyTag() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::GetPolicyTagRequest, ::google::cloud::datacatalog::v1::PolicyTag>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::GetPolicyTagRequest* request, ::google::cloud::datacatalog::v1::PolicyTag* response) { return this->GetPolicyTag(context, request, response); }));}
    void SetMessageAllocatorFor_GetPolicyTag(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::GetPolicyTagRequest, ::google::cloud::datacatalog::v1::PolicyTag>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::GetPolicyTagRequest, ::google::cloud::datacatalog::v1::PolicyTag>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetPolicyTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPolicyTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::GetPolicyTagRequest* /*request*/, ::google::cloud::datacatalog::v1::PolicyTag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetPolicyTag(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::GetPolicyTagRequest* /*request*/, ::google::cloud::datacatalog::v1::PolicyTag* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response) { return this->GetIamPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_GetIamPolicy(
        ::grpc::MessageAllocator< ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetIamPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response) { return this->SetIamPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_SetIamPolicy(
        ::grpc::MessageAllocator< ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SetIamPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response) { return this->TestIamPermissions(context, request, response); }));}
    void SetMessageAllocatorFor_TestIamPermissions(
        ::grpc::MessageAllocator< ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* TestIamPermissions(
      ::grpc::CallbackServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CreateTaxonomy<WithCallbackMethod_DeleteTaxonomy<WithCallbackMethod_UpdateTaxonomy<WithCallbackMethod_ListTaxonomies<WithCallbackMethod_GetTaxonomy<WithCallbackMethod_CreatePolicyTag<WithCallbackMethod_DeletePolicyTag<WithCallbackMethod_UpdatePolicyTag<WithCallbackMethod_ListPolicyTags<WithCallbackMethod_GetPolicyTag<WithCallbackMethod_GetIamPolicy<WithCallbackMethod_SetIamPolicy<WithCallbackMethod_TestIamPermissions<Service > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CreateTaxonomy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateTaxonomy() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CreateTaxonomy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTaxonomy(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateTaxonomyRequest* /*request*/, ::google::cloud::datacatalog::v1::Taxonomy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteTaxonomy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteTaxonomy() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_DeleteTaxonomy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTaxonomy(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteTaxonomyRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateTaxonomy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateTaxonomy() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_UpdateTaxonomy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTaxonomy(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateTaxonomyRequest* /*request*/, ::google::cloud::datacatalog::v1::Taxonomy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListTaxonomies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListTaxonomies() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_ListTaxonomies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTaxonomies(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ListTaxonomiesRequest* /*request*/, ::google::cloud::datacatalog::v1::ListTaxonomiesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetTaxonomy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetTaxonomy() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_GetTaxonomy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTaxonomy(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::GetTaxonomyRequest* /*request*/, ::google::cloud::datacatalog::v1::Taxonomy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreatePolicyTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreatePolicyTag() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_CreatePolicyTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePolicyTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreatePolicyTagRequest* /*request*/, ::google::cloud::datacatalog::v1::PolicyTag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeletePolicyTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeletePolicyTag() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_DeletePolicyTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePolicyTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeletePolicyTagRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdatePolicyTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdatePolicyTag() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_UpdatePolicyTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePolicyTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdatePolicyTagRequest* /*request*/, ::google::cloud::datacatalog::v1::PolicyTag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListPolicyTags : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListPolicyTags() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_ListPolicyTags() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPolicyTags(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ListPolicyTagsRequest* /*request*/, ::google::cloud::datacatalog::v1::ListPolicyTagsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetPolicyTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetPolicyTag() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_GetPolicyTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPolicyTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::GetPolicyTagRequest* /*request*/, ::google::cloud::datacatalog::v1::PolicyTag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateTaxonomy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateTaxonomy() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CreateTaxonomy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTaxonomy(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateTaxonomyRequest* /*request*/, ::google::cloud::datacatalog::v1::Taxonomy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateTaxonomy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteTaxonomy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteTaxonomy() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_DeleteTaxonomy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTaxonomy(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteTaxonomyRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteTaxonomy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateTaxonomy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateTaxonomy() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_UpdateTaxonomy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTaxonomy(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateTaxonomyRequest* /*request*/, ::google::cloud::datacatalog::v1::Taxonomy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateTaxonomy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListTaxonomies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListTaxonomies() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_ListTaxonomies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTaxonomies(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ListTaxonomiesRequest* /*request*/, ::google::cloud::datacatalog::v1::ListTaxonomiesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListTaxonomies(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetTaxonomy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetTaxonomy() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_GetTaxonomy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTaxonomy(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::GetTaxonomyRequest* /*request*/, ::google::cloud::datacatalog::v1::Taxonomy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetTaxonomy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreatePolicyTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreatePolicyTag() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_CreatePolicyTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePolicyTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreatePolicyTagRequest* /*request*/, ::google::cloud::datacatalog::v1::PolicyTag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreatePolicyTag(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeletePolicyTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeletePolicyTag() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_DeletePolicyTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePolicyTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeletePolicyTagRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeletePolicyTag(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdatePolicyTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdatePolicyTag() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_UpdatePolicyTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePolicyTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdatePolicyTagRequest* /*request*/, ::google::cloud::datacatalog::v1::PolicyTag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdatePolicyTag(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListPolicyTags : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListPolicyTags() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_ListPolicyTags() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPolicyTags(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ListPolicyTagsRequest* /*request*/, ::google::cloud::datacatalog::v1::ListPolicyTagsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPolicyTags(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetPolicyTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetPolicyTag() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_GetPolicyTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPolicyTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::GetPolicyTagRequest* /*request*/, ::google::cloud::datacatalog::v1::PolicyTag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetPolicyTag(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetIamPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSetIamPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTestIamPermissions(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateTaxonomy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateTaxonomy() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateTaxonomy(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateTaxonomy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTaxonomy(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateTaxonomyRequest* /*request*/, ::google::cloud::datacatalog::v1::Taxonomy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateTaxonomy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteTaxonomy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteTaxonomy() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteTaxonomy(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteTaxonomy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTaxonomy(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteTaxonomyRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteTaxonomy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateTaxonomy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateTaxonomy() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateTaxonomy(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateTaxonomy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTaxonomy(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateTaxonomyRequest* /*request*/, ::google::cloud::datacatalog::v1::Taxonomy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateTaxonomy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListTaxonomies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListTaxonomies() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListTaxonomies(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListTaxonomies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTaxonomies(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ListTaxonomiesRequest* /*request*/, ::google::cloud::datacatalog::v1::ListTaxonomiesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListTaxonomies(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetTaxonomy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetTaxonomy() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetTaxonomy(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetTaxonomy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTaxonomy(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::GetTaxonomyRequest* /*request*/, ::google::cloud::datacatalog::v1::Taxonomy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetTaxonomy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreatePolicyTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreatePolicyTag() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreatePolicyTag(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreatePolicyTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePolicyTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreatePolicyTagRequest* /*request*/, ::google::cloud::datacatalog::v1::PolicyTag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreatePolicyTag(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeletePolicyTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeletePolicyTag() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeletePolicyTag(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeletePolicyTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePolicyTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeletePolicyTagRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeletePolicyTag(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdatePolicyTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdatePolicyTag() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdatePolicyTag(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdatePolicyTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePolicyTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdatePolicyTagRequest* /*request*/, ::google::cloud::datacatalog::v1::PolicyTag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdatePolicyTag(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListPolicyTags : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListPolicyTags() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListPolicyTags(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListPolicyTags() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPolicyTags(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ListPolicyTagsRequest* /*request*/, ::google::cloud::datacatalog::v1::ListPolicyTagsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPolicyTags(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetPolicyTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetPolicyTag() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetPolicyTag(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetPolicyTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPolicyTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::GetPolicyTagRequest* /*request*/, ::google::cloud::datacatalog::v1::PolicyTag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetPolicyTag(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetIamPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetIamPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SetIamPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SetIamPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->TestIamPermissions(context, request, response); }));
    }
    ~WithRawCallbackMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* TestIamPermissions(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateTaxonomy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateTaxonomy() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::CreateTaxonomyRequest, ::google::cloud::datacatalog::v1::Taxonomy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::CreateTaxonomyRequest, ::google::cloud::datacatalog::v1::Taxonomy>* streamer) {
                       return this->StreamedCreateTaxonomy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateTaxonomy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateTaxonomy(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateTaxonomyRequest* /*request*/, ::google::cloud::datacatalog::v1::Taxonomy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateTaxonomy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::CreateTaxonomyRequest,::google::cloud::datacatalog::v1::Taxonomy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteTaxonomy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteTaxonomy() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::DeleteTaxonomyRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::DeleteTaxonomyRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteTaxonomy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteTaxonomy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteTaxonomy(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteTaxonomyRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteTaxonomy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::DeleteTaxonomyRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateTaxonomy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateTaxonomy() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::UpdateTaxonomyRequest, ::google::cloud::datacatalog::v1::Taxonomy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::UpdateTaxonomyRequest, ::google::cloud::datacatalog::v1::Taxonomy>* streamer) {
                       return this->StreamedUpdateTaxonomy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateTaxonomy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateTaxonomy(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateTaxonomyRequest* /*request*/, ::google::cloud::datacatalog::v1::Taxonomy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateTaxonomy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::UpdateTaxonomyRequest,::google::cloud::datacatalog::v1::Taxonomy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListTaxonomies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListTaxonomies() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::ListTaxonomiesRequest, ::google::cloud::datacatalog::v1::ListTaxonomiesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::ListTaxonomiesRequest, ::google::cloud::datacatalog::v1::ListTaxonomiesResponse>* streamer) {
                       return this->StreamedListTaxonomies(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListTaxonomies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListTaxonomies(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ListTaxonomiesRequest* /*request*/, ::google::cloud::datacatalog::v1::ListTaxonomiesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListTaxonomies(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::ListTaxonomiesRequest,::google::cloud::datacatalog::v1::ListTaxonomiesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetTaxonomy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetTaxonomy() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::GetTaxonomyRequest, ::google::cloud::datacatalog::v1::Taxonomy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::GetTaxonomyRequest, ::google::cloud::datacatalog::v1::Taxonomy>* streamer) {
                       return this->StreamedGetTaxonomy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetTaxonomy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetTaxonomy(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::GetTaxonomyRequest* /*request*/, ::google::cloud::datacatalog::v1::Taxonomy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetTaxonomy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::GetTaxonomyRequest,::google::cloud::datacatalog::v1::Taxonomy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreatePolicyTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreatePolicyTag() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::CreatePolicyTagRequest, ::google::cloud::datacatalog::v1::PolicyTag>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::CreatePolicyTagRequest, ::google::cloud::datacatalog::v1::PolicyTag>* streamer) {
                       return this->StreamedCreatePolicyTag(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreatePolicyTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreatePolicyTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreatePolicyTagRequest* /*request*/, ::google::cloud::datacatalog::v1::PolicyTag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreatePolicyTag(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::CreatePolicyTagRequest,::google::cloud::datacatalog::v1::PolicyTag>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeletePolicyTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeletePolicyTag() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::DeletePolicyTagRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::DeletePolicyTagRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeletePolicyTag(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeletePolicyTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeletePolicyTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeletePolicyTagRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeletePolicyTag(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::DeletePolicyTagRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdatePolicyTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdatePolicyTag() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::UpdatePolicyTagRequest, ::google::cloud::datacatalog::v1::PolicyTag>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::UpdatePolicyTagRequest, ::google::cloud::datacatalog::v1::PolicyTag>* streamer) {
                       return this->StreamedUpdatePolicyTag(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdatePolicyTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdatePolicyTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdatePolicyTagRequest* /*request*/, ::google::cloud::datacatalog::v1::PolicyTag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdatePolicyTag(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::UpdatePolicyTagRequest,::google::cloud::datacatalog::v1::PolicyTag>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListPolicyTags : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListPolicyTags() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::ListPolicyTagsRequest, ::google::cloud::datacatalog::v1::ListPolicyTagsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::ListPolicyTagsRequest, ::google::cloud::datacatalog::v1::ListPolicyTagsResponse>* streamer) {
                       return this->StreamedListPolicyTags(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListPolicyTags() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListPolicyTags(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ListPolicyTagsRequest* /*request*/, ::google::cloud::datacatalog::v1::ListPolicyTagsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListPolicyTags(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::ListPolicyTagsRequest,::google::cloud::datacatalog::v1::ListPolicyTagsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetPolicyTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetPolicyTag() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::GetPolicyTagRequest, ::google::cloud::datacatalog::v1::PolicyTag>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::GetPolicyTagRequest, ::google::cloud::datacatalog::v1::PolicyTag>* streamer) {
                       return this->StreamedGetPolicyTag(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetPolicyTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetPolicyTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::GetPolicyTagRequest* /*request*/, ::google::cloud::datacatalog::v1::PolicyTag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetPolicyTag(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::GetPolicyTagRequest,::google::cloud::datacatalog::v1::PolicyTag>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>* streamer) {
                       return this->StreamedGetIamPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetIamPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::iam::v1::GetIamPolicyRequest,::google::iam::v1::Policy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>* streamer) {
                       return this->StreamedSetIamPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSetIamPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::iam::v1::SetIamPolicyRequest,::google::iam::v1::Policy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>* streamer) {
                       return this->StreamedTestIamPermissions(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedTestIamPermissions(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::iam::v1::TestIamPermissionsRequest,::google::iam::v1::TestIamPermissionsResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CreateTaxonomy<WithStreamedUnaryMethod_DeleteTaxonomy<WithStreamedUnaryMethod_UpdateTaxonomy<WithStreamedUnaryMethod_ListTaxonomies<WithStreamedUnaryMethod_GetTaxonomy<WithStreamedUnaryMethod_CreatePolicyTag<WithStreamedUnaryMethod_DeletePolicyTag<WithStreamedUnaryMethod_UpdatePolicyTag<WithStreamedUnaryMethod_ListPolicyTags<WithStreamedUnaryMethod_GetPolicyTag<WithStreamedUnaryMethod_GetIamPolicy<WithStreamedUnaryMethod_SetIamPolicy<WithStreamedUnaryMethod_TestIamPermissions<Service > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CreateTaxonomy<WithStreamedUnaryMethod_DeleteTaxonomy<WithStreamedUnaryMethod_UpdateTaxonomy<WithStreamedUnaryMethod_ListTaxonomies<WithStreamedUnaryMethod_GetTaxonomy<WithStreamedUnaryMethod_CreatePolicyTag<WithStreamedUnaryMethod_DeletePolicyTag<WithStreamedUnaryMethod_UpdatePolicyTag<WithStreamedUnaryMethod_ListPolicyTags<WithStreamedUnaryMethod_GetPolicyTag<WithStreamedUnaryMethod_GetIamPolicy<WithStreamedUnaryMethod_SetIamPolicy<WithStreamedUnaryMethod_TestIamPermissions<Service > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace datacatalog
}  // namespace cloud
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fcloud_2fdatacatalog_2fv1_2fpolicytagmanager_2eproto__INCLUDED
