// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/dialogflow/v2/encryption_spec.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fdialogflow_2fv2_2fencryption_5fspec_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fdialogflow_2fv2_2fencryption_5fspec_2eproto__INCLUDED

#include "google/cloud/dialogflow/v2/encryption_spec.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace cloud {
namespace dialogflow {
namespace v2 {

// Manages encryption spec settings for Dialogflow and Agent Assist.
class EncryptionSpecService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.dialogflow.v2.EncryptionSpecService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Gets location-level encryption key specification.
    virtual ::grpc::Status GetEncryptionSpec(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetEncryptionSpecRequest& request, ::google::cloud::dialogflow::v2::EncryptionSpec* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::EncryptionSpec>> AsyncGetEncryptionSpec(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetEncryptionSpecRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::EncryptionSpec>>(AsyncGetEncryptionSpecRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::EncryptionSpec>> PrepareAsyncGetEncryptionSpec(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetEncryptionSpecRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::EncryptionSpec>>(PrepareAsyncGetEncryptionSpecRaw(context, request, cq));
    }
    // Initializes a location-level encryption key specification.  An error will
    // be thrown if the location has resources already created before the
    // initialization. Once the encryption specification is initialized at a
    // location, it is immutable and all newly created resources under the
    // location will be encrypted with the existing specification.
    virtual ::grpc::Status InitializeEncryptionSpec(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::InitializeEncryptionSpecRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncInitializeEncryptionSpec(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::InitializeEncryptionSpecRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncInitializeEncryptionSpecRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncInitializeEncryptionSpec(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::InitializeEncryptionSpecRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncInitializeEncryptionSpecRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Gets location-level encryption key specification.
      virtual void GetEncryptionSpec(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetEncryptionSpecRequest* request, ::google::cloud::dialogflow::v2::EncryptionSpec* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetEncryptionSpec(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetEncryptionSpecRequest* request, ::google::cloud::dialogflow::v2::EncryptionSpec* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Initializes a location-level encryption key specification.  An error will
      // be thrown if the location has resources already created before the
      // initialization. Once the encryption specification is initialized at a
      // location, it is immutable and all newly created resources under the
      // location will be encrypted with the existing specification.
      virtual void InitializeEncryptionSpec(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::InitializeEncryptionSpecRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void InitializeEncryptionSpec(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::InitializeEncryptionSpecRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::EncryptionSpec>* AsyncGetEncryptionSpecRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetEncryptionSpecRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::EncryptionSpec>* PrepareAsyncGetEncryptionSpecRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetEncryptionSpecRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncInitializeEncryptionSpecRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::InitializeEncryptionSpecRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncInitializeEncryptionSpecRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::InitializeEncryptionSpecRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status GetEncryptionSpec(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetEncryptionSpecRequest& request, ::google::cloud::dialogflow::v2::EncryptionSpec* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::EncryptionSpec>> AsyncGetEncryptionSpec(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetEncryptionSpecRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::EncryptionSpec>>(AsyncGetEncryptionSpecRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::EncryptionSpec>> PrepareAsyncGetEncryptionSpec(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetEncryptionSpecRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::EncryptionSpec>>(PrepareAsyncGetEncryptionSpecRaw(context, request, cq));
    }
    ::grpc::Status InitializeEncryptionSpec(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::InitializeEncryptionSpecRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncInitializeEncryptionSpec(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::InitializeEncryptionSpecRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncInitializeEncryptionSpecRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncInitializeEncryptionSpec(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::InitializeEncryptionSpecRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncInitializeEncryptionSpecRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void GetEncryptionSpec(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetEncryptionSpecRequest* request, ::google::cloud::dialogflow::v2::EncryptionSpec* response, std::function<void(::grpc::Status)>) override;
      void GetEncryptionSpec(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetEncryptionSpecRequest* request, ::google::cloud::dialogflow::v2::EncryptionSpec* response, ::grpc::ClientUnaryReactor* reactor) override;
      void InitializeEncryptionSpec(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::InitializeEncryptionSpecRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void InitializeEncryptionSpec(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::InitializeEncryptionSpecRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::EncryptionSpec>* AsyncGetEncryptionSpecRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetEncryptionSpecRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::EncryptionSpec>* PrepareAsyncGetEncryptionSpecRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetEncryptionSpecRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncInitializeEncryptionSpecRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::InitializeEncryptionSpecRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncInitializeEncryptionSpecRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::InitializeEncryptionSpecRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_GetEncryptionSpec_;
    const ::grpc::internal::RpcMethod rpcmethod_InitializeEncryptionSpec_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Gets location-level encryption key specification.
    virtual ::grpc::Status GetEncryptionSpec(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2::GetEncryptionSpecRequest* request, ::google::cloud::dialogflow::v2::EncryptionSpec* response);
    // Initializes a location-level encryption key specification.  An error will
    // be thrown if the location has resources already created before the
    // initialization. Once the encryption specification is initialized at a
    // location, it is immutable and all newly created resources under the
    // location will be encrypted with the existing specification.
    virtual ::grpc::Status InitializeEncryptionSpec(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2::InitializeEncryptionSpecRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_GetEncryptionSpec : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetEncryptionSpec() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_GetEncryptionSpec() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEncryptionSpec(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::GetEncryptionSpecRequest* /*request*/, ::google::cloud::dialogflow::v2::EncryptionSpec* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetEncryptionSpec(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2::GetEncryptionSpecRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dialogflow::v2::EncryptionSpec>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_InitializeEncryptionSpec : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_InitializeEncryptionSpec() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_InitializeEncryptionSpec() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InitializeEncryptionSpec(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::InitializeEncryptionSpecRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestInitializeEncryptionSpec(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2::InitializeEncryptionSpecRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_GetEncryptionSpec<WithAsyncMethod_InitializeEncryptionSpec<Service > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_GetEncryptionSpec : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetEncryptionSpec() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::GetEncryptionSpecRequest, ::google::cloud::dialogflow::v2::EncryptionSpec>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dialogflow::v2::GetEncryptionSpecRequest* request, ::google::cloud::dialogflow::v2::EncryptionSpec* response) { return this->GetEncryptionSpec(context, request, response); }));}
    void SetMessageAllocatorFor_GetEncryptionSpec(
        ::grpc::MessageAllocator< ::google::cloud::dialogflow::v2::GetEncryptionSpecRequest, ::google::cloud::dialogflow::v2::EncryptionSpec>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::GetEncryptionSpecRequest, ::google::cloud::dialogflow::v2::EncryptionSpec>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetEncryptionSpec() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEncryptionSpec(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::GetEncryptionSpecRequest* /*request*/, ::google::cloud::dialogflow::v2::EncryptionSpec* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetEncryptionSpec(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dialogflow::v2::GetEncryptionSpecRequest* /*request*/, ::google::cloud::dialogflow::v2::EncryptionSpec* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_InitializeEncryptionSpec : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_InitializeEncryptionSpec() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::InitializeEncryptionSpecRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dialogflow::v2::InitializeEncryptionSpecRequest* request, ::google::longrunning::Operation* response) { return this->InitializeEncryptionSpec(context, request, response); }));}
    void SetMessageAllocatorFor_InitializeEncryptionSpec(
        ::grpc::MessageAllocator< ::google::cloud::dialogflow::v2::InitializeEncryptionSpecRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::InitializeEncryptionSpecRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_InitializeEncryptionSpec() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InitializeEncryptionSpec(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::InitializeEncryptionSpecRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* InitializeEncryptionSpec(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dialogflow::v2::InitializeEncryptionSpecRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_GetEncryptionSpec<WithCallbackMethod_InitializeEncryptionSpec<Service > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_GetEncryptionSpec : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetEncryptionSpec() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_GetEncryptionSpec() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEncryptionSpec(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::GetEncryptionSpecRequest* /*request*/, ::google::cloud::dialogflow::v2::EncryptionSpec* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_InitializeEncryptionSpec : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_InitializeEncryptionSpec() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_InitializeEncryptionSpec() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InitializeEncryptionSpec(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::InitializeEncryptionSpecRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetEncryptionSpec : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetEncryptionSpec() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_GetEncryptionSpec() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEncryptionSpec(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::GetEncryptionSpecRequest* /*request*/, ::google::cloud::dialogflow::v2::EncryptionSpec* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetEncryptionSpec(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_InitializeEncryptionSpec : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_InitializeEncryptionSpec() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_InitializeEncryptionSpec() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InitializeEncryptionSpec(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::InitializeEncryptionSpecRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestInitializeEncryptionSpec(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetEncryptionSpec : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetEncryptionSpec() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetEncryptionSpec(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetEncryptionSpec() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEncryptionSpec(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::GetEncryptionSpecRequest* /*request*/, ::google::cloud::dialogflow::v2::EncryptionSpec* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetEncryptionSpec(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_InitializeEncryptionSpec : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_InitializeEncryptionSpec() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->InitializeEncryptionSpec(context, request, response); }));
    }
    ~WithRawCallbackMethod_InitializeEncryptionSpec() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InitializeEncryptionSpec(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::InitializeEncryptionSpecRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* InitializeEncryptionSpec(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetEncryptionSpec : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetEncryptionSpec() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dialogflow::v2::GetEncryptionSpecRequest, ::google::cloud::dialogflow::v2::EncryptionSpec>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dialogflow::v2::GetEncryptionSpecRequest, ::google::cloud::dialogflow::v2::EncryptionSpec>* streamer) {
                       return this->StreamedGetEncryptionSpec(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetEncryptionSpec() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetEncryptionSpec(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::GetEncryptionSpecRequest* /*request*/, ::google::cloud::dialogflow::v2::EncryptionSpec* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetEncryptionSpec(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2::GetEncryptionSpecRequest,::google::cloud::dialogflow::v2::EncryptionSpec>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_InitializeEncryptionSpec : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_InitializeEncryptionSpec() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dialogflow::v2::InitializeEncryptionSpecRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dialogflow::v2::InitializeEncryptionSpecRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedInitializeEncryptionSpec(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_InitializeEncryptionSpec() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status InitializeEncryptionSpec(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::InitializeEncryptionSpecRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedInitializeEncryptionSpec(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2::InitializeEncryptionSpecRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_GetEncryptionSpec<WithStreamedUnaryMethod_InitializeEncryptionSpec<Service > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_GetEncryptionSpec<WithStreamedUnaryMethod_InitializeEncryptionSpec<Service > > StreamedService;
};

}  // namespace v2
}  // namespace dialogflow
}  // namespace cloud
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fcloud_2fdialogflow_2fv2_2fencryption_5fspec_2eproto__INCLUDED
