// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/securesourcemanager/v1/secure_source_manager.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fsecuresourcemanager_2fv1_2fsecure_5fsource_5fmanager_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fsecuresourcemanager_2fv1_2fsecure_5fsource_5fmanager_2eproto__INCLUDED

#include "google/cloud/securesourcemanager/v1/secure_source_manager.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace cloud {
namespace securesourcemanager {
namespace v1 {

// Secure Source Manager API
//
// Access Secure Source Manager instances, resources, and repositories.
//
// This API is split across two servers: the Control Plane and the Data Plane.
//
// Data Plane endpoints are hosted directly by your Secure Source Manager
// instance, so you must connect to your instance's API hostname to access
// them. The API hostname looks like the following:
//
//    https://[instance-id]-[project-number]-api.[location].sourcemanager.dev
//
// For example,
//
//    https://my-instance-702770452863-api.us-central1.sourcemanager.dev
//
// Data Plane endpoints are denoted with **Host: Data Plane**.
//
// All other endpoints are found in the normal Cloud API location, namely,
// `securcesourcemanager.googleapis.com`.
class SecureSourceManager final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.securesourcemanager.v1.SecureSourceManager";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists Instances in a given project and location.
    virtual ::grpc::Status ListInstances(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListInstancesRequest& request, ::google::cloud::securesourcemanager::v1::ListInstancesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::securesourcemanager::v1::ListInstancesResponse>> AsyncListInstances(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::securesourcemanager::v1::ListInstancesResponse>>(AsyncListInstancesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::securesourcemanager::v1::ListInstancesResponse>> PrepareAsyncListInstances(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::securesourcemanager::v1::ListInstancesResponse>>(PrepareAsyncListInstancesRaw(context, request, cq));
    }
    // Gets details of a single instance.
    virtual ::grpc::Status GetInstance(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetInstanceRequest& request, ::google::cloud::securesourcemanager::v1::Instance* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::securesourcemanager::v1::Instance>> AsyncGetInstance(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::securesourcemanager::v1::Instance>>(AsyncGetInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::securesourcemanager::v1::Instance>> PrepareAsyncGetInstance(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::securesourcemanager::v1::Instance>>(PrepareAsyncGetInstanceRaw(context, request, cq));
    }
    // Creates a new instance in a given project and location.
    virtual ::grpc::Status CreateInstance(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateInstanceRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateInstance(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateInstance(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateInstanceRaw(context, request, cq));
    }
    // Deletes a single instance.
    virtual ::grpc::Status DeleteInstance(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteInstanceRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteInstance(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteInstance(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteInstanceRaw(context, request, cq));
    }
    // Lists Repositories in a given project and location.
    //
    // **Host: Data Plane**
    virtual ::grpc::Status ListRepositories(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListRepositoriesRequest& request, ::google::cloud::securesourcemanager::v1::ListRepositoriesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::securesourcemanager::v1::ListRepositoriesResponse>> AsyncListRepositories(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListRepositoriesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::securesourcemanager::v1::ListRepositoriesResponse>>(AsyncListRepositoriesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::securesourcemanager::v1::ListRepositoriesResponse>> PrepareAsyncListRepositories(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListRepositoriesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::securesourcemanager::v1::ListRepositoriesResponse>>(PrepareAsyncListRepositoriesRaw(context, request, cq));
    }
    // Gets metadata of a repository.
    //
    // **Host: Data Plane**
    virtual ::grpc::Status GetRepository(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetRepositoryRequest& request, ::google::cloud::securesourcemanager::v1::Repository* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::securesourcemanager::v1::Repository>> AsyncGetRepository(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetRepositoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::securesourcemanager::v1::Repository>>(AsyncGetRepositoryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::securesourcemanager::v1::Repository>> PrepareAsyncGetRepository(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetRepositoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::securesourcemanager::v1::Repository>>(PrepareAsyncGetRepositoryRaw(context, request, cq));
    }
    // Creates a new repository in a given project and location.
    //
    // **Host: Data Plane**
    virtual ::grpc::Status CreateRepository(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateRepositoryRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateRepository(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateRepositoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateRepositoryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateRepository(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateRepositoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateRepositoryRaw(context, request, cq));
    }
    // Deletes a Repository.
    //
    // **Host: Data Plane**
    virtual ::grpc::Status DeleteRepository(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteRepositoryRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteRepository(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteRepositoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteRepositoryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteRepository(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteRepositoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteRepositoryRaw(context, request, cq));
    }
    // Get IAM policy for a repository.
    virtual ::grpc::Status GetIamPolicyRepo(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::google::iam::v1::Policy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> AsyncGetIamPolicyRepo(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(AsyncGetIamPolicyRepoRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> PrepareAsyncGetIamPolicyRepo(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(PrepareAsyncGetIamPolicyRepoRaw(context, request, cq));
    }
    // Set IAM policy on a repository.
    virtual ::grpc::Status SetIamPolicyRepo(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::google::iam::v1::Policy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> AsyncSetIamPolicyRepo(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(AsyncSetIamPolicyRepoRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> PrepareAsyncSetIamPolicyRepo(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(PrepareAsyncSetIamPolicyRepoRaw(context, request, cq));
    }
    // Test IAM permissions on a repository.
    // IAM permission checks are not required on this method.
    virtual ::grpc::Status TestIamPermissionsRepo(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::google::iam::v1::TestIamPermissionsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>> AsyncTestIamPermissionsRepo(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>>(AsyncTestIamPermissionsRepoRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>> PrepareAsyncTestIamPermissionsRepo(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>>(PrepareAsyncTestIamPermissionsRepoRaw(context, request, cq));
    }
    // CreateBranchRule creates a branch rule in a given repository.
    virtual ::grpc::Status CreateBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateBranchRuleRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateBranchRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateBranchRuleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateBranchRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateBranchRuleRaw(context, request, cq));
    }
    // ListBranchRules lists branch rules in a given repository.
    virtual ::grpc::Status ListBranchRules(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListBranchRulesRequest& request, ::google::cloud::securesourcemanager::v1::ListBranchRulesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::securesourcemanager::v1::ListBranchRulesResponse>> AsyncListBranchRules(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListBranchRulesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::securesourcemanager::v1::ListBranchRulesResponse>>(AsyncListBranchRulesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::securesourcemanager::v1::ListBranchRulesResponse>> PrepareAsyncListBranchRules(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListBranchRulesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::securesourcemanager::v1::ListBranchRulesResponse>>(PrepareAsyncListBranchRulesRaw(context, request, cq));
    }
    // GetBranchRule gets a branch rule.
    virtual ::grpc::Status GetBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetBranchRuleRequest& request, ::google::cloud::securesourcemanager::v1::BranchRule* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::securesourcemanager::v1::BranchRule>> AsyncGetBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetBranchRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::securesourcemanager::v1::BranchRule>>(AsyncGetBranchRuleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::securesourcemanager::v1::BranchRule>> PrepareAsyncGetBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetBranchRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::securesourcemanager::v1::BranchRule>>(PrepareAsyncGetBranchRuleRaw(context, request, cq));
    }
    // UpdateBranchRule updates a branch rule.
    virtual ::grpc::Status UpdateBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::UpdateBranchRuleRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::UpdateBranchRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateBranchRuleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::UpdateBranchRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateBranchRuleRaw(context, request, cq));
    }
    // DeleteBranchRule deletes a branch rule.
    virtual ::grpc::Status DeleteBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteBranchRuleRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteBranchRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteBranchRuleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteBranchRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteBranchRuleRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists Instances in a given project and location.
      virtual void ListInstances(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListInstancesRequest* request, ::google::cloud::securesourcemanager::v1::ListInstancesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListInstances(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListInstancesRequest* request, ::google::cloud::securesourcemanager::v1::ListInstancesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single instance.
      virtual void GetInstance(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetInstanceRequest* request, ::google::cloud::securesourcemanager::v1::Instance* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetInstance(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetInstanceRequest* request, ::google::cloud::securesourcemanager::v1::Instance* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new instance in a given project and location.
      virtual void CreateInstance(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateInstance(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a single instance.
      virtual void DeleteInstance(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteInstance(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists Repositories in a given project and location.
      //
      // **Host: Data Plane**
      virtual void ListRepositories(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListRepositoriesRequest* request, ::google::cloud::securesourcemanager::v1::ListRepositoriesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListRepositories(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListRepositoriesRequest* request, ::google::cloud::securesourcemanager::v1::ListRepositoriesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets metadata of a repository.
      //
      // **Host: Data Plane**
      virtual void GetRepository(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetRepositoryRequest* request, ::google::cloud::securesourcemanager::v1::Repository* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetRepository(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetRepositoryRequest* request, ::google::cloud::securesourcemanager::v1::Repository* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new repository in a given project and location.
      //
      // **Host: Data Plane**
      virtual void CreateRepository(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateRepositoryRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateRepository(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateRepositoryRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a Repository.
      //
      // **Host: Data Plane**
      virtual void DeleteRepository(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteRepositoryRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteRepository(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteRepositoryRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Get IAM policy for a repository.
      virtual void GetIamPolicyRepo(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetIamPolicyRepo(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Set IAM policy on a repository.
      virtual void SetIamPolicyRepo(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SetIamPolicyRepo(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Test IAM permissions on a repository.
      // IAM permission checks are not required on this method.
      virtual void TestIamPermissionsRepo(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void TestIamPermissionsRepo(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // CreateBranchRule creates a branch rule in a given repository.
      virtual void CreateBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateBranchRuleRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateBranchRuleRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // ListBranchRules lists branch rules in a given repository.
      virtual void ListBranchRules(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListBranchRulesRequest* request, ::google::cloud::securesourcemanager::v1::ListBranchRulesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListBranchRules(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListBranchRulesRequest* request, ::google::cloud::securesourcemanager::v1::ListBranchRulesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // GetBranchRule gets a branch rule.
      virtual void GetBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetBranchRuleRequest* request, ::google::cloud::securesourcemanager::v1::BranchRule* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetBranchRuleRequest* request, ::google::cloud::securesourcemanager::v1::BranchRule* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // UpdateBranchRule updates a branch rule.
      virtual void UpdateBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::UpdateBranchRuleRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::UpdateBranchRuleRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // DeleteBranchRule deletes a branch rule.
      virtual void DeleteBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteBranchRuleRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteBranchRuleRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::securesourcemanager::v1::ListInstancesResponse>* AsyncListInstancesRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::securesourcemanager::v1::ListInstancesResponse>* PrepareAsyncListInstancesRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::securesourcemanager::v1::Instance>* AsyncGetInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::securesourcemanager::v1::Instance>* PrepareAsyncGetInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::securesourcemanager::v1::ListRepositoriesResponse>* AsyncListRepositoriesRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListRepositoriesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::securesourcemanager::v1::ListRepositoriesResponse>* PrepareAsyncListRepositoriesRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListRepositoriesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::securesourcemanager::v1::Repository>* AsyncGetRepositoryRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetRepositoryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::securesourcemanager::v1::Repository>* PrepareAsyncGetRepositoryRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetRepositoryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateRepositoryRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateRepositoryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateRepositoryRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateRepositoryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteRepositoryRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteRepositoryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteRepositoryRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteRepositoryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* AsyncGetIamPolicyRepoRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* PrepareAsyncGetIamPolicyRepoRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* AsyncSetIamPolicyRepoRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* PrepareAsyncSetIamPolicyRepoRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>* AsyncTestIamPermissionsRepoRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>* PrepareAsyncTestIamPermissionsRepoRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateBranchRuleRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateBranchRuleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateBranchRuleRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateBranchRuleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::securesourcemanager::v1::ListBranchRulesResponse>* AsyncListBranchRulesRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListBranchRulesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::securesourcemanager::v1::ListBranchRulesResponse>* PrepareAsyncListBranchRulesRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListBranchRulesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::securesourcemanager::v1::BranchRule>* AsyncGetBranchRuleRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetBranchRuleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::securesourcemanager::v1::BranchRule>* PrepareAsyncGetBranchRuleRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetBranchRuleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateBranchRuleRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::UpdateBranchRuleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateBranchRuleRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::UpdateBranchRuleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteBranchRuleRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteBranchRuleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteBranchRuleRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteBranchRuleRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListInstances(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListInstancesRequest& request, ::google::cloud::securesourcemanager::v1::ListInstancesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::securesourcemanager::v1::ListInstancesResponse>> AsyncListInstances(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::securesourcemanager::v1::ListInstancesResponse>>(AsyncListInstancesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::securesourcemanager::v1::ListInstancesResponse>> PrepareAsyncListInstances(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::securesourcemanager::v1::ListInstancesResponse>>(PrepareAsyncListInstancesRaw(context, request, cq));
    }
    ::grpc::Status GetInstance(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetInstanceRequest& request, ::google::cloud::securesourcemanager::v1::Instance* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::securesourcemanager::v1::Instance>> AsyncGetInstance(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::securesourcemanager::v1::Instance>>(AsyncGetInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::securesourcemanager::v1::Instance>> PrepareAsyncGetInstance(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::securesourcemanager::v1::Instance>>(PrepareAsyncGetInstanceRaw(context, request, cq));
    }
    ::grpc::Status CreateInstance(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateInstanceRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateInstance(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateInstance(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateInstanceRaw(context, request, cq));
    }
    ::grpc::Status DeleteInstance(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteInstanceRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteInstance(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteInstance(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteInstanceRaw(context, request, cq));
    }
    ::grpc::Status ListRepositories(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListRepositoriesRequest& request, ::google::cloud::securesourcemanager::v1::ListRepositoriesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::securesourcemanager::v1::ListRepositoriesResponse>> AsyncListRepositories(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListRepositoriesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::securesourcemanager::v1::ListRepositoriesResponse>>(AsyncListRepositoriesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::securesourcemanager::v1::ListRepositoriesResponse>> PrepareAsyncListRepositories(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListRepositoriesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::securesourcemanager::v1::ListRepositoriesResponse>>(PrepareAsyncListRepositoriesRaw(context, request, cq));
    }
    ::grpc::Status GetRepository(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetRepositoryRequest& request, ::google::cloud::securesourcemanager::v1::Repository* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::securesourcemanager::v1::Repository>> AsyncGetRepository(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetRepositoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::securesourcemanager::v1::Repository>>(AsyncGetRepositoryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::securesourcemanager::v1::Repository>> PrepareAsyncGetRepository(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetRepositoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::securesourcemanager::v1::Repository>>(PrepareAsyncGetRepositoryRaw(context, request, cq));
    }
    ::grpc::Status CreateRepository(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateRepositoryRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateRepository(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateRepositoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateRepositoryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateRepository(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateRepositoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateRepositoryRaw(context, request, cq));
    }
    ::grpc::Status DeleteRepository(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteRepositoryRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteRepository(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteRepositoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteRepositoryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteRepository(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteRepositoryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteRepositoryRaw(context, request, cq));
    }
    ::grpc::Status GetIamPolicyRepo(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::google::iam::v1::Policy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> AsyncGetIamPolicyRepo(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(AsyncGetIamPolicyRepoRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> PrepareAsyncGetIamPolicyRepo(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(PrepareAsyncGetIamPolicyRepoRaw(context, request, cq));
    }
    ::grpc::Status SetIamPolicyRepo(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::google::iam::v1::Policy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> AsyncSetIamPolicyRepo(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(AsyncSetIamPolicyRepoRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> PrepareAsyncSetIamPolicyRepo(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(PrepareAsyncSetIamPolicyRepoRaw(context, request, cq));
    }
    ::grpc::Status TestIamPermissionsRepo(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::google::iam::v1::TestIamPermissionsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>> AsyncTestIamPermissionsRepo(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>>(AsyncTestIamPermissionsRepoRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>> PrepareAsyncTestIamPermissionsRepo(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>>(PrepareAsyncTestIamPermissionsRepoRaw(context, request, cq));
    }
    ::grpc::Status CreateBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateBranchRuleRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateBranchRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateBranchRuleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateBranchRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateBranchRuleRaw(context, request, cq));
    }
    ::grpc::Status ListBranchRules(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListBranchRulesRequest& request, ::google::cloud::securesourcemanager::v1::ListBranchRulesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::securesourcemanager::v1::ListBranchRulesResponse>> AsyncListBranchRules(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListBranchRulesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::securesourcemanager::v1::ListBranchRulesResponse>>(AsyncListBranchRulesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::securesourcemanager::v1::ListBranchRulesResponse>> PrepareAsyncListBranchRules(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListBranchRulesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::securesourcemanager::v1::ListBranchRulesResponse>>(PrepareAsyncListBranchRulesRaw(context, request, cq));
    }
    ::grpc::Status GetBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetBranchRuleRequest& request, ::google::cloud::securesourcemanager::v1::BranchRule* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::securesourcemanager::v1::BranchRule>> AsyncGetBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetBranchRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::securesourcemanager::v1::BranchRule>>(AsyncGetBranchRuleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::securesourcemanager::v1::BranchRule>> PrepareAsyncGetBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetBranchRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::securesourcemanager::v1::BranchRule>>(PrepareAsyncGetBranchRuleRaw(context, request, cq));
    }
    ::grpc::Status UpdateBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::UpdateBranchRuleRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::UpdateBranchRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateBranchRuleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::UpdateBranchRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateBranchRuleRaw(context, request, cq));
    }
    ::grpc::Status DeleteBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteBranchRuleRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteBranchRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteBranchRuleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteBranchRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteBranchRuleRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListInstances(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListInstancesRequest* request, ::google::cloud::securesourcemanager::v1::ListInstancesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListInstances(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListInstancesRequest* request, ::google::cloud::securesourcemanager::v1::ListInstancesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetInstance(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetInstanceRequest* request, ::google::cloud::securesourcemanager::v1::Instance* response, std::function<void(::grpc::Status)>) override;
      void GetInstance(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetInstanceRequest* request, ::google::cloud::securesourcemanager::v1::Instance* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateInstance(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateInstance(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteInstance(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteInstance(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListRepositories(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListRepositoriesRequest* request, ::google::cloud::securesourcemanager::v1::ListRepositoriesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListRepositories(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListRepositoriesRequest* request, ::google::cloud::securesourcemanager::v1::ListRepositoriesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetRepository(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetRepositoryRequest* request, ::google::cloud::securesourcemanager::v1::Repository* response, std::function<void(::grpc::Status)>) override;
      void GetRepository(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetRepositoryRequest* request, ::google::cloud::securesourcemanager::v1::Repository* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateRepository(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateRepositoryRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateRepository(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateRepositoryRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteRepository(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteRepositoryRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteRepository(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteRepositoryRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetIamPolicyRepo(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) override;
      void GetIamPolicyRepo(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) override;
      void SetIamPolicyRepo(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) override;
      void SetIamPolicyRepo(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) override;
      void TestIamPermissionsRepo(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, std::function<void(::grpc::Status)>) override;
      void TestIamPermissionsRepo(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateBranchRuleRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateBranchRuleRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListBranchRules(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListBranchRulesRequest* request, ::google::cloud::securesourcemanager::v1::ListBranchRulesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListBranchRules(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListBranchRulesRequest* request, ::google::cloud::securesourcemanager::v1::ListBranchRulesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetBranchRuleRequest* request, ::google::cloud::securesourcemanager::v1::BranchRule* response, std::function<void(::grpc::Status)>) override;
      void GetBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetBranchRuleRequest* request, ::google::cloud::securesourcemanager::v1::BranchRule* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::UpdateBranchRuleRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::UpdateBranchRuleRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteBranchRuleRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteBranchRule(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteBranchRuleRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::securesourcemanager::v1::ListInstancesResponse>* AsyncListInstancesRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::securesourcemanager::v1::ListInstancesResponse>* PrepareAsyncListInstancesRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::securesourcemanager::v1::Instance>* AsyncGetInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::securesourcemanager::v1::Instance>* PrepareAsyncGetInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::securesourcemanager::v1::ListRepositoriesResponse>* AsyncListRepositoriesRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListRepositoriesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::securesourcemanager::v1::ListRepositoriesResponse>* PrepareAsyncListRepositoriesRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListRepositoriesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::securesourcemanager::v1::Repository>* AsyncGetRepositoryRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetRepositoryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::securesourcemanager::v1::Repository>* PrepareAsyncGetRepositoryRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetRepositoryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateRepositoryRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateRepositoryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateRepositoryRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateRepositoryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteRepositoryRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteRepositoryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteRepositoryRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteRepositoryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* AsyncGetIamPolicyRepoRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* PrepareAsyncGetIamPolicyRepoRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* AsyncSetIamPolicyRepoRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* PrepareAsyncSetIamPolicyRepoRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>* AsyncTestIamPermissionsRepoRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>* PrepareAsyncTestIamPermissionsRepoRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateBranchRuleRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateBranchRuleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateBranchRuleRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::CreateBranchRuleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::securesourcemanager::v1::ListBranchRulesResponse>* AsyncListBranchRulesRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListBranchRulesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::securesourcemanager::v1::ListBranchRulesResponse>* PrepareAsyncListBranchRulesRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::ListBranchRulesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::securesourcemanager::v1::BranchRule>* AsyncGetBranchRuleRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetBranchRuleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::securesourcemanager::v1::BranchRule>* PrepareAsyncGetBranchRuleRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::GetBranchRuleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateBranchRuleRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::UpdateBranchRuleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateBranchRuleRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::UpdateBranchRuleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteBranchRuleRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteBranchRuleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteBranchRuleRaw(::grpc::ClientContext* context, const ::google::cloud::securesourcemanager::v1::DeleteBranchRuleRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListInstances_;
    const ::grpc::internal::RpcMethod rpcmethod_GetInstance_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateInstance_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteInstance_;
    const ::grpc::internal::RpcMethod rpcmethod_ListRepositories_;
    const ::grpc::internal::RpcMethod rpcmethod_GetRepository_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateRepository_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteRepository_;
    const ::grpc::internal::RpcMethod rpcmethod_GetIamPolicyRepo_;
    const ::grpc::internal::RpcMethod rpcmethod_SetIamPolicyRepo_;
    const ::grpc::internal::RpcMethod rpcmethod_TestIamPermissionsRepo_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateBranchRule_;
    const ::grpc::internal::RpcMethod rpcmethod_ListBranchRules_;
    const ::grpc::internal::RpcMethod rpcmethod_GetBranchRule_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateBranchRule_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteBranchRule_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists Instances in a given project and location.
    virtual ::grpc::Status ListInstances(::grpc::ServerContext* context, const ::google::cloud::securesourcemanager::v1::ListInstancesRequest* request, ::google::cloud::securesourcemanager::v1::ListInstancesResponse* response);
    // Gets details of a single instance.
    virtual ::grpc::Status GetInstance(::grpc::ServerContext* context, const ::google::cloud::securesourcemanager::v1::GetInstanceRequest* request, ::google::cloud::securesourcemanager::v1::Instance* response);
    // Creates a new instance in a given project and location.
    virtual ::grpc::Status CreateInstance(::grpc::ServerContext* context, const ::google::cloud::securesourcemanager::v1::CreateInstanceRequest* request, ::google::longrunning::Operation* response);
    // Deletes a single instance.
    virtual ::grpc::Status DeleteInstance(::grpc::ServerContext* context, const ::google::cloud::securesourcemanager::v1::DeleteInstanceRequest* request, ::google::longrunning::Operation* response);
    // Lists Repositories in a given project and location.
    //
    // **Host: Data Plane**
    virtual ::grpc::Status ListRepositories(::grpc::ServerContext* context, const ::google::cloud::securesourcemanager::v1::ListRepositoriesRequest* request, ::google::cloud::securesourcemanager::v1::ListRepositoriesResponse* response);
    // Gets metadata of a repository.
    //
    // **Host: Data Plane**
    virtual ::grpc::Status GetRepository(::grpc::ServerContext* context, const ::google::cloud::securesourcemanager::v1::GetRepositoryRequest* request, ::google::cloud::securesourcemanager::v1::Repository* response);
    // Creates a new repository in a given project and location.
    //
    // **Host: Data Plane**
    virtual ::grpc::Status CreateRepository(::grpc::ServerContext* context, const ::google::cloud::securesourcemanager::v1::CreateRepositoryRequest* request, ::google::longrunning::Operation* response);
    // Deletes a Repository.
    //
    // **Host: Data Plane**
    virtual ::grpc::Status DeleteRepository(::grpc::ServerContext* context, const ::google::cloud::securesourcemanager::v1::DeleteRepositoryRequest* request, ::google::longrunning::Operation* response);
    // Get IAM policy for a repository.
    virtual ::grpc::Status GetIamPolicyRepo(::grpc::ServerContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response);
    // Set IAM policy on a repository.
    virtual ::grpc::Status SetIamPolicyRepo(::grpc::ServerContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response);
    // Test IAM permissions on a repository.
    // IAM permission checks are not required on this method.
    virtual ::grpc::Status TestIamPermissionsRepo(::grpc::ServerContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response);
    // CreateBranchRule creates a branch rule in a given repository.
    virtual ::grpc::Status CreateBranchRule(::grpc::ServerContext* context, const ::google::cloud::securesourcemanager::v1::CreateBranchRuleRequest* request, ::google::longrunning::Operation* response);
    // ListBranchRules lists branch rules in a given repository.
    virtual ::grpc::Status ListBranchRules(::grpc::ServerContext* context, const ::google::cloud::securesourcemanager::v1::ListBranchRulesRequest* request, ::google::cloud::securesourcemanager::v1::ListBranchRulesResponse* response);
    // GetBranchRule gets a branch rule.
    virtual ::grpc::Status GetBranchRule(::grpc::ServerContext* context, const ::google::cloud::securesourcemanager::v1::GetBranchRuleRequest* request, ::google::cloud::securesourcemanager::v1::BranchRule* response);
    // UpdateBranchRule updates a branch rule.
    virtual ::grpc::Status UpdateBranchRule(::grpc::ServerContext* context, const ::google::cloud::securesourcemanager::v1::UpdateBranchRuleRequest* request, ::google::longrunning::Operation* response);
    // DeleteBranchRule deletes a branch rule.
    virtual ::grpc::Status DeleteBranchRule(::grpc::ServerContext* context, const ::google::cloud::securesourcemanager::v1::DeleteBranchRuleRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListInstances : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListInstances() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListInstances() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstances(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::ListInstancesRequest* /*request*/, ::google::cloud::securesourcemanager::v1::ListInstancesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListInstances(::grpc::ServerContext* context, ::google::cloud::securesourcemanager::v1::ListInstancesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::securesourcemanager::v1::ListInstancesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetInstance() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::GetInstanceRequest* /*request*/, ::google::cloud::securesourcemanager::v1::Instance* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetInstance(::grpc::ServerContext* context, ::google::cloud::securesourcemanager::v1::GetInstanceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::securesourcemanager::v1::Instance>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateInstance() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CreateInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::CreateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateInstance(::grpc::ServerContext* context, ::google::cloud::securesourcemanager::v1::CreateInstanceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteInstance() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_DeleteInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::DeleteInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteInstance(::grpc::ServerContext* context, ::google::cloud::securesourcemanager::v1::DeleteInstanceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListRepositories : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListRepositories() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_ListRepositories() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRepositories(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::ListRepositoriesRequest* /*request*/, ::google::cloud::securesourcemanager::v1::ListRepositoriesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListRepositories(::grpc::ServerContext* context, ::google::cloud::securesourcemanager::v1::ListRepositoriesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::securesourcemanager::v1::ListRepositoriesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetRepository() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_GetRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRepository(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::GetRepositoryRequest* /*request*/, ::google::cloud::securesourcemanager::v1::Repository* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetRepository(::grpc::ServerContext* context, ::google::cloud::securesourcemanager::v1::GetRepositoryRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::securesourcemanager::v1::Repository>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateRepository() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_CreateRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRepository(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::CreateRepositoryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateRepository(::grpc::ServerContext* context, ::google::cloud::securesourcemanager::v1::CreateRepositoryRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteRepository() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_DeleteRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteRepository(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::DeleteRepositoryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteRepository(::grpc::ServerContext* context, ::google::cloud::securesourcemanager::v1::DeleteRepositoryRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetIamPolicyRepo : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetIamPolicyRepo() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_GetIamPolicyRepo() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicyRepo(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetIamPolicyRepo(::grpc::ServerContext* context, ::google::iam::v1::GetIamPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::iam::v1::Policy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SetIamPolicyRepo : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SetIamPolicyRepo() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_SetIamPolicyRepo() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicyRepo(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSetIamPolicyRepo(::grpc::ServerContext* context, ::google::iam::v1::SetIamPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::iam::v1::Policy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_TestIamPermissionsRepo : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_TestIamPermissionsRepo() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_TestIamPermissionsRepo() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissionsRepo(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTestIamPermissionsRepo(::grpc::ServerContext* context, ::google::iam::v1::TestIamPermissionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::iam::v1::TestIamPermissionsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateBranchRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateBranchRule() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_CreateBranchRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBranchRule(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::CreateBranchRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateBranchRule(::grpc::ServerContext* context, ::google::cloud::securesourcemanager::v1::CreateBranchRuleRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListBranchRules : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListBranchRules() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_ListBranchRules() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBranchRules(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::ListBranchRulesRequest* /*request*/, ::google::cloud::securesourcemanager::v1::ListBranchRulesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListBranchRules(::grpc::ServerContext* context, ::google::cloud::securesourcemanager::v1::ListBranchRulesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::securesourcemanager::v1::ListBranchRulesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetBranchRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetBranchRule() {
      ::grpc::Service::MarkMethodAsync(13);
    }
    ~WithAsyncMethod_GetBranchRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBranchRule(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::GetBranchRuleRequest* /*request*/, ::google::cloud::securesourcemanager::v1::BranchRule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetBranchRule(::grpc::ServerContext* context, ::google::cloud::securesourcemanager::v1::GetBranchRuleRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::securesourcemanager::v1::BranchRule>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateBranchRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateBranchRule() {
      ::grpc::Service::MarkMethodAsync(14);
    }
    ~WithAsyncMethod_UpdateBranchRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateBranchRule(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::UpdateBranchRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateBranchRule(::grpc::ServerContext* context, ::google::cloud::securesourcemanager::v1::UpdateBranchRuleRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteBranchRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteBranchRule() {
      ::grpc::Service::MarkMethodAsync(15);
    }
    ~WithAsyncMethod_DeleteBranchRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBranchRule(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::DeleteBranchRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteBranchRule(::grpc::ServerContext* context, ::google::cloud::securesourcemanager::v1::DeleteBranchRuleRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListInstances<WithAsyncMethod_GetInstance<WithAsyncMethod_CreateInstance<WithAsyncMethod_DeleteInstance<WithAsyncMethod_ListRepositories<WithAsyncMethod_GetRepository<WithAsyncMethod_CreateRepository<WithAsyncMethod_DeleteRepository<WithAsyncMethod_GetIamPolicyRepo<WithAsyncMethod_SetIamPolicyRepo<WithAsyncMethod_TestIamPermissionsRepo<WithAsyncMethod_CreateBranchRule<WithAsyncMethod_ListBranchRules<WithAsyncMethod_GetBranchRule<WithAsyncMethod_UpdateBranchRule<WithAsyncMethod_DeleteBranchRule<Service > > > > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListInstances : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListInstances() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::securesourcemanager::v1::ListInstancesRequest, ::google::cloud::securesourcemanager::v1::ListInstancesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::securesourcemanager::v1::ListInstancesRequest* request, ::google::cloud::securesourcemanager::v1::ListInstancesResponse* response) { return this->ListInstances(context, request, response); }));}
    void SetMessageAllocatorFor_ListInstances(
        ::grpc::MessageAllocator< ::google::cloud::securesourcemanager::v1::ListInstancesRequest, ::google::cloud::securesourcemanager::v1::ListInstancesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::securesourcemanager::v1::ListInstancesRequest, ::google::cloud::securesourcemanager::v1::ListInstancesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListInstances() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstances(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::ListInstancesRequest* /*request*/, ::google::cloud::securesourcemanager::v1::ListInstancesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListInstances(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::ListInstancesRequest* /*request*/, ::google::cloud::securesourcemanager::v1::ListInstancesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetInstance() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::securesourcemanager::v1::GetInstanceRequest, ::google::cloud::securesourcemanager::v1::Instance>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::securesourcemanager::v1::GetInstanceRequest* request, ::google::cloud::securesourcemanager::v1::Instance* response) { return this->GetInstance(context, request, response); }));}
    void SetMessageAllocatorFor_GetInstance(
        ::grpc::MessageAllocator< ::google::cloud::securesourcemanager::v1::GetInstanceRequest, ::google::cloud::securesourcemanager::v1::Instance>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::securesourcemanager::v1::GetInstanceRequest, ::google::cloud::securesourcemanager::v1::Instance>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::GetInstanceRequest* /*request*/, ::google::cloud::securesourcemanager::v1::Instance* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::GetInstanceRequest* /*request*/, ::google::cloud::securesourcemanager::v1::Instance* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateInstance() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::securesourcemanager::v1::CreateInstanceRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::securesourcemanager::v1::CreateInstanceRequest* request, ::google::longrunning::Operation* response) { return this->CreateInstance(context, request, response); }));}
    void SetMessageAllocatorFor_CreateInstance(
        ::grpc::MessageAllocator< ::google::cloud::securesourcemanager::v1::CreateInstanceRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::securesourcemanager::v1::CreateInstanceRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::CreateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::CreateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteInstance() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::securesourcemanager::v1::DeleteInstanceRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::securesourcemanager::v1::DeleteInstanceRequest* request, ::google::longrunning::Operation* response) { return this->DeleteInstance(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteInstance(
        ::grpc::MessageAllocator< ::google::cloud::securesourcemanager::v1::DeleteInstanceRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::securesourcemanager::v1::DeleteInstanceRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::DeleteInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::DeleteInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListRepositories : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListRepositories() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::securesourcemanager::v1::ListRepositoriesRequest, ::google::cloud::securesourcemanager::v1::ListRepositoriesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::securesourcemanager::v1::ListRepositoriesRequest* request, ::google::cloud::securesourcemanager::v1::ListRepositoriesResponse* response) { return this->ListRepositories(context, request, response); }));}
    void SetMessageAllocatorFor_ListRepositories(
        ::grpc::MessageAllocator< ::google::cloud::securesourcemanager::v1::ListRepositoriesRequest, ::google::cloud::securesourcemanager::v1::ListRepositoriesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::securesourcemanager::v1::ListRepositoriesRequest, ::google::cloud::securesourcemanager::v1::ListRepositoriesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListRepositories() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRepositories(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::ListRepositoriesRequest* /*request*/, ::google::cloud::securesourcemanager::v1::ListRepositoriesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListRepositories(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::ListRepositoriesRequest* /*request*/, ::google::cloud::securesourcemanager::v1::ListRepositoriesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetRepository() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::securesourcemanager::v1::GetRepositoryRequest, ::google::cloud::securesourcemanager::v1::Repository>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::securesourcemanager::v1::GetRepositoryRequest* request, ::google::cloud::securesourcemanager::v1::Repository* response) { return this->GetRepository(context, request, response); }));}
    void SetMessageAllocatorFor_GetRepository(
        ::grpc::MessageAllocator< ::google::cloud::securesourcemanager::v1::GetRepositoryRequest, ::google::cloud::securesourcemanager::v1::Repository>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::securesourcemanager::v1::GetRepositoryRequest, ::google::cloud::securesourcemanager::v1::Repository>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRepository(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::GetRepositoryRequest* /*request*/, ::google::cloud::securesourcemanager::v1::Repository* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetRepository(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::GetRepositoryRequest* /*request*/, ::google::cloud::securesourcemanager::v1::Repository* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateRepository() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::securesourcemanager::v1::CreateRepositoryRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::securesourcemanager::v1::CreateRepositoryRequest* request, ::google::longrunning::Operation* response) { return this->CreateRepository(context, request, response); }));}
    void SetMessageAllocatorFor_CreateRepository(
        ::grpc::MessageAllocator< ::google::cloud::securesourcemanager::v1::CreateRepositoryRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::securesourcemanager::v1::CreateRepositoryRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRepository(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::CreateRepositoryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateRepository(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::CreateRepositoryRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteRepository() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::securesourcemanager::v1::DeleteRepositoryRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::securesourcemanager::v1::DeleteRepositoryRequest* request, ::google::longrunning::Operation* response) { return this->DeleteRepository(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteRepository(
        ::grpc::MessageAllocator< ::google::cloud::securesourcemanager::v1::DeleteRepositoryRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::securesourcemanager::v1::DeleteRepositoryRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteRepository(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::DeleteRepositoryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteRepository(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::DeleteRepositoryRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetIamPolicyRepo : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetIamPolicyRepo() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response) { return this->GetIamPolicyRepo(context, request, response); }));}
    void SetMessageAllocatorFor_GetIamPolicyRepo(
        ::grpc::MessageAllocator< ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetIamPolicyRepo() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicyRepo(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetIamPolicyRepo(
      ::grpc::CallbackServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_SetIamPolicyRepo : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SetIamPolicyRepo() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response) { return this->SetIamPolicyRepo(context, request, response); }));}
    void SetMessageAllocatorFor_SetIamPolicyRepo(
        ::grpc::MessageAllocator< ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SetIamPolicyRepo() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicyRepo(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SetIamPolicyRepo(
      ::grpc::CallbackServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_TestIamPermissionsRepo : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_TestIamPermissionsRepo() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response) { return this->TestIamPermissionsRepo(context, request, response); }));}
    void SetMessageAllocatorFor_TestIamPermissionsRepo(
        ::grpc::MessageAllocator< ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_TestIamPermissionsRepo() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissionsRepo(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* TestIamPermissionsRepo(
      ::grpc::CallbackServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateBranchRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateBranchRule() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::securesourcemanager::v1::CreateBranchRuleRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::securesourcemanager::v1::CreateBranchRuleRequest* request, ::google::longrunning::Operation* response) { return this->CreateBranchRule(context, request, response); }));}
    void SetMessageAllocatorFor_CreateBranchRule(
        ::grpc::MessageAllocator< ::google::cloud::securesourcemanager::v1::CreateBranchRuleRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::securesourcemanager::v1::CreateBranchRuleRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateBranchRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBranchRule(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::CreateBranchRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateBranchRule(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::CreateBranchRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListBranchRules : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListBranchRules() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::securesourcemanager::v1::ListBranchRulesRequest, ::google::cloud::securesourcemanager::v1::ListBranchRulesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::securesourcemanager::v1::ListBranchRulesRequest* request, ::google::cloud::securesourcemanager::v1::ListBranchRulesResponse* response) { return this->ListBranchRules(context, request, response); }));}
    void SetMessageAllocatorFor_ListBranchRules(
        ::grpc::MessageAllocator< ::google::cloud::securesourcemanager::v1::ListBranchRulesRequest, ::google::cloud::securesourcemanager::v1::ListBranchRulesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::securesourcemanager::v1::ListBranchRulesRequest, ::google::cloud::securesourcemanager::v1::ListBranchRulesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListBranchRules() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBranchRules(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::ListBranchRulesRequest* /*request*/, ::google::cloud::securesourcemanager::v1::ListBranchRulesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListBranchRules(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::ListBranchRulesRequest* /*request*/, ::google::cloud::securesourcemanager::v1::ListBranchRulesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetBranchRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetBranchRule() {
      ::grpc::Service::MarkMethodCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::securesourcemanager::v1::GetBranchRuleRequest, ::google::cloud::securesourcemanager::v1::BranchRule>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::securesourcemanager::v1::GetBranchRuleRequest* request, ::google::cloud::securesourcemanager::v1::BranchRule* response) { return this->GetBranchRule(context, request, response); }));}
    void SetMessageAllocatorFor_GetBranchRule(
        ::grpc::MessageAllocator< ::google::cloud::securesourcemanager::v1::GetBranchRuleRequest, ::google::cloud::securesourcemanager::v1::BranchRule>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(13);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::securesourcemanager::v1::GetBranchRuleRequest, ::google::cloud::securesourcemanager::v1::BranchRule>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetBranchRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBranchRule(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::GetBranchRuleRequest* /*request*/, ::google::cloud::securesourcemanager::v1::BranchRule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetBranchRule(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::GetBranchRuleRequest* /*request*/, ::google::cloud::securesourcemanager::v1::BranchRule* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateBranchRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateBranchRule() {
      ::grpc::Service::MarkMethodCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::securesourcemanager::v1::UpdateBranchRuleRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::securesourcemanager::v1::UpdateBranchRuleRequest* request, ::google::longrunning::Operation* response) { return this->UpdateBranchRule(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateBranchRule(
        ::grpc::MessageAllocator< ::google::cloud::securesourcemanager::v1::UpdateBranchRuleRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(14);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::securesourcemanager::v1::UpdateBranchRuleRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateBranchRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateBranchRule(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::UpdateBranchRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateBranchRule(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::UpdateBranchRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteBranchRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteBranchRule() {
      ::grpc::Service::MarkMethodCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::securesourcemanager::v1::DeleteBranchRuleRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::securesourcemanager::v1::DeleteBranchRuleRequest* request, ::google::longrunning::Operation* response) { return this->DeleteBranchRule(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteBranchRule(
        ::grpc::MessageAllocator< ::google::cloud::securesourcemanager::v1::DeleteBranchRuleRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(15);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::securesourcemanager::v1::DeleteBranchRuleRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteBranchRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBranchRule(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::DeleteBranchRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteBranchRule(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::DeleteBranchRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListInstances<WithCallbackMethod_GetInstance<WithCallbackMethod_CreateInstance<WithCallbackMethod_DeleteInstance<WithCallbackMethod_ListRepositories<WithCallbackMethod_GetRepository<WithCallbackMethod_CreateRepository<WithCallbackMethod_DeleteRepository<WithCallbackMethod_GetIamPolicyRepo<WithCallbackMethod_SetIamPolicyRepo<WithCallbackMethod_TestIamPermissionsRepo<WithCallbackMethod_CreateBranchRule<WithCallbackMethod_ListBranchRules<WithCallbackMethod_GetBranchRule<WithCallbackMethod_UpdateBranchRule<WithCallbackMethod_DeleteBranchRule<Service > > > > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListInstances : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListInstances() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListInstances() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstances(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::ListInstancesRequest* /*request*/, ::google::cloud::securesourcemanager::v1::ListInstancesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetInstance() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::GetInstanceRequest* /*request*/, ::google::cloud::securesourcemanager::v1::Instance* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateInstance() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CreateInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::CreateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteInstance() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_DeleteInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::DeleteInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListRepositories : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListRepositories() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_ListRepositories() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRepositories(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::ListRepositoriesRequest* /*request*/, ::google::cloud::securesourcemanager::v1::ListRepositoriesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetRepository() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_GetRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRepository(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::GetRepositoryRequest* /*request*/, ::google::cloud::securesourcemanager::v1::Repository* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateRepository() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_CreateRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRepository(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::CreateRepositoryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteRepository() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_DeleteRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteRepository(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::DeleteRepositoryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetIamPolicyRepo : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetIamPolicyRepo() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_GetIamPolicyRepo() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicyRepo(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SetIamPolicyRepo : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SetIamPolicyRepo() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_SetIamPolicyRepo() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicyRepo(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_TestIamPermissionsRepo : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_TestIamPermissionsRepo() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_TestIamPermissionsRepo() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissionsRepo(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateBranchRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateBranchRule() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_CreateBranchRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBranchRule(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::CreateBranchRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListBranchRules : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListBranchRules() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_ListBranchRules() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBranchRules(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::ListBranchRulesRequest* /*request*/, ::google::cloud::securesourcemanager::v1::ListBranchRulesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetBranchRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetBranchRule() {
      ::grpc::Service::MarkMethodGeneric(13);
    }
    ~WithGenericMethod_GetBranchRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBranchRule(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::GetBranchRuleRequest* /*request*/, ::google::cloud::securesourcemanager::v1::BranchRule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateBranchRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateBranchRule() {
      ::grpc::Service::MarkMethodGeneric(14);
    }
    ~WithGenericMethod_UpdateBranchRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateBranchRule(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::UpdateBranchRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteBranchRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteBranchRule() {
      ::grpc::Service::MarkMethodGeneric(15);
    }
    ~WithGenericMethod_DeleteBranchRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBranchRule(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::DeleteBranchRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListInstances : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListInstances() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListInstances() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstances(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::ListInstancesRequest* /*request*/, ::google::cloud::securesourcemanager::v1::ListInstancesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListInstances(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetInstance() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::GetInstanceRequest* /*request*/, ::google::cloud::securesourcemanager::v1::Instance* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetInstance(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateInstance() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CreateInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::CreateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateInstance(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteInstance() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_DeleteInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::DeleteInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteInstance(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListRepositories : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListRepositories() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_ListRepositories() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRepositories(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::ListRepositoriesRequest* /*request*/, ::google::cloud::securesourcemanager::v1::ListRepositoriesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListRepositories(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetRepository() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_GetRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRepository(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::GetRepositoryRequest* /*request*/, ::google::cloud::securesourcemanager::v1::Repository* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetRepository(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateRepository() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_CreateRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRepository(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::CreateRepositoryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateRepository(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteRepository() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_DeleteRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteRepository(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::DeleteRepositoryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteRepository(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetIamPolicyRepo : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetIamPolicyRepo() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_GetIamPolicyRepo() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicyRepo(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetIamPolicyRepo(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SetIamPolicyRepo : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SetIamPolicyRepo() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_SetIamPolicyRepo() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicyRepo(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSetIamPolicyRepo(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_TestIamPermissionsRepo : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_TestIamPermissionsRepo() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_TestIamPermissionsRepo() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissionsRepo(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTestIamPermissionsRepo(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateBranchRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateBranchRule() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_CreateBranchRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBranchRule(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::CreateBranchRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateBranchRule(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListBranchRules : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListBranchRules() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_ListBranchRules() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBranchRules(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::ListBranchRulesRequest* /*request*/, ::google::cloud::securesourcemanager::v1::ListBranchRulesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListBranchRules(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetBranchRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetBranchRule() {
      ::grpc::Service::MarkMethodRaw(13);
    }
    ~WithRawMethod_GetBranchRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBranchRule(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::GetBranchRuleRequest* /*request*/, ::google::cloud::securesourcemanager::v1::BranchRule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetBranchRule(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateBranchRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateBranchRule() {
      ::grpc::Service::MarkMethodRaw(14);
    }
    ~WithRawMethod_UpdateBranchRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateBranchRule(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::UpdateBranchRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateBranchRule(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteBranchRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteBranchRule() {
      ::grpc::Service::MarkMethodRaw(15);
    }
    ~WithRawMethod_DeleteBranchRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBranchRule(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::DeleteBranchRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteBranchRule(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListInstances : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListInstances() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListInstances(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListInstances() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstances(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::ListInstancesRequest* /*request*/, ::google::cloud::securesourcemanager::v1::ListInstancesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListInstances(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetInstance() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetInstance(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::GetInstanceRequest* /*request*/, ::google::cloud::securesourcemanager::v1::Instance* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateInstance() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateInstance(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::CreateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteInstance() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteInstance(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::DeleteInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListRepositories : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListRepositories() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListRepositories(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListRepositories() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRepositories(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::ListRepositoriesRequest* /*request*/, ::google::cloud::securesourcemanager::v1::ListRepositoriesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListRepositories(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetRepository() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetRepository(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRepository(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::GetRepositoryRequest* /*request*/, ::google::cloud::securesourcemanager::v1::Repository* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetRepository(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateRepository() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateRepository(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRepository(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::CreateRepositoryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateRepository(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteRepository() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteRepository(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteRepository(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::DeleteRepositoryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteRepository(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetIamPolicyRepo : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetIamPolicyRepo() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetIamPolicyRepo(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetIamPolicyRepo() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicyRepo(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetIamPolicyRepo(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SetIamPolicyRepo : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SetIamPolicyRepo() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SetIamPolicyRepo(context, request, response); }));
    }
    ~WithRawCallbackMethod_SetIamPolicyRepo() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicyRepo(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SetIamPolicyRepo(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_TestIamPermissionsRepo : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_TestIamPermissionsRepo() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->TestIamPermissionsRepo(context, request, response); }));
    }
    ~WithRawCallbackMethod_TestIamPermissionsRepo() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissionsRepo(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* TestIamPermissionsRepo(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateBranchRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateBranchRule() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateBranchRule(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateBranchRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBranchRule(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::CreateBranchRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateBranchRule(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListBranchRules : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListBranchRules() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListBranchRules(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListBranchRules() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBranchRules(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::ListBranchRulesRequest* /*request*/, ::google::cloud::securesourcemanager::v1::ListBranchRulesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListBranchRules(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetBranchRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetBranchRule() {
      ::grpc::Service::MarkMethodRawCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetBranchRule(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetBranchRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBranchRule(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::GetBranchRuleRequest* /*request*/, ::google::cloud::securesourcemanager::v1::BranchRule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetBranchRule(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateBranchRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateBranchRule() {
      ::grpc::Service::MarkMethodRawCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateBranchRule(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateBranchRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateBranchRule(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::UpdateBranchRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateBranchRule(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteBranchRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteBranchRule() {
      ::grpc::Service::MarkMethodRawCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteBranchRule(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteBranchRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBranchRule(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::DeleteBranchRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteBranchRule(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListInstances : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListInstances() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::securesourcemanager::v1::ListInstancesRequest, ::google::cloud::securesourcemanager::v1::ListInstancesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::securesourcemanager::v1::ListInstancesRequest, ::google::cloud::securesourcemanager::v1::ListInstancesResponse>* streamer) {
                       return this->StreamedListInstances(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListInstances() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListInstances(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::ListInstancesRequest* /*request*/, ::google::cloud::securesourcemanager::v1::ListInstancesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListInstances(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::securesourcemanager::v1::ListInstancesRequest,::google::cloud::securesourcemanager::v1::ListInstancesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetInstance() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::securesourcemanager::v1::GetInstanceRequest, ::google::cloud::securesourcemanager::v1::Instance>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::securesourcemanager::v1::GetInstanceRequest, ::google::cloud::securesourcemanager::v1::Instance>* streamer) {
                       return this->StreamedGetInstance(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::GetInstanceRequest* /*request*/, ::google::cloud::securesourcemanager::v1::Instance* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetInstance(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::securesourcemanager::v1::GetInstanceRequest,::google::cloud::securesourcemanager::v1::Instance>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateInstance() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::securesourcemanager::v1::CreateInstanceRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::securesourcemanager::v1::CreateInstanceRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateInstance(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::CreateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateInstance(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::securesourcemanager::v1::CreateInstanceRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteInstance() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::securesourcemanager::v1::DeleteInstanceRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::securesourcemanager::v1::DeleteInstanceRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteInstance(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::DeleteInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteInstance(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::securesourcemanager::v1::DeleteInstanceRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListRepositories : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListRepositories() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::securesourcemanager::v1::ListRepositoriesRequest, ::google::cloud::securesourcemanager::v1::ListRepositoriesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::securesourcemanager::v1::ListRepositoriesRequest, ::google::cloud::securesourcemanager::v1::ListRepositoriesResponse>* streamer) {
                       return this->StreamedListRepositories(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListRepositories() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListRepositories(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::ListRepositoriesRequest* /*request*/, ::google::cloud::securesourcemanager::v1::ListRepositoriesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListRepositories(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::securesourcemanager::v1::ListRepositoriesRequest,::google::cloud::securesourcemanager::v1::ListRepositoriesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetRepository() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::securesourcemanager::v1::GetRepositoryRequest, ::google::cloud::securesourcemanager::v1::Repository>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::securesourcemanager::v1::GetRepositoryRequest, ::google::cloud::securesourcemanager::v1::Repository>* streamer) {
                       return this->StreamedGetRepository(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetRepository(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::GetRepositoryRequest* /*request*/, ::google::cloud::securesourcemanager::v1::Repository* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetRepository(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::securesourcemanager::v1::GetRepositoryRequest,::google::cloud::securesourcemanager::v1::Repository>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateRepository() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::securesourcemanager::v1::CreateRepositoryRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::securesourcemanager::v1::CreateRepositoryRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateRepository(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateRepository(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::CreateRepositoryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateRepository(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::securesourcemanager::v1::CreateRepositoryRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteRepository : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteRepository() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::securesourcemanager::v1::DeleteRepositoryRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::securesourcemanager::v1::DeleteRepositoryRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteRepository(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteRepository() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteRepository(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::DeleteRepositoryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteRepository(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::securesourcemanager::v1::DeleteRepositoryRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetIamPolicyRepo : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetIamPolicyRepo() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>* streamer) {
                       return this->StreamedGetIamPolicyRepo(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetIamPolicyRepo() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetIamPolicyRepo(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetIamPolicyRepo(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::iam::v1::GetIamPolicyRequest,::google::iam::v1::Policy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SetIamPolicyRepo : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SetIamPolicyRepo() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>* streamer) {
                       return this->StreamedSetIamPolicyRepo(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SetIamPolicyRepo() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SetIamPolicyRepo(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSetIamPolicyRepo(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::iam::v1::SetIamPolicyRequest,::google::iam::v1::Policy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_TestIamPermissionsRepo : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_TestIamPermissionsRepo() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>* streamer) {
                       return this->StreamedTestIamPermissionsRepo(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_TestIamPermissionsRepo() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status TestIamPermissionsRepo(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedTestIamPermissionsRepo(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::iam::v1::TestIamPermissionsRequest,::google::iam::v1::TestIamPermissionsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateBranchRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateBranchRule() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::securesourcemanager::v1::CreateBranchRuleRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::securesourcemanager::v1::CreateBranchRuleRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateBranchRule(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateBranchRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateBranchRule(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::CreateBranchRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateBranchRule(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::securesourcemanager::v1::CreateBranchRuleRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListBranchRules : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListBranchRules() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::securesourcemanager::v1::ListBranchRulesRequest, ::google::cloud::securesourcemanager::v1::ListBranchRulesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::securesourcemanager::v1::ListBranchRulesRequest, ::google::cloud::securesourcemanager::v1::ListBranchRulesResponse>* streamer) {
                       return this->StreamedListBranchRules(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListBranchRules() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListBranchRules(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::ListBranchRulesRequest* /*request*/, ::google::cloud::securesourcemanager::v1::ListBranchRulesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListBranchRules(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::securesourcemanager::v1::ListBranchRulesRequest,::google::cloud::securesourcemanager::v1::ListBranchRulesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetBranchRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetBranchRule() {
      ::grpc::Service::MarkMethodStreamed(13,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::securesourcemanager::v1::GetBranchRuleRequest, ::google::cloud::securesourcemanager::v1::BranchRule>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::securesourcemanager::v1::GetBranchRuleRequest, ::google::cloud::securesourcemanager::v1::BranchRule>* streamer) {
                       return this->StreamedGetBranchRule(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetBranchRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetBranchRule(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::GetBranchRuleRequest* /*request*/, ::google::cloud::securesourcemanager::v1::BranchRule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetBranchRule(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::securesourcemanager::v1::GetBranchRuleRequest,::google::cloud::securesourcemanager::v1::BranchRule>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateBranchRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateBranchRule() {
      ::grpc::Service::MarkMethodStreamed(14,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::securesourcemanager::v1::UpdateBranchRuleRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::securesourcemanager::v1::UpdateBranchRuleRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateBranchRule(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateBranchRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateBranchRule(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::UpdateBranchRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateBranchRule(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::securesourcemanager::v1::UpdateBranchRuleRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteBranchRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteBranchRule() {
      ::grpc::Service::MarkMethodStreamed(15,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::securesourcemanager::v1::DeleteBranchRuleRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::securesourcemanager::v1::DeleteBranchRuleRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteBranchRule(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteBranchRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteBranchRule(::grpc::ServerContext* /*context*/, const ::google::cloud::securesourcemanager::v1::DeleteBranchRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteBranchRule(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::securesourcemanager::v1::DeleteBranchRuleRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListInstances<WithStreamedUnaryMethod_GetInstance<WithStreamedUnaryMethod_CreateInstance<WithStreamedUnaryMethod_DeleteInstance<WithStreamedUnaryMethod_ListRepositories<WithStreamedUnaryMethod_GetRepository<WithStreamedUnaryMethod_CreateRepository<WithStreamedUnaryMethod_DeleteRepository<WithStreamedUnaryMethod_GetIamPolicyRepo<WithStreamedUnaryMethod_SetIamPolicyRepo<WithStreamedUnaryMethod_TestIamPermissionsRepo<WithStreamedUnaryMethod_CreateBranchRule<WithStreamedUnaryMethod_ListBranchRules<WithStreamedUnaryMethod_GetBranchRule<WithStreamedUnaryMethod_UpdateBranchRule<WithStreamedUnaryMethod_DeleteBranchRule<Service > > > > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListInstances<WithStreamedUnaryMethod_GetInstance<WithStreamedUnaryMethod_CreateInstance<WithStreamedUnaryMethod_DeleteInstance<WithStreamedUnaryMethod_ListRepositories<WithStreamedUnaryMethod_GetRepository<WithStreamedUnaryMethod_CreateRepository<WithStreamedUnaryMethod_DeleteRepository<WithStreamedUnaryMethod_GetIamPolicyRepo<WithStreamedUnaryMethod_SetIamPolicyRepo<WithStreamedUnaryMethod_TestIamPermissionsRepo<WithStreamedUnaryMethod_CreateBranchRule<WithStreamedUnaryMethod_ListBranchRules<WithStreamedUnaryMethod_GetBranchRule<WithStreamedUnaryMethod_UpdateBranchRule<WithStreamedUnaryMethod_DeleteBranchRule<Service > > > > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace securesourcemanager
}  // namespace cloud
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fcloud_2fsecuresourcemanager_2fv1_2fsecure_5fsource_5fmanager_2eproto__INCLUDED
