// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/webrisk/v1/webrisk.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fwebrisk_2fv1_2fwebrisk_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fwebrisk_2fv1_2fwebrisk_2eproto__INCLUDED

#include "google/cloud/webrisk/v1/webrisk.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace cloud {
namespace webrisk {
namespace v1 {

// Web Risk API defines an interface to detect malicious URLs on your
// website and in client applications.
class WebRiskService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.webrisk.v1.WebRiskService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Gets the most recent threat list diffs. These diffs should be applied to
    // a local database of hashes to keep it up-to-date. If the local database is
    // empty or excessively out-of-date, a complete snapshot of the database will
    // be returned. This Method only updates a single ThreatList at a time. To
    // update multiple ThreatList databases, this method needs to be called once
    // for each list.
    virtual ::grpc::Status ComputeThreatListDiff(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::ComputeThreatListDiffRequest& request, ::google::cloud::webrisk::v1::ComputeThreatListDiffResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::webrisk::v1::ComputeThreatListDiffResponse>> AsyncComputeThreatListDiff(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::ComputeThreatListDiffRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::webrisk::v1::ComputeThreatListDiffResponse>>(AsyncComputeThreatListDiffRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::webrisk::v1::ComputeThreatListDiffResponse>> PrepareAsyncComputeThreatListDiff(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::ComputeThreatListDiffRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::webrisk::v1::ComputeThreatListDiffResponse>>(PrepareAsyncComputeThreatListDiffRaw(context, request, cq));
    }
    // This method is used to check whether a URI is on a given threatList.
    // Multiple threatLists may be searched in a single query.
    // The response will list all requested threatLists the URI was found to
    // match. If the URI is not found on any of the requested ThreatList an
    // empty response will be returned.
    virtual ::grpc::Status SearchUris(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SearchUrisRequest& request, ::google::cloud::webrisk::v1::SearchUrisResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::webrisk::v1::SearchUrisResponse>> AsyncSearchUris(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SearchUrisRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::webrisk::v1::SearchUrisResponse>>(AsyncSearchUrisRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::webrisk::v1::SearchUrisResponse>> PrepareAsyncSearchUris(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SearchUrisRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::webrisk::v1::SearchUrisResponse>>(PrepareAsyncSearchUrisRaw(context, request, cq));
    }
    // Gets the full hashes that match the requested hash prefix.
    // This is used after a hash prefix is looked up in a threatList
    // and there is a match. The client side threatList only holds partial hashes
    // so the client must query this method to determine if there is a full
    // hash match of a threat.
    virtual ::grpc::Status SearchHashes(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SearchHashesRequest& request, ::google::cloud::webrisk::v1::SearchHashesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::webrisk::v1::SearchHashesResponse>> AsyncSearchHashes(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SearchHashesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::webrisk::v1::SearchHashesResponse>>(AsyncSearchHashesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::webrisk::v1::SearchHashesResponse>> PrepareAsyncSearchHashes(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SearchHashesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::webrisk::v1::SearchHashesResponse>>(PrepareAsyncSearchHashesRaw(context, request, cq));
    }
    // Creates a Submission of a URI suspected of containing phishing content to
    // be reviewed. If the result verifies the existence of malicious phishing
    // content, the site will be added to the [Google's Social Engineering
    // lists](https://support.google.com/webmasters/answer/6350487/) in order to
    // protect users that could get exposed to this threat in the future. Only
    // allowlisted projects can use this method during Early Access. Please reach
    // out to Sales or your customer engineer to obtain access.
    virtual ::grpc::Status CreateSubmission(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::CreateSubmissionRequest& request, ::google::cloud::webrisk::v1::Submission* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::webrisk::v1::Submission>> AsyncCreateSubmission(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::CreateSubmissionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::webrisk::v1::Submission>>(AsyncCreateSubmissionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::webrisk::v1::Submission>> PrepareAsyncCreateSubmission(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::CreateSubmissionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::webrisk::v1::Submission>>(PrepareAsyncCreateSubmissionRaw(context, request, cq));
    }
    // Submits a URI suspected of containing malicious content to be reviewed.
    // Returns a google.longrunning.Operation which, once the review is complete,
    // is updated with its result. You can use the [Pub/Sub API]
    // (https://cloud.google.com/pubsub) to receive notifications for the returned
    // Operation. If the result verifies the existence of malicious content, the
    // site will be added to the [Google's Social Engineering lists]
    // (https://support.google.com/webmasters/answer/6350487/) in order to
    // protect users that could get exposed to this threat in the future. Only
    // allowlisted projects can use this method during Early Access. Please reach
    // out to Sales or your customer engineer to obtain access.
    virtual ::grpc::Status SubmitUri(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SubmitUriRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncSubmitUri(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SubmitUriRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncSubmitUriRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncSubmitUri(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SubmitUriRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncSubmitUriRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Gets the most recent threat list diffs. These diffs should be applied to
      // a local database of hashes to keep it up-to-date. If the local database is
      // empty or excessively out-of-date, a complete snapshot of the database will
      // be returned. This Method only updates a single ThreatList at a time. To
      // update multiple ThreatList databases, this method needs to be called once
      // for each list.
      virtual void ComputeThreatListDiff(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::ComputeThreatListDiffRequest* request, ::google::cloud::webrisk::v1::ComputeThreatListDiffResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ComputeThreatListDiff(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::ComputeThreatListDiffRequest* request, ::google::cloud::webrisk::v1::ComputeThreatListDiffResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // This method is used to check whether a URI is on a given threatList.
      // Multiple threatLists may be searched in a single query.
      // The response will list all requested threatLists the URI was found to
      // match. If the URI is not found on any of the requested ThreatList an
      // empty response will be returned.
      virtual void SearchUris(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SearchUrisRequest* request, ::google::cloud::webrisk::v1::SearchUrisResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SearchUris(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SearchUrisRequest* request, ::google::cloud::webrisk::v1::SearchUrisResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the full hashes that match the requested hash prefix.
      // This is used after a hash prefix is looked up in a threatList
      // and there is a match. The client side threatList only holds partial hashes
      // so the client must query this method to determine if there is a full
      // hash match of a threat.
      virtual void SearchHashes(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SearchHashesRequest* request, ::google::cloud::webrisk::v1::SearchHashesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SearchHashes(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SearchHashesRequest* request, ::google::cloud::webrisk::v1::SearchHashesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a Submission of a URI suspected of containing phishing content to
      // be reviewed. If the result verifies the existence of malicious phishing
      // content, the site will be added to the [Google's Social Engineering
      // lists](https://support.google.com/webmasters/answer/6350487/) in order to
      // protect users that could get exposed to this threat in the future. Only
      // allowlisted projects can use this method during Early Access. Please reach
      // out to Sales or your customer engineer to obtain access.
      virtual void CreateSubmission(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::CreateSubmissionRequest* request, ::google::cloud::webrisk::v1::Submission* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateSubmission(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::CreateSubmissionRequest* request, ::google::cloud::webrisk::v1::Submission* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Submits a URI suspected of containing malicious content to be reviewed.
      // Returns a google.longrunning.Operation which, once the review is complete,
      // is updated with its result. You can use the [Pub/Sub API]
      // (https://cloud.google.com/pubsub) to receive notifications for the returned
      // Operation. If the result verifies the existence of malicious content, the
      // site will be added to the [Google's Social Engineering lists]
      // (https://support.google.com/webmasters/answer/6350487/) in order to
      // protect users that could get exposed to this threat in the future. Only
      // allowlisted projects can use this method during Early Access. Please reach
      // out to Sales or your customer engineer to obtain access.
      virtual void SubmitUri(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SubmitUriRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SubmitUri(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SubmitUriRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::webrisk::v1::ComputeThreatListDiffResponse>* AsyncComputeThreatListDiffRaw(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::ComputeThreatListDiffRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::webrisk::v1::ComputeThreatListDiffResponse>* PrepareAsyncComputeThreatListDiffRaw(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::ComputeThreatListDiffRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::webrisk::v1::SearchUrisResponse>* AsyncSearchUrisRaw(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SearchUrisRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::webrisk::v1::SearchUrisResponse>* PrepareAsyncSearchUrisRaw(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SearchUrisRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::webrisk::v1::SearchHashesResponse>* AsyncSearchHashesRaw(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SearchHashesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::webrisk::v1::SearchHashesResponse>* PrepareAsyncSearchHashesRaw(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SearchHashesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::webrisk::v1::Submission>* AsyncCreateSubmissionRaw(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::CreateSubmissionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::webrisk::v1::Submission>* PrepareAsyncCreateSubmissionRaw(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::CreateSubmissionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncSubmitUriRaw(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SubmitUriRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncSubmitUriRaw(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SubmitUriRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ComputeThreatListDiff(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::ComputeThreatListDiffRequest& request, ::google::cloud::webrisk::v1::ComputeThreatListDiffResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::webrisk::v1::ComputeThreatListDiffResponse>> AsyncComputeThreatListDiff(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::ComputeThreatListDiffRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::webrisk::v1::ComputeThreatListDiffResponse>>(AsyncComputeThreatListDiffRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::webrisk::v1::ComputeThreatListDiffResponse>> PrepareAsyncComputeThreatListDiff(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::ComputeThreatListDiffRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::webrisk::v1::ComputeThreatListDiffResponse>>(PrepareAsyncComputeThreatListDiffRaw(context, request, cq));
    }
    ::grpc::Status SearchUris(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SearchUrisRequest& request, ::google::cloud::webrisk::v1::SearchUrisResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::webrisk::v1::SearchUrisResponse>> AsyncSearchUris(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SearchUrisRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::webrisk::v1::SearchUrisResponse>>(AsyncSearchUrisRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::webrisk::v1::SearchUrisResponse>> PrepareAsyncSearchUris(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SearchUrisRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::webrisk::v1::SearchUrisResponse>>(PrepareAsyncSearchUrisRaw(context, request, cq));
    }
    ::grpc::Status SearchHashes(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SearchHashesRequest& request, ::google::cloud::webrisk::v1::SearchHashesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::webrisk::v1::SearchHashesResponse>> AsyncSearchHashes(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SearchHashesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::webrisk::v1::SearchHashesResponse>>(AsyncSearchHashesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::webrisk::v1::SearchHashesResponse>> PrepareAsyncSearchHashes(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SearchHashesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::webrisk::v1::SearchHashesResponse>>(PrepareAsyncSearchHashesRaw(context, request, cq));
    }
    ::grpc::Status CreateSubmission(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::CreateSubmissionRequest& request, ::google::cloud::webrisk::v1::Submission* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::webrisk::v1::Submission>> AsyncCreateSubmission(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::CreateSubmissionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::webrisk::v1::Submission>>(AsyncCreateSubmissionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::webrisk::v1::Submission>> PrepareAsyncCreateSubmission(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::CreateSubmissionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::webrisk::v1::Submission>>(PrepareAsyncCreateSubmissionRaw(context, request, cq));
    }
    ::grpc::Status SubmitUri(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SubmitUriRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncSubmitUri(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SubmitUriRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncSubmitUriRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncSubmitUri(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SubmitUriRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncSubmitUriRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ComputeThreatListDiff(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::ComputeThreatListDiffRequest* request, ::google::cloud::webrisk::v1::ComputeThreatListDiffResponse* response, std::function<void(::grpc::Status)>) override;
      void ComputeThreatListDiff(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::ComputeThreatListDiffRequest* request, ::google::cloud::webrisk::v1::ComputeThreatListDiffResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void SearchUris(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SearchUrisRequest* request, ::google::cloud::webrisk::v1::SearchUrisResponse* response, std::function<void(::grpc::Status)>) override;
      void SearchUris(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SearchUrisRequest* request, ::google::cloud::webrisk::v1::SearchUrisResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void SearchHashes(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SearchHashesRequest* request, ::google::cloud::webrisk::v1::SearchHashesResponse* response, std::function<void(::grpc::Status)>) override;
      void SearchHashes(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SearchHashesRequest* request, ::google::cloud::webrisk::v1::SearchHashesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateSubmission(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::CreateSubmissionRequest* request, ::google::cloud::webrisk::v1::Submission* response, std::function<void(::grpc::Status)>) override;
      void CreateSubmission(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::CreateSubmissionRequest* request, ::google::cloud::webrisk::v1::Submission* response, ::grpc::ClientUnaryReactor* reactor) override;
      void SubmitUri(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SubmitUriRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void SubmitUri(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SubmitUriRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::webrisk::v1::ComputeThreatListDiffResponse>* AsyncComputeThreatListDiffRaw(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::ComputeThreatListDiffRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::webrisk::v1::ComputeThreatListDiffResponse>* PrepareAsyncComputeThreatListDiffRaw(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::ComputeThreatListDiffRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::webrisk::v1::SearchUrisResponse>* AsyncSearchUrisRaw(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SearchUrisRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::webrisk::v1::SearchUrisResponse>* PrepareAsyncSearchUrisRaw(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SearchUrisRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::webrisk::v1::SearchHashesResponse>* AsyncSearchHashesRaw(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SearchHashesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::webrisk::v1::SearchHashesResponse>* PrepareAsyncSearchHashesRaw(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SearchHashesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::webrisk::v1::Submission>* AsyncCreateSubmissionRaw(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::CreateSubmissionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::webrisk::v1::Submission>* PrepareAsyncCreateSubmissionRaw(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::CreateSubmissionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncSubmitUriRaw(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SubmitUriRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncSubmitUriRaw(::grpc::ClientContext* context, const ::google::cloud::webrisk::v1::SubmitUriRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ComputeThreatListDiff_;
    const ::grpc::internal::RpcMethod rpcmethod_SearchUris_;
    const ::grpc::internal::RpcMethod rpcmethod_SearchHashes_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateSubmission_;
    const ::grpc::internal::RpcMethod rpcmethod_SubmitUri_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Gets the most recent threat list diffs. These diffs should be applied to
    // a local database of hashes to keep it up-to-date. If the local database is
    // empty or excessively out-of-date, a complete snapshot of the database will
    // be returned. This Method only updates a single ThreatList at a time. To
    // update multiple ThreatList databases, this method needs to be called once
    // for each list.
    virtual ::grpc::Status ComputeThreatListDiff(::grpc::ServerContext* context, const ::google::cloud::webrisk::v1::ComputeThreatListDiffRequest* request, ::google::cloud::webrisk::v1::ComputeThreatListDiffResponse* response);
    // This method is used to check whether a URI is on a given threatList.
    // Multiple threatLists may be searched in a single query.
    // The response will list all requested threatLists the URI was found to
    // match. If the URI is not found on any of the requested ThreatList an
    // empty response will be returned.
    virtual ::grpc::Status SearchUris(::grpc::ServerContext* context, const ::google::cloud::webrisk::v1::SearchUrisRequest* request, ::google::cloud::webrisk::v1::SearchUrisResponse* response);
    // Gets the full hashes that match the requested hash prefix.
    // This is used after a hash prefix is looked up in a threatList
    // and there is a match. The client side threatList only holds partial hashes
    // so the client must query this method to determine if there is a full
    // hash match of a threat.
    virtual ::grpc::Status SearchHashes(::grpc::ServerContext* context, const ::google::cloud::webrisk::v1::SearchHashesRequest* request, ::google::cloud::webrisk::v1::SearchHashesResponse* response);
    // Creates a Submission of a URI suspected of containing phishing content to
    // be reviewed. If the result verifies the existence of malicious phishing
    // content, the site will be added to the [Google's Social Engineering
    // lists](https://support.google.com/webmasters/answer/6350487/) in order to
    // protect users that could get exposed to this threat in the future. Only
    // allowlisted projects can use this method during Early Access. Please reach
    // out to Sales or your customer engineer to obtain access.
    virtual ::grpc::Status CreateSubmission(::grpc::ServerContext* context, const ::google::cloud::webrisk::v1::CreateSubmissionRequest* request, ::google::cloud::webrisk::v1::Submission* response);
    // Submits a URI suspected of containing malicious content to be reviewed.
    // Returns a google.longrunning.Operation which, once the review is complete,
    // is updated with its result. You can use the [Pub/Sub API]
    // (https://cloud.google.com/pubsub) to receive notifications for the returned
    // Operation. If the result verifies the existence of malicious content, the
    // site will be added to the [Google's Social Engineering lists]
    // (https://support.google.com/webmasters/answer/6350487/) in order to
    // protect users that could get exposed to this threat in the future. Only
    // allowlisted projects can use this method during Early Access. Please reach
    // out to Sales or your customer engineer to obtain access.
    virtual ::grpc::Status SubmitUri(::grpc::ServerContext* context, const ::google::cloud::webrisk::v1::SubmitUriRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ComputeThreatListDiff : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ComputeThreatListDiff() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ComputeThreatListDiff() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ComputeThreatListDiff(::grpc::ServerContext* /*context*/, const ::google::cloud::webrisk::v1::ComputeThreatListDiffRequest* /*request*/, ::google::cloud::webrisk::v1::ComputeThreatListDiffResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestComputeThreatListDiff(::grpc::ServerContext* context, ::google::cloud::webrisk::v1::ComputeThreatListDiffRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::webrisk::v1::ComputeThreatListDiffResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SearchUris : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SearchUris() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_SearchUris() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchUris(::grpc::ServerContext* /*context*/, const ::google::cloud::webrisk::v1::SearchUrisRequest* /*request*/, ::google::cloud::webrisk::v1::SearchUrisResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchUris(::grpc::ServerContext* context, ::google::cloud::webrisk::v1::SearchUrisRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::webrisk::v1::SearchUrisResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SearchHashes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SearchHashes() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_SearchHashes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchHashes(::grpc::ServerContext* /*context*/, const ::google::cloud::webrisk::v1::SearchHashesRequest* /*request*/, ::google::cloud::webrisk::v1::SearchHashesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchHashes(::grpc::ServerContext* context, ::google::cloud::webrisk::v1::SearchHashesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::webrisk::v1::SearchHashesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateSubmission : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateSubmission() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_CreateSubmission() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSubmission(::grpc::ServerContext* /*context*/, const ::google::cloud::webrisk::v1::CreateSubmissionRequest* /*request*/, ::google::cloud::webrisk::v1::Submission* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateSubmission(::grpc::ServerContext* context, ::google::cloud::webrisk::v1::CreateSubmissionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::webrisk::v1::Submission>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SubmitUri : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SubmitUri() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_SubmitUri() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SubmitUri(::grpc::ServerContext* /*context*/, const ::google::cloud::webrisk::v1::SubmitUriRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSubmitUri(::grpc::ServerContext* context, ::google::cloud::webrisk::v1::SubmitUriRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ComputeThreatListDiff<WithAsyncMethod_SearchUris<WithAsyncMethod_SearchHashes<WithAsyncMethod_CreateSubmission<WithAsyncMethod_SubmitUri<Service > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ComputeThreatListDiff : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ComputeThreatListDiff() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::webrisk::v1::ComputeThreatListDiffRequest, ::google::cloud::webrisk::v1::ComputeThreatListDiffResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::webrisk::v1::ComputeThreatListDiffRequest* request, ::google::cloud::webrisk::v1::ComputeThreatListDiffResponse* response) { return this->ComputeThreatListDiff(context, request, response); }));}
    void SetMessageAllocatorFor_ComputeThreatListDiff(
        ::grpc::MessageAllocator< ::google::cloud::webrisk::v1::ComputeThreatListDiffRequest, ::google::cloud::webrisk::v1::ComputeThreatListDiffResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::webrisk::v1::ComputeThreatListDiffRequest, ::google::cloud::webrisk::v1::ComputeThreatListDiffResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ComputeThreatListDiff() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ComputeThreatListDiff(::grpc::ServerContext* /*context*/, const ::google::cloud::webrisk::v1::ComputeThreatListDiffRequest* /*request*/, ::google::cloud::webrisk::v1::ComputeThreatListDiffResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ComputeThreatListDiff(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::webrisk::v1::ComputeThreatListDiffRequest* /*request*/, ::google::cloud::webrisk::v1::ComputeThreatListDiffResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_SearchUris : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SearchUris() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::webrisk::v1::SearchUrisRequest, ::google::cloud::webrisk::v1::SearchUrisResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::webrisk::v1::SearchUrisRequest* request, ::google::cloud::webrisk::v1::SearchUrisResponse* response) { return this->SearchUris(context, request, response); }));}
    void SetMessageAllocatorFor_SearchUris(
        ::grpc::MessageAllocator< ::google::cloud::webrisk::v1::SearchUrisRequest, ::google::cloud::webrisk::v1::SearchUrisResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::webrisk::v1::SearchUrisRequest, ::google::cloud::webrisk::v1::SearchUrisResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SearchUris() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchUris(::grpc::ServerContext* /*context*/, const ::google::cloud::webrisk::v1::SearchUrisRequest* /*request*/, ::google::cloud::webrisk::v1::SearchUrisResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchUris(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::webrisk::v1::SearchUrisRequest* /*request*/, ::google::cloud::webrisk::v1::SearchUrisResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_SearchHashes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SearchHashes() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::webrisk::v1::SearchHashesRequest, ::google::cloud::webrisk::v1::SearchHashesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::webrisk::v1::SearchHashesRequest* request, ::google::cloud::webrisk::v1::SearchHashesResponse* response) { return this->SearchHashes(context, request, response); }));}
    void SetMessageAllocatorFor_SearchHashes(
        ::grpc::MessageAllocator< ::google::cloud::webrisk::v1::SearchHashesRequest, ::google::cloud::webrisk::v1::SearchHashesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::webrisk::v1::SearchHashesRequest, ::google::cloud::webrisk::v1::SearchHashesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SearchHashes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchHashes(::grpc::ServerContext* /*context*/, const ::google::cloud::webrisk::v1::SearchHashesRequest* /*request*/, ::google::cloud::webrisk::v1::SearchHashesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchHashes(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::webrisk::v1::SearchHashesRequest* /*request*/, ::google::cloud::webrisk::v1::SearchHashesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateSubmission : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateSubmission() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::webrisk::v1::CreateSubmissionRequest, ::google::cloud::webrisk::v1::Submission>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::webrisk::v1::CreateSubmissionRequest* request, ::google::cloud::webrisk::v1::Submission* response) { return this->CreateSubmission(context, request, response); }));}
    void SetMessageAllocatorFor_CreateSubmission(
        ::grpc::MessageAllocator< ::google::cloud::webrisk::v1::CreateSubmissionRequest, ::google::cloud::webrisk::v1::Submission>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::webrisk::v1::CreateSubmissionRequest, ::google::cloud::webrisk::v1::Submission>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateSubmission() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSubmission(::grpc::ServerContext* /*context*/, const ::google::cloud::webrisk::v1::CreateSubmissionRequest* /*request*/, ::google::cloud::webrisk::v1::Submission* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateSubmission(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::webrisk::v1::CreateSubmissionRequest* /*request*/, ::google::cloud::webrisk::v1::Submission* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_SubmitUri : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SubmitUri() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::webrisk::v1::SubmitUriRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::webrisk::v1::SubmitUriRequest* request, ::google::longrunning::Operation* response) { return this->SubmitUri(context, request, response); }));}
    void SetMessageAllocatorFor_SubmitUri(
        ::grpc::MessageAllocator< ::google::cloud::webrisk::v1::SubmitUriRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::webrisk::v1::SubmitUriRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SubmitUri() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SubmitUri(::grpc::ServerContext* /*context*/, const ::google::cloud::webrisk::v1::SubmitUriRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SubmitUri(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::webrisk::v1::SubmitUriRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ComputeThreatListDiff<WithCallbackMethod_SearchUris<WithCallbackMethod_SearchHashes<WithCallbackMethod_CreateSubmission<WithCallbackMethod_SubmitUri<Service > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ComputeThreatListDiff : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ComputeThreatListDiff() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ComputeThreatListDiff() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ComputeThreatListDiff(::grpc::ServerContext* /*context*/, const ::google::cloud::webrisk::v1::ComputeThreatListDiffRequest* /*request*/, ::google::cloud::webrisk::v1::ComputeThreatListDiffResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SearchUris : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SearchUris() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_SearchUris() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchUris(::grpc::ServerContext* /*context*/, const ::google::cloud::webrisk::v1::SearchUrisRequest* /*request*/, ::google::cloud::webrisk::v1::SearchUrisResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SearchHashes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SearchHashes() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_SearchHashes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchHashes(::grpc::ServerContext* /*context*/, const ::google::cloud::webrisk::v1::SearchHashesRequest* /*request*/, ::google::cloud::webrisk::v1::SearchHashesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateSubmission : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateSubmission() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_CreateSubmission() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSubmission(::grpc::ServerContext* /*context*/, const ::google::cloud::webrisk::v1::CreateSubmissionRequest* /*request*/, ::google::cloud::webrisk::v1::Submission* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SubmitUri : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SubmitUri() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_SubmitUri() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SubmitUri(::grpc::ServerContext* /*context*/, const ::google::cloud::webrisk::v1::SubmitUriRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ComputeThreatListDiff : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ComputeThreatListDiff() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ComputeThreatListDiff() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ComputeThreatListDiff(::grpc::ServerContext* /*context*/, const ::google::cloud::webrisk::v1::ComputeThreatListDiffRequest* /*request*/, ::google::cloud::webrisk::v1::ComputeThreatListDiffResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestComputeThreatListDiff(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SearchUris : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SearchUris() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_SearchUris() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchUris(::grpc::ServerContext* /*context*/, const ::google::cloud::webrisk::v1::SearchUrisRequest* /*request*/, ::google::cloud::webrisk::v1::SearchUrisResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchUris(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SearchHashes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SearchHashes() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_SearchHashes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchHashes(::grpc::ServerContext* /*context*/, const ::google::cloud::webrisk::v1::SearchHashesRequest* /*request*/, ::google::cloud::webrisk::v1::SearchHashesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchHashes(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateSubmission : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateSubmission() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_CreateSubmission() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSubmission(::grpc::ServerContext* /*context*/, const ::google::cloud::webrisk::v1::CreateSubmissionRequest* /*request*/, ::google::cloud::webrisk::v1::Submission* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateSubmission(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SubmitUri : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SubmitUri() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_SubmitUri() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SubmitUri(::grpc::ServerContext* /*context*/, const ::google::cloud::webrisk::v1::SubmitUriRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSubmitUri(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ComputeThreatListDiff : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ComputeThreatListDiff() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ComputeThreatListDiff(context, request, response); }));
    }
    ~WithRawCallbackMethod_ComputeThreatListDiff() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ComputeThreatListDiff(::grpc::ServerContext* /*context*/, const ::google::cloud::webrisk::v1::ComputeThreatListDiffRequest* /*request*/, ::google::cloud::webrisk::v1::ComputeThreatListDiffResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ComputeThreatListDiff(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SearchUris : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SearchUris() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SearchUris(context, request, response); }));
    }
    ~WithRawCallbackMethod_SearchUris() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchUris(::grpc::ServerContext* /*context*/, const ::google::cloud::webrisk::v1::SearchUrisRequest* /*request*/, ::google::cloud::webrisk::v1::SearchUrisResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchUris(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SearchHashes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SearchHashes() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SearchHashes(context, request, response); }));
    }
    ~WithRawCallbackMethod_SearchHashes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchHashes(::grpc::ServerContext* /*context*/, const ::google::cloud::webrisk::v1::SearchHashesRequest* /*request*/, ::google::cloud::webrisk::v1::SearchHashesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchHashes(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateSubmission : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateSubmission() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateSubmission(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateSubmission() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSubmission(::grpc::ServerContext* /*context*/, const ::google::cloud::webrisk::v1::CreateSubmissionRequest* /*request*/, ::google::cloud::webrisk::v1::Submission* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateSubmission(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SubmitUri : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SubmitUri() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SubmitUri(context, request, response); }));
    }
    ~WithRawCallbackMethod_SubmitUri() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SubmitUri(::grpc::ServerContext* /*context*/, const ::google::cloud::webrisk::v1::SubmitUriRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SubmitUri(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ComputeThreatListDiff : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ComputeThreatListDiff() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::webrisk::v1::ComputeThreatListDiffRequest, ::google::cloud::webrisk::v1::ComputeThreatListDiffResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::webrisk::v1::ComputeThreatListDiffRequest, ::google::cloud::webrisk::v1::ComputeThreatListDiffResponse>* streamer) {
                       return this->StreamedComputeThreatListDiff(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ComputeThreatListDiff() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ComputeThreatListDiff(::grpc::ServerContext* /*context*/, const ::google::cloud::webrisk::v1::ComputeThreatListDiffRequest* /*request*/, ::google::cloud::webrisk::v1::ComputeThreatListDiffResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedComputeThreatListDiff(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::webrisk::v1::ComputeThreatListDiffRequest,::google::cloud::webrisk::v1::ComputeThreatListDiffResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SearchUris : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SearchUris() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::webrisk::v1::SearchUrisRequest, ::google::cloud::webrisk::v1::SearchUrisResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::webrisk::v1::SearchUrisRequest, ::google::cloud::webrisk::v1::SearchUrisResponse>* streamer) {
                       return this->StreamedSearchUris(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SearchUris() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SearchUris(::grpc::ServerContext* /*context*/, const ::google::cloud::webrisk::v1::SearchUrisRequest* /*request*/, ::google::cloud::webrisk::v1::SearchUrisResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSearchUris(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::webrisk::v1::SearchUrisRequest,::google::cloud::webrisk::v1::SearchUrisResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SearchHashes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SearchHashes() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::webrisk::v1::SearchHashesRequest, ::google::cloud::webrisk::v1::SearchHashesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::webrisk::v1::SearchHashesRequest, ::google::cloud::webrisk::v1::SearchHashesResponse>* streamer) {
                       return this->StreamedSearchHashes(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SearchHashes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SearchHashes(::grpc::ServerContext* /*context*/, const ::google::cloud::webrisk::v1::SearchHashesRequest* /*request*/, ::google::cloud::webrisk::v1::SearchHashesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSearchHashes(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::webrisk::v1::SearchHashesRequest,::google::cloud::webrisk::v1::SearchHashesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateSubmission : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateSubmission() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::webrisk::v1::CreateSubmissionRequest, ::google::cloud::webrisk::v1::Submission>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::webrisk::v1::CreateSubmissionRequest, ::google::cloud::webrisk::v1::Submission>* streamer) {
                       return this->StreamedCreateSubmission(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateSubmission() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateSubmission(::grpc::ServerContext* /*context*/, const ::google::cloud::webrisk::v1::CreateSubmissionRequest* /*request*/, ::google::cloud::webrisk::v1::Submission* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateSubmission(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::webrisk::v1::CreateSubmissionRequest,::google::cloud::webrisk::v1::Submission>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SubmitUri : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SubmitUri() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::webrisk::v1::SubmitUriRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::webrisk::v1::SubmitUriRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedSubmitUri(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SubmitUri() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SubmitUri(::grpc::ServerContext* /*context*/, const ::google::cloud::webrisk::v1::SubmitUriRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSubmitUri(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::webrisk::v1::SubmitUriRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ComputeThreatListDiff<WithStreamedUnaryMethod_SearchUris<WithStreamedUnaryMethod_SearchHashes<WithStreamedUnaryMethod_CreateSubmission<WithStreamedUnaryMethod_SubmitUri<Service > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ComputeThreatListDiff<WithStreamedUnaryMethod_SearchUris<WithStreamedUnaryMethod_SearchHashes<WithStreamedUnaryMethod_CreateSubmission<WithStreamedUnaryMethod_SubmitUri<Service > > > > > StreamedService;
};

}  // namespace v1
}  // namespace webrisk
}  // namespace cloud
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fcloud_2fwebrisk_2fv1_2fwebrisk_2eproto__INCLUDED
