// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/kms/v1/service.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fkms_2fv1_2fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fkms_2fv1_2fservice_2eproto__INCLUDED

#include "google/cloud/kms/v1/service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace cloud {
namespace kms {
namespace v1 {

// Google Cloud Key Management Service
//
// Manages cryptographic keys and operations using those keys. Implements a REST
// model with the following objects:
//
// * [KeyRing][google.cloud.kms.v1.KeyRing]
// * [CryptoKey][google.cloud.kms.v1.CryptoKey]
// * [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion]
// * [ImportJob][google.cloud.kms.v1.ImportJob]
//
// If you are using manual gRPC libraries, see
// [Using gRPC with Cloud KMS](https://cloud.google.com/kms/docs/grpc).
class KeyManagementService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.kms.v1.KeyManagementService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists [KeyRings][google.cloud.kms.v1.KeyRing].
    virtual ::grpc::Status ListKeyRings(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListKeyRingsRequest& request, ::google::cloud::kms::v1::ListKeyRingsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ListKeyRingsResponse>> AsyncListKeyRings(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListKeyRingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ListKeyRingsResponse>>(AsyncListKeyRingsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ListKeyRingsResponse>> PrepareAsyncListKeyRings(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListKeyRingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ListKeyRingsResponse>>(PrepareAsyncListKeyRingsRaw(context, request, cq));
    }
    // Lists [CryptoKeys][google.cloud.kms.v1.CryptoKey].
    virtual ::grpc::Status ListCryptoKeys(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListCryptoKeysRequest& request, ::google::cloud::kms::v1::ListCryptoKeysResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ListCryptoKeysResponse>> AsyncListCryptoKeys(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListCryptoKeysRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ListCryptoKeysResponse>>(AsyncListCryptoKeysRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ListCryptoKeysResponse>> PrepareAsyncListCryptoKeys(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListCryptoKeysRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ListCryptoKeysResponse>>(PrepareAsyncListCryptoKeysRaw(context, request, cq));
    }
    // Lists [CryptoKeyVersions][google.cloud.kms.v1.CryptoKeyVersion].
    virtual ::grpc::Status ListCryptoKeyVersions(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListCryptoKeyVersionsRequest& request, ::google::cloud::kms::v1::ListCryptoKeyVersionsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ListCryptoKeyVersionsResponse>> AsyncListCryptoKeyVersions(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListCryptoKeyVersionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ListCryptoKeyVersionsResponse>>(AsyncListCryptoKeyVersionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ListCryptoKeyVersionsResponse>> PrepareAsyncListCryptoKeyVersions(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListCryptoKeyVersionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ListCryptoKeyVersionsResponse>>(PrepareAsyncListCryptoKeyVersionsRaw(context, request, cq));
    }
    // Lists [ImportJobs][google.cloud.kms.v1.ImportJob].
    virtual ::grpc::Status ListImportJobs(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListImportJobsRequest& request, ::google::cloud::kms::v1::ListImportJobsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ListImportJobsResponse>> AsyncListImportJobs(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListImportJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ListImportJobsResponse>>(AsyncListImportJobsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ListImportJobsResponse>> PrepareAsyncListImportJobs(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListImportJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ListImportJobsResponse>>(PrepareAsyncListImportJobsRaw(context, request, cq));
    }
    // Returns metadata for a given [KeyRing][google.cloud.kms.v1.KeyRing].
    virtual ::grpc::Status GetKeyRing(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetKeyRingRequest& request, ::google::cloud::kms::v1::KeyRing* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::KeyRing>> AsyncGetKeyRing(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetKeyRingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::KeyRing>>(AsyncGetKeyRingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::KeyRing>> PrepareAsyncGetKeyRing(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetKeyRingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::KeyRing>>(PrepareAsyncGetKeyRingRaw(context, request, cq));
    }
    // Returns metadata for a given [CryptoKey][google.cloud.kms.v1.CryptoKey], as
    // well as its [primary][google.cloud.kms.v1.CryptoKey.primary]
    // [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion].
    virtual ::grpc::Status GetCryptoKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetCryptoKeyRequest& request, ::google::cloud::kms::v1::CryptoKey* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKey>> AsyncGetCryptoKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetCryptoKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKey>>(AsyncGetCryptoKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKey>> PrepareAsyncGetCryptoKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetCryptoKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKey>>(PrepareAsyncGetCryptoKeyRaw(context, request, cq));
    }
    // Returns metadata for a given
    // [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion].
    virtual ::grpc::Status GetCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetCryptoKeyVersionRequest& request, ::google::cloud::kms::v1::CryptoKeyVersion* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKeyVersion>> AsyncGetCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKeyVersion>>(AsyncGetCryptoKeyVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKeyVersion>> PrepareAsyncGetCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKeyVersion>>(PrepareAsyncGetCryptoKeyVersionRaw(context, request, cq));
    }
    // Returns the public key for the given
    // [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion]. The
    // [CryptoKey.purpose][google.cloud.kms.v1.CryptoKey.purpose] must be
    // [ASYMMETRIC_SIGN][google.cloud.kms.v1.CryptoKey.CryptoKeyPurpose.ASYMMETRIC_SIGN]
    // or
    // [ASYMMETRIC_DECRYPT][google.cloud.kms.v1.CryptoKey.CryptoKeyPurpose.ASYMMETRIC_DECRYPT].
    virtual ::grpc::Status GetPublicKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetPublicKeyRequest& request, ::google::cloud::kms::v1::PublicKey* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::PublicKey>> AsyncGetPublicKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetPublicKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::PublicKey>>(AsyncGetPublicKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::PublicKey>> PrepareAsyncGetPublicKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetPublicKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::PublicKey>>(PrepareAsyncGetPublicKeyRaw(context, request, cq));
    }
    // Returns metadata for a given [ImportJob][google.cloud.kms.v1.ImportJob].
    virtual ::grpc::Status GetImportJob(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetImportJobRequest& request, ::google::cloud::kms::v1::ImportJob* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ImportJob>> AsyncGetImportJob(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetImportJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ImportJob>>(AsyncGetImportJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ImportJob>> PrepareAsyncGetImportJob(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetImportJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ImportJob>>(PrepareAsyncGetImportJobRaw(context, request, cq));
    }
    // Create a new [KeyRing][google.cloud.kms.v1.KeyRing] in a given Project and
    // Location.
    virtual ::grpc::Status CreateKeyRing(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateKeyRingRequest& request, ::google::cloud::kms::v1::KeyRing* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::KeyRing>> AsyncCreateKeyRing(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateKeyRingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::KeyRing>>(AsyncCreateKeyRingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::KeyRing>> PrepareAsyncCreateKeyRing(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateKeyRingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::KeyRing>>(PrepareAsyncCreateKeyRingRaw(context, request, cq));
    }
    // Create a new [CryptoKey][google.cloud.kms.v1.CryptoKey] within a
    // [KeyRing][google.cloud.kms.v1.KeyRing].
    //
    // [CryptoKey.purpose][google.cloud.kms.v1.CryptoKey.purpose] and
    // [CryptoKey.version_template.algorithm][google.cloud.kms.v1.CryptoKeyVersionTemplate.algorithm]
    // are required.
    virtual ::grpc::Status CreateCryptoKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateCryptoKeyRequest& request, ::google::cloud::kms::v1::CryptoKey* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKey>> AsyncCreateCryptoKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateCryptoKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKey>>(AsyncCreateCryptoKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKey>> PrepareAsyncCreateCryptoKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateCryptoKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKey>>(PrepareAsyncCreateCryptoKeyRaw(context, request, cq));
    }
    // Create a new [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion] in a
    // [CryptoKey][google.cloud.kms.v1.CryptoKey].
    //
    // The server will assign the next sequential id. If unset,
    // [state][google.cloud.kms.v1.CryptoKeyVersion.state] will be set to
    // [ENABLED][google.cloud.kms.v1.CryptoKeyVersion.CryptoKeyVersionState.ENABLED].
    virtual ::grpc::Status CreateCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateCryptoKeyVersionRequest& request, ::google::cloud::kms::v1::CryptoKeyVersion* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKeyVersion>> AsyncCreateCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKeyVersion>>(AsyncCreateCryptoKeyVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKeyVersion>> PrepareAsyncCreateCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKeyVersion>>(PrepareAsyncCreateCryptoKeyVersionRaw(context, request, cq));
    }
    // Import wrapped key material into a
    // [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion].
    //
    // All requests must specify a [CryptoKey][google.cloud.kms.v1.CryptoKey]. If
    // a [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion] is additionally
    // specified in the request, key material will be reimported into that
    // version. Otherwise, a new version will be created, and will be assigned the
    // next sequential id within the [CryptoKey][google.cloud.kms.v1.CryptoKey].
    virtual ::grpc::Status ImportCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ImportCryptoKeyVersionRequest& request, ::google::cloud::kms::v1::CryptoKeyVersion* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKeyVersion>> AsyncImportCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ImportCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKeyVersion>>(AsyncImportCryptoKeyVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKeyVersion>> PrepareAsyncImportCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ImportCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKeyVersion>>(PrepareAsyncImportCryptoKeyVersionRaw(context, request, cq));
    }
    // Create a new [ImportJob][google.cloud.kms.v1.ImportJob] within a
    // [KeyRing][google.cloud.kms.v1.KeyRing].
    //
    // [ImportJob.import_method][google.cloud.kms.v1.ImportJob.import_method] is
    // required.
    virtual ::grpc::Status CreateImportJob(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateImportJobRequest& request, ::google::cloud::kms::v1::ImportJob* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ImportJob>> AsyncCreateImportJob(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateImportJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ImportJob>>(AsyncCreateImportJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ImportJob>> PrepareAsyncCreateImportJob(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateImportJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ImportJob>>(PrepareAsyncCreateImportJobRaw(context, request, cq));
    }
    // Update a [CryptoKey][google.cloud.kms.v1.CryptoKey].
    virtual ::grpc::Status UpdateCryptoKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyRequest& request, ::google::cloud::kms::v1::CryptoKey* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKey>> AsyncUpdateCryptoKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKey>>(AsyncUpdateCryptoKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKey>> PrepareAsyncUpdateCryptoKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKey>>(PrepareAsyncUpdateCryptoKeyRaw(context, request, cq));
    }
    // Update a [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion]'s
    // metadata.
    //
    // [state][google.cloud.kms.v1.CryptoKeyVersion.state] may be changed between
    // [ENABLED][google.cloud.kms.v1.CryptoKeyVersion.CryptoKeyVersionState.ENABLED]
    // and
    // [DISABLED][google.cloud.kms.v1.CryptoKeyVersion.CryptoKeyVersionState.DISABLED]
    // using this method. See
    // [DestroyCryptoKeyVersion][google.cloud.kms.v1.KeyManagementService.DestroyCryptoKeyVersion]
    // and
    // [RestoreCryptoKeyVersion][google.cloud.kms.v1.KeyManagementService.RestoreCryptoKeyVersion]
    // to move between other states.
    virtual ::grpc::Status UpdateCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyVersionRequest& request, ::google::cloud::kms::v1::CryptoKeyVersion* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKeyVersion>> AsyncUpdateCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKeyVersion>>(AsyncUpdateCryptoKeyVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKeyVersion>> PrepareAsyncUpdateCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKeyVersion>>(PrepareAsyncUpdateCryptoKeyVersionRaw(context, request, cq));
    }
    // Update the version of a [CryptoKey][google.cloud.kms.v1.CryptoKey] that
    // will be used in
    // [Encrypt][google.cloud.kms.v1.KeyManagementService.Encrypt].
    //
    // Returns an error if called on a key whose purpose is not
    // [ENCRYPT_DECRYPT][google.cloud.kms.v1.CryptoKey.CryptoKeyPurpose.ENCRYPT_DECRYPT].
    virtual ::grpc::Status UpdateCryptoKeyPrimaryVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyPrimaryVersionRequest& request, ::google::cloud::kms::v1::CryptoKey* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKey>> AsyncUpdateCryptoKeyPrimaryVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyPrimaryVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKey>>(AsyncUpdateCryptoKeyPrimaryVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKey>> PrepareAsyncUpdateCryptoKeyPrimaryVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyPrimaryVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKey>>(PrepareAsyncUpdateCryptoKeyPrimaryVersionRaw(context, request, cq));
    }
    // Schedule a [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion] for
    // destruction.
    //
    // Upon calling this method,
    // [CryptoKeyVersion.state][google.cloud.kms.v1.CryptoKeyVersion.state] will
    // be set to
    // [DESTROY_SCHEDULED][google.cloud.kms.v1.CryptoKeyVersion.CryptoKeyVersionState.DESTROY_SCHEDULED],
    // and [destroy_time][google.cloud.kms.v1.CryptoKeyVersion.destroy_time] will
    // be set to the time
    // [destroy_scheduled_duration][google.cloud.kms.v1.CryptoKey.destroy_scheduled_duration]
    // in the future. At that time, the
    // [state][google.cloud.kms.v1.CryptoKeyVersion.state] will automatically
    // change to
    // [DESTROYED][google.cloud.kms.v1.CryptoKeyVersion.CryptoKeyVersionState.DESTROYED],
    // and the key material will be irrevocably destroyed.
    //
    // Before the
    // [destroy_time][google.cloud.kms.v1.CryptoKeyVersion.destroy_time] is
    // reached,
    // [RestoreCryptoKeyVersion][google.cloud.kms.v1.KeyManagementService.RestoreCryptoKeyVersion]
    // may be called to reverse the process.
    virtual ::grpc::Status DestroyCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::DestroyCryptoKeyVersionRequest& request, ::google::cloud::kms::v1::CryptoKeyVersion* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKeyVersion>> AsyncDestroyCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::DestroyCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKeyVersion>>(AsyncDestroyCryptoKeyVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKeyVersion>> PrepareAsyncDestroyCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::DestroyCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKeyVersion>>(PrepareAsyncDestroyCryptoKeyVersionRaw(context, request, cq));
    }
    // Restore a [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion] in the
    // [DESTROY_SCHEDULED][google.cloud.kms.v1.CryptoKeyVersion.CryptoKeyVersionState.DESTROY_SCHEDULED]
    // state.
    //
    // Upon restoration of the CryptoKeyVersion,
    // [state][google.cloud.kms.v1.CryptoKeyVersion.state] will be set to
    // [DISABLED][google.cloud.kms.v1.CryptoKeyVersion.CryptoKeyVersionState.DISABLED],
    // and [destroy_time][google.cloud.kms.v1.CryptoKeyVersion.destroy_time] will
    // be cleared.
    virtual ::grpc::Status RestoreCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RestoreCryptoKeyVersionRequest& request, ::google::cloud::kms::v1::CryptoKeyVersion* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKeyVersion>> AsyncRestoreCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RestoreCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKeyVersion>>(AsyncRestoreCryptoKeyVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKeyVersion>> PrepareAsyncRestoreCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RestoreCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKeyVersion>>(PrepareAsyncRestoreCryptoKeyVersionRaw(context, request, cq));
    }
    // Encrypts data, so that it can only be recovered by a call to
    // [Decrypt][google.cloud.kms.v1.KeyManagementService.Decrypt]. The
    // [CryptoKey.purpose][google.cloud.kms.v1.CryptoKey.purpose] must be
    // [ENCRYPT_DECRYPT][google.cloud.kms.v1.CryptoKey.CryptoKeyPurpose.ENCRYPT_DECRYPT].
    virtual ::grpc::Status Encrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::EncryptRequest& request, ::google::cloud::kms::v1::EncryptResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::EncryptResponse>> AsyncEncrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::EncryptRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::EncryptResponse>>(AsyncEncryptRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::EncryptResponse>> PrepareAsyncEncrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::EncryptRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::EncryptResponse>>(PrepareAsyncEncryptRaw(context, request, cq));
    }
    // Decrypts data that was protected by
    // [Encrypt][google.cloud.kms.v1.KeyManagementService.Encrypt]. The
    // [CryptoKey.purpose][google.cloud.kms.v1.CryptoKey.purpose] must be
    // [ENCRYPT_DECRYPT][google.cloud.kms.v1.CryptoKey.CryptoKeyPurpose.ENCRYPT_DECRYPT].
    virtual ::grpc::Status Decrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::DecryptRequest& request, ::google::cloud::kms::v1::DecryptResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::DecryptResponse>> AsyncDecrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::DecryptRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::DecryptResponse>>(AsyncDecryptRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::DecryptResponse>> PrepareAsyncDecrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::DecryptRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::DecryptResponse>>(PrepareAsyncDecryptRaw(context, request, cq));
    }
    // Encrypts data using portable cryptographic primitives. Most users should
    // choose [Encrypt][google.cloud.kms.v1.KeyManagementService.Encrypt] and
    // [Decrypt][google.cloud.kms.v1.KeyManagementService.Decrypt] rather than
    // their raw counterparts. The
    // [CryptoKey.purpose][google.cloud.kms.v1.CryptoKey.purpose] must be
    // [RAW_ENCRYPT_DECRYPT][google.cloud.kms.v1.CryptoKey.CryptoKeyPurpose.RAW_ENCRYPT_DECRYPT].
    virtual ::grpc::Status RawEncrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RawEncryptRequest& request, ::google::cloud::kms::v1::RawEncryptResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::RawEncryptResponse>> AsyncRawEncrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RawEncryptRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::RawEncryptResponse>>(AsyncRawEncryptRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::RawEncryptResponse>> PrepareAsyncRawEncrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RawEncryptRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::RawEncryptResponse>>(PrepareAsyncRawEncryptRaw(context, request, cq));
    }
    // Decrypts data that was originally encrypted using a raw cryptographic
    // mechanism. The [CryptoKey.purpose][google.cloud.kms.v1.CryptoKey.purpose]
    // must be
    // [RAW_ENCRYPT_DECRYPT][google.cloud.kms.v1.CryptoKey.CryptoKeyPurpose.RAW_ENCRYPT_DECRYPT].
    virtual ::grpc::Status RawDecrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RawDecryptRequest& request, ::google::cloud::kms::v1::RawDecryptResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::RawDecryptResponse>> AsyncRawDecrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RawDecryptRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::RawDecryptResponse>>(AsyncRawDecryptRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::RawDecryptResponse>> PrepareAsyncRawDecrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RawDecryptRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::RawDecryptResponse>>(PrepareAsyncRawDecryptRaw(context, request, cq));
    }
    // Signs data using a [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion]
    // with [CryptoKey.purpose][google.cloud.kms.v1.CryptoKey.purpose]
    // ASYMMETRIC_SIGN, producing a signature that can be verified with the public
    // key retrieved from
    // [GetPublicKey][google.cloud.kms.v1.KeyManagementService.GetPublicKey].
    virtual ::grpc::Status AsymmetricSign(::grpc::ClientContext* context, const ::google::cloud::kms::v1::AsymmetricSignRequest& request, ::google::cloud::kms::v1::AsymmetricSignResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::AsymmetricSignResponse>> AsyncAsymmetricSign(::grpc::ClientContext* context, const ::google::cloud::kms::v1::AsymmetricSignRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::AsymmetricSignResponse>>(AsyncAsymmetricSignRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::AsymmetricSignResponse>> PrepareAsyncAsymmetricSign(::grpc::ClientContext* context, const ::google::cloud::kms::v1::AsymmetricSignRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::AsymmetricSignResponse>>(PrepareAsyncAsymmetricSignRaw(context, request, cq));
    }
    // Decrypts data that was encrypted with a public key retrieved from
    // [GetPublicKey][google.cloud.kms.v1.KeyManagementService.GetPublicKey]
    // corresponding to a [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion]
    // with [CryptoKey.purpose][google.cloud.kms.v1.CryptoKey.purpose]
    // ASYMMETRIC_DECRYPT.
    virtual ::grpc::Status AsymmetricDecrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::AsymmetricDecryptRequest& request, ::google::cloud::kms::v1::AsymmetricDecryptResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::AsymmetricDecryptResponse>> AsyncAsymmetricDecrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::AsymmetricDecryptRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::AsymmetricDecryptResponse>>(AsyncAsymmetricDecryptRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::AsymmetricDecryptResponse>> PrepareAsyncAsymmetricDecrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::AsymmetricDecryptRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::AsymmetricDecryptResponse>>(PrepareAsyncAsymmetricDecryptRaw(context, request, cq));
    }
    // Signs data using a [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion]
    // with [CryptoKey.purpose][google.cloud.kms.v1.CryptoKey.purpose] MAC,
    // producing a tag that can be verified by another source with the same key.
    virtual ::grpc::Status MacSign(::grpc::ClientContext* context, const ::google::cloud::kms::v1::MacSignRequest& request, ::google::cloud::kms::v1::MacSignResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::MacSignResponse>> AsyncMacSign(::grpc::ClientContext* context, const ::google::cloud::kms::v1::MacSignRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::MacSignResponse>>(AsyncMacSignRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::MacSignResponse>> PrepareAsyncMacSign(::grpc::ClientContext* context, const ::google::cloud::kms::v1::MacSignRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::MacSignResponse>>(PrepareAsyncMacSignRaw(context, request, cq));
    }
    // Verifies MAC tag using a
    // [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion] with
    // [CryptoKey.purpose][google.cloud.kms.v1.CryptoKey.purpose] MAC, and returns
    // a response that indicates whether or not the verification was successful.
    virtual ::grpc::Status MacVerify(::grpc::ClientContext* context, const ::google::cloud::kms::v1::MacVerifyRequest& request, ::google::cloud::kms::v1::MacVerifyResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::MacVerifyResponse>> AsyncMacVerify(::grpc::ClientContext* context, const ::google::cloud::kms::v1::MacVerifyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::MacVerifyResponse>>(AsyncMacVerifyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::MacVerifyResponse>> PrepareAsyncMacVerify(::grpc::ClientContext* context, const ::google::cloud::kms::v1::MacVerifyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::MacVerifyResponse>>(PrepareAsyncMacVerifyRaw(context, request, cq));
    }
    // Generate random bytes using the Cloud KMS randomness source in the provided
    // location.
    virtual ::grpc::Status GenerateRandomBytes(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GenerateRandomBytesRequest& request, ::google::cloud::kms::v1::GenerateRandomBytesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::GenerateRandomBytesResponse>> AsyncGenerateRandomBytes(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GenerateRandomBytesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::GenerateRandomBytesResponse>>(AsyncGenerateRandomBytesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::GenerateRandomBytesResponse>> PrepareAsyncGenerateRandomBytes(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GenerateRandomBytesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::GenerateRandomBytesResponse>>(PrepareAsyncGenerateRandomBytesRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists [KeyRings][google.cloud.kms.v1.KeyRing].
      virtual void ListKeyRings(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListKeyRingsRequest* request, ::google::cloud::kms::v1::ListKeyRingsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListKeyRings(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListKeyRingsRequest* request, ::google::cloud::kms::v1::ListKeyRingsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists [CryptoKeys][google.cloud.kms.v1.CryptoKey].
      virtual void ListCryptoKeys(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListCryptoKeysRequest* request, ::google::cloud::kms::v1::ListCryptoKeysResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListCryptoKeys(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListCryptoKeysRequest* request, ::google::cloud::kms::v1::ListCryptoKeysResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists [CryptoKeyVersions][google.cloud.kms.v1.CryptoKeyVersion].
      virtual void ListCryptoKeyVersions(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListCryptoKeyVersionsRequest* request, ::google::cloud::kms::v1::ListCryptoKeyVersionsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListCryptoKeyVersions(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListCryptoKeyVersionsRequest* request, ::google::cloud::kms::v1::ListCryptoKeyVersionsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists [ImportJobs][google.cloud.kms.v1.ImportJob].
      virtual void ListImportJobs(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListImportJobsRequest* request, ::google::cloud::kms::v1::ListImportJobsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListImportJobs(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListImportJobsRequest* request, ::google::cloud::kms::v1::ListImportJobsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns metadata for a given [KeyRing][google.cloud.kms.v1.KeyRing].
      virtual void GetKeyRing(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetKeyRingRequest* request, ::google::cloud::kms::v1::KeyRing* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetKeyRing(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetKeyRingRequest* request, ::google::cloud::kms::v1::KeyRing* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns metadata for a given [CryptoKey][google.cloud.kms.v1.CryptoKey], as
      // well as its [primary][google.cloud.kms.v1.CryptoKey.primary]
      // [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion].
      virtual void GetCryptoKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetCryptoKeyRequest* request, ::google::cloud::kms::v1::CryptoKey* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetCryptoKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetCryptoKeyRequest* request, ::google::cloud::kms::v1::CryptoKey* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns metadata for a given
      // [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion].
      virtual void GetCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetCryptoKeyVersionRequest* request, ::google::cloud::kms::v1::CryptoKeyVersion* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetCryptoKeyVersionRequest* request, ::google::cloud::kms::v1::CryptoKeyVersion* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns the public key for the given
      // [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion]. The
      // [CryptoKey.purpose][google.cloud.kms.v1.CryptoKey.purpose] must be
      // [ASYMMETRIC_SIGN][google.cloud.kms.v1.CryptoKey.CryptoKeyPurpose.ASYMMETRIC_SIGN]
      // or
      // [ASYMMETRIC_DECRYPT][google.cloud.kms.v1.CryptoKey.CryptoKeyPurpose.ASYMMETRIC_DECRYPT].
      virtual void GetPublicKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetPublicKeyRequest* request, ::google::cloud::kms::v1::PublicKey* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetPublicKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetPublicKeyRequest* request, ::google::cloud::kms::v1::PublicKey* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns metadata for a given [ImportJob][google.cloud.kms.v1.ImportJob].
      virtual void GetImportJob(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetImportJobRequest* request, ::google::cloud::kms::v1::ImportJob* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetImportJob(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetImportJobRequest* request, ::google::cloud::kms::v1::ImportJob* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Create a new [KeyRing][google.cloud.kms.v1.KeyRing] in a given Project and
      // Location.
      virtual void CreateKeyRing(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateKeyRingRequest* request, ::google::cloud::kms::v1::KeyRing* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateKeyRing(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateKeyRingRequest* request, ::google::cloud::kms::v1::KeyRing* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Create a new [CryptoKey][google.cloud.kms.v1.CryptoKey] within a
      // [KeyRing][google.cloud.kms.v1.KeyRing].
      //
      // [CryptoKey.purpose][google.cloud.kms.v1.CryptoKey.purpose] and
      // [CryptoKey.version_template.algorithm][google.cloud.kms.v1.CryptoKeyVersionTemplate.algorithm]
      // are required.
      virtual void CreateCryptoKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateCryptoKeyRequest* request, ::google::cloud::kms::v1::CryptoKey* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateCryptoKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateCryptoKeyRequest* request, ::google::cloud::kms::v1::CryptoKey* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Create a new [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion] in a
      // [CryptoKey][google.cloud.kms.v1.CryptoKey].
      //
      // The server will assign the next sequential id. If unset,
      // [state][google.cloud.kms.v1.CryptoKeyVersion.state] will be set to
      // [ENABLED][google.cloud.kms.v1.CryptoKeyVersion.CryptoKeyVersionState.ENABLED].
      virtual void CreateCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateCryptoKeyVersionRequest* request, ::google::cloud::kms::v1::CryptoKeyVersion* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateCryptoKeyVersionRequest* request, ::google::cloud::kms::v1::CryptoKeyVersion* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Import wrapped key material into a
      // [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion].
      //
      // All requests must specify a [CryptoKey][google.cloud.kms.v1.CryptoKey]. If
      // a [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion] is additionally
      // specified in the request, key material will be reimported into that
      // version. Otherwise, a new version will be created, and will be assigned the
      // next sequential id within the [CryptoKey][google.cloud.kms.v1.CryptoKey].
      virtual void ImportCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ImportCryptoKeyVersionRequest* request, ::google::cloud::kms::v1::CryptoKeyVersion* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ImportCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ImportCryptoKeyVersionRequest* request, ::google::cloud::kms::v1::CryptoKeyVersion* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Create a new [ImportJob][google.cloud.kms.v1.ImportJob] within a
      // [KeyRing][google.cloud.kms.v1.KeyRing].
      //
      // [ImportJob.import_method][google.cloud.kms.v1.ImportJob.import_method] is
      // required.
      virtual void CreateImportJob(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateImportJobRequest* request, ::google::cloud::kms::v1::ImportJob* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateImportJob(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateImportJobRequest* request, ::google::cloud::kms::v1::ImportJob* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Update a [CryptoKey][google.cloud.kms.v1.CryptoKey].
      virtual void UpdateCryptoKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyRequest* request, ::google::cloud::kms::v1::CryptoKey* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateCryptoKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyRequest* request, ::google::cloud::kms::v1::CryptoKey* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Update a [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion]'s
      // metadata.
      //
      // [state][google.cloud.kms.v1.CryptoKeyVersion.state] may be changed between
      // [ENABLED][google.cloud.kms.v1.CryptoKeyVersion.CryptoKeyVersionState.ENABLED]
      // and
      // [DISABLED][google.cloud.kms.v1.CryptoKeyVersion.CryptoKeyVersionState.DISABLED]
      // using this method. See
      // [DestroyCryptoKeyVersion][google.cloud.kms.v1.KeyManagementService.DestroyCryptoKeyVersion]
      // and
      // [RestoreCryptoKeyVersion][google.cloud.kms.v1.KeyManagementService.RestoreCryptoKeyVersion]
      // to move between other states.
      virtual void UpdateCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyVersionRequest* request, ::google::cloud::kms::v1::CryptoKeyVersion* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyVersionRequest* request, ::google::cloud::kms::v1::CryptoKeyVersion* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Update the version of a [CryptoKey][google.cloud.kms.v1.CryptoKey] that
      // will be used in
      // [Encrypt][google.cloud.kms.v1.KeyManagementService.Encrypt].
      //
      // Returns an error if called on a key whose purpose is not
      // [ENCRYPT_DECRYPT][google.cloud.kms.v1.CryptoKey.CryptoKeyPurpose.ENCRYPT_DECRYPT].
      virtual void UpdateCryptoKeyPrimaryVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyPrimaryVersionRequest* request, ::google::cloud::kms::v1::CryptoKey* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateCryptoKeyPrimaryVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyPrimaryVersionRequest* request, ::google::cloud::kms::v1::CryptoKey* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Schedule a [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion] for
      // destruction.
      //
      // Upon calling this method,
      // [CryptoKeyVersion.state][google.cloud.kms.v1.CryptoKeyVersion.state] will
      // be set to
      // [DESTROY_SCHEDULED][google.cloud.kms.v1.CryptoKeyVersion.CryptoKeyVersionState.DESTROY_SCHEDULED],
      // and [destroy_time][google.cloud.kms.v1.CryptoKeyVersion.destroy_time] will
      // be set to the time
      // [destroy_scheduled_duration][google.cloud.kms.v1.CryptoKey.destroy_scheduled_duration]
      // in the future. At that time, the
      // [state][google.cloud.kms.v1.CryptoKeyVersion.state] will automatically
      // change to
      // [DESTROYED][google.cloud.kms.v1.CryptoKeyVersion.CryptoKeyVersionState.DESTROYED],
      // and the key material will be irrevocably destroyed.
      //
      // Before the
      // [destroy_time][google.cloud.kms.v1.CryptoKeyVersion.destroy_time] is
      // reached,
      // [RestoreCryptoKeyVersion][google.cloud.kms.v1.KeyManagementService.RestoreCryptoKeyVersion]
      // may be called to reverse the process.
      virtual void DestroyCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::DestroyCryptoKeyVersionRequest* request, ::google::cloud::kms::v1::CryptoKeyVersion* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DestroyCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::DestroyCryptoKeyVersionRequest* request, ::google::cloud::kms::v1::CryptoKeyVersion* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Restore a [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion] in the
      // [DESTROY_SCHEDULED][google.cloud.kms.v1.CryptoKeyVersion.CryptoKeyVersionState.DESTROY_SCHEDULED]
      // state.
      //
      // Upon restoration of the CryptoKeyVersion,
      // [state][google.cloud.kms.v1.CryptoKeyVersion.state] will be set to
      // [DISABLED][google.cloud.kms.v1.CryptoKeyVersion.CryptoKeyVersionState.DISABLED],
      // and [destroy_time][google.cloud.kms.v1.CryptoKeyVersion.destroy_time] will
      // be cleared.
      virtual void RestoreCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RestoreCryptoKeyVersionRequest* request, ::google::cloud::kms::v1::CryptoKeyVersion* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RestoreCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RestoreCryptoKeyVersionRequest* request, ::google::cloud::kms::v1::CryptoKeyVersion* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Encrypts data, so that it can only be recovered by a call to
      // [Decrypt][google.cloud.kms.v1.KeyManagementService.Decrypt]. The
      // [CryptoKey.purpose][google.cloud.kms.v1.CryptoKey.purpose] must be
      // [ENCRYPT_DECRYPT][google.cloud.kms.v1.CryptoKey.CryptoKeyPurpose.ENCRYPT_DECRYPT].
      virtual void Encrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::EncryptRequest* request, ::google::cloud::kms::v1::EncryptResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void Encrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::EncryptRequest* request, ::google::cloud::kms::v1::EncryptResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Decrypts data that was protected by
      // [Encrypt][google.cloud.kms.v1.KeyManagementService.Encrypt]. The
      // [CryptoKey.purpose][google.cloud.kms.v1.CryptoKey.purpose] must be
      // [ENCRYPT_DECRYPT][google.cloud.kms.v1.CryptoKey.CryptoKeyPurpose.ENCRYPT_DECRYPT].
      virtual void Decrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::DecryptRequest* request, ::google::cloud::kms::v1::DecryptResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void Decrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::DecryptRequest* request, ::google::cloud::kms::v1::DecryptResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Encrypts data using portable cryptographic primitives. Most users should
      // choose [Encrypt][google.cloud.kms.v1.KeyManagementService.Encrypt] and
      // [Decrypt][google.cloud.kms.v1.KeyManagementService.Decrypt] rather than
      // their raw counterparts. The
      // [CryptoKey.purpose][google.cloud.kms.v1.CryptoKey.purpose] must be
      // [RAW_ENCRYPT_DECRYPT][google.cloud.kms.v1.CryptoKey.CryptoKeyPurpose.RAW_ENCRYPT_DECRYPT].
      virtual void RawEncrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RawEncryptRequest* request, ::google::cloud::kms::v1::RawEncryptResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RawEncrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RawEncryptRequest* request, ::google::cloud::kms::v1::RawEncryptResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Decrypts data that was originally encrypted using a raw cryptographic
      // mechanism. The [CryptoKey.purpose][google.cloud.kms.v1.CryptoKey.purpose]
      // must be
      // [RAW_ENCRYPT_DECRYPT][google.cloud.kms.v1.CryptoKey.CryptoKeyPurpose.RAW_ENCRYPT_DECRYPT].
      virtual void RawDecrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RawDecryptRequest* request, ::google::cloud::kms::v1::RawDecryptResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RawDecrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RawDecryptRequest* request, ::google::cloud::kms::v1::RawDecryptResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Signs data using a [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion]
      // with [CryptoKey.purpose][google.cloud.kms.v1.CryptoKey.purpose]
      // ASYMMETRIC_SIGN, producing a signature that can be verified with the public
      // key retrieved from
      // [GetPublicKey][google.cloud.kms.v1.KeyManagementService.GetPublicKey].
      virtual void AsymmetricSign(::grpc::ClientContext* context, const ::google::cloud::kms::v1::AsymmetricSignRequest* request, ::google::cloud::kms::v1::AsymmetricSignResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void AsymmetricSign(::grpc::ClientContext* context, const ::google::cloud::kms::v1::AsymmetricSignRequest* request, ::google::cloud::kms::v1::AsymmetricSignResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Decrypts data that was encrypted with a public key retrieved from
      // [GetPublicKey][google.cloud.kms.v1.KeyManagementService.GetPublicKey]
      // corresponding to a [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion]
      // with [CryptoKey.purpose][google.cloud.kms.v1.CryptoKey.purpose]
      // ASYMMETRIC_DECRYPT.
      virtual void AsymmetricDecrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::AsymmetricDecryptRequest* request, ::google::cloud::kms::v1::AsymmetricDecryptResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void AsymmetricDecrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::AsymmetricDecryptRequest* request, ::google::cloud::kms::v1::AsymmetricDecryptResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Signs data using a [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion]
      // with [CryptoKey.purpose][google.cloud.kms.v1.CryptoKey.purpose] MAC,
      // producing a tag that can be verified by another source with the same key.
      virtual void MacSign(::grpc::ClientContext* context, const ::google::cloud::kms::v1::MacSignRequest* request, ::google::cloud::kms::v1::MacSignResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void MacSign(::grpc::ClientContext* context, const ::google::cloud::kms::v1::MacSignRequest* request, ::google::cloud::kms::v1::MacSignResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Verifies MAC tag using a
      // [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion] with
      // [CryptoKey.purpose][google.cloud.kms.v1.CryptoKey.purpose] MAC, and returns
      // a response that indicates whether or not the verification was successful.
      virtual void MacVerify(::grpc::ClientContext* context, const ::google::cloud::kms::v1::MacVerifyRequest* request, ::google::cloud::kms::v1::MacVerifyResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void MacVerify(::grpc::ClientContext* context, const ::google::cloud::kms::v1::MacVerifyRequest* request, ::google::cloud::kms::v1::MacVerifyResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Generate random bytes using the Cloud KMS randomness source in the provided
      // location.
      virtual void GenerateRandomBytes(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GenerateRandomBytesRequest* request, ::google::cloud::kms::v1::GenerateRandomBytesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GenerateRandomBytes(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GenerateRandomBytesRequest* request, ::google::cloud::kms::v1::GenerateRandomBytesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ListKeyRingsResponse>* AsyncListKeyRingsRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListKeyRingsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ListKeyRingsResponse>* PrepareAsyncListKeyRingsRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListKeyRingsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ListCryptoKeysResponse>* AsyncListCryptoKeysRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListCryptoKeysRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ListCryptoKeysResponse>* PrepareAsyncListCryptoKeysRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListCryptoKeysRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ListCryptoKeyVersionsResponse>* AsyncListCryptoKeyVersionsRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListCryptoKeyVersionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ListCryptoKeyVersionsResponse>* PrepareAsyncListCryptoKeyVersionsRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListCryptoKeyVersionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ListImportJobsResponse>* AsyncListImportJobsRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListImportJobsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ListImportJobsResponse>* PrepareAsyncListImportJobsRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListImportJobsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::KeyRing>* AsyncGetKeyRingRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetKeyRingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::KeyRing>* PrepareAsyncGetKeyRingRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetKeyRingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKey>* AsyncGetCryptoKeyRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetCryptoKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKey>* PrepareAsyncGetCryptoKeyRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetCryptoKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKeyVersion>* AsyncGetCryptoKeyVersionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKeyVersion>* PrepareAsyncGetCryptoKeyVersionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::PublicKey>* AsyncGetPublicKeyRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetPublicKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::PublicKey>* PrepareAsyncGetPublicKeyRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetPublicKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ImportJob>* AsyncGetImportJobRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetImportJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ImportJob>* PrepareAsyncGetImportJobRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetImportJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::KeyRing>* AsyncCreateKeyRingRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateKeyRingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::KeyRing>* PrepareAsyncCreateKeyRingRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateKeyRingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKey>* AsyncCreateCryptoKeyRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateCryptoKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKey>* PrepareAsyncCreateCryptoKeyRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateCryptoKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKeyVersion>* AsyncCreateCryptoKeyVersionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKeyVersion>* PrepareAsyncCreateCryptoKeyVersionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKeyVersion>* AsyncImportCryptoKeyVersionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ImportCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKeyVersion>* PrepareAsyncImportCryptoKeyVersionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ImportCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ImportJob>* AsyncCreateImportJobRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateImportJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ImportJob>* PrepareAsyncCreateImportJobRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateImportJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKey>* AsyncUpdateCryptoKeyRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKey>* PrepareAsyncUpdateCryptoKeyRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKeyVersion>* AsyncUpdateCryptoKeyVersionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKeyVersion>* PrepareAsyncUpdateCryptoKeyVersionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKey>* AsyncUpdateCryptoKeyPrimaryVersionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyPrimaryVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKey>* PrepareAsyncUpdateCryptoKeyPrimaryVersionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyPrimaryVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKeyVersion>* AsyncDestroyCryptoKeyVersionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::DestroyCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKeyVersion>* PrepareAsyncDestroyCryptoKeyVersionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::DestroyCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKeyVersion>* AsyncRestoreCryptoKeyVersionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RestoreCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::CryptoKeyVersion>* PrepareAsyncRestoreCryptoKeyVersionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RestoreCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::EncryptResponse>* AsyncEncryptRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::EncryptRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::EncryptResponse>* PrepareAsyncEncryptRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::EncryptRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::DecryptResponse>* AsyncDecryptRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::DecryptRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::DecryptResponse>* PrepareAsyncDecryptRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::DecryptRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::RawEncryptResponse>* AsyncRawEncryptRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RawEncryptRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::RawEncryptResponse>* PrepareAsyncRawEncryptRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RawEncryptRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::RawDecryptResponse>* AsyncRawDecryptRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RawDecryptRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::RawDecryptResponse>* PrepareAsyncRawDecryptRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RawDecryptRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::AsymmetricSignResponse>* AsyncAsymmetricSignRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::AsymmetricSignRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::AsymmetricSignResponse>* PrepareAsyncAsymmetricSignRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::AsymmetricSignRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::AsymmetricDecryptResponse>* AsyncAsymmetricDecryptRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::AsymmetricDecryptRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::AsymmetricDecryptResponse>* PrepareAsyncAsymmetricDecryptRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::AsymmetricDecryptRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::MacSignResponse>* AsyncMacSignRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::MacSignRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::MacSignResponse>* PrepareAsyncMacSignRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::MacSignRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::MacVerifyResponse>* AsyncMacVerifyRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::MacVerifyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::MacVerifyResponse>* PrepareAsyncMacVerifyRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::MacVerifyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::GenerateRandomBytesResponse>* AsyncGenerateRandomBytesRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GenerateRandomBytesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::GenerateRandomBytesResponse>* PrepareAsyncGenerateRandomBytesRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GenerateRandomBytesRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListKeyRings(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListKeyRingsRequest& request, ::google::cloud::kms::v1::ListKeyRingsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ListKeyRingsResponse>> AsyncListKeyRings(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListKeyRingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ListKeyRingsResponse>>(AsyncListKeyRingsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ListKeyRingsResponse>> PrepareAsyncListKeyRings(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListKeyRingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ListKeyRingsResponse>>(PrepareAsyncListKeyRingsRaw(context, request, cq));
    }
    ::grpc::Status ListCryptoKeys(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListCryptoKeysRequest& request, ::google::cloud::kms::v1::ListCryptoKeysResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ListCryptoKeysResponse>> AsyncListCryptoKeys(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListCryptoKeysRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ListCryptoKeysResponse>>(AsyncListCryptoKeysRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ListCryptoKeysResponse>> PrepareAsyncListCryptoKeys(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListCryptoKeysRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ListCryptoKeysResponse>>(PrepareAsyncListCryptoKeysRaw(context, request, cq));
    }
    ::grpc::Status ListCryptoKeyVersions(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListCryptoKeyVersionsRequest& request, ::google::cloud::kms::v1::ListCryptoKeyVersionsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ListCryptoKeyVersionsResponse>> AsyncListCryptoKeyVersions(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListCryptoKeyVersionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ListCryptoKeyVersionsResponse>>(AsyncListCryptoKeyVersionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ListCryptoKeyVersionsResponse>> PrepareAsyncListCryptoKeyVersions(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListCryptoKeyVersionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ListCryptoKeyVersionsResponse>>(PrepareAsyncListCryptoKeyVersionsRaw(context, request, cq));
    }
    ::grpc::Status ListImportJobs(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListImportJobsRequest& request, ::google::cloud::kms::v1::ListImportJobsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ListImportJobsResponse>> AsyncListImportJobs(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListImportJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ListImportJobsResponse>>(AsyncListImportJobsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ListImportJobsResponse>> PrepareAsyncListImportJobs(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListImportJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ListImportJobsResponse>>(PrepareAsyncListImportJobsRaw(context, request, cq));
    }
    ::grpc::Status GetKeyRing(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetKeyRingRequest& request, ::google::cloud::kms::v1::KeyRing* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::KeyRing>> AsyncGetKeyRing(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetKeyRingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::KeyRing>>(AsyncGetKeyRingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::KeyRing>> PrepareAsyncGetKeyRing(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetKeyRingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::KeyRing>>(PrepareAsyncGetKeyRingRaw(context, request, cq));
    }
    ::grpc::Status GetCryptoKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetCryptoKeyRequest& request, ::google::cloud::kms::v1::CryptoKey* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKey>> AsyncGetCryptoKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetCryptoKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKey>>(AsyncGetCryptoKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKey>> PrepareAsyncGetCryptoKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetCryptoKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKey>>(PrepareAsyncGetCryptoKeyRaw(context, request, cq));
    }
    ::grpc::Status GetCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetCryptoKeyVersionRequest& request, ::google::cloud::kms::v1::CryptoKeyVersion* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKeyVersion>> AsyncGetCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKeyVersion>>(AsyncGetCryptoKeyVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKeyVersion>> PrepareAsyncGetCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKeyVersion>>(PrepareAsyncGetCryptoKeyVersionRaw(context, request, cq));
    }
    ::grpc::Status GetPublicKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetPublicKeyRequest& request, ::google::cloud::kms::v1::PublicKey* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::PublicKey>> AsyncGetPublicKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetPublicKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::PublicKey>>(AsyncGetPublicKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::PublicKey>> PrepareAsyncGetPublicKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetPublicKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::PublicKey>>(PrepareAsyncGetPublicKeyRaw(context, request, cq));
    }
    ::grpc::Status GetImportJob(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetImportJobRequest& request, ::google::cloud::kms::v1::ImportJob* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ImportJob>> AsyncGetImportJob(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetImportJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ImportJob>>(AsyncGetImportJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ImportJob>> PrepareAsyncGetImportJob(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetImportJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ImportJob>>(PrepareAsyncGetImportJobRaw(context, request, cq));
    }
    ::grpc::Status CreateKeyRing(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateKeyRingRequest& request, ::google::cloud::kms::v1::KeyRing* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::KeyRing>> AsyncCreateKeyRing(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateKeyRingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::KeyRing>>(AsyncCreateKeyRingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::KeyRing>> PrepareAsyncCreateKeyRing(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateKeyRingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::KeyRing>>(PrepareAsyncCreateKeyRingRaw(context, request, cq));
    }
    ::grpc::Status CreateCryptoKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateCryptoKeyRequest& request, ::google::cloud::kms::v1::CryptoKey* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKey>> AsyncCreateCryptoKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateCryptoKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKey>>(AsyncCreateCryptoKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKey>> PrepareAsyncCreateCryptoKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateCryptoKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKey>>(PrepareAsyncCreateCryptoKeyRaw(context, request, cq));
    }
    ::grpc::Status CreateCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateCryptoKeyVersionRequest& request, ::google::cloud::kms::v1::CryptoKeyVersion* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKeyVersion>> AsyncCreateCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKeyVersion>>(AsyncCreateCryptoKeyVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKeyVersion>> PrepareAsyncCreateCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKeyVersion>>(PrepareAsyncCreateCryptoKeyVersionRaw(context, request, cq));
    }
    ::grpc::Status ImportCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ImportCryptoKeyVersionRequest& request, ::google::cloud::kms::v1::CryptoKeyVersion* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKeyVersion>> AsyncImportCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ImportCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKeyVersion>>(AsyncImportCryptoKeyVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKeyVersion>> PrepareAsyncImportCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ImportCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKeyVersion>>(PrepareAsyncImportCryptoKeyVersionRaw(context, request, cq));
    }
    ::grpc::Status CreateImportJob(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateImportJobRequest& request, ::google::cloud::kms::v1::ImportJob* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ImportJob>> AsyncCreateImportJob(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateImportJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ImportJob>>(AsyncCreateImportJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ImportJob>> PrepareAsyncCreateImportJob(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateImportJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ImportJob>>(PrepareAsyncCreateImportJobRaw(context, request, cq));
    }
    ::grpc::Status UpdateCryptoKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyRequest& request, ::google::cloud::kms::v1::CryptoKey* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKey>> AsyncUpdateCryptoKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKey>>(AsyncUpdateCryptoKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKey>> PrepareAsyncUpdateCryptoKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKey>>(PrepareAsyncUpdateCryptoKeyRaw(context, request, cq));
    }
    ::grpc::Status UpdateCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyVersionRequest& request, ::google::cloud::kms::v1::CryptoKeyVersion* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKeyVersion>> AsyncUpdateCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKeyVersion>>(AsyncUpdateCryptoKeyVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKeyVersion>> PrepareAsyncUpdateCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKeyVersion>>(PrepareAsyncUpdateCryptoKeyVersionRaw(context, request, cq));
    }
    ::grpc::Status UpdateCryptoKeyPrimaryVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyPrimaryVersionRequest& request, ::google::cloud::kms::v1::CryptoKey* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKey>> AsyncUpdateCryptoKeyPrimaryVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyPrimaryVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKey>>(AsyncUpdateCryptoKeyPrimaryVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKey>> PrepareAsyncUpdateCryptoKeyPrimaryVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyPrimaryVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKey>>(PrepareAsyncUpdateCryptoKeyPrimaryVersionRaw(context, request, cq));
    }
    ::grpc::Status DestroyCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::DestroyCryptoKeyVersionRequest& request, ::google::cloud::kms::v1::CryptoKeyVersion* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKeyVersion>> AsyncDestroyCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::DestroyCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKeyVersion>>(AsyncDestroyCryptoKeyVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKeyVersion>> PrepareAsyncDestroyCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::DestroyCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKeyVersion>>(PrepareAsyncDestroyCryptoKeyVersionRaw(context, request, cq));
    }
    ::grpc::Status RestoreCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RestoreCryptoKeyVersionRequest& request, ::google::cloud::kms::v1::CryptoKeyVersion* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKeyVersion>> AsyncRestoreCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RestoreCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKeyVersion>>(AsyncRestoreCryptoKeyVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKeyVersion>> PrepareAsyncRestoreCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RestoreCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKeyVersion>>(PrepareAsyncRestoreCryptoKeyVersionRaw(context, request, cq));
    }
    ::grpc::Status Encrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::EncryptRequest& request, ::google::cloud::kms::v1::EncryptResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::EncryptResponse>> AsyncEncrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::EncryptRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::EncryptResponse>>(AsyncEncryptRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::EncryptResponse>> PrepareAsyncEncrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::EncryptRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::EncryptResponse>>(PrepareAsyncEncryptRaw(context, request, cq));
    }
    ::grpc::Status Decrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::DecryptRequest& request, ::google::cloud::kms::v1::DecryptResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::DecryptResponse>> AsyncDecrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::DecryptRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::DecryptResponse>>(AsyncDecryptRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::DecryptResponse>> PrepareAsyncDecrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::DecryptRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::DecryptResponse>>(PrepareAsyncDecryptRaw(context, request, cq));
    }
    ::grpc::Status RawEncrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RawEncryptRequest& request, ::google::cloud::kms::v1::RawEncryptResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::RawEncryptResponse>> AsyncRawEncrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RawEncryptRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::RawEncryptResponse>>(AsyncRawEncryptRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::RawEncryptResponse>> PrepareAsyncRawEncrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RawEncryptRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::RawEncryptResponse>>(PrepareAsyncRawEncryptRaw(context, request, cq));
    }
    ::grpc::Status RawDecrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RawDecryptRequest& request, ::google::cloud::kms::v1::RawDecryptResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::RawDecryptResponse>> AsyncRawDecrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RawDecryptRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::RawDecryptResponse>>(AsyncRawDecryptRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::RawDecryptResponse>> PrepareAsyncRawDecrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RawDecryptRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::RawDecryptResponse>>(PrepareAsyncRawDecryptRaw(context, request, cq));
    }
    ::grpc::Status AsymmetricSign(::grpc::ClientContext* context, const ::google::cloud::kms::v1::AsymmetricSignRequest& request, ::google::cloud::kms::v1::AsymmetricSignResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::AsymmetricSignResponse>> AsyncAsymmetricSign(::grpc::ClientContext* context, const ::google::cloud::kms::v1::AsymmetricSignRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::AsymmetricSignResponse>>(AsyncAsymmetricSignRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::AsymmetricSignResponse>> PrepareAsyncAsymmetricSign(::grpc::ClientContext* context, const ::google::cloud::kms::v1::AsymmetricSignRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::AsymmetricSignResponse>>(PrepareAsyncAsymmetricSignRaw(context, request, cq));
    }
    ::grpc::Status AsymmetricDecrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::AsymmetricDecryptRequest& request, ::google::cloud::kms::v1::AsymmetricDecryptResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::AsymmetricDecryptResponse>> AsyncAsymmetricDecrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::AsymmetricDecryptRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::AsymmetricDecryptResponse>>(AsyncAsymmetricDecryptRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::AsymmetricDecryptResponse>> PrepareAsyncAsymmetricDecrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::AsymmetricDecryptRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::AsymmetricDecryptResponse>>(PrepareAsyncAsymmetricDecryptRaw(context, request, cq));
    }
    ::grpc::Status MacSign(::grpc::ClientContext* context, const ::google::cloud::kms::v1::MacSignRequest& request, ::google::cloud::kms::v1::MacSignResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::MacSignResponse>> AsyncMacSign(::grpc::ClientContext* context, const ::google::cloud::kms::v1::MacSignRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::MacSignResponse>>(AsyncMacSignRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::MacSignResponse>> PrepareAsyncMacSign(::grpc::ClientContext* context, const ::google::cloud::kms::v1::MacSignRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::MacSignResponse>>(PrepareAsyncMacSignRaw(context, request, cq));
    }
    ::grpc::Status MacVerify(::grpc::ClientContext* context, const ::google::cloud::kms::v1::MacVerifyRequest& request, ::google::cloud::kms::v1::MacVerifyResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::MacVerifyResponse>> AsyncMacVerify(::grpc::ClientContext* context, const ::google::cloud::kms::v1::MacVerifyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::MacVerifyResponse>>(AsyncMacVerifyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::MacVerifyResponse>> PrepareAsyncMacVerify(::grpc::ClientContext* context, const ::google::cloud::kms::v1::MacVerifyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::MacVerifyResponse>>(PrepareAsyncMacVerifyRaw(context, request, cq));
    }
    ::grpc::Status GenerateRandomBytes(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GenerateRandomBytesRequest& request, ::google::cloud::kms::v1::GenerateRandomBytesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::GenerateRandomBytesResponse>> AsyncGenerateRandomBytes(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GenerateRandomBytesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::GenerateRandomBytesResponse>>(AsyncGenerateRandomBytesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::GenerateRandomBytesResponse>> PrepareAsyncGenerateRandomBytes(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GenerateRandomBytesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::GenerateRandomBytesResponse>>(PrepareAsyncGenerateRandomBytesRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListKeyRings(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListKeyRingsRequest* request, ::google::cloud::kms::v1::ListKeyRingsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListKeyRings(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListKeyRingsRequest* request, ::google::cloud::kms::v1::ListKeyRingsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListCryptoKeys(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListCryptoKeysRequest* request, ::google::cloud::kms::v1::ListCryptoKeysResponse* response, std::function<void(::grpc::Status)>) override;
      void ListCryptoKeys(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListCryptoKeysRequest* request, ::google::cloud::kms::v1::ListCryptoKeysResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListCryptoKeyVersions(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListCryptoKeyVersionsRequest* request, ::google::cloud::kms::v1::ListCryptoKeyVersionsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListCryptoKeyVersions(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListCryptoKeyVersionsRequest* request, ::google::cloud::kms::v1::ListCryptoKeyVersionsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListImportJobs(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListImportJobsRequest* request, ::google::cloud::kms::v1::ListImportJobsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListImportJobs(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListImportJobsRequest* request, ::google::cloud::kms::v1::ListImportJobsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetKeyRing(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetKeyRingRequest* request, ::google::cloud::kms::v1::KeyRing* response, std::function<void(::grpc::Status)>) override;
      void GetKeyRing(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetKeyRingRequest* request, ::google::cloud::kms::v1::KeyRing* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetCryptoKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetCryptoKeyRequest* request, ::google::cloud::kms::v1::CryptoKey* response, std::function<void(::grpc::Status)>) override;
      void GetCryptoKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetCryptoKeyRequest* request, ::google::cloud::kms::v1::CryptoKey* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetCryptoKeyVersionRequest* request, ::google::cloud::kms::v1::CryptoKeyVersion* response, std::function<void(::grpc::Status)>) override;
      void GetCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetCryptoKeyVersionRequest* request, ::google::cloud::kms::v1::CryptoKeyVersion* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetPublicKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetPublicKeyRequest* request, ::google::cloud::kms::v1::PublicKey* response, std::function<void(::grpc::Status)>) override;
      void GetPublicKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetPublicKeyRequest* request, ::google::cloud::kms::v1::PublicKey* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetImportJob(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetImportJobRequest* request, ::google::cloud::kms::v1::ImportJob* response, std::function<void(::grpc::Status)>) override;
      void GetImportJob(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetImportJobRequest* request, ::google::cloud::kms::v1::ImportJob* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateKeyRing(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateKeyRingRequest* request, ::google::cloud::kms::v1::KeyRing* response, std::function<void(::grpc::Status)>) override;
      void CreateKeyRing(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateKeyRingRequest* request, ::google::cloud::kms::v1::KeyRing* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateCryptoKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateCryptoKeyRequest* request, ::google::cloud::kms::v1::CryptoKey* response, std::function<void(::grpc::Status)>) override;
      void CreateCryptoKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateCryptoKeyRequest* request, ::google::cloud::kms::v1::CryptoKey* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateCryptoKeyVersionRequest* request, ::google::cloud::kms::v1::CryptoKeyVersion* response, std::function<void(::grpc::Status)>) override;
      void CreateCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateCryptoKeyVersionRequest* request, ::google::cloud::kms::v1::CryptoKeyVersion* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ImportCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ImportCryptoKeyVersionRequest* request, ::google::cloud::kms::v1::CryptoKeyVersion* response, std::function<void(::grpc::Status)>) override;
      void ImportCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ImportCryptoKeyVersionRequest* request, ::google::cloud::kms::v1::CryptoKeyVersion* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateImportJob(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateImportJobRequest* request, ::google::cloud::kms::v1::ImportJob* response, std::function<void(::grpc::Status)>) override;
      void CreateImportJob(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateImportJobRequest* request, ::google::cloud::kms::v1::ImportJob* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateCryptoKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyRequest* request, ::google::cloud::kms::v1::CryptoKey* response, std::function<void(::grpc::Status)>) override;
      void UpdateCryptoKey(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyRequest* request, ::google::cloud::kms::v1::CryptoKey* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyVersionRequest* request, ::google::cloud::kms::v1::CryptoKeyVersion* response, std::function<void(::grpc::Status)>) override;
      void UpdateCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyVersionRequest* request, ::google::cloud::kms::v1::CryptoKeyVersion* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateCryptoKeyPrimaryVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyPrimaryVersionRequest* request, ::google::cloud::kms::v1::CryptoKey* response, std::function<void(::grpc::Status)>) override;
      void UpdateCryptoKeyPrimaryVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyPrimaryVersionRequest* request, ::google::cloud::kms::v1::CryptoKey* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DestroyCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::DestroyCryptoKeyVersionRequest* request, ::google::cloud::kms::v1::CryptoKeyVersion* response, std::function<void(::grpc::Status)>) override;
      void DestroyCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::DestroyCryptoKeyVersionRequest* request, ::google::cloud::kms::v1::CryptoKeyVersion* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RestoreCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RestoreCryptoKeyVersionRequest* request, ::google::cloud::kms::v1::CryptoKeyVersion* response, std::function<void(::grpc::Status)>) override;
      void RestoreCryptoKeyVersion(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RestoreCryptoKeyVersionRequest* request, ::google::cloud::kms::v1::CryptoKeyVersion* response, ::grpc::ClientUnaryReactor* reactor) override;
      void Encrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::EncryptRequest* request, ::google::cloud::kms::v1::EncryptResponse* response, std::function<void(::grpc::Status)>) override;
      void Encrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::EncryptRequest* request, ::google::cloud::kms::v1::EncryptResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void Decrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::DecryptRequest* request, ::google::cloud::kms::v1::DecryptResponse* response, std::function<void(::grpc::Status)>) override;
      void Decrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::DecryptRequest* request, ::google::cloud::kms::v1::DecryptResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RawEncrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RawEncryptRequest* request, ::google::cloud::kms::v1::RawEncryptResponse* response, std::function<void(::grpc::Status)>) override;
      void RawEncrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RawEncryptRequest* request, ::google::cloud::kms::v1::RawEncryptResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RawDecrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RawDecryptRequest* request, ::google::cloud::kms::v1::RawDecryptResponse* response, std::function<void(::grpc::Status)>) override;
      void RawDecrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RawDecryptRequest* request, ::google::cloud::kms::v1::RawDecryptResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void AsymmetricSign(::grpc::ClientContext* context, const ::google::cloud::kms::v1::AsymmetricSignRequest* request, ::google::cloud::kms::v1::AsymmetricSignResponse* response, std::function<void(::grpc::Status)>) override;
      void AsymmetricSign(::grpc::ClientContext* context, const ::google::cloud::kms::v1::AsymmetricSignRequest* request, ::google::cloud::kms::v1::AsymmetricSignResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void AsymmetricDecrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::AsymmetricDecryptRequest* request, ::google::cloud::kms::v1::AsymmetricDecryptResponse* response, std::function<void(::grpc::Status)>) override;
      void AsymmetricDecrypt(::grpc::ClientContext* context, const ::google::cloud::kms::v1::AsymmetricDecryptRequest* request, ::google::cloud::kms::v1::AsymmetricDecryptResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void MacSign(::grpc::ClientContext* context, const ::google::cloud::kms::v1::MacSignRequest* request, ::google::cloud::kms::v1::MacSignResponse* response, std::function<void(::grpc::Status)>) override;
      void MacSign(::grpc::ClientContext* context, const ::google::cloud::kms::v1::MacSignRequest* request, ::google::cloud::kms::v1::MacSignResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void MacVerify(::grpc::ClientContext* context, const ::google::cloud::kms::v1::MacVerifyRequest* request, ::google::cloud::kms::v1::MacVerifyResponse* response, std::function<void(::grpc::Status)>) override;
      void MacVerify(::grpc::ClientContext* context, const ::google::cloud::kms::v1::MacVerifyRequest* request, ::google::cloud::kms::v1::MacVerifyResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GenerateRandomBytes(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GenerateRandomBytesRequest* request, ::google::cloud::kms::v1::GenerateRandomBytesResponse* response, std::function<void(::grpc::Status)>) override;
      void GenerateRandomBytes(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GenerateRandomBytesRequest* request, ::google::cloud::kms::v1::GenerateRandomBytesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ListKeyRingsResponse>* AsyncListKeyRingsRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListKeyRingsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ListKeyRingsResponse>* PrepareAsyncListKeyRingsRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListKeyRingsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ListCryptoKeysResponse>* AsyncListCryptoKeysRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListCryptoKeysRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ListCryptoKeysResponse>* PrepareAsyncListCryptoKeysRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListCryptoKeysRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ListCryptoKeyVersionsResponse>* AsyncListCryptoKeyVersionsRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListCryptoKeyVersionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ListCryptoKeyVersionsResponse>* PrepareAsyncListCryptoKeyVersionsRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListCryptoKeyVersionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ListImportJobsResponse>* AsyncListImportJobsRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListImportJobsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ListImportJobsResponse>* PrepareAsyncListImportJobsRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ListImportJobsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::KeyRing>* AsyncGetKeyRingRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetKeyRingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::KeyRing>* PrepareAsyncGetKeyRingRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetKeyRingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKey>* AsyncGetCryptoKeyRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetCryptoKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKey>* PrepareAsyncGetCryptoKeyRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetCryptoKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKeyVersion>* AsyncGetCryptoKeyVersionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKeyVersion>* PrepareAsyncGetCryptoKeyVersionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::PublicKey>* AsyncGetPublicKeyRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetPublicKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::PublicKey>* PrepareAsyncGetPublicKeyRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetPublicKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ImportJob>* AsyncGetImportJobRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetImportJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ImportJob>* PrepareAsyncGetImportJobRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetImportJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::KeyRing>* AsyncCreateKeyRingRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateKeyRingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::KeyRing>* PrepareAsyncCreateKeyRingRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateKeyRingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKey>* AsyncCreateCryptoKeyRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateCryptoKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKey>* PrepareAsyncCreateCryptoKeyRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateCryptoKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKeyVersion>* AsyncCreateCryptoKeyVersionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKeyVersion>* PrepareAsyncCreateCryptoKeyVersionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKeyVersion>* AsyncImportCryptoKeyVersionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ImportCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKeyVersion>* PrepareAsyncImportCryptoKeyVersionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ImportCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ImportJob>* AsyncCreateImportJobRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateImportJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ImportJob>* PrepareAsyncCreateImportJobRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::CreateImportJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKey>* AsyncUpdateCryptoKeyRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKey>* PrepareAsyncUpdateCryptoKeyRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKeyVersion>* AsyncUpdateCryptoKeyVersionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKeyVersion>* PrepareAsyncUpdateCryptoKeyVersionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKey>* AsyncUpdateCryptoKeyPrimaryVersionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyPrimaryVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKey>* PrepareAsyncUpdateCryptoKeyPrimaryVersionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyPrimaryVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKeyVersion>* AsyncDestroyCryptoKeyVersionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::DestroyCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKeyVersion>* PrepareAsyncDestroyCryptoKeyVersionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::DestroyCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKeyVersion>* AsyncRestoreCryptoKeyVersionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RestoreCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::CryptoKeyVersion>* PrepareAsyncRestoreCryptoKeyVersionRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RestoreCryptoKeyVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::EncryptResponse>* AsyncEncryptRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::EncryptRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::EncryptResponse>* PrepareAsyncEncryptRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::EncryptRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::DecryptResponse>* AsyncDecryptRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::DecryptRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::DecryptResponse>* PrepareAsyncDecryptRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::DecryptRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::RawEncryptResponse>* AsyncRawEncryptRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RawEncryptRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::RawEncryptResponse>* PrepareAsyncRawEncryptRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RawEncryptRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::RawDecryptResponse>* AsyncRawDecryptRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RawDecryptRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::RawDecryptResponse>* PrepareAsyncRawDecryptRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::RawDecryptRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::AsymmetricSignResponse>* AsyncAsymmetricSignRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::AsymmetricSignRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::AsymmetricSignResponse>* PrepareAsyncAsymmetricSignRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::AsymmetricSignRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::AsymmetricDecryptResponse>* AsyncAsymmetricDecryptRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::AsymmetricDecryptRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::AsymmetricDecryptResponse>* PrepareAsyncAsymmetricDecryptRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::AsymmetricDecryptRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::MacSignResponse>* AsyncMacSignRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::MacSignRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::MacSignResponse>* PrepareAsyncMacSignRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::MacSignRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::MacVerifyResponse>* AsyncMacVerifyRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::MacVerifyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::MacVerifyResponse>* PrepareAsyncMacVerifyRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::MacVerifyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::GenerateRandomBytesResponse>* AsyncGenerateRandomBytesRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GenerateRandomBytesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::GenerateRandomBytesResponse>* PrepareAsyncGenerateRandomBytesRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GenerateRandomBytesRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListKeyRings_;
    const ::grpc::internal::RpcMethod rpcmethod_ListCryptoKeys_;
    const ::grpc::internal::RpcMethod rpcmethod_ListCryptoKeyVersions_;
    const ::grpc::internal::RpcMethod rpcmethod_ListImportJobs_;
    const ::grpc::internal::RpcMethod rpcmethod_GetKeyRing_;
    const ::grpc::internal::RpcMethod rpcmethod_GetCryptoKey_;
    const ::grpc::internal::RpcMethod rpcmethod_GetCryptoKeyVersion_;
    const ::grpc::internal::RpcMethod rpcmethod_GetPublicKey_;
    const ::grpc::internal::RpcMethod rpcmethod_GetImportJob_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateKeyRing_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateCryptoKey_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateCryptoKeyVersion_;
    const ::grpc::internal::RpcMethod rpcmethod_ImportCryptoKeyVersion_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateImportJob_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateCryptoKey_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateCryptoKeyVersion_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateCryptoKeyPrimaryVersion_;
    const ::grpc::internal::RpcMethod rpcmethod_DestroyCryptoKeyVersion_;
    const ::grpc::internal::RpcMethod rpcmethod_RestoreCryptoKeyVersion_;
    const ::grpc::internal::RpcMethod rpcmethod_Encrypt_;
    const ::grpc::internal::RpcMethod rpcmethod_Decrypt_;
    const ::grpc::internal::RpcMethod rpcmethod_RawEncrypt_;
    const ::grpc::internal::RpcMethod rpcmethod_RawDecrypt_;
    const ::grpc::internal::RpcMethod rpcmethod_AsymmetricSign_;
    const ::grpc::internal::RpcMethod rpcmethod_AsymmetricDecrypt_;
    const ::grpc::internal::RpcMethod rpcmethod_MacSign_;
    const ::grpc::internal::RpcMethod rpcmethod_MacVerify_;
    const ::grpc::internal::RpcMethod rpcmethod_GenerateRandomBytes_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists [KeyRings][google.cloud.kms.v1.KeyRing].
    virtual ::grpc::Status ListKeyRings(::grpc::ServerContext* context, const ::google::cloud::kms::v1::ListKeyRingsRequest* request, ::google::cloud::kms::v1::ListKeyRingsResponse* response);
    // Lists [CryptoKeys][google.cloud.kms.v1.CryptoKey].
    virtual ::grpc::Status ListCryptoKeys(::grpc::ServerContext* context, const ::google::cloud::kms::v1::ListCryptoKeysRequest* request, ::google::cloud::kms::v1::ListCryptoKeysResponse* response);
    // Lists [CryptoKeyVersions][google.cloud.kms.v1.CryptoKeyVersion].
    virtual ::grpc::Status ListCryptoKeyVersions(::grpc::ServerContext* context, const ::google::cloud::kms::v1::ListCryptoKeyVersionsRequest* request, ::google::cloud::kms::v1::ListCryptoKeyVersionsResponse* response);
    // Lists [ImportJobs][google.cloud.kms.v1.ImportJob].
    virtual ::grpc::Status ListImportJobs(::grpc::ServerContext* context, const ::google::cloud::kms::v1::ListImportJobsRequest* request, ::google::cloud::kms::v1::ListImportJobsResponse* response);
    // Returns metadata for a given [KeyRing][google.cloud.kms.v1.KeyRing].
    virtual ::grpc::Status GetKeyRing(::grpc::ServerContext* context, const ::google::cloud::kms::v1::GetKeyRingRequest* request, ::google::cloud::kms::v1::KeyRing* response);
    // Returns metadata for a given [CryptoKey][google.cloud.kms.v1.CryptoKey], as
    // well as its [primary][google.cloud.kms.v1.CryptoKey.primary]
    // [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion].
    virtual ::grpc::Status GetCryptoKey(::grpc::ServerContext* context, const ::google::cloud::kms::v1::GetCryptoKeyRequest* request, ::google::cloud::kms::v1::CryptoKey* response);
    // Returns metadata for a given
    // [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion].
    virtual ::grpc::Status GetCryptoKeyVersion(::grpc::ServerContext* context, const ::google::cloud::kms::v1::GetCryptoKeyVersionRequest* request, ::google::cloud::kms::v1::CryptoKeyVersion* response);
    // Returns the public key for the given
    // [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion]. The
    // [CryptoKey.purpose][google.cloud.kms.v1.CryptoKey.purpose] must be
    // [ASYMMETRIC_SIGN][google.cloud.kms.v1.CryptoKey.CryptoKeyPurpose.ASYMMETRIC_SIGN]
    // or
    // [ASYMMETRIC_DECRYPT][google.cloud.kms.v1.CryptoKey.CryptoKeyPurpose.ASYMMETRIC_DECRYPT].
    virtual ::grpc::Status GetPublicKey(::grpc::ServerContext* context, const ::google::cloud::kms::v1::GetPublicKeyRequest* request, ::google::cloud::kms::v1::PublicKey* response);
    // Returns metadata for a given [ImportJob][google.cloud.kms.v1.ImportJob].
    virtual ::grpc::Status GetImportJob(::grpc::ServerContext* context, const ::google::cloud::kms::v1::GetImportJobRequest* request, ::google::cloud::kms::v1::ImportJob* response);
    // Create a new [KeyRing][google.cloud.kms.v1.KeyRing] in a given Project and
    // Location.
    virtual ::grpc::Status CreateKeyRing(::grpc::ServerContext* context, const ::google::cloud::kms::v1::CreateKeyRingRequest* request, ::google::cloud::kms::v1::KeyRing* response);
    // Create a new [CryptoKey][google.cloud.kms.v1.CryptoKey] within a
    // [KeyRing][google.cloud.kms.v1.KeyRing].
    //
    // [CryptoKey.purpose][google.cloud.kms.v1.CryptoKey.purpose] and
    // [CryptoKey.version_template.algorithm][google.cloud.kms.v1.CryptoKeyVersionTemplate.algorithm]
    // are required.
    virtual ::grpc::Status CreateCryptoKey(::grpc::ServerContext* context, const ::google::cloud::kms::v1::CreateCryptoKeyRequest* request, ::google::cloud::kms::v1::CryptoKey* response);
    // Create a new [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion] in a
    // [CryptoKey][google.cloud.kms.v1.CryptoKey].
    //
    // The server will assign the next sequential id. If unset,
    // [state][google.cloud.kms.v1.CryptoKeyVersion.state] will be set to
    // [ENABLED][google.cloud.kms.v1.CryptoKeyVersion.CryptoKeyVersionState.ENABLED].
    virtual ::grpc::Status CreateCryptoKeyVersion(::grpc::ServerContext* context, const ::google::cloud::kms::v1::CreateCryptoKeyVersionRequest* request, ::google::cloud::kms::v1::CryptoKeyVersion* response);
    // Import wrapped key material into a
    // [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion].
    //
    // All requests must specify a [CryptoKey][google.cloud.kms.v1.CryptoKey]. If
    // a [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion] is additionally
    // specified in the request, key material will be reimported into that
    // version. Otherwise, a new version will be created, and will be assigned the
    // next sequential id within the [CryptoKey][google.cloud.kms.v1.CryptoKey].
    virtual ::grpc::Status ImportCryptoKeyVersion(::grpc::ServerContext* context, const ::google::cloud::kms::v1::ImportCryptoKeyVersionRequest* request, ::google::cloud::kms::v1::CryptoKeyVersion* response);
    // Create a new [ImportJob][google.cloud.kms.v1.ImportJob] within a
    // [KeyRing][google.cloud.kms.v1.KeyRing].
    //
    // [ImportJob.import_method][google.cloud.kms.v1.ImportJob.import_method] is
    // required.
    virtual ::grpc::Status CreateImportJob(::grpc::ServerContext* context, const ::google::cloud::kms::v1::CreateImportJobRequest* request, ::google::cloud::kms::v1::ImportJob* response);
    // Update a [CryptoKey][google.cloud.kms.v1.CryptoKey].
    virtual ::grpc::Status UpdateCryptoKey(::grpc::ServerContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyRequest* request, ::google::cloud::kms::v1::CryptoKey* response);
    // Update a [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion]'s
    // metadata.
    //
    // [state][google.cloud.kms.v1.CryptoKeyVersion.state] may be changed between
    // [ENABLED][google.cloud.kms.v1.CryptoKeyVersion.CryptoKeyVersionState.ENABLED]
    // and
    // [DISABLED][google.cloud.kms.v1.CryptoKeyVersion.CryptoKeyVersionState.DISABLED]
    // using this method. See
    // [DestroyCryptoKeyVersion][google.cloud.kms.v1.KeyManagementService.DestroyCryptoKeyVersion]
    // and
    // [RestoreCryptoKeyVersion][google.cloud.kms.v1.KeyManagementService.RestoreCryptoKeyVersion]
    // to move between other states.
    virtual ::grpc::Status UpdateCryptoKeyVersion(::grpc::ServerContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyVersionRequest* request, ::google::cloud::kms::v1::CryptoKeyVersion* response);
    // Update the version of a [CryptoKey][google.cloud.kms.v1.CryptoKey] that
    // will be used in
    // [Encrypt][google.cloud.kms.v1.KeyManagementService.Encrypt].
    //
    // Returns an error if called on a key whose purpose is not
    // [ENCRYPT_DECRYPT][google.cloud.kms.v1.CryptoKey.CryptoKeyPurpose.ENCRYPT_DECRYPT].
    virtual ::grpc::Status UpdateCryptoKeyPrimaryVersion(::grpc::ServerContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyPrimaryVersionRequest* request, ::google::cloud::kms::v1::CryptoKey* response);
    // Schedule a [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion] for
    // destruction.
    //
    // Upon calling this method,
    // [CryptoKeyVersion.state][google.cloud.kms.v1.CryptoKeyVersion.state] will
    // be set to
    // [DESTROY_SCHEDULED][google.cloud.kms.v1.CryptoKeyVersion.CryptoKeyVersionState.DESTROY_SCHEDULED],
    // and [destroy_time][google.cloud.kms.v1.CryptoKeyVersion.destroy_time] will
    // be set to the time
    // [destroy_scheduled_duration][google.cloud.kms.v1.CryptoKey.destroy_scheduled_duration]
    // in the future. At that time, the
    // [state][google.cloud.kms.v1.CryptoKeyVersion.state] will automatically
    // change to
    // [DESTROYED][google.cloud.kms.v1.CryptoKeyVersion.CryptoKeyVersionState.DESTROYED],
    // and the key material will be irrevocably destroyed.
    //
    // Before the
    // [destroy_time][google.cloud.kms.v1.CryptoKeyVersion.destroy_time] is
    // reached,
    // [RestoreCryptoKeyVersion][google.cloud.kms.v1.KeyManagementService.RestoreCryptoKeyVersion]
    // may be called to reverse the process.
    virtual ::grpc::Status DestroyCryptoKeyVersion(::grpc::ServerContext* context, const ::google::cloud::kms::v1::DestroyCryptoKeyVersionRequest* request, ::google::cloud::kms::v1::CryptoKeyVersion* response);
    // Restore a [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion] in the
    // [DESTROY_SCHEDULED][google.cloud.kms.v1.CryptoKeyVersion.CryptoKeyVersionState.DESTROY_SCHEDULED]
    // state.
    //
    // Upon restoration of the CryptoKeyVersion,
    // [state][google.cloud.kms.v1.CryptoKeyVersion.state] will be set to
    // [DISABLED][google.cloud.kms.v1.CryptoKeyVersion.CryptoKeyVersionState.DISABLED],
    // and [destroy_time][google.cloud.kms.v1.CryptoKeyVersion.destroy_time] will
    // be cleared.
    virtual ::grpc::Status RestoreCryptoKeyVersion(::grpc::ServerContext* context, const ::google::cloud::kms::v1::RestoreCryptoKeyVersionRequest* request, ::google::cloud::kms::v1::CryptoKeyVersion* response);
    // Encrypts data, so that it can only be recovered by a call to
    // [Decrypt][google.cloud.kms.v1.KeyManagementService.Decrypt]. The
    // [CryptoKey.purpose][google.cloud.kms.v1.CryptoKey.purpose] must be
    // [ENCRYPT_DECRYPT][google.cloud.kms.v1.CryptoKey.CryptoKeyPurpose.ENCRYPT_DECRYPT].
    virtual ::grpc::Status Encrypt(::grpc::ServerContext* context, const ::google::cloud::kms::v1::EncryptRequest* request, ::google::cloud::kms::v1::EncryptResponse* response);
    // Decrypts data that was protected by
    // [Encrypt][google.cloud.kms.v1.KeyManagementService.Encrypt]. The
    // [CryptoKey.purpose][google.cloud.kms.v1.CryptoKey.purpose] must be
    // [ENCRYPT_DECRYPT][google.cloud.kms.v1.CryptoKey.CryptoKeyPurpose.ENCRYPT_DECRYPT].
    virtual ::grpc::Status Decrypt(::grpc::ServerContext* context, const ::google::cloud::kms::v1::DecryptRequest* request, ::google::cloud::kms::v1::DecryptResponse* response);
    // Encrypts data using portable cryptographic primitives. Most users should
    // choose [Encrypt][google.cloud.kms.v1.KeyManagementService.Encrypt] and
    // [Decrypt][google.cloud.kms.v1.KeyManagementService.Decrypt] rather than
    // their raw counterparts. The
    // [CryptoKey.purpose][google.cloud.kms.v1.CryptoKey.purpose] must be
    // [RAW_ENCRYPT_DECRYPT][google.cloud.kms.v1.CryptoKey.CryptoKeyPurpose.RAW_ENCRYPT_DECRYPT].
    virtual ::grpc::Status RawEncrypt(::grpc::ServerContext* context, const ::google::cloud::kms::v1::RawEncryptRequest* request, ::google::cloud::kms::v1::RawEncryptResponse* response);
    // Decrypts data that was originally encrypted using a raw cryptographic
    // mechanism. The [CryptoKey.purpose][google.cloud.kms.v1.CryptoKey.purpose]
    // must be
    // [RAW_ENCRYPT_DECRYPT][google.cloud.kms.v1.CryptoKey.CryptoKeyPurpose.RAW_ENCRYPT_DECRYPT].
    virtual ::grpc::Status RawDecrypt(::grpc::ServerContext* context, const ::google::cloud::kms::v1::RawDecryptRequest* request, ::google::cloud::kms::v1::RawDecryptResponse* response);
    // Signs data using a [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion]
    // with [CryptoKey.purpose][google.cloud.kms.v1.CryptoKey.purpose]
    // ASYMMETRIC_SIGN, producing a signature that can be verified with the public
    // key retrieved from
    // [GetPublicKey][google.cloud.kms.v1.KeyManagementService.GetPublicKey].
    virtual ::grpc::Status AsymmetricSign(::grpc::ServerContext* context, const ::google::cloud::kms::v1::AsymmetricSignRequest* request, ::google::cloud::kms::v1::AsymmetricSignResponse* response);
    // Decrypts data that was encrypted with a public key retrieved from
    // [GetPublicKey][google.cloud.kms.v1.KeyManagementService.GetPublicKey]
    // corresponding to a [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion]
    // with [CryptoKey.purpose][google.cloud.kms.v1.CryptoKey.purpose]
    // ASYMMETRIC_DECRYPT.
    virtual ::grpc::Status AsymmetricDecrypt(::grpc::ServerContext* context, const ::google::cloud::kms::v1::AsymmetricDecryptRequest* request, ::google::cloud::kms::v1::AsymmetricDecryptResponse* response);
    // Signs data using a [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion]
    // with [CryptoKey.purpose][google.cloud.kms.v1.CryptoKey.purpose] MAC,
    // producing a tag that can be verified by another source with the same key.
    virtual ::grpc::Status MacSign(::grpc::ServerContext* context, const ::google::cloud::kms::v1::MacSignRequest* request, ::google::cloud::kms::v1::MacSignResponse* response);
    // Verifies MAC tag using a
    // [CryptoKeyVersion][google.cloud.kms.v1.CryptoKeyVersion] with
    // [CryptoKey.purpose][google.cloud.kms.v1.CryptoKey.purpose] MAC, and returns
    // a response that indicates whether or not the verification was successful.
    virtual ::grpc::Status MacVerify(::grpc::ServerContext* context, const ::google::cloud::kms::v1::MacVerifyRequest* request, ::google::cloud::kms::v1::MacVerifyResponse* response);
    // Generate random bytes using the Cloud KMS randomness source in the provided
    // location.
    virtual ::grpc::Status GenerateRandomBytes(::grpc::ServerContext* context, const ::google::cloud::kms::v1::GenerateRandomBytesRequest* request, ::google::cloud::kms::v1::GenerateRandomBytesResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListKeyRings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListKeyRings() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListKeyRings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListKeyRings(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ListKeyRingsRequest* /*request*/, ::google::cloud::kms::v1::ListKeyRingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListKeyRings(::grpc::ServerContext* context, ::google::cloud::kms::v1::ListKeyRingsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::ListKeyRingsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListCryptoKeys : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListCryptoKeys() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_ListCryptoKeys() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCryptoKeys(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ListCryptoKeysRequest* /*request*/, ::google::cloud::kms::v1::ListCryptoKeysResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListCryptoKeys(::grpc::ServerContext* context, ::google::cloud::kms::v1::ListCryptoKeysRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::ListCryptoKeysResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListCryptoKeyVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListCryptoKeyVersions() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_ListCryptoKeyVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCryptoKeyVersions(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ListCryptoKeyVersionsRequest* /*request*/, ::google::cloud::kms::v1::ListCryptoKeyVersionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListCryptoKeyVersions(::grpc::ServerContext* context, ::google::cloud::kms::v1::ListCryptoKeyVersionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::ListCryptoKeyVersionsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListImportJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListImportJobs() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_ListImportJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListImportJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ListImportJobsRequest* /*request*/, ::google::cloud::kms::v1::ListImportJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListImportJobs(::grpc::ServerContext* context, ::google::cloud::kms::v1::ListImportJobsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::ListImportJobsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetKeyRing : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetKeyRing() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_GetKeyRing() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetKeyRing(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetKeyRingRequest* /*request*/, ::google::cloud::kms::v1::KeyRing* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetKeyRing(::grpc::ServerContext* context, ::google::cloud::kms::v1::GetKeyRingRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::KeyRing>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetCryptoKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetCryptoKey() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_GetCryptoKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCryptoKey(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetCryptoKeyRequest* /*request*/, ::google::cloud::kms::v1::CryptoKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetCryptoKey(::grpc::ServerContext* context, ::google::cloud::kms::v1::GetCryptoKeyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::CryptoKey>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetCryptoKeyVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetCryptoKeyVersion() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_GetCryptoKeyVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCryptoKeyVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetCryptoKeyVersion(::grpc::ServerContext* context, ::google::cloud::kms::v1::GetCryptoKeyVersionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::CryptoKeyVersion>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetPublicKey() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_GetPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetPublicKeyRequest* /*request*/, ::google::cloud::kms::v1::PublicKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetPublicKey(::grpc::ServerContext* context, ::google::cloud::kms::v1::GetPublicKeyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::PublicKey>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetImportJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetImportJob() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_GetImportJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetImportJob(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetImportJobRequest* /*request*/, ::google::cloud::kms::v1::ImportJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetImportJob(::grpc::ServerContext* context, ::google::cloud::kms::v1::GetImportJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::ImportJob>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateKeyRing : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateKeyRing() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_CreateKeyRing() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateKeyRing(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::CreateKeyRingRequest* /*request*/, ::google::cloud::kms::v1::KeyRing* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateKeyRing(::grpc::ServerContext* context, ::google::cloud::kms::v1::CreateKeyRingRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::KeyRing>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateCryptoKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateCryptoKey() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_CreateCryptoKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCryptoKey(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::CreateCryptoKeyRequest* /*request*/, ::google::cloud::kms::v1::CryptoKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateCryptoKey(::grpc::ServerContext* context, ::google::cloud::kms::v1::CreateCryptoKeyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::CryptoKey>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateCryptoKeyVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateCryptoKeyVersion() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_CreateCryptoKeyVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCryptoKeyVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::CreateCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateCryptoKeyVersion(::grpc::ServerContext* context, ::google::cloud::kms::v1::CreateCryptoKeyVersionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::CryptoKeyVersion>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ImportCryptoKeyVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ImportCryptoKeyVersion() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_ImportCryptoKeyVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportCryptoKeyVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ImportCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestImportCryptoKeyVersion(::grpc::ServerContext* context, ::google::cloud::kms::v1::ImportCryptoKeyVersionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::CryptoKeyVersion>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateImportJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateImportJob() {
      ::grpc::Service::MarkMethodAsync(13);
    }
    ~WithAsyncMethod_CreateImportJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateImportJob(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::CreateImportJobRequest* /*request*/, ::google::cloud::kms::v1::ImportJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateImportJob(::grpc::ServerContext* context, ::google::cloud::kms::v1::CreateImportJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::ImportJob>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateCryptoKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateCryptoKey() {
      ::grpc::Service::MarkMethodAsync(14);
    }
    ~WithAsyncMethod_UpdateCryptoKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCryptoKey(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateCryptoKeyRequest* /*request*/, ::google::cloud::kms::v1::CryptoKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateCryptoKey(::grpc::ServerContext* context, ::google::cloud::kms::v1::UpdateCryptoKeyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::CryptoKey>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateCryptoKeyVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateCryptoKeyVersion() {
      ::grpc::Service::MarkMethodAsync(15);
    }
    ~WithAsyncMethod_UpdateCryptoKeyVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCryptoKeyVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateCryptoKeyVersion(::grpc::ServerContext* context, ::google::cloud::kms::v1::UpdateCryptoKeyVersionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::CryptoKeyVersion>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateCryptoKeyPrimaryVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateCryptoKeyPrimaryVersion() {
      ::grpc::Service::MarkMethodAsync(16);
    }
    ~WithAsyncMethod_UpdateCryptoKeyPrimaryVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCryptoKeyPrimaryVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateCryptoKeyPrimaryVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateCryptoKeyPrimaryVersion(::grpc::ServerContext* context, ::google::cloud::kms::v1::UpdateCryptoKeyPrimaryVersionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::CryptoKey>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DestroyCryptoKeyVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DestroyCryptoKeyVersion() {
      ::grpc::Service::MarkMethodAsync(17);
    }
    ~WithAsyncMethod_DestroyCryptoKeyVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DestroyCryptoKeyVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::DestroyCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDestroyCryptoKeyVersion(::grpc::ServerContext* context, ::google::cloud::kms::v1::DestroyCryptoKeyVersionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::CryptoKeyVersion>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RestoreCryptoKeyVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RestoreCryptoKeyVersion() {
      ::grpc::Service::MarkMethodAsync(18);
    }
    ~WithAsyncMethod_RestoreCryptoKeyVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RestoreCryptoKeyVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::RestoreCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRestoreCryptoKeyVersion(::grpc::ServerContext* context, ::google::cloud::kms::v1::RestoreCryptoKeyVersionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::CryptoKeyVersion>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_Encrypt : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_Encrypt() {
      ::grpc::Service::MarkMethodAsync(19);
    }
    ~WithAsyncMethod_Encrypt() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Encrypt(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::EncryptRequest* /*request*/, ::google::cloud::kms::v1::EncryptResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestEncrypt(::grpc::ServerContext* context, ::google::cloud::kms::v1::EncryptRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::EncryptResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_Decrypt : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_Decrypt() {
      ::grpc::Service::MarkMethodAsync(20);
    }
    ~WithAsyncMethod_Decrypt() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Decrypt(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::DecryptRequest* /*request*/, ::google::cloud::kms::v1::DecryptResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDecrypt(::grpc::ServerContext* context, ::google::cloud::kms::v1::DecryptRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::DecryptResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RawEncrypt : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RawEncrypt() {
      ::grpc::Service::MarkMethodAsync(21);
    }
    ~WithAsyncMethod_RawEncrypt() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RawEncrypt(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::RawEncryptRequest* /*request*/, ::google::cloud::kms::v1::RawEncryptResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRawEncrypt(::grpc::ServerContext* context, ::google::cloud::kms::v1::RawEncryptRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::RawEncryptResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(21, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RawDecrypt : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RawDecrypt() {
      ::grpc::Service::MarkMethodAsync(22);
    }
    ~WithAsyncMethod_RawDecrypt() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RawDecrypt(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::RawDecryptRequest* /*request*/, ::google::cloud::kms::v1::RawDecryptResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRawDecrypt(::grpc::ServerContext* context, ::google::cloud::kms::v1::RawDecryptRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::RawDecryptResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(22, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_AsymmetricSign : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_AsymmetricSign() {
      ::grpc::Service::MarkMethodAsync(23);
    }
    ~WithAsyncMethod_AsymmetricSign() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AsymmetricSign(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::AsymmetricSignRequest* /*request*/, ::google::cloud::kms::v1::AsymmetricSignResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAsymmetricSign(::grpc::ServerContext* context, ::google::cloud::kms::v1::AsymmetricSignRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::AsymmetricSignResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(23, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_AsymmetricDecrypt : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_AsymmetricDecrypt() {
      ::grpc::Service::MarkMethodAsync(24);
    }
    ~WithAsyncMethod_AsymmetricDecrypt() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AsymmetricDecrypt(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::AsymmetricDecryptRequest* /*request*/, ::google::cloud::kms::v1::AsymmetricDecryptResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAsymmetricDecrypt(::grpc::ServerContext* context, ::google::cloud::kms::v1::AsymmetricDecryptRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::AsymmetricDecryptResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(24, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_MacSign : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_MacSign() {
      ::grpc::Service::MarkMethodAsync(25);
    }
    ~WithAsyncMethod_MacSign() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MacSign(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::MacSignRequest* /*request*/, ::google::cloud::kms::v1::MacSignResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestMacSign(::grpc::ServerContext* context, ::google::cloud::kms::v1::MacSignRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::MacSignResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(25, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_MacVerify : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_MacVerify() {
      ::grpc::Service::MarkMethodAsync(26);
    }
    ~WithAsyncMethod_MacVerify() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MacVerify(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::MacVerifyRequest* /*request*/, ::google::cloud::kms::v1::MacVerifyResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestMacVerify(::grpc::ServerContext* context, ::google::cloud::kms::v1::MacVerifyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::MacVerifyResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(26, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GenerateRandomBytes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GenerateRandomBytes() {
      ::grpc::Service::MarkMethodAsync(27);
    }
    ~WithAsyncMethod_GenerateRandomBytes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateRandomBytes(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GenerateRandomBytesRequest* /*request*/, ::google::cloud::kms::v1::GenerateRandomBytesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGenerateRandomBytes(::grpc::ServerContext* context, ::google::cloud::kms::v1::GenerateRandomBytesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::GenerateRandomBytesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(27, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListKeyRings<WithAsyncMethod_ListCryptoKeys<WithAsyncMethod_ListCryptoKeyVersions<WithAsyncMethod_ListImportJobs<WithAsyncMethod_GetKeyRing<WithAsyncMethod_GetCryptoKey<WithAsyncMethod_GetCryptoKeyVersion<WithAsyncMethod_GetPublicKey<WithAsyncMethod_GetImportJob<WithAsyncMethod_CreateKeyRing<WithAsyncMethod_CreateCryptoKey<WithAsyncMethod_CreateCryptoKeyVersion<WithAsyncMethod_ImportCryptoKeyVersion<WithAsyncMethod_CreateImportJob<WithAsyncMethod_UpdateCryptoKey<WithAsyncMethod_UpdateCryptoKeyVersion<WithAsyncMethod_UpdateCryptoKeyPrimaryVersion<WithAsyncMethod_DestroyCryptoKeyVersion<WithAsyncMethod_RestoreCryptoKeyVersion<WithAsyncMethod_Encrypt<WithAsyncMethod_Decrypt<WithAsyncMethod_RawEncrypt<WithAsyncMethod_RawDecrypt<WithAsyncMethod_AsymmetricSign<WithAsyncMethod_AsymmetricDecrypt<WithAsyncMethod_MacSign<WithAsyncMethod_MacVerify<WithAsyncMethod_GenerateRandomBytes<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListKeyRings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListKeyRings() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::ListKeyRingsRequest, ::google::cloud::kms::v1::ListKeyRingsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::ListKeyRingsRequest* request, ::google::cloud::kms::v1::ListKeyRingsResponse* response) { return this->ListKeyRings(context, request, response); }));}
    void SetMessageAllocatorFor_ListKeyRings(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::ListKeyRingsRequest, ::google::cloud::kms::v1::ListKeyRingsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::ListKeyRingsRequest, ::google::cloud::kms::v1::ListKeyRingsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListKeyRings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListKeyRings(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ListKeyRingsRequest* /*request*/, ::google::cloud::kms::v1::ListKeyRingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListKeyRings(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::ListKeyRingsRequest* /*request*/, ::google::cloud::kms::v1::ListKeyRingsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListCryptoKeys : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListCryptoKeys() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::ListCryptoKeysRequest, ::google::cloud::kms::v1::ListCryptoKeysResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::ListCryptoKeysRequest* request, ::google::cloud::kms::v1::ListCryptoKeysResponse* response) { return this->ListCryptoKeys(context, request, response); }));}
    void SetMessageAllocatorFor_ListCryptoKeys(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::ListCryptoKeysRequest, ::google::cloud::kms::v1::ListCryptoKeysResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::ListCryptoKeysRequest, ::google::cloud::kms::v1::ListCryptoKeysResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListCryptoKeys() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCryptoKeys(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ListCryptoKeysRequest* /*request*/, ::google::cloud::kms::v1::ListCryptoKeysResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListCryptoKeys(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::ListCryptoKeysRequest* /*request*/, ::google::cloud::kms::v1::ListCryptoKeysResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListCryptoKeyVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListCryptoKeyVersions() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::ListCryptoKeyVersionsRequest, ::google::cloud::kms::v1::ListCryptoKeyVersionsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::ListCryptoKeyVersionsRequest* request, ::google::cloud::kms::v1::ListCryptoKeyVersionsResponse* response) { return this->ListCryptoKeyVersions(context, request, response); }));}
    void SetMessageAllocatorFor_ListCryptoKeyVersions(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::ListCryptoKeyVersionsRequest, ::google::cloud::kms::v1::ListCryptoKeyVersionsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::ListCryptoKeyVersionsRequest, ::google::cloud::kms::v1::ListCryptoKeyVersionsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListCryptoKeyVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCryptoKeyVersions(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ListCryptoKeyVersionsRequest* /*request*/, ::google::cloud::kms::v1::ListCryptoKeyVersionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListCryptoKeyVersions(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::ListCryptoKeyVersionsRequest* /*request*/, ::google::cloud::kms::v1::ListCryptoKeyVersionsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListImportJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListImportJobs() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::ListImportJobsRequest, ::google::cloud::kms::v1::ListImportJobsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::ListImportJobsRequest* request, ::google::cloud::kms::v1::ListImportJobsResponse* response) { return this->ListImportJobs(context, request, response); }));}
    void SetMessageAllocatorFor_ListImportJobs(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::ListImportJobsRequest, ::google::cloud::kms::v1::ListImportJobsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::ListImportJobsRequest, ::google::cloud::kms::v1::ListImportJobsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListImportJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListImportJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ListImportJobsRequest* /*request*/, ::google::cloud::kms::v1::ListImportJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListImportJobs(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::ListImportJobsRequest* /*request*/, ::google::cloud::kms::v1::ListImportJobsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetKeyRing : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetKeyRing() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::GetKeyRingRequest, ::google::cloud::kms::v1::KeyRing>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::GetKeyRingRequest* request, ::google::cloud::kms::v1::KeyRing* response) { return this->GetKeyRing(context, request, response); }));}
    void SetMessageAllocatorFor_GetKeyRing(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::GetKeyRingRequest, ::google::cloud::kms::v1::KeyRing>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::GetKeyRingRequest, ::google::cloud::kms::v1::KeyRing>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetKeyRing() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetKeyRing(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetKeyRingRequest* /*request*/, ::google::cloud::kms::v1::KeyRing* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetKeyRing(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::GetKeyRingRequest* /*request*/, ::google::cloud::kms::v1::KeyRing* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetCryptoKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetCryptoKey() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::GetCryptoKeyRequest, ::google::cloud::kms::v1::CryptoKey>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::GetCryptoKeyRequest* request, ::google::cloud::kms::v1::CryptoKey* response) { return this->GetCryptoKey(context, request, response); }));}
    void SetMessageAllocatorFor_GetCryptoKey(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::GetCryptoKeyRequest, ::google::cloud::kms::v1::CryptoKey>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::GetCryptoKeyRequest, ::google::cloud::kms::v1::CryptoKey>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetCryptoKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCryptoKey(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetCryptoKeyRequest* /*request*/, ::google::cloud::kms::v1::CryptoKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetCryptoKey(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::GetCryptoKeyRequest* /*request*/, ::google::cloud::kms::v1::CryptoKey* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetCryptoKeyVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetCryptoKeyVersion() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::GetCryptoKeyVersionRequest, ::google::cloud::kms::v1::CryptoKeyVersion>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::GetCryptoKeyVersionRequest* request, ::google::cloud::kms::v1::CryptoKeyVersion* response) { return this->GetCryptoKeyVersion(context, request, response); }));}
    void SetMessageAllocatorFor_GetCryptoKeyVersion(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::GetCryptoKeyVersionRequest, ::google::cloud::kms::v1::CryptoKeyVersion>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::GetCryptoKeyVersionRequest, ::google::cloud::kms::v1::CryptoKeyVersion>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetCryptoKeyVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCryptoKeyVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetCryptoKeyVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::GetCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetPublicKey() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::GetPublicKeyRequest, ::google::cloud::kms::v1::PublicKey>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::GetPublicKeyRequest* request, ::google::cloud::kms::v1::PublicKey* response) { return this->GetPublicKey(context, request, response); }));}
    void SetMessageAllocatorFor_GetPublicKey(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::GetPublicKeyRequest, ::google::cloud::kms::v1::PublicKey>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::GetPublicKeyRequest, ::google::cloud::kms::v1::PublicKey>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetPublicKeyRequest* /*request*/, ::google::cloud::kms::v1::PublicKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetPublicKey(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::GetPublicKeyRequest* /*request*/, ::google::cloud::kms::v1::PublicKey* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetImportJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetImportJob() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::GetImportJobRequest, ::google::cloud::kms::v1::ImportJob>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::GetImportJobRequest* request, ::google::cloud::kms::v1::ImportJob* response) { return this->GetImportJob(context, request, response); }));}
    void SetMessageAllocatorFor_GetImportJob(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::GetImportJobRequest, ::google::cloud::kms::v1::ImportJob>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::GetImportJobRequest, ::google::cloud::kms::v1::ImportJob>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetImportJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetImportJob(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetImportJobRequest* /*request*/, ::google::cloud::kms::v1::ImportJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetImportJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::GetImportJobRequest* /*request*/, ::google::cloud::kms::v1::ImportJob* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateKeyRing : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateKeyRing() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::CreateKeyRingRequest, ::google::cloud::kms::v1::KeyRing>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::CreateKeyRingRequest* request, ::google::cloud::kms::v1::KeyRing* response) { return this->CreateKeyRing(context, request, response); }));}
    void SetMessageAllocatorFor_CreateKeyRing(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::CreateKeyRingRequest, ::google::cloud::kms::v1::KeyRing>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::CreateKeyRingRequest, ::google::cloud::kms::v1::KeyRing>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateKeyRing() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateKeyRing(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::CreateKeyRingRequest* /*request*/, ::google::cloud::kms::v1::KeyRing* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateKeyRing(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::CreateKeyRingRequest* /*request*/, ::google::cloud::kms::v1::KeyRing* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateCryptoKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateCryptoKey() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::CreateCryptoKeyRequest, ::google::cloud::kms::v1::CryptoKey>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::CreateCryptoKeyRequest* request, ::google::cloud::kms::v1::CryptoKey* response) { return this->CreateCryptoKey(context, request, response); }));}
    void SetMessageAllocatorFor_CreateCryptoKey(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::CreateCryptoKeyRequest, ::google::cloud::kms::v1::CryptoKey>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::CreateCryptoKeyRequest, ::google::cloud::kms::v1::CryptoKey>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateCryptoKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCryptoKey(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::CreateCryptoKeyRequest* /*request*/, ::google::cloud::kms::v1::CryptoKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateCryptoKey(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::CreateCryptoKeyRequest* /*request*/, ::google::cloud::kms::v1::CryptoKey* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateCryptoKeyVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateCryptoKeyVersion() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::CreateCryptoKeyVersionRequest, ::google::cloud::kms::v1::CryptoKeyVersion>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::CreateCryptoKeyVersionRequest* request, ::google::cloud::kms::v1::CryptoKeyVersion* response) { return this->CreateCryptoKeyVersion(context, request, response); }));}
    void SetMessageAllocatorFor_CreateCryptoKeyVersion(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::CreateCryptoKeyVersionRequest, ::google::cloud::kms::v1::CryptoKeyVersion>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::CreateCryptoKeyVersionRequest, ::google::cloud::kms::v1::CryptoKeyVersion>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateCryptoKeyVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCryptoKeyVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::CreateCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateCryptoKeyVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::CreateCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ImportCryptoKeyVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ImportCryptoKeyVersion() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::ImportCryptoKeyVersionRequest, ::google::cloud::kms::v1::CryptoKeyVersion>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::ImportCryptoKeyVersionRequest* request, ::google::cloud::kms::v1::CryptoKeyVersion* response) { return this->ImportCryptoKeyVersion(context, request, response); }));}
    void SetMessageAllocatorFor_ImportCryptoKeyVersion(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::ImportCryptoKeyVersionRequest, ::google::cloud::kms::v1::CryptoKeyVersion>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::ImportCryptoKeyVersionRequest, ::google::cloud::kms::v1::CryptoKeyVersion>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ImportCryptoKeyVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportCryptoKeyVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ImportCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ImportCryptoKeyVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::ImportCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateImportJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateImportJob() {
      ::grpc::Service::MarkMethodCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::CreateImportJobRequest, ::google::cloud::kms::v1::ImportJob>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::CreateImportJobRequest* request, ::google::cloud::kms::v1::ImportJob* response) { return this->CreateImportJob(context, request, response); }));}
    void SetMessageAllocatorFor_CreateImportJob(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::CreateImportJobRequest, ::google::cloud::kms::v1::ImportJob>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(13);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::CreateImportJobRequest, ::google::cloud::kms::v1::ImportJob>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateImportJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateImportJob(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::CreateImportJobRequest* /*request*/, ::google::cloud::kms::v1::ImportJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateImportJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::CreateImportJobRequest* /*request*/, ::google::cloud::kms::v1::ImportJob* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateCryptoKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateCryptoKey() {
      ::grpc::Service::MarkMethodCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::UpdateCryptoKeyRequest, ::google::cloud::kms::v1::CryptoKey>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyRequest* request, ::google::cloud::kms::v1::CryptoKey* response) { return this->UpdateCryptoKey(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateCryptoKey(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::UpdateCryptoKeyRequest, ::google::cloud::kms::v1::CryptoKey>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(14);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::UpdateCryptoKeyRequest, ::google::cloud::kms::v1::CryptoKey>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateCryptoKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCryptoKey(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateCryptoKeyRequest* /*request*/, ::google::cloud::kms::v1::CryptoKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateCryptoKey(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateCryptoKeyRequest* /*request*/, ::google::cloud::kms::v1::CryptoKey* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateCryptoKeyVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateCryptoKeyVersion() {
      ::grpc::Service::MarkMethodCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::UpdateCryptoKeyVersionRequest, ::google::cloud::kms::v1::CryptoKeyVersion>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyVersionRequest* request, ::google::cloud::kms::v1::CryptoKeyVersion* response) { return this->UpdateCryptoKeyVersion(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateCryptoKeyVersion(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::UpdateCryptoKeyVersionRequest, ::google::cloud::kms::v1::CryptoKeyVersion>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(15);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::UpdateCryptoKeyVersionRequest, ::google::cloud::kms::v1::CryptoKeyVersion>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateCryptoKeyVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCryptoKeyVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateCryptoKeyVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateCryptoKeyPrimaryVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateCryptoKeyPrimaryVersion() {
      ::grpc::Service::MarkMethodCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::UpdateCryptoKeyPrimaryVersionRequest, ::google::cloud::kms::v1::CryptoKey>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::UpdateCryptoKeyPrimaryVersionRequest* request, ::google::cloud::kms::v1::CryptoKey* response) { return this->UpdateCryptoKeyPrimaryVersion(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateCryptoKeyPrimaryVersion(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::UpdateCryptoKeyPrimaryVersionRequest, ::google::cloud::kms::v1::CryptoKey>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(16);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::UpdateCryptoKeyPrimaryVersionRequest, ::google::cloud::kms::v1::CryptoKey>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateCryptoKeyPrimaryVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCryptoKeyPrimaryVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateCryptoKeyPrimaryVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateCryptoKeyPrimaryVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateCryptoKeyPrimaryVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKey* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DestroyCryptoKeyVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DestroyCryptoKeyVersion() {
      ::grpc::Service::MarkMethodCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::DestroyCryptoKeyVersionRequest, ::google::cloud::kms::v1::CryptoKeyVersion>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::DestroyCryptoKeyVersionRequest* request, ::google::cloud::kms::v1::CryptoKeyVersion* response) { return this->DestroyCryptoKeyVersion(context, request, response); }));}
    void SetMessageAllocatorFor_DestroyCryptoKeyVersion(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::DestroyCryptoKeyVersionRequest, ::google::cloud::kms::v1::CryptoKeyVersion>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(17);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::DestroyCryptoKeyVersionRequest, ::google::cloud::kms::v1::CryptoKeyVersion>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DestroyCryptoKeyVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DestroyCryptoKeyVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::DestroyCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DestroyCryptoKeyVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::DestroyCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RestoreCryptoKeyVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RestoreCryptoKeyVersion() {
      ::grpc::Service::MarkMethodCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::RestoreCryptoKeyVersionRequest, ::google::cloud::kms::v1::CryptoKeyVersion>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::RestoreCryptoKeyVersionRequest* request, ::google::cloud::kms::v1::CryptoKeyVersion* response) { return this->RestoreCryptoKeyVersion(context, request, response); }));}
    void SetMessageAllocatorFor_RestoreCryptoKeyVersion(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::RestoreCryptoKeyVersionRequest, ::google::cloud::kms::v1::CryptoKeyVersion>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(18);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::RestoreCryptoKeyVersionRequest, ::google::cloud::kms::v1::CryptoKeyVersion>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RestoreCryptoKeyVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RestoreCryptoKeyVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::RestoreCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RestoreCryptoKeyVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::RestoreCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_Encrypt : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_Encrypt() {
      ::grpc::Service::MarkMethodCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::EncryptRequest, ::google::cloud::kms::v1::EncryptResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::EncryptRequest* request, ::google::cloud::kms::v1::EncryptResponse* response) { return this->Encrypt(context, request, response); }));}
    void SetMessageAllocatorFor_Encrypt(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::EncryptRequest, ::google::cloud::kms::v1::EncryptResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(19);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::EncryptRequest, ::google::cloud::kms::v1::EncryptResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_Encrypt() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Encrypt(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::EncryptRequest* /*request*/, ::google::cloud::kms::v1::EncryptResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Encrypt(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::EncryptRequest* /*request*/, ::google::cloud::kms::v1::EncryptResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_Decrypt : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_Decrypt() {
      ::grpc::Service::MarkMethodCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::DecryptRequest, ::google::cloud::kms::v1::DecryptResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::DecryptRequest* request, ::google::cloud::kms::v1::DecryptResponse* response) { return this->Decrypt(context, request, response); }));}
    void SetMessageAllocatorFor_Decrypt(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::DecryptRequest, ::google::cloud::kms::v1::DecryptResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(20);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::DecryptRequest, ::google::cloud::kms::v1::DecryptResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_Decrypt() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Decrypt(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::DecryptRequest* /*request*/, ::google::cloud::kms::v1::DecryptResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Decrypt(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::DecryptRequest* /*request*/, ::google::cloud::kms::v1::DecryptResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RawEncrypt : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RawEncrypt() {
      ::grpc::Service::MarkMethodCallback(21,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::RawEncryptRequest, ::google::cloud::kms::v1::RawEncryptResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::RawEncryptRequest* request, ::google::cloud::kms::v1::RawEncryptResponse* response) { return this->RawEncrypt(context, request, response); }));}
    void SetMessageAllocatorFor_RawEncrypt(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::RawEncryptRequest, ::google::cloud::kms::v1::RawEncryptResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(21);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::RawEncryptRequest, ::google::cloud::kms::v1::RawEncryptResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RawEncrypt() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RawEncrypt(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::RawEncryptRequest* /*request*/, ::google::cloud::kms::v1::RawEncryptResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RawEncrypt(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::RawEncryptRequest* /*request*/, ::google::cloud::kms::v1::RawEncryptResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RawDecrypt : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RawDecrypt() {
      ::grpc::Service::MarkMethodCallback(22,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::RawDecryptRequest, ::google::cloud::kms::v1::RawDecryptResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::RawDecryptRequest* request, ::google::cloud::kms::v1::RawDecryptResponse* response) { return this->RawDecrypt(context, request, response); }));}
    void SetMessageAllocatorFor_RawDecrypt(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::RawDecryptRequest, ::google::cloud::kms::v1::RawDecryptResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(22);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::RawDecryptRequest, ::google::cloud::kms::v1::RawDecryptResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RawDecrypt() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RawDecrypt(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::RawDecryptRequest* /*request*/, ::google::cloud::kms::v1::RawDecryptResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RawDecrypt(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::RawDecryptRequest* /*request*/, ::google::cloud::kms::v1::RawDecryptResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_AsymmetricSign : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_AsymmetricSign() {
      ::grpc::Service::MarkMethodCallback(23,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::AsymmetricSignRequest, ::google::cloud::kms::v1::AsymmetricSignResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::AsymmetricSignRequest* request, ::google::cloud::kms::v1::AsymmetricSignResponse* response) { return this->AsymmetricSign(context, request, response); }));}
    void SetMessageAllocatorFor_AsymmetricSign(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::AsymmetricSignRequest, ::google::cloud::kms::v1::AsymmetricSignResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(23);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::AsymmetricSignRequest, ::google::cloud::kms::v1::AsymmetricSignResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_AsymmetricSign() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AsymmetricSign(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::AsymmetricSignRequest* /*request*/, ::google::cloud::kms::v1::AsymmetricSignResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AsymmetricSign(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::AsymmetricSignRequest* /*request*/, ::google::cloud::kms::v1::AsymmetricSignResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_AsymmetricDecrypt : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_AsymmetricDecrypt() {
      ::grpc::Service::MarkMethodCallback(24,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::AsymmetricDecryptRequest, ::google::cloud::kms::v1::AsymmetricDecryptResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::AsymmetricDecryptRequest* request, ::google::cloud::kms::v1::AsymmetricDecryptResponse* response) { return this->AsymmetricDecrypt(context, request, response); }));}
    void SetMessageAllocatorFor_AsymmetricDecrypt(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::AsymmetricDecryptRequest, ::google::cloud::kms::v1::AsymmetricDecryptResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(24);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::AsymmetricDecryptRequest, ::google::cloud::kms::v1::AsymmetricDecryptResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_AsymmetricDecrypt() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AsymmetricDecrypt(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::AsymmetricDecryptRequest* /*request*/, ::google::cloud::kms::v1::AsymmetricDecryptResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AsymmetricDecrypt(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::AsymmetricDecryptRequest* /*request*/, ::google::cloud::kms::v1::AsymmetricDecryptResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_MacSign : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_MacSign() {
      ::grpc::Service::MarkMethodCallback(25,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::MacSignRequest, ::google::cloud::kms::v1::MacSignResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::MacSignRequest* request, ::google::cloud::kms::v1::MacSignResponse* response) { return this->MacSign(context, request, response); }));}
    void SetMessageAllocatorFor_MacSign(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::MacSignRequest, ::google::cloud::kms::v1::MacSignResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(25);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::MacSignRequest, ::google::cloud::kms::v1::MacSignResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_MacSign() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MacSign(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::MacSignRequest* /*request*/, ::google::cloud::kms::v1::MacSignResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* MacSign(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::MacSignRequest* /*request*/, ::google::cloud::kms::v1::MacSignResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_MacVerify : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_MacVerify() {
      ::grpc::Service::MarkMethodCallback(26,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::MacVerifyRequest, ::google::cloud::kms::v1::MacVerifyResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::MacVerifyRequest* request, ::google::cloud::kms::v1::MacVerifyResponse* response) { return this->MacVerify(context, request, response); }));}
    void SetMessageAllocatorFor_MacVerify(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::MacVerifyRequest, ::google::cloud::kms::v1::MacVerifyResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(26);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::MacVerifyRequest, ::google::cloud::kms::v1::MacVerifyResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_MacVerify() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MacVerify(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::MacVerifyRequest* /*request*/, ::google::cloud::kms::v1::MacVerifyResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* MacVerify(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::MacVerifyRequest* /*request*/, ::google::cloud::kms::v1::MacVerifyResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GenerateRandomBytes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GenerateRandomBytes() {
      ::grpc::Service::MarkMethodCallback(27,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::GenerateRandomBytesRequest, ::google::cloud::kms::v1::GenerateRandomBytesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::GenerateRandomBytesRequest* request, ::google::cloud::kms::v1::GenerateRandomBytesResponse* response) { return this->GenerateRandomBytes(context, request, response); }));}
    void SetMessageAllocatorFor_GenerateRandomBytes(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::GenerateRandomBytesRequest, ::google::cloud::kms::v1::GenerateRandomBytesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(27);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::GenerateRandomBytesRequest, ::google::cloud::kms::v1::GenerateRandomBytesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GenerateRandomBytes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateRandomBytes(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GenerateRandomBytesRequest* /*request*/, ::google::cloud::kms::v1::GenerateRandomBytesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GenerateRandomBytes(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::GenerateRandomBytesRequest* /*request*/, ::google::cloud::kms::v1::GenerateRandomBytesResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListKeyRings<WithCallbackMethod_ListCryptoKeys<WithCallbackMethod_ListCryptoKeyVersions<WithCallbackMethod_ListImportJobs<WithCallbackMethod_GetKeyRing<WithCallbackMethod_GetCryptoKey<WithCallbackMethod_GetCryptoKeyVersion<WithCallbackMethod_GetPublicKey<WithCallbackMethod_GetImportJob<WithCallbackMethod_CreateKeyRing<WithCallbackMethod_CreateCryptoKey<WithCallbackMethod_CreateCryptoKeyVersion<WithCallbackMethod_ImportCryptoKeyVersion<WithCallbackMethod_CreateImportJob<WithCallbackMethod_UpdateCryptoKey<WithCallbackMethod_UpdateCryptoKeyVersion<WithCallbackMethod_UpdateCryptoKeyPrimaryVersion<WithCallbackMethod_DestroyCryptoKeyVersion<WithCallbackMethod_RestoreCryptoKeyVersion<WithCallbackMethod_Encrypt<WithCallbackMethod_Decrypt<WithCallbackMethod_RawEncrypt<WithCallbackMethod_RawDecrypt<WithCallbackMethod_AsymmetricSign<WithCallbackMethod_AsymmetricDecrypt<WithCallbackMethod_MacSign<WithCallbackMethod_MacVerify<WithCallbackMethod_GenerateRandomBytes<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListKeyRings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListKeyRings() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListKeyRings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListKeyRings(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ListKeyRingsRequest* /*request*/, ::google::cloud::kms::v1::ListKeyRingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListCryptoKeys : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListCryptoKeys() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_ListCryptoKeys() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCryptoKeys(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ListCryptoKeysRequest* /*request*/, ::google::cloud::kms::v1::ListCryptoKeysResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListCryptoKeyVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListCryptoKeyVersions() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_ListCryptoKeyVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCryptoKeyVersions(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ListCryptoKeyVersionsRequest* /*request*/, ::google::cloud::kms::v1::ListCryptoKeyVersionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListImportJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListImportJobs() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_ListImportJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListImportJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ListImportJobsRequest* /*request*/, ::google::cloud::kms::v1::ListImportJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetKeyRing : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetKeyRing() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_GetKeyRing() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetKeyRing(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetKeyRingRequest* /*request*/, ::google::cloud::kms::v1::KeyRing* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetCryptoKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetCryptoKey() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_GetCryptoKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCryptoKey(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetCryptoKeyRequest* /*request*/, ::google::cloud::kms::v1::CryptoKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetCryptoKeyVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetCryptoKeyVersion() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_GetCryptoKeyVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCryptoKeyVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetPublicKey() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_GetPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetPublicKeyRequest* /*request*/, ::google::cloud::kms::v1::PublicKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetImportJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetImportJob() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_GetImportJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetImportJob(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetImportJobRequest* /*request*/, ::google::cloud::kms::v1::ImportJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateKeyRing : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateKeyRing() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_CreateKeyRing() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateKeyRing(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::CreateKeyRingRequest* /*request*/, ::google::cloud::kms::v1::KeyRing* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateCryptoKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateCryptoKey() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_CreateCryptoKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCryptoKey(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::CreateCryptoKeyRequest* /*request*/, ::google::cloud::kms::v1::CryptoKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateCryptoKeyVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateCryptoKeyVersion() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_CreateCryptoKeyVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCryptoKeyVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::CreateCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ImportCryptoKeyVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ImportCryptoKeyVersion() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_ImportCryptoKeyVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportCryptoKeyVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ImportCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateImportJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateImportJob() {
      ::grpc::Service::MarkMethodGeneric(13);
    }
    ~WithGenericMethod_CreateImportJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateImportJob(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::CreateImportJobRequest* /*request*/, ::google::cloud::kms::v1::ImportJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateCryptoKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateCryptoKey() {
      ::grpc::Service::MarkMethodGeneric(14);
    }
    ~WithGenericMethod_UpdateCryptoKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCryptoKey(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateCryptoKeyRequest* /*request*/, ::google::cloud::kms::v1::CryptoKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateCryptoKeyVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateCryptoKeyVersion() {
      ::grpc::Service::MarkMethodGeneric(15);
    }
    ~WithGenericMethod_UpdateCryptoKeyVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCryptoKeyVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateCryptoKeyPrimaryVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateCryptoKeyPrimaryVersion() {
      ::grpc::Service::MarkMethodGeneric(16);
    }
    ~WithGenericMethod_UpdateCryptoKeyPrimaryVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCryptoKeyPrimaryVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateCryptoKeyPrimaryVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DestroyCryptoKeyVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DestroyCryptoKeyVersion() {
      ::grpc::Service::MarkMethodGeneric(17);
    }
    ~WithGenericMethod_DestroyCryptoKeyVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DestroyCryptoKeyVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::DestroyCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RestoreCryptoKeyVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RestoreCryptoKeyVersion() {
      ::grpc::Service::MarkMethodGeneric(18);
    }
    ~WithGenericMethod_RestoreCryptoKeyVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RestoreCryptoKeyVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::RestoreCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_Encrypt : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_Encrypt() {
      ::grpc::Service::MarkMethodGeneric(19);
    }
    ~WithGenericMethod_Encrypt() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Encrypt(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::EncryptRequest* /*request*/, ::google::cloud::kms::v1::EncryptResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_Decrypt : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_Decrypt() {
      ::grpc::Service::MarkMethodGeneric(20);
    }
    ~WithGenericMethod_Decrypt() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Decrypt(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::DecryptRequest* /*request*/, ::google::cloud::kms::v1::DecryptResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RawEncrypt : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RawEncrypt() {
      ::grpc::Service::MarkMethodGeneric(21);
    }
    ~WithGenericMethod_RawEncrypt() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RawEncrypt(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::RawEncryptRequest* /*request*/, ::google::cloud::kms::v1::RawEncryptResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RawDecrypt : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RawDecrypt() {
      ::grpc::Service::MarkMethodGeneric(22);
    }
    ~WithGenericMethod_RawDecrypt() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RawDecrypt(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::RawDecryptRequest* /*request*/, ::google::cloud::kms::v1::RawDecryptResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_AsymmetricSign : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_AsymmetricSign() {
      ::grpc::Service::MarkMethodGeneric(23);
    }
    ~WithGenericMethod_AsymmetricSign() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AsymmetricSign(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::AsymmetricSignRequest* /*request*/, ::google::cloud::kms::v1::AsymmetricSignResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_AsymmetricDecrypt : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_AsymmetricDecrypt() {
      ::grpc::Service::MarkMethodGeneric(24);
    }
    ~WithGenericMethod_AsymmetricDecrypt() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AsymmetricDecrypt(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::AsymmetricDecryptRequest* /*request*/, ::google::cloud::kms::v1::AsymmetricDecryptResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_MacSign : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_MacSign() {
      ::grpc::Service::MarkMethodGeneric(25);
    }
    ~WithGenericMethod_MacSign() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MacSign(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::MacSignRequest* /*request*/, ::google::cloud::kms::v1::MacSignResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_MacVerify : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_MacVerify() {
      ::grpc::Service::MarkMethodGeneric(26);
    }
    ~WithGenericMethod_MacVerify() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MacVerify(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::MacVerifyRequest* /*request*/, ::google::cloud::kms::v1::MacVerifyResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GenerateRandomBytes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GenerateRandomBytes() {
      ::grpc::Service::MarkMethodGeneric(27);
    }
    ~WithGenericMethod_GenerateRandomBytes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateRandomBytes(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GenerateRandomBytesRequest* /*request*/, ::google::cloud::kms::v1::GenerateRandomBytesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListKeyRings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListKeyRings() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListKeyRings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListKeyRings(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ListKeyRingsRequest* /*request*/, ::google::cloud::kms::v1::ListKeyRingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListKeyRings(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListCryptoKeys : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListCryptoKeys() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_ListCryptoKeys() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCryptoKeys(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ListCryptoKeysRequest* /*request*/, ::google::cloud::kms::v1::ListCryptoKeysResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListCryptoKeys(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListCryptoKeyVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListCryptoKeyVersions() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_ListCryptoKeyVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCryptoKeyVersions(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ListCryptoKeyVersionsRequest* /*request*/, ::google::cloud::kms::v1::ListCryptoKeyVersionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListCryptoKeyVersions(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListImportJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListImportJobs() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_ListImportJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListImportJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ListImportJobsRequest* /*request*/, ::google::cloud::kms::v1::ListImportJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListImportJobs(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetKeyRing : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetKeyRing() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_GetKeyRing() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetKeyRing(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetKeyRingRequest* /*request*/, ::google::cloud::kms::v1::KeyRing* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetKeyRing(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetCryptoKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetCryptoKey() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_GetCryptoKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCryptoKey(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetCryptoKeyRequest* /*request*/, ::google::cloud::kms::v1::CryptoKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetCryptoKey(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetCryptoKeyVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetCryptoKeyVersion() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_GetCryptoKeyVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCryptoKeyVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetCryptoKeyVersion(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetPublicKey() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_GetPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetPublicKeyRequest* /*request*/, ::google::cloud::kms::v1::PublicKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetPublicKey(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetImportJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetImportJob() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_GetImportJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetImportJob(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetImportJobRequest* /*request*/, ::google::cloud::kms::v1::ImportJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetImportJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateKeyRing : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateKeyRing() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_CreateKeyRing() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateKeyRing(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::CreateKeyRingRequest* /*request*/, ::google::cloud::kms::v1::KeyRing* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateKeyRing(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateCryptoKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateCryptoKey() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_CreateCryptoKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCryptoKey(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::CreateCryptoKeyRequest* /*request*/, ::google::cloud::kms::v1::CryptoKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateCryptoKey(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateCryptoKeyVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateCryptoKeyVersion() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_CreateCryptoKeyVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCryptoKeyVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::CreateCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateCryptoKeyVersion(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ImportCryptoKeyVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ImportCryptoKeyVersion() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_ImportCryptoKeyVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportCryptoKeyVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ImportCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestImportCryptoKeyVersion(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateImportJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateImportJob() {
      ::grpc::Service::MarkMethodRaw(13);
    }
    ~WithRawMethod_CreateImportJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateImportJob(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::CreateImportJobRequest* /*request*/, ::google::cloud::kms::v1::ImportJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateImportJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateCryptoKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateCryptoKey() {
      ::grpc::Service::MarkMethodRaw(14);
    }
    ~WithRawMethod_UpdateCryptoKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCryptoKey(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateCryptoKeyRequest* /*request*/, ::google::cloud::kms::v1::CryptoKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateCryptoKey(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateCryptoKeyVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateCryptoKeyVersion() {
      ::grpc::Service::MarkMethodRaw(15);
    }
    ~WithRawMethod_UpdateCryptoKeyVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCryptoKeyVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateCryptoKeyVersion(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateCryptoKeyPrimaryVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateCryptoKeyPrimaryVersion() {
      ::grpc::Service::MarkMethodRaw(16);
    }
    ~WithRawMethod_UpdateCryptoKeyPrimaryVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCryptoKeyPrimaryVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateCryptoKeyPrimaryVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateCryptoKeyPrimaryVersion(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DestroyCryptoKeyVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DestroyCryptoKeyVersion() {
      ::grpc::Service::MarkMethodRaw(17);
    }
    ~WithRawMethod_DestroyCryptoKeyVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DestroyCryptoKeyVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::DestroyCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDestroyCryptoKeyVersion(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RestoreCryptoKeyVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RestoreCryptoKeyVersion() {
      ::grpc::Service::MarkMethodRaw(18);
    }
    ~WithRawMethod_RestoreCryptoKeyVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RestoreCryptoKeyVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::RestoreCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRestoreCryptoKeyVersion(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_Encrypt : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_Encrypt() {
      ::grpc::Service::MarkMethodRaw(19);
    }
    ~WithRawMethod_Encrypt() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Encrypt(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::EncryptRequest* /*request*/, ::google::cloud::kms::v1::EncryptResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestEncrypt(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_Decrypt : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_Decrypt() {
      ::grpc::Service::MarkMethodRaw(20);
    }
    ~WithRawMethod_Decrypt() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Decrypt(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::DecryptRequest* /*request*/, ::google::cloud::kms::v1::DecryptResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDecrypt(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RawEncrypt : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RawEncrypt() {
      ::grpc::Service::MarkMethodRaw(21);
    }
    ~WithRawMethod_RawEncrypt() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RawEncrypt(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::RawEncryptRequest* /*request*/, ::google::cloud::kms::v1::RawEncryptResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRawEncrypt(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(21, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RawDecrypt : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RawDecrypt() {
      ::grpc::Service::MarkMethodRaw(22);
    }
    ~WithRawMethod_RawDecrypt() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RawDecrypt(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::RawDecryptRequest* /*request*/, ::google::cloud::kms::v1::RawDecryptResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRawDecrypt(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(22, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_AsymmetricSign : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_AsymmetricSign() {
      ::grpc::Service::MarkMethodRaw(23);
    }
    ~WithRawMethod_AsymmetricSign() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AsymmetricSign(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::AsymmetricSignRequest* /*request*/, ::google::cloud::kms::v1::AsymmetricSignResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAsymmetricSign(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(23, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_AsymmetricDecrypt : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_AsymmetricDecrypt() {
      ::grpc::Service::MarkMethodRaw(24);
    }
    ~WithRawMethod_AsymmetricDecrypt() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AsymmetricDecrypt(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::AsymmetricDecryptRequest* /*request*/, ::google::cloud::kms::v1::AsymmetricDecryptResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAsymmetricDecrypt(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(24, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_MacSign : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_MacSign() {
      ::grpc::Service::MarkMethodRaw(25);
    }
    ~WithRawMethod_MacSign() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MacSign(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::MacSignRequest* /*request*/, ::google::cloud::kms::v1::MacSignResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestMacSign(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(25, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_MacVerify : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_MacVerify() {
      ::grpc::Service::MarkMethodRaw(26);
    }
    ~WithRawMethod_MacVerify() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MacVerify(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::MacVerifyRequest* /*request*/, ::google::cloud::kms::v1::MacVerifyResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestMacVerify(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(26, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GenerateRandomBytes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GenerateRandomBytes() {
      ::grpc::Service::MarkMethodRaw(27);
    }
    ~WithRawMethod_GenerateRandomBytes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateRandomBytes(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GenerateRandomBytesRequest* /*request*/, ::google::cloud::kms::v1::GenerateRandomBytesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGenerateRandomBytes(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(27, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListKeyRings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListKeyRings() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListKeyRings(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListKeyRings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListKeyRings(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ListKeyRingsRequest* /*request*/, ::google::cloud::kms::v1::ListKeyRingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListKeyRings(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListCryptoKeys : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListCryptoKeys() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListCryptoKeys(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListCryptoKeys() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCryptoKeys(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ListCryptoKeysRequest* /*request*/, ::google::cloud::kms::v1::ListCryptoKeysResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListCryptoKeys(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListCryptoKeyVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListCryptoKeyVersions() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListCryptoKeyVersions(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListCryptoKeyVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCryptoKeyVersions(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ListCryptoKeyVersionsRequest* /*request*/, ::google::cloud::kms::v1::ListCryptoKeyVersionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListCryptoKeyVersions(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListImportJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListImportJobs() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListImportJobs(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListImportJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListImportJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ListImportJobsRequest* /*request*/, ::google::cloud::kms::v1::ListImportJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListImportJobs(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetKeyRing : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetKeyRing() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetKeyRing(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetKeyRing() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetKeyRing(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetKeyRingRequest* /*request*/, ::google::cloud::kms::v1::KeyRing* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetKeyRing(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetCryptoKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetCryptoKey() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetCryptoKey(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetCryptoKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCryptoKey(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetCryptoKeyRequest* /*request*/, ::google::cloud::kms::v1::CryptoKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetCryptoKey(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetCryptoKeyVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetCryptoKeyVersion() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetCryptoKeyVersion(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetCryptoKeyVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCryptoKeyVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetCryptoKeyVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetPublicKey() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetPublicKey(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetPublicKeyRequest* /*request*/, ::google::cloud::kms::v1::PublicKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetPublicKey(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetImportJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetImportJob() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetImportJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetImportJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetImportJob(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetImportJobRequest* /*request*/, ::google::cloud::kms::v1::ImportJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetImportJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateKeyRing : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateKeyRing() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateKeyRing(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateKeyRing() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateKeyRing(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::CreateKeyRingRequest* /*request*/, ::google::cloud::kms::v1::KeyRing* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateKeyRing(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateCryptoKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateCryptoKey() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateCryptoKey(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateCryptoKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCryptoKey(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::CreateCryptoKeyRequest* /*request*/, ::google::cloud::kms::v1::CryptoKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateCryptoKey(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateCryptoKeyVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateCryptoKeyVersion() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateCryptoKeyVersion(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateCryptoKeyVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCryptoKeyVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::CreateCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateCryptoKeyVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ImportCryptoKeyVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ImportCryptoKeyVersion() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ImportCryptoKeyVersion(context, request, response); }));
    }
    ~WithRawCallbackMethod_ImportCryptoKeyVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportCryptoKeyVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ImportCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ImportCryptoKeyVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateImportJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateImportJob() {
      ::grpc::Service::MarkMethodRawCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateImportJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateImportJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateImportJob(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::CreateImportJobRequest* /*request*/, ::google::cloud::kms::v1::ImportJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateImportJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateCryptoKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateCryptoKey() {
      ::grpc::Service::MarkMethodRawCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateCryptoKey(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateCryptoKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCryptoKey(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateCryptoKeyRequest* /*request*/, ::google::cloud::kms::v1::CryptoKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateCryptoKey(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateCryptoKeyVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateCryptoKeyVersion() {
      ::grpc::Service::MarkMethodRawCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateCryptoKeyVersion(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateCryptoKeyVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCryptoKeyVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateCryptoKeyVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateCryptoKeyPrimaryVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateCryptoKeyPrimaryVersion() {
      ::grpc::Service::MarkMethodRawCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateCryptoKeyPrimaryVersion(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateCryptoKeyPrimaryVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCryptoKeyPrimaryVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateCryptoKeyPrimaryVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateCryptoKeyPrimaryVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DestroyCryptoKeyVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DestroyCryptoKeyVersion() {
      ::grpc::Service::MarkMethodRawCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DestroyCryptoKeyVersion(context, request, response); }));
    }
    ~WithRawCallbackMethod_DestroyCryptoKeyVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DestroyCryptoKeyVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::DestroyCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DestroyCryptoKeyVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RestoreCryptoKeyVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RestoreCryptoKeyVersion() {
      ::grpc::Service::MarkMethodRawCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RestoreCryptoKeyVersion(context, request, response); }));
    }
    ~WithRawCallbackMethod_RestoreCryptoKeyVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RestoreCryptoKeyVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::RestoreCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RestoreCryptoKeyVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_Encrypt : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_Encrypt() {
      ::grpc::Service::MarkMethodRawCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->Encrypt(context, request, response); }));
    }
    ~WithRawCallbackMethod_Encrypt() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Encrypt(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::EncryptRequest* /*request*/, ::google::cloud::kms::v1::EncryptResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Encrypt(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_Decrypt : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_Decrypt() {
      ::grpc::Service::MarkMethodRawCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->Decrypt(context, request, response); }));
    }
    ~WithRawCallbackMethod_Decrypt() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Decrypt(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::DecryptRequest* /*request*/, ::google::cloud::kms::v1::DecryptResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Decrypt(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RawEncrypt : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RawEncrypt() {
      ::grpc::Service::MarkMethodRawCallback(21,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RawEncrypt(context, request, response); }));
    }
    ~WithRawCallbackMethod_RawEncrypt() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RawEncrypt(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::RawEncryptRequest* /*request*/, ::google::cloud::kms::v1::RawEncryptResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RawEncrypt(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RawDecrypt : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RawDecrypt() {
      ::grpc::Service::MarkMethodRawCallback(22,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RawDecrypt(context, request, response); }));
    }
    ~WithRawCallbackMethod_RawDecrypt() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RawDecrypt(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::RawDecryptRequest* /*request*/, ::google::cloud::kms::v1::RawDecryptResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RawDecrypt(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_AsymmetricSign : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_AsymmetricSign() {
      ::grpc::Service::MarkMethodRawCallback(23,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->AsymmetricSign(context, request, response); }));
    }
    ~WithRawCallbackMethod_AsymmetricSign() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AsymmetricSign(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::AsymmetricSignRequest* /*request*/, ::google::cloud::kms::v1::AsymmetricSignResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AsymmetricSign(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_AsymmetricDecrypt : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_AsymmetricDecrypt() {
      ::grpc::Service::MarkMethodRawCallback(24,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->AsymmetricDecrypt(context, request, response); }));
    }
    ~WithRawCallbackMethod_AsymmetricDecrypt() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AsymmetricDecrypt(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::AsymmetricDecryptRequest* /*request*/, ::google::cloud::kms::v1::AsymmetricDecryptResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AsymmetricDecrypt(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_MacSign : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_MacSign() {
      ::grpc::Service::MarkMethodRawCallback(25,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->MacSign(context, request, response); }));
    }
    ~WithRawCallbackMethod_MacSign() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MacSign(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::MacSignRequest* /*request*/, ::google::cloud::kms::v1::MacSignResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* MacSign(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_MacVerify : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_MacVerify() {
      ::grpc::Service::MarkMethodRawCallback(26,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->MacVerify(context, request, response); }));
    }
    ~WithRawCallbackMethod_MacVerify() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status MacVerify(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::MacVerifyRequest* /*request*/, ::google::cloud::kms::v1::MacVerifyResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* MacVerify(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GenerateRandomBytes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GenerateRandomBytes() {
      ::grpc::Service::MarkMethodRawCallback(27,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GenerateRandomBytes(context, request, response); }));
    }
    ~WithRawCallbackMethod_GenerateRandomBytes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateRandomBytes(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GenerateRandomBytesRequest* /*request*/, ::google::cloud::kms::v1::GenerateRandomBytesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GenerateRandomBytes(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListKeyRings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListKeyRings() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::ListKeyRingsRequest, ::google::cloud::kms::v1::ListKeyRingsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::ListKeyRingsRequest, ::google::cloud::kms::v1::ListKeyRingsResponse>* streamer) {
                       return this->StreamedListKeyRings(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListKeyRings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListKeyRings(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ListKeyRingsRequest* /*request*/, ::google::cloud::kms::v1::ListKeyRingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListKeyRings(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::ListKeyRingsRequest,::google::cloud::kms::v1::ListKeyRingsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListCryptoKeys : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListCryptoKeys() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::ListCryptoKeysRequest, ::google::cloud::kms::v1::ListCryptoKeysResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::ListCryptoKeysRequest, ::google::cloud::kms::v1::ListCryptoKeysResponse>* streamer) {
                       return this->StreamedListCryptoKeys(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListCryptoKeys() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListCryptoKeys(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ListCryptoKeysRequest* /*request*/, ::google::cloud::kms::v1::ListCryptoKeysResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListCryptoKeys(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::ListCryptoKeysRequest,::google::cloud::kms::v1::ListCryptoKeysResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListCryptoKeyVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListCryptoKeyVersions() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::ListCryptoKeyVersionsRequest, ::google::cloud::kms::v1::ListCryptoKeyVersionsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::ListCryptoKeyVersionsRequest, ::google::cloud::kms::v1::ListCryptoKeyVersionsResponse>* streamer) {
                       return this->StreamedListCryptoKeyVersions(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListCryptoKeyVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListCryptoKeyVersions(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ListCryptoKeyVersionsRequest* /*request*/, ::google::cloud::kms::v1::ListCryptoKeyVersionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListCryptoKeyVersions(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::ListCryptoKeyVersionsRequest,::google::cloud::kms::v1::ListCryptoKeyVersionsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListImportJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListImportJobs() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::ListImportJobsRequest, ::google::cloud::kms::v1::ListImportJobsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::ListImportJobsRequest, ::google::cloud::kms::v1::ListImportJobsResponse>* streamer) {
                       return this->StreamedListImportJobs(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListImportJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListImportJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ListImportJobsRequest* /*request*/, ::google::cloud::kms::v1::ListImportJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListImportJobs(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::ListImportJobsRequest,::google::cloud::kms::v1::ListImportJobsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetKeyRing : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetKeyRing() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::GetKeyRingRequest, ::google::cloud::kms::v1::KeyRing>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::GetKeyRingRequest, ::google::cloud::kms::v1::KeyRing>* streamer) {
                       return this->StreamedGetKeyRing(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetKeyRing() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetKeyRing(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetKeyRingRequest* /*request*/, ::google::cloud::kms::v1::KeyRing* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetKeyRing(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::GetKeyRingRequest,::google::cloud::kms::v1::KeyRing>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetCryptoKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetCryptoKey() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::GetCryptoKeyRequest, ::google::cloud::kms::v1::CryptoKey>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::GetCryptoKeyRequest, ::google::cloud::kms::v1::CryptoKey>* streamer) {
                       return this->StreamedGetCryptoKey(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetCryptoKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetCryptoKey(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetCryptoKeyRequest* /*request*/, ::google::cloud::kms::v1::CryptoKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetCryptoKey(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::GetCryptoKeyRequest,::google::cloud::kms::v1::CryptoKey>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetCryptoKeyVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetCryptoKeyVersion() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::GetCryptoKeyVersionRequest, ::google::cloud::kms::v1::CryptoKeyVersion>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::GetCryptoKeyVersionRequest, ::google::cloud::kms::v1::CryptoKeyVersion>* streamer) {
                       return this->StreamedGetCryptoKeyVersion(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetCryptoKeyVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetCryptoKeyVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetCryptoKeyVersion(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::GetCryptoKeyVersionRequest,::google::cloud::kms::v1::CryptoKeyVersion>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetPublicKey() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::GetPublicKeyRequest, ::google::cloud::kms::v1::PublicKey>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::GetPublicKeyRequest, ::google::cloud::kms::v1::PublicKey>* streamer) {
                       return this->StreamedGetPublicKey(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetPublicKeyRequest* /*request*/, ::google::cloud::kms::v1::PublicKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetPublicKey(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::GetPublicKeyRequest,::google::cloud::kms::v1::PublicKey>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetImportJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetImportJob() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::GetImportJobRequest, ::google::cloud::kms::v1::ImportJob>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::GetImportJobRequest, ::google::cloud::kms::v1::ImportJob>* streamer) {
                       return this->StreamedGetImportJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetImportJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetImportJob(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetImportJobRequest* /*request*/, ::google::cloud::kms::v1::ImportJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetImportJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::GetImportJobRequest,::google::cloud::kms::v1::ImportJob>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateKeyRing : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateKeyRing() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::CreateKeyRingRequest, ::google::cloud::kms::v1::KeyRing>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::CreateKeyRingRequest, ::google::cloud::kms::v1::KeyRing>* streamer) {
                       return this->StreamedCreateKeyRing(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateKeyRing() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateKeyRing(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::CreateKeyRingRequest* /*request*/, ::google::cloud::kms::v1::KeyRing* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateKeyRing(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::CreateKeyRingRequest,::google::cloud::kms::v1::KeyRing>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateCryptoKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateCryptoKey() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::CreateCryptoKeyRequest, ::google::cloud::kms::v1::CryptoKey>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::CreateCryptoKeyRequest, ::google::cloud::kms::v1::CryptoKey>* streamer) {
                       return this->StreamedCreateCryptoKey(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateCryptoKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateCryptoKey(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::CreateCryptoKeyRequest* /*request*/, ::google::cloud::kms::v1::CryptoKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateCryptoKey(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::CreateCryptoKeyRequest,::google::cloud::kms::v1::CryptoKey>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateCryptoKeyVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateCryptoKeyVersion() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::CreateCryptoKeyVersionRequest, ::google::cloud::kms::v1::CryptoKeyVersion>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::CreateCryptoKeyVersionRequest, ::google::cloud::kms::v1::CryptoKeyVersion>* streamer) {
                       return this->StreamedCreateCryptoKeyVersion(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateCryptoKeyVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateCryptoKeyVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::CreateCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateCryptoKeyVersion(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::CreateCryptoKeyVersionRequest,::google::cloud::kms::v1::CryptoKeyVersion>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ImportCryptoKeyVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ImportCryptoKeyVersion() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::ImportCryptoKeyVersionRequest, ::google::cloud::kms::v1::CryptoKeyVersion>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::ImportCryptoKeyVersionRequest, ::google::cloud::kms::v1::CryptoKeyVersion>* streamer) {
                       return this->StreamedImportCryptoKeyVersion(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ImportCryptoKeyVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ImportCryptoKeyVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ImportCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedImportCryptoKeyVersion(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::ImportCryptoKeyVersionRequest,::google::cloud::kms::v1::CryptoKeyVersion>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateImportJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateImportJob() {
      ::grpc::Service::MarkMethodStreamed(13,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::CreateImportJobRequest, ::google::cloud::kms::v1::ImportJob>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::CreateImportJobRequest, ::google::cloud::kms::v1::ImportJob>* streamer) {
                       return this->StreamedCreateImportJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateImportJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateImportJob(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::CreateImportJobRequest* /*request*/, ::google::cloud::kms::v1::ImportJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateImportJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::CreateImportJobRequest,::google::cloud::kms::v1::ImportJob>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateCryptoKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateCryptoKey() {
      ::grpc::Service::MarkMethodStreamed(14,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::UpdateCryptoKeyRequest, ::google::cloud::kms::v1::CryptoKey>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::UpdateCryptoKeyRequest, ::google::cloud::kms::v1::CryptoKey>* streamer) {
                       return this->StreamedUpdateCryptoKey(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateCryptoKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateCryptoKey(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateCryptoKeyRequest* /*request*/, ::google::cloud::kms::v1::CryptoKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateCryptoKey(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::UpdateCryptoKeyRequest,::google::cloud::kms::v1::CryptoKey>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateCryptoKeyVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateCryptoKeyVersion() {
      ::grpc::Service::MarkMethodStreamed(15,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::UpdateCryptoKeyVersionRequest, ::google::cloud::kms::v1::CryptoKeyVersion>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::UpdateCryptoKeyVersionRequest, ::google::cloud::kms::v1::CryptoKeyVersion>* streamer) {
                       return this->StreamedUpdateCryptoKeyVersion(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateCryptoKeyVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateCryptoKeyVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateCryptoKeyVersion(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::UpdateCryptoKeyVersionRequest,::google::cloud::kms::v1::CryptoKeyVersion>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateCryptoKeyPrimaryVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateCryptoKeyPrimaryVersion() {
      ::grpc::Service::MarkMethodStreamed(16,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::UpdateCryptoKeyPrimaryVersionRequest, ::google::cloud::kms::v1::CryptoKey>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::UpdateCryptoKeyPrimaryVersionRequest, ::google::cloud::kms::v1::CryptoKey>* streamer) {
                       return this->StreamedUpdateCryptoKeyPrimaryVersion(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateCryptoKeyPrimaryVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateCryptoKeyPrimaryVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateCryptoKeyPrimaryVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateCryptoKeyPrimaryVersion(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::UpdateCryptoKeyPrimaryVersionRequest,::google::cloud::kms::v1::CryptoKey>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DestroyCryptoKeyVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DestroyCryptoKeyVersion() {
      ::grpc::Service::MarkMethodStreamed(17,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::DestroyCryptoKeyVersionRequest, ::google::cloud::kms::v1::CryptoKeyVersion>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::DestroyCryptoKeyVersionRequest, ::google::cloud::kms::v1::CryptoKeyVersion>* streamer) {
                       return this->StreamedDestroyCryptoKeyVersion(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DestroyCryptoKeyVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DestroyCryptoKeyVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::DestroyCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDestroyCryptoKeyVersion(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::DestroyCryptoKeyVersionRequest,::google::cloud::kms::v1::CryptoKeyVersion>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RestoreCryptoKeyVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RestoreCryptoKeyVersion() {
      ::grpc::Service::MarkMethodStreamed(18,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::RestoreCryptoKeyVersionRequest, ::google::cloud::kms::v1::CryptoKeyVersion>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::RestoreCryptoKeyVersionRequest, ::google::cloud::kms::v1::CryptoKeyVersion>* streamer) {
                       return this->StreamedRestoreCryptoKeyVersion(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RestoreCryptoKeyVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RestoreCryptoKeyVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::RestoreCryptoKeyVersionRequest* /*request*/, ::google::cloud::kms::v1::CryptoKeyVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRestoreCryptoKeyVersion(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::RestoreCryptoKeyVersionRequest,::google::cloud::kms::v1::CryptoKeyVersion>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_Encrypt : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_Encrypt() {
      ::grpc::Service::MarkMethodStreamed(19,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::EncryptRequest, ::google::cloud::kms::v1::EncryptResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::EncryptRequest, ::google::cloud::kms::v1::EncryptResponse>* streamer) {
                       return this->StreamedEncrypt(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_Encrypt() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status Encrypt(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::EncryptRequest* /*request*/, ::google::cloud::kms::v1::EncryptResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedEncrypt(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::EncryptRequest,::google::cloud::kms::v1::EncryptResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_Decrypt : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_Decrypt() {
      ::grpc::Service::MarkMethodStreamed(20,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::DecryptRequest, ::google::cloud::kms::v1::DecryptResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::DecryptRequest, ::google::cloud::kms::v1::DecryptResponse>* streamer) {
                       return this->StreamedDecrypt(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_Decrypt() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status Decrypt(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::DecryptRequest* /*request*/, ::google::cloud::kms::v1::DecryptResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDecrypt(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::DecryptRequest,::google::cloud::kms::v1::DecryptResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RawEncrypt : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RawEncrypt() {
      ::grpc::Service::MarkMethodStreamed(21,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::RawEncryptRequest, ::google::cloud::kms::v1::RawEncryptResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::RawEncryptRequest, ::google::cloud::kms::v1::RawEncryptResponse>* streamer) {
                       return this->StreamedRawEncrypt(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RawEncrypt() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RawEncrypt(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::RawEncryptRequest* /*request*/, ::google::cloud::kms::v1::RawEncryptResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRawEncrypt(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::RawEncryptRequest,::google::cloud::kms::v1::RawEncryptResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RawDecrypt : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RawDecrypt() {
      ::grpc::Service::MarkMethodStreamed(22,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::RawDecryptRequest, ::google::cloud::kms::v1::RawDecryptResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::RawDecryptRequest, ::google::cloud::kms::v1::RawDecryptResponse>* streamer) {
                       return this->StreamedRawDecrypt(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RawDecrypt() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RawDecrypt(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::RawDecryptRequest* /*request*/, ::google::cloud::kms::v1::RawDecryptResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRawDecrypt(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::RawDecryptRequest,::google::cloud::kms::v1::RawDecryptResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_AsymmetricSign : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_AsymmetricSign() {
      ::grpc::Service::MarkMethodStreamed(23,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::AsymmetricSignRequest, ::google::cloud::kms::v1::AsymmetricSignResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::AsymmetricSignRequest, ::google::cloud::kms::v1::AsymmetricSignResponse>* streamer) {
                       return this->StreamedAsymmetricSign(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_AsymmetricSign() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status AsymmetricSign(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::AsymmetricSignRequest* /*request*/, ::google::cloud::kms::v1::AsymmetricSignResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedAsymmetricSign(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::AsymmetricSignRequest,::google::cloud::kms::v1::AsymmetricSignResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_AsymmetricDecrypt : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_AsymmetricDecrypt() {
      ::grpc::Service::MarkMethodStreamed(24,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::AsymmetricDecryptRequest, ::google::cloud::kms::v1::AsymmetricDecryptResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::AsymmetricDecryptRequest, ::google::cloud::kms::v1::AsymmetricDecryptResponse>* streamer) {
                       return this->StreamedAsymmetricDecrypt(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_AsymmetricDecrypt() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status AsymmetricDecrypt(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::AsymmetricDecryptRequest* /*request*/, ::google::cloud::kms::v1::AsymmetricDecryptResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedAsymmetricDecrypt(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::AsymmetricDecryptRequest,::google::cloud::kms::v1::AsymmetricDecryptResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_MacSign : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_MacSign() {
      ::grpc::Service::MarkMethodStreamed(25,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::MacSignRequest, ::google::cloud::kms::v1::MacSignResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::MacSignRequest, ::google::cloud::kms::v1::MacSignResponse>* streamer) {
                       return this->StreamedMacSign(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_MacSign() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status MacSign(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::MacSignRequest* /*request*/, ::google::cloud::kms::v1::MacSignResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedMacSign(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::MacSignRequest,::google::cloud::kms::v1::MacSignResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_MacVerify : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_MacVerify() {
      ::grpc::Service::MarkMethodStreamed(26,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::MacVerifyRequest, ::google::cloud::kms::v1::MacVerifyResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::MacVerifyRequest, ::google::cloud::kms::v1::MacVerifyResponse>* streamer) {
                       return this->StreamedMacVerify(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_MacVerify() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status MacVerify(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::MacVerifyRequest* /*request*/, ::google::cloud::kms::v1::MacVerifyResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedMacVerify(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::MacVerifyRequest,::google::cloud::kms::v1::MacVerifyResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GenerateRandomBytes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GenerateRandomBytes() {
      ::grpc::Service::MarkMethodStreamed(27,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::GenerateRandomBytesRequest, ::google::cloud::kms::v1::GenerateRandomBytesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::GenerateRandomBytesRequest, ::google::cloud::kms::v1::GenerateRandomBytesResponse>* streamer) {
                       return this->StreamedGenerateRandomBytes(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GenerateRandomBytes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GenerateRandomBytes(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GenerateRandomBytesRequest* /*request*/, ::google::cloud::kms::v1::GenerateRandomBytesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGenerateRandomBytes(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::GenerateRandomBytesRequest,::google::cloud::kms::v1::GenerateRandomBytesResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListKeyRings<WithStreamedUnaryMethod_ListCryptoKeys<WithStreamedUnaryMethod_ListCryptoKeyVersions<WithStreamedUnaryMethod_ListImportJobs<WithStreamedUnaryMethod_GetKeyRing<WithStreamedUnaryMethod_GetCryptoKey<WithStreamedUnaryMethod_GetCryptoKeyVersion<WithStreamedUnaryMethod_GetPublicKey<WithStreamedUnaryMethod_GetImportJob<WithStreamedUnaryMethod_CreateKeyRing<WithStreamedUnaryMethod_CreateCryptoKey<WithStreamedUnaryMethod_CreateCryptoKeyVersion<WithStreamedUnaryMethod_ImportCryptoKeyVersion<WithStreamedUnaryMethod_CreateImportJob<WithStreamedUnaryMethod_UpdateCryptoKey<WithStreamedUnaryMethod_UpdateCryptoKeyVersion<WithStreamedUnaryMethod_UpdateCryptoKeyPrimaryVersion<WithStreamedUnaryMethod_DestroyCryptoKeyVersion<WithStreamedUnaryMethod_RestoreCryptoKeyVersion<WithStreamedUnaryMethod_Encrypt<WithStreamedUnaryMethod_Decrypt<WithStreamedUnaryMethod_RawEncrypt<WithStreamedUnaryMethod_RawDecrypt<WithStreamedUnaryMethod_AsymmetricSign<WithStreamedUnaryMethod_AsymmetricDecrypt<WithStreamedUnaryMethod_MacSign<WithStreamedUnaryMethod_MacVerify<WithStreamedUnaryMethod_GenerateRandomBytes<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListKeyRings<WithStreamedUnaryMethod_ListCryptoKeys<WithStreamedUnaryMethod_ListCryptoKeyVersions<WithStreamedUnaryMethod_ListImportJobs<WithStreamedUnaryMethod_GetKeyRing<WithStreamedUnaryMethod_GetCryptoKey<WithStreamedUnaryMethod_GetCryptoKeyVersion<WithStreamedUnaryMethod_GetPublicKey<WithStreamedUnaryMethod_GetImportJob<WithStreamedUnaryMethod_CreateKeyRing<WithStreamedUnaryMethod_CreateCryptoKey<WithStreamedUnaryMethod_CreateCryptoKeyVersion<WithStreamedUnaryMethod_ImportCryptoKeyVersion<WithStreamedUnaryMethod_CreateImportJob<WithStreamedUnaryMethod_UpdateCryptoKey<WithStreamedUnaryMethod_UpdateCryptoKeyVersion<WithStreamedUnaryMethod_UpdateCryptoKeyPrimaryVersion<WithStreamedUnaryMethod_DestroyCryptoKeyVersion<WithStreamedUnaryMethod_RestoreCryptoKeyVersion<WithStreamedUnaryMethod_Encrypt<WithStreamedUnaryMethod_Decrypt<WithStreamedUnaryMethod_RawEncrypt<WithStreamedUnaryMethod_RawDecrypt<WithStreamedUnaryMethod_AsymmetricSign<WithStreamedUnaryMethod_AsymmetricDecrypt<WithStreamedUnaryMethod_MacSign<WithStreamedUnaryMethod_MacVerify<WithStreamedUnaryMethod_GenerateRandomBytes<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace kms
}  // namespace cloud
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fcloud_2fkms_2fv1_2fservice_2eproto__INCLUDED
