// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/telcoautomation/v1/telcoautomation.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2ftelcoautomation_2fv1_2ftelcoautomation_2eproto__INCLUDED
#define GRPC_google_2fcloud_2ftelcoautomation_2fv1_2ftelcoautomation_2eproto__INCLUDED

#include "google/cloud/telcoautomation/v1/telcoautomation.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace cloud {
namespace telcoautomation {
namespace v1 {

// TelcoAutomation Service manages the control plane cluster a.k.a.
// Orchestration Cluster (GKE cluster with config controller) of TNA. It also
// exposes blueprint APIs which manages the lifecycle of blueprints that control
// the infrastructure setup (e.g GDCE clusters) and deployment of network
// functions.
class TelcoAutomation final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.telcoautomation.v1.TelcoAutomation";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists OrchestrationClusters in a given project and location.
    virtual ::grpc::Status ListOrchestrationClusters(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListOrchestrationClustersRequest& request, ::google::cloud::telcoautomation::v1::ListOrchestrationClustersResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListOrchestrationClustersResponse>> AsyncListOrchestrationClusters(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListOrchestrationClustersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListOrchestrationClustersResponse>>(AsyncListOrchestrationClustersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListOrchestrationClustersResponse>> PrepareAsyncListOrchestrationClusters(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListOrchestrationClustersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListOrchestrationClustersResponse>>(PrepareAsyncListOrchestrationClustersRaw(context, request, cq));
    }
    // Gets details of a single OrchestrationCluster.
    virtual ::grpc::Status GetOrchestrationCluster(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetOrchestrationClusterRequest& request, ::google::cloud::telcoautomation::v1::OrchestrationCluster* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::OrchestrationCluster>> AsyncGetOrchestrationCluster(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetOrchestrationClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::OrchestrationCluster>>(AsyncGetOrchestrationClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::OrchestrationCluster>> PrepareAsyncGetOrchestrationCluster(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetOrchestrationClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::OrchestrationCluster>>(PrepareAsyncGetOrchestrationClusterRaw(context, request, cq));
    }
    // Creates a new OrchestrationCluster in a given project and location.
    virtual ::grpc::Status CreateOrchestrationCluster(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateOrchestrationClusterRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateOrchestrationCluster(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateOrchestrationClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateOrchestrationClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateOrchestrationCluster(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateOrchestrationClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateOrchestrationClusterRaw(context, request, cq));
    }
    // Deletes a single OrchestrationCluster.
    virtual ::grpc::Status DeleteOrchestrationCluster(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteOrchestrationClusterRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteOrchestrationCluster(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteOrchestrationClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteOrchestrationClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteOrchestrationCluster(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteOrchestrationClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteOrchestrationClusterRaw(context, request, cq));
    }
    // Lists EdgeSlms in a given project and location.
    virtual ::grpc::Status ListEdgeSlms(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListEdgeSlmsRequest& request, ::google::cloud::telcoautomation::v1::ListEdgeSlmsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListEdgeSlmsResponse>> AsyncListEdgeSlms(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListEdgeSlmsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListEdgeSlmsResponse>>(AsyncListEdgeSlmsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListEdgeSlmsResponse>> PrepareAsyncListEdgeSlms(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListEdgeSlmsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListEdgeSlmsResponse>>(PrepareAsyncListEdgeSlmsRaw(context, request, cq));
    }
    // Gets details of a single EdgeSlm.
    virtual ::grpc::Status GetEdgeSlm(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetEdgeSlmRequest& request, ::google::cloud::telcoautomation::v1::EdgeSlm* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::EdgeSlm>> AsyncGetEdgeSlm(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetEdgeSlmRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::EdgeSlm>>(AsyncGetEdgeSlmRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::EdgeSlm>> PrepareAsyncGetEdgeSlm(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetEdgeSlmRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::EdgeSlm>>(PrepareAsyncGetEdgeSlmRaw(context, request, cq));
    }
    // Creates a new EdgeSlm in a given project and location.
    virtual ::grpc::Status CreateEdgeSlm(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateEdgeSlmRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateEdgeSlm(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateEdgeSlmRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateEdgeSlmRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateEdgeSlm(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateEdgeSlmRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateEdgeSlmRaw(context, request, cq));
    }
    // Deletes a single EdgeSlm.
    virtual ::grpc::Status DeleteEdgeSlm(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteEdgeSlmRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteEdgeSlm(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteEdgeSlmRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteEdgeSlmRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteEdgeSlm(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteEdgeSlmRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteEdgeSlmRaw(context, request, cq));
    }
    // Creates a blueprint.
    virtual ::grpc::Status CreateBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateBlueprintRequest& request, ::google::cloud::telcoautomation::v1::Blueprint* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Blueprint>> AsyncCreateBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateBlueprintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Blueprint>>(AsyncCreateBlueprintRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Blueprint>> PrepareAsyncCreateBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateBlueprintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Blueprint>>(PrepareAsyncCreateBlueprintRaw(context, request, cq));
    }
    // Updates a blueprint.
    virtual ::grpc::Status UpdateBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateBlueprintRequest& request, ::google::cloud::telcoautomation::v1::Blueprint* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Blueprint>> AsyncUpdateBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateBlueprintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Blueprint>>(AsyncUpdateBlueprintRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Blueprint>> PrepareAsyncUpdateBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateBlueprintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Blueprint>>(PrepareAsyncUpdateBlueprintRaw(context, request, cq));
    }
    // Returns the requested blueprint.
    virtual ::grpc::Status GetBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetBlueprintRequest& request, ::google::cloud::telcoautomation::v1::Blueprint* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Blueprint>> AsyncGetBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetBlueprintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Blueprint>>(AsyncGetBlueprintRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Blueprint>> PrepareAsyncGetBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetBlueprintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Blueprint>>(PrepareAsyncGetBlueprintRaw(context, request, cq));
    }
    // Deletes a blueprint and all its revisions.
    virtual ::grpc::Status DeleteBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteBlueprintRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteBlueprintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteBlueprintRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteBlueprintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteBlueprintRaw(context, request, cq));
    }
    // List all blueprints.
    virtual ::grpc::Status ListBlueprints(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListBlueprintsRequest& request, ::google::cloud::telcoautomation::v1::ListBlueprintsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListBlueprintsResponse>> AsyncListBlueprints(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListBlueprintsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListBlueprintsResponse>>(AsyncListBlueprintsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListBlueprintsResponse>> PrepareAsyncListBlueprints(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListBlueprintsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListBlueprintsResponse>>(PrepareAsyncListBlueprintsRaw(context, request, cq));
    }
    // Approves a blueprint and commits a new revision.
    virtual ::grpc::Status ApproveBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApproveBlueprintRequest& request, ::google::cloud::telcoautomation::v1::Blueprint* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Blueprint>> AsyncApproveBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApproveBlueprintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Blueprint>>(AsyncApproveBlueprintRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Blueprint>> PrepareAsyncApproveBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApproveBlueprintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Blueprint>>(PrepareAsyncApproveBlueprintRaw(context, request, cq));
    }
    // Proposes a blueprint for approval of changes.
    virtual ::grpc::Status ProposeBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ProposeBlueprintRequest& request, ::google::cloud::telcoautomation::v1::Blueprint* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Blueprint>> AsyncProposeBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ProposeBlueprintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Blueprint>>(AsyncProposeBlueprintRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Blueprint>> PrepareAsyncProposeBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ProposeBlueprintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Blueprint>>(PrepareAsyncProposeBlueprintRaw(context, request, cq));
    }
    // Rejects a blueprint revision proposal and flips it back to Draft state.
    virtual ::grpc::Status RejectBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RejectBlueprintRequest& request, ::google::cloud::telcoautomation::v1::Blueprint* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Blueprint>> AsyncRejectBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RejectBlueprintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Blueprint>>(AsyncRejectBlueprintRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Blueprint>> PrepareAsyncRejectBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RejectBlueprintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Blueprint>>(PrepareAsyncRejectBlueprintRaw(context, request, cq));
    }
    // List blueprint revisions of a given blueprint.
    virtual ::grpc::Status ListBlueprintRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsRequest& request, ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsResponse>> AsyncListBlueprintRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsResponse>>(AsyncListBlueprintRevisionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsResponse>> PrepareAsyncListBlueprintRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsResponse>>(PrepareAsyncListBlueprintRevisionsRaw(context, request, cq));
    }
    // Searches across blueprint revisions.
    virtual ::grpc::Status SearchBlueprintRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsRequest& request, ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsResponse>> AsyncSearchBlueprintRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsResponse>>(AsyncSearchBlueprintRevisionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsResponse>> PrepareAsyncSearchBlueprintRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsResponse>>(PrepareAsyncSearchBlueprintRevisionsRaw(context, request, cq));
    }
    // Searches across deployment revisions.
    virtual ::grpc::Status SearchDeploymentRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsRequest& request, ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsResponse>> AsyncSearchDeploymentRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsResponse>>(AsyncSearchDeploymentRevisionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsResponse>> PrepareAsyncSearchDeploymentRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsResponse>>(PrepareAsyncSearchDeploymentRevisionsRaw(context, request, cq));
    }
    // Discards the changes in a blueprint and reverts the blueprint to the last
    // approved blueprint revision. No changes take place if a blueprint does not
    // have revisions.
    virtual ::grpc::Status DiscardBlueprintChanges(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesRequest& request, ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesResponse>> AsyncDiscardBlueprintChanges(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesResponse>>(AsyncDiscardBlueprintChangesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesResponse>> PrepareAsyncDiscardBlueprintChanges(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesResponse>>(PrepareAsyncDiscardBlueprintChangesRaw(context, request, cq));
    }
    // Lists the blueprints in TNA's public catalog. Default page size = 20,
    // Max Page Size = 100.
    virtual ::grpc::Status ListPublicBlueprints(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListPublicBlueprintsRequest& request, ::google::cloud::telcoautomation::v1::ListPublicBlueprintsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListPublicBlueprintsResponse>> AsyncListPublicBlueprints(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListPublicBlueprintsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListPublicBlueprintsResponse>>(AsyncListPublicBlueprintsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListPublicBlueprintsResponse>> PrepareAsyncListPublicBlueprints(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListPublicBlueprintsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListPublicBlueprintsResponse>>(PrepareAsyncListPublicBlueprintsRaw(context, request, cq));
    }
    // Returns the requested public blueprint.
    virtual ::grpc::Status GetPublicBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetPublicBlueprintRequest& request, ::google::cloud::telcoautomation::v1::PublicBlueprint* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::PublicBlueprint>> AsyncGetPublicBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetPublicBlueprintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::PublicBlueprint>>(AsyncGetPublicBlueprintRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::PublicBlueprint>> PrepareAsyncGetPublicBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetPublicBlueprintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::PublicBlueprint>>(PrepareAsyncGetPublicBlueprintRaw(context, request, cq));
    }
    // Creates a deployment.
    virtual ::grpc::Status CreateDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateDeploymentRequest& request, ::google::cloud::telcoautomation::v1::Deployment* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Deployment>> AsyncCreateDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Deployment>>(AsyncCreateDeploymentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Deployment>> PrepareAsyncCreateDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Deployment>>(PrepareAsyncCreateDeploymentRaw(context, request, cq));
    }
    // Updates a deployment.
    virtual ::grpc::Status UpdateDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateDeploymentRequest& request, ::google::cloud::telcoautomation::v1::Deployment* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Deployment>> AsyncUpdateDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Deployment>>(AsyncUpdateDeploymentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Deployment>> PrepareAsyncUpdateDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Deployment>>(PrepareAsyncUpdateDeploymentRaw(context, request, cq));
    }
    // Returns the requested deployment.
    virtual ::grpc::Status GetDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetDeploymentRequest& request, ::google::cloud::telcoautomation::v1::Deployment* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Deployment>> AsyncGetDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Deployment>>(AsyncGetDeploymentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Deployment>> PrepareAsyncGetDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Deployment>>(PrepareAsyncGetDeploymentRaw(context, request, cq));
    }
    // Removes the deployment by marking it as DELETING. Post which deployment and
    // it's revisions gets deleted.
    virtual ::grpc::Status RemoveDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RemoveDeploymentRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncRemoveDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RemoveDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncRemoveDeploymentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncRemoveDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RemoveDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncRemoveDeploymentRaw(context, request, cq));
    }
    // List all deployments.
    virtual ::grpc::Status ListDeployments(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListDeploymentsRequest& request, ::google::cloud::telcoautomation::v1::ListDeploymentsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListDeploymentsResponse>> AsyncListDeployments(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListDeploymentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListDeploymentsResponse>>(AsyncListDeploymentsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListDeploymentsResponse>> PrepareAsyncListDeployments(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListDeploymentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListDeploymentsResponse>>(PrepareAsyncListDeploymentsRaw(context, request, cq));
    }
    // List deployment revisions of a given deployment.
    virtual ::grpc::Status ListDeploymentRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsRequest& request, ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsResponse>> AsyncListDeploymentRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsResponse>>(AsyncListDeploymentRevisionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsResponse>> PrepareAsyncListDeploymentRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsResponse>>(PrepareAsyncListDeploymentRevisionsRaw(context, request, cq));
    }
    // Discards the changes in a deployment and reverts the deployment to the last
    // approved deployment revision. No changes take place if a deployment does
    // not have revisions.
    virtual ::grpc::Status DiscardDeploymentChanges(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesRequest& request, ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesResponse>> AsyncDiscardDeploymentChanges(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesResponse>>(AsyncDiscardDeploymentChangesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesResponse>> PrepareAsyncDiscardDeploymentChanges(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesResponse>>(PrepareAsyncDiscardDeploymentChangesRaw(context, request, cq));
    }
    // Applies the deployment's YAML files to the parent orchestration cluster.
    virtual ::grpc::Status ApplyDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApplyDeploymentRequest& request, ::google::cloud::telcoautomation::v1::Deployment* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Deployment>> AsyncApplyDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApplyDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Deployment>>(AsyncApplyDeploymentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Deployment>> PrepareAsyncApplyDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApplyDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Deployment>>(PrepareAsyncApplyDeploymentRaw(context, request, cq));
    }
    // Returns the requested deployment status.
    virtual ::grpc::Status ComputeDeploymentStatus(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusRequest& request, ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusResponse>> AsyncComputeDeploymentStatus(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusResponse>>(AsyncComputeDeploymentStatusRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusResponse>> PrepareAsyncComputeDeploymentStatus(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusResponse>>(PrepareAsyncComputeDeploymentStatusRaw(context, request, cq));
    }
    // Rollback the active deployment to the given past approved deployment
    // revision.
    virtual ::grpc::Status RollbackDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RollbackDeploymentRequest& request, ::google::cloud::telcoautomation::v1::Deployment* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Deployment>> AsyncRollbackDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RollbackDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Deployment>>(AsyncRollbackDeploymentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Deployment>> PrepareAsyncRollbackDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RollbackDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Deployment>>(PrepareAsyncRollbackDeploymentRaw(context, request, cq));
    }
    // Returns the requested hydrated deployment.
    virtual ::grpc::Status GetHydratedDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetHydratedDeploymentRequest& request, ::google::cloud::telcoautomation::v1::HydratedDeployment* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::HydratedDeployment>> AsyncGetHydratedDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetHydratedDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::HydratedDeployment>>(AsyncGetHydratedDeploymentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::HydratedDeployment>> PrepareAsyncGetHydratedDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetHydratedDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::HydratedDeployment>>(PrepareAsyncGetHydratedDeploymentRaw(context, request, cq));
    }
    // List all hydrated deployments present under a deployment.
    virtual ::grpc::Status ListHydratedDeployments(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsRequest& request, ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsResponse>> AsyncListHydratedDeployments(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsResponse>>(AsyncListHydratedDeploymentsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsResponse>> PrepareAsyncListHydratedDeployments(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsResponse>>(PrepareAsyncListHydratedDeploymentsRaw(context, request, cq));
    }
    // Updates a hydrated deployment.
    virtual ::grpc::Status UpdateHydratedDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateHydratedDeploymentRequest& request, ::google::cloud::telcoautomation::v1::HydratedDeployment* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::HydratedDeployment>> AsyncUpdateHydratedDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateHydratedDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::HydratedDeployment>>(AsyncUpdateHydratedDeploymentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::HydratedDeployment>> PrepareAsyncUpdateHydratedDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateHydratedDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::HydratedDeployment>>(PrepareAsyncUpdateHydratedDeploymentRaw(context, request, cq));
    }
    // Applies a hydrated deployment to a workload cluster.
    virtual ::grpc::Status ApplyHydratedDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApplyHydratedDeploymentRequest& request, ::google::cloud::telcoautomation::v1::HydratedDeployment* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::HydratedDeployment>> AsyncApplyHydratedDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApplyHydratedDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::HydratedDeployment>>(AsyncApplyHydratedDeploymentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::HydratedDeployment>> PrepareAsyncApplyHydratedDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApplyHydratedDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::HydratedDeployment>>(PrepareAsyncApplyHydratedDeploymentRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists OrchestrationClusters in a given project and location.
      virtual void ListOrchestrationClusters(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListOrchestrationClustersRequest* request, ::google::cloud::telcoautomation::v1::ListOrchestrationClustersResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListOrchestrationClusters(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListOrchestrationClustersRequest* request, ::google::cloud::telcoautomation::v1::ListOrchestrationClustersResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single OrchestrationCluster.
      virtual void GetOrchestrationCluster(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetOrchestrationClusterRequest* request, ::google::cloud::telcoautomation::v1::OrchestrationCluster* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetOrchestrationCluster(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetOrchestrationClusterRequest* request, ::google::cloud::telcoautomation::v1::OrchestrationCluster* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new OrchestrationCluster in a given project and location.
      virtual void CreateOrchestrationCluster(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateOrchestrationClusterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateOrchestrationCluster(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateOrchestrationClusterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a single OrchestrationCluster.
      virtual void DeleteOrchestrationCluster(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteOrchestrationClusterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteOrchestrationCluster(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteOrchestrationClusterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists EdgeSlms in a given project and location.
      virtual void ListEdgeSlms(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListEdgeSlmsRequest* request, ::google::cloud::telcoautomation::v1::ListEdgeSlmsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListEdgeSlms(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListEdgeSlmsRequest* request, ::google::cloud::telcoautomation::v1::ListEdgeSlmsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single EdgeSlm.
      virtual void GetEdgeSlm(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetEdgeSlmRequest* request, ::google::cloud::telcoautomation::v1::EdgeSlm* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetEdgeSlm(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetEdgeSlmRequest* request, ::google::cloud::telcoautomation::v1::EdgeSlm* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new EdgeSlm in a given project and location.
      virtual void CreateEdgeSlm(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateEdgeSlmRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateEdgeSlm(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateEdgeSlmRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a single EdgeSlm.
      virtual void DeleteEdgeSlm(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteEdgeSlmRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteEdgeSlm(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteEdgeSlmRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a blueprint.
      virtual void CreateBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateBlueprintRequest* request, ::google::cloud::telcoautomation::v1::Blueprint* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateBlueprintRequest* request, ::google::cloud::telcoautomation::v1::Blueprint* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a blueprint.
      virtual void UpdateBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateBlueprintRequest* request, ::google::cloud::telcoautomation::v1::Blueprint* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateBlueprintRequest* request, ::google::cloud::telcoautomation::v1::Blueprint* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns the requested blueprint.
      virtual void GetBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetBlueprintRequest* request, ::google::cloud::telcoautomation::v1::Blueprint* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetBlueprintRequest* request, ::google::cloud::telcoautomation::v1::Blueprint* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a blueprint and all its revisions.
      virtual void DeleteBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteBlueprintRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteBlueprintRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // List all blueprints.
      virtual void ListBlueprints(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListBlueprintsRequest* request, ::google::cloud::telcoautomation::v1::ListBlueprintsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListBlueprints(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListBlueprintsRequest* request, ::google::cloud::telcoautomation::v1::ListBlueprintsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Approves a blueprint and commits a new revision.
      virtual void ApproveBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApproveBlueprintRequest* request, ::google::cloud::telcoautomation::v1::Blueprint* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ApproveBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApproveBlueprintRequest* request, ::google::cloud::telcoautomation::v1::Blueprint* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Proposes a blueprint for approval of changes.
      virtual void ProposeBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ProposeBlueprintRequest* request, ::google::cloud::telcoautomation::v1::Blueprint* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ProposeBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ProposeBlueprintRequest* request, ::google::cloud::telcoautomation::v1::Blueprint* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Rejects a blueprint revision proposal and flips it back to Draft state.
      virtual void RejectBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RejectBlueprintRequest* request, ::google::cloud::telcoautomation::v1::Blueprint* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RejectBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RejectBlueprintRequest* request, ::google::cloud::telcoautomation::v1::Blueprint* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // List blueprint revisions of a given blueprint.
      virtual void ListBlueprintRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsRequest* request, ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListBlueprintRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsRequest* request, ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Searches across blueprint revisions.
      virtual void SearchBlueprintRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsRequest* request, ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SearchBlueprintRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsRequest* request, ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Searches across deployment revisions.
      virtual void SearchDeploymentRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsRequest* request, ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SearchDeploymentRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsRequest* request, ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Discards the changes in a blueprint and reverts the blueprint to the last
      // approved blueprint revision. No changes take place if a blueprint does not
      // have revisions.
      virtual void DiscardBlueprintChanges(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesRequest* request, ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DiscardBlueprintChanges(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesRequest* request, ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists the blueprints in TNA's public catalog. Default page size = 20,
      // Max Page Size = 100.
      virtual void ListPublicBlueprints(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListPublicBlueprintsRequest* request, ::google::cloud::telcoautomation::v1::ListPublicBlueprintsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListPublicBlueprints(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListPublicBlueprintsRequest* request, ::google::cloud::telcoautomation::v1::ListPublicBlueprintsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns the requested public blueprint.
      virtual void GetPublicBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetPublicBlueprintRequest* request, ::google::cloud::telcoautomation::v1::PublicBlueprint* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetPublicBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetPublicBlueprintRequest* request, ::google::cloud::telcoautomation::v1::PublicBlueprint* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a deployment.
      virtual void CreateDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateDeploymentRequest* request, ::google::cloud::telcoautomation::v1::Deployment* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateDeploymentRequest* request, ::google::cloud::telcoautomation::v1::Deployment* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a deployment.
      virtual void UpdateDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateDeploymentRequest* request, ::google::cloud::telcoautomation::v1::Deployment* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateDeploymentRequest* request, ::google::cloud::telcoautomation::v1::Deployment* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns the requested deployment.
      virtual void GetDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetDeploymentRequest* request, ::google::cloud::telcoautomation::v1::Deployment* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetDeploymentRequest* request, ::google::cloud::telcoautomation::v1::Deployment* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Removes the deployment by marking it as DELETING. Post which deployment and
      // it's revisions gets deleted.
      virtual void RemoveDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RemoveDeploymentRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RemoveDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RemoveDeploymentRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // List all deployments.
      virtual void ListDeployments(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListDeploymentsRequest* request, ::google::cloud::telcoautomation::v1::ListDeploymentsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListDeployments(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListDeploymentsRequest* request, ::google::cloud::telcoautomation::v1::ListDeploymentsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // List deployment revisions of a given deployment.
      virtual void ListDeploymentRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsRequest* request, ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListDeploymentRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsRequest* request, ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Discards the changes in a deployment and reverts the deployment to the last
      // approved deployment revision. No changes take place if a deployment does
      // not have revisions.
      virtual void DiscardDeploymentChanges(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesRequest* request, ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DiscardDeploymentChanges(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesRequest* request, ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Applies the deployment's YAML files to the parent orchestration cluster.
      virtual void ApplyDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApplyDeploymentRequest* request, ::google::cloud::telcoautomation::v1::Deployment* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ApplyDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApplyDeploymentRequest* request, ::google::cloud::telcoautomation::v1::Deployment* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns the requested deployment status.
      virtual void ComputeDeploymentStatus(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusRequest* request, ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ComputeDeploymentStatus(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusRequest* request, ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Rollback the active deployment to the given past approved deployment
      // revision.
      virtual void RollbackDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RollbackDeploymentRequest* request, ::google::cloud::telcoautomation::v1::Deployment* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RollbackDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RollbackDeploymentRequest* request, ::google::cloud::telcoautomation::v1::Deployment* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns the requested hydrated deployment.
      virtual void GetHydratedDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetHydratedDeploymentRequest* request, ::google::cloud::telcoautomation::v1::HydratedDeployment* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetHydratedDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetHydratedDeploymentRequest* request, ::google::cloud::telcoautomation::v1::HydratedDeployment* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // List all hydrated deployments present under a deployment.
      virtual void ListHydratedDeployments(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsRequest* request, ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListHydratedDeployments(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsRequest* request, ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a hydrated deployment.
      virtual void UpdateHydratedDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateHydratedDeploymentRequest* request, ::google::cloud::telcoautomation::v1::HydratedDeployment* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateHydratedDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateHydratedDeploymentRequest* request, ::google::cloud::telcoautomation::v1::HydratedDeployment* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Applies a hydrated deployment to a workload cluster.
      virtual void ApplyHydratedDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApplyHydratedDeploymentRequest* request, ::google::cloud::telcoautomation::v1::HydratedDeployment* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ApplyHydratedDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApplyHydratedDeploymentRequest* request, ::google::cloud::telcoautomation::v1::HydratedDeployment* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListOrchestrationClustersResponse>* AsyncListOrchestrationClustersRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListOrchestrationClustersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListOrchestrationClustersResponse>* PrepareAsyncListOrchestrationClustersRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListOrchestrationClustersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::OrchestrationCluster>* AsyncGetOrchestrationClusterRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetOrchestrationClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::OrchestrationCluster>* PrepareAsyncGetOrchestrationClusterRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetOrchestrationClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateOrchestrationClusterRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateOrchestrationClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateOrchestrationClusterRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateOrchestrationClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteOrchestrationClusterRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteOrchestrationClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteOrchestrationClusterRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteOrchestrationClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListEdgeSlmsResponse>* AsyncListEdgeSlmsRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListEdgeSlmsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListEdgeSlmsResponse>* PrepareAsyncListEdgeSlmsRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListEdgeSlmsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::EdgeSlm>* AsyncGetEdgeSlmRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetEdgeSlmRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::EdgeSlm>* PrepareAsyncGetEdgeSlmRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetEdgeSlmRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateEdgeSlmRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateEdgeSlmRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateEdgeSlmRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateEdgeSlmRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteEdgeSlmRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteEdgeSlmRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteEdgeSlmRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteEdgeSlmRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Blueprint>* AsyncCreateBlueprintRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateBlueprintRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Blueprint>* PrepareAsyncCreateBlueprintRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateBlueprintRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Blueprint>* AsyncUpdateBlueprintRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateBlueprintRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Blueprint>* PrepareAsyncUpdateBlueprintRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateBlueprintRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Blueprint>* AsyncGetBlueprintRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetBlueprintRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Blueprint>* PrepareAsyncGetBlueprintRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetBlueprintRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteBlueprintRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteBlueprintRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteBlueprintRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteBlueprintRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListBlueprintsResponse>* AsyncListBlueprintsRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListBlueprintsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListBlueprintsResponse>* PrepareAsyncListBlueprintsRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListBlueprintsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Blueprint>* AsyncApproveBlueprintRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApproveBlueprintRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Blueprint>* PrepareAsyncApproveBlueprintRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApproveBlueprintRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Blueprint>* AsyncProposeBlueprintRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ProposeBlueprintRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Blueprint>* PrepareAsyncProposeBlueprintRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ProposeBlueprintRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Blueprint>* AsyncRejectBlueprintRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RejectBlueprintRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Blueprint>* PrepareAsyncRejectBlueprintRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RejectBlueprintRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsResponse>* AsyncListBlueprintRevisionsRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsResponse>* PrepareAsyncListBlueprintRevisionsRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsResponse>* AsyncSearchBlueprintRevisionsRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsResponse>* PrepareAsyncSearchBlueprintRevisionsRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsResponse>* AsyncSearchDeploymentRevisionsRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsResponse>* PrepareAsyncSearchDeploymentRevisionsRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesResponse>* AsyncDiscardBlueprintChangesRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesResponse>* PrepareAsyncDiscardBlueprintChangesRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListPublicBlueprintsResponse>* AsyncListPublicBlueprintsRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListPublicBlueprintsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListPublicBlueprintsResponse>* PrepareAsyncListPublicBlueprintsRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListPublicBlueprintsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::PublicBlueprint>* AsyncGetPublicBlueprintRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetPublicBlueprintRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::PublicBlueprint>* PrepareAsyncGetPublicBlueprintRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetPublicBlueprintRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Deployment>* AsyncCreateDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateDeploymentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Deployment>* PrepareAsyncCreateDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateDeploymentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Deployment>* AsyncUpdateDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateDeploymentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Deployment>* PrepareAsyncUpdateDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateDeploymentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Deployment>* AsyncGetDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetDeploymentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Deployment>* PrepareAsyncGetDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetDeploymentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncRemoveDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RemoveDeploymentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncRemoveDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RemoveDeploymentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListDeploymentsResponse>* AsyncListDeploymentsRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListDeploymentsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListDeploymentsResponse>* PrepareAsyncListDeploymentsRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListDeploymentsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsResponse>* AsyncListDeploymentRevisionsRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsResponse>* PrepareAsyncListDeploymentRevisionsRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesResponse>* AsyncDiscardDeploymentChangesRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesResponse>* PrepareAsyncDiscardDeploymentChangesRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Deployment>* AsyncApplyDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApplyDeploymentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Deployment>* PrepareAsyncApplyDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApplyDeploymentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusResponse>* AsyncComputeDeploymentStatusRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusResponse>* PrepareAsyncComputeDeploymentStatusRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Deployment>* AsyncRollbackDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RollbackDeploymentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::Deployment>* PrepareAsyncRollbackDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RollbackDeploymentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::HydratedDeployment>* AsyncGetHydratedDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetHydratedDeploymentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::HydratedDeployment>* PrepareAsyncGetHydratedDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetHydratedDeploymentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsResponse>* AsyncListHydratedDeploymentsRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsResponse>* PrepareAsyncListHydratedDeploymentsRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::HydratedDeployment>* AsyncUpdateHydratedDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateHydratedDeploymentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::HydratedDeployment>* PrepareAsyncUpdateHydratedDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateHydratedDeploymentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::HydratedDeployment>* AsyncApplyHydratedDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApplyHydratedDeploymentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::telcoautomation::v1::HydratedDeployment>* PrepareAsyncApplyHydratedDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApplyHydratedDeploymentRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListOrchestrationClusters(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListOrchestrationClustersRequest& request, ::google::cloud::telcoautomation::v1::ListOrchestrationClustersResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListOrchestrationClustersResponse>> AsyncListOrchestrationClusters(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListOrchestrationClustersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListOrchestrationClustersResponse>>(AsyncListOrchestrationClustersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListOrchestrationClustersResponse>> PrepareAsyncListOrchestrationClusters(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListOrchestrationClustersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListOrchestrationClustersResponse>>(PrepareAsyncListOrchestrationClustersRaw(context, request, cq));
    }
    ::grpc::Status GetOrchestrationCluster(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetOrchestrationClusterRequest& request, ::google::cloud::telcoautomation::v1::OrchestrationCluster* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::OrchestrationCluster>> AsyncGetOrchestrationCluster(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetOrchestrationClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::OrchestrationCluster>>(AsyncGetOrchestrationClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::OrchestrationCluster>> PrepareAsyncGetOrchestrationCluster(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetOrchestrationClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::OrchestrationCluster>>(PrepareAsyncGetOrchestrationClusterRaw(context, request, cq));
    }
    ::grpc::Status CreateOrchestrationCluster(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateOrchestrationClusterRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateOrchestrationCluster(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateOrchestrationClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateOrchestrationClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateOrchestrationCluster(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateOrchestrationClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateOrchestrationClusterRaw(context, request, cq));
    }
    ::grpc::Status DeleteOrchestrationCluster(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteOrchestrationClusterRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteOrchestrationCluster(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteOrchestrationClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteOrchestrationClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteOrchestrationCluster(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteOrchestrationClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteOrchestrationClusterRaw(context, request, cq));
    }
    ::grpc::Status ListEdgeSlms(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListEdgeSlmsRequest& request, ::google::cloud::telcoautomation::v1::ListEdgeSlmsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListEdgeSlmsResponse>> AsyncListEdgeSlms(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListEdgeSlmsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListEdgeSlmsResponse>>(AsyncListEdgeSlmsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListEdgeSlmsResponse>> PrepareAsyncListEdgeSlms(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListEdgeSlmsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListEdgeSlmsResponse>>(PrepareAsyncListEdgeSlmsRaw(context, request, cq));
    }
    ::grpc::Status GetEdgeSlm(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetEdgeSlmRequest& request, ::google::cloud::telcoautomation::v1::EdgeSlm* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::EdgeSlm>> AsyncGetEdgeSlm(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetEdgeSlmRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::EdgeSlm>>(AsyncGetEdgeSlmRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::EdgeSlm>> PrepareAsyncGetEdgeSlm(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetEdgeSlmRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::EdgeSlm>>(PrepareAsyncGetEdgeSlmRaw(context, request, cq));
    }
    ::grpc::Status CreateEdgeSlm(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateEdgeSlmRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateEdgeSlm(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateEdgeSlmRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateEdgeSlmRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateEdgeSlm(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateEdgeSlmRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateEdgeSlmRaw(context, request, cq));
    }
    ::grpc::Status DeleteEdgeSlm(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteEdgeSlmRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteEdgeSlm(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteEdgeSlmRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteEdgeSlmRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteEdgeSlm(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteEdgeSlmRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteEdgeSlmRaw(context, request, cq));
    }
    ::grpc::Status CreateBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateBlueprintRequest& request, ::google::cloud::telcoautomation::v1::Blueprint* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Blueprint>> AsyncCreateBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateBlueprintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Blueprint>>(AsyncCreateBlueprintRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Blueprint>> PrepareAsyncCreateBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateBlueprintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Blueprint>>(PrepareAsyncCreateBlueprintRaw(context, request, cq));
    }
    ::grpc::Status UpdateBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateBlueprintRequest& request, ::google::cloud::telcoautomation::v1::Blueprint* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Blueprint>> AsyncUpdateBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateBlueprintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Blueprint>>(AsyncUpdateBlueprintRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Blueprint>> PrepareAsyncUpdateBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateBlueprintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Blueprint>>(PrepareAsyncUpdateBlueprintRaw(context, request, cq));
    }
    ::grpc::Status GetBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetBlueprintRequest& request, ::google::cloud::telcoautomation::v1::Blueprint* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Blueprint>> AsyncGetBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetBlueprintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Blueprint>>(AsyncGetBlueprintRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Blueprint>> PrepareAsyncGetBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetBlueprintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Blueprint>>(PrepareAsyncGetBlueprintRaw(context, request, cq));
    }
    ::grpc::Status DeleteBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteBlueprintRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteBlueprintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteBlueprintRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteBlueprintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteBlueprintRaw(context, request, cq));
    }
    ::grpc::Status ListBlueprints(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListBlueprintsRequest& request, ::google::cloud::telcoautomation::v1::ListBlueprintsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListBlueprintsResponse>> AsyncListBlueprints(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListBlueprintsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListBlueprintsResponse>>(AsyncListBlueprintsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListBlueprintsResponse>> PrepareAsyncListBlueprints(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListBlueprintsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListBlueprintsResponse>>(PrepareAsyncListBlueprintsRaw(context, request, cq));
    }
    ::grpc::Status ApproveBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApproveBlueprintRequest& request, ::google::cloud::telcoautomation::v1::Blueprint* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Blueprint>> AsyncApproveBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApproveBlueprintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Blueprint>>(AsyncApproveBlueprintRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Blueprint>> PrepareAsyncApproveBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApproveBlueprintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Blueprint>>(PrepareAsyncApproveBlueprintRaw(context, request, cq));
    }
    ::grpc::Status ProposeBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ProposeBlueprintRequest& request, ::google::cloud::telcoautomation::v1::Blueprint* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Blueprint>> AsyncProposeBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ProposeBlueprintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Blueprint>>(AsyncProposeBlueprintRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Blueprint>> PrepareAsyncProposeBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ProposeBlueprintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Blueprint>>(PrepareAsyncProposeBlueprintRaw(context, request, cq));
    }
    ::grpc::Status RejectBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RejectBlueprintRequest& request, ::google::cloud::telcoautomation::v1::Blueprint* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Blueprint>> AsyncRejectBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RejectBlueprintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Blueprint>>(AsyncRejectBlueprintRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Blueprint>> PrepareAsyncRejectBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RejectBlueprintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Blueprint>>(PrepareAsyncRejectBlueprintRaw(context, request, cq));
    }
    ::grpc::Status ListBlueprintRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsRequest& request, ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsResponse>> AsyncListBlueprintRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsResponse>>(AsyncListBlueprintRevisionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsResponse>> PrepareAsyncListBlueprintRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsResponse>>(PrepareAsyncListBlueprintRevisionsRaw(context, request, cq));
    }
    ::grpc::Status SearchBlueprintRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsRequest& request, ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsResponse>> AsyncSearchBlueprintRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsResponse>>(AsyncSearchBlueprintRevisionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsResponse>> PrepareAsyncSearchBlueprintRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsResponse>>(PrepareAsyncSearchBlueprintRevisionsRaw(context, request, cq));
    }
    ::grpc::Status SearchDeploymentRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsRequest& request, ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsResponse>> AsyncSearchDeploymentRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsResponse>>(AsyncSearchDeploymentRevisionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsResponse>> PrepareAsyncSearchDeploymentRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsResponse>>(PrepareAsyncSearchDeploymentRevisionsRaw(context, request, cq));
    }
    ::grpc::Status DiscardBlueprintChanges(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesRequest& request, ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesResponse>> AsyncDiscardBlueprintChanges(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesResponse>>(AsyncDiscardBlueprintChangesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesResponse>> PrepareAsyncDiscardBlueprintChanges(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesResponse>>(PrepareAsyncDiscardBlueprintChangesRaw(context, request, cq));
    }
    ::grpc::Status ListPublicBlueprints(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListPublicBlueprintsRequest& request, ::google::cloud::telcoautomation::v1::ListPublicBlueprintsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListPublicBlueprintsResponse>> AsyncListPublicBlueprints(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListPublicBlueprintsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListPublicBlueprintsResponse>>(AsyncListPublicBlueprintsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListPublicBlueprintsResponse>> PrepareAsyncListPublicBlueprints(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListPublicBlueprintsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListPublicBlueprintsResponse>>(PrepareAsyncListPublicBlueprintsRaw(context, request, cq));
    }
    ::grpc::Status GetPublicBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetPublicBlueprintRequest& request, ::google::cloud::telcoautomation::v1::PublicBlueprint* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::PublicBlueprint>> AsyncGetPublicBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetPublicBlueprintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::PublicBlueprint>>(AsyncGetPublicBlueprintRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::PublicBlueprint>> PrepareAsyncGetPublicBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetPublicBlueprintRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::PublicBlueprint>>(PrepareAsyncGetPublicBlueprintRaw(context, request, cq));
    }
    ::grpc::Status CreateDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateDeploymentRequest& request, ::google::cloud::telcoautomation::v1::Deployment* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Deployment>> AsyncCreateDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Deployment>>(AsyncCreateDeploymentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Deployment>> PrepareAsyncCreateDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Deployment>>(PrepareAsyncCreateDeploymentRaw(context, request, cq));
    }
    ::grpc::Status UpdateDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateDeploymentRequest& request, ::google::cloud::telcoautomation::v1::Deployment* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Deployment>> AsyncUpdateDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Deployment>>(AsyncUpdateDeploymentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Deployment>> PrepareAsyncUpdateDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Deployment>>(PrepareAsyncUpdateDeploymentRaw(context, request, cq));
    }
    ::grpc::Status GetDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetDeploymentRequest& request, ::google::cloud::telcoautomation::v1::Deployment* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Deployment>> AsyncGetDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Deployment>>(AsyncGetDeploymentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Deployment>> PrepareAsyncGetDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Deployment>>(PrepareAsyncGetDeploymentRaw(context, request, cq));
    }
    ::grpc::Status RemoveDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RemoveDeploymentRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncRemoveDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RemoveDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncRemoveDeploymentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncRemoveDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RemoveDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncRemoveDeploymentRaw(context, request, cq));
    }
    ::grpc::Status ListDeployments(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListDeploymentsRequest& request, ::google::cloud::telcoautomation::v1::ListDeploymentsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListDeploymentsResponse>> AsyncListDeployments(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListDeploymentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListDeploymentsResponse>>(AsyncListDeploymentsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListDeploymentsResponse>> PrepareAsyncListDeployments(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListDeploymentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListDeploymentsResponse>>(PrepareAsyncListDeploymentsRaw(context, request, cq));
    }
    ::grpc::Status ListDeploymentRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsRequest& request, ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsResponse>> AsyncListDeploymentRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsResponse>>(AsyncListDeploymentRevisionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsResponse>> PrepareAsyncListDeploymentRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsResponse>>(PrepareAsyncListDeploymentRevisionsRaw(context, request, cq));
    }
    ::grpc::Status DiscardDeploymentChanges(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesRequest& request, ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesResponse>> AsyncDiscardDeploymentChanges(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesResponse>>(AsyncDiscardDeploymentChangesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesResponse>> PrepareAsyncDiscardDeploymentChanges(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesResponse>>(PrepareAsyncDiscardDeploymentChangesRaw(context, request, cq));
    }
    ::grpc::Status ApplyDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApplyDeploymentRequest& request, ::google::cloud::telcoautomation::v1::Deployment* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Deployment>> AsyncApplyDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApplyDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Deployment>>(AsyncApplyDeploymentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Deployment>> PrepareAsyncApplyDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApplyDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Deployment>>(PrepareAsyncApplyDeploymentRaw(context, request, cq));
    }
    ::grpc::Status ComputeDeploymentStatus(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusRequest& request, ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusResponse>> AsyncComputeDeploymentStatus(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusResponse>>(AsyncComputeDeploymentStatusRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusResponse>> PrepareAsyncComputeDeploymentStatus(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusResponse>>(PrepareAsyncComputeDeploymentStatusRaw(context, request, cq));
    }
    ::grpc::Status RollbackDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RollbackDeploymentRequest& request, ::google::cloud::telcoautomation::v1::Deployment* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Deployment>> AsyncRollbackDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RollbackDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Deployment>>(AsyncRollbackDeploymentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Deployment>> PrepareAsyncRollbackDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RollbackDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Deployment>>(PrepareAsyncRollbackDeploymentRaw(context, request, cq));
    }
    ::grpc::Status GetHydratedDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetHydratedDeploymentRequest& request, ::google::cloud::telcoautomation::v1::HydratedDeployment* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::HydratedDeployment>> AsyncGetHydratedDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetHydratedDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::HydratedDeployment>>(AsyncGetHydratedDeploymentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::HydratedDeployment>> PrepareAsyncGetHydratedDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetHydratedDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::HydratedDeployment>>(PrepareAsyncGetHydratedDeploymentRaw(context, request, cq));
    }
    ::grpc::Status ListHydratedDeployments(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsRequest& request, ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsResponse>> AsyncListHydratedDeployments(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsResponse>>(AsyncListHydratedDeploymentsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsResponse>> PrepareAsyncListHydratedDeployments(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsResponse>>(PrepareAsyncListHydratedDeploymentsRaw(context, request, cq));
    }
    ::grpc::Status UpdateHydratedDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateHydratedDeploymentRequest& request, ::google::cloud::telcoautomation::v1::HydratedDeployment* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::HydratedDeployment>> AsyncUpdateHydratedDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateHydratedDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::HydratedDeployment>>(AsyncUpdateHydratedDeploymentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::HydratedDeployment>> PrepareAsyncUpdateHydratedDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateHydratedDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::HydratedDeployment>>(PrepareAsyncUpdateHydratedDeploymentRaw(context, request, cq));
    }
    ::grpc::Status ApplyHydratedDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApplyHydratedDeploymentRequest& request, ::google::cloud::telcoautomation::v1::HydratedDeployment* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::HydratedDeployment>> AsyncApplyHydratedDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApplyHydratedDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::HydratedDeployment>>(AsyncApplyHydratedDeploymentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::HydratedDeployment>> PrepareAsyncApplyHydratedDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApplyHydratedDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::HydratedDeployment>>(PrepareAsyncApplyHydratedDeploymentRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListOrchestrationClusters(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListOrchestrationClustersRequest* request, ::google::cloud::telcoautomation::v1::ListOrchestrationClustersResponse* response, std::function<void(::grpc::Status)>) override;
      void ListOrchestrationClusters(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListOrchestrationClustersRequest* request, ::google::cloud::telcoautomation::v1::ListOrchestrationClustersResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetOrchestrationCluster(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetOrchestrationClusterRequest* request, ::google::cloud::telcoautomation::v1::OrchestrationCluster* response, std::function<void(::grpc::Status)>) override;
      void GetOrchestrationCluster(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetOrchestrationClusterRequest* request, ::google::cloud::telcoautomation::v1::OrchestrationCluster* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateOrchestrationCluster(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateOrchestrationClusterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateOrchestrationCluster(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateOrchestrationClusterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteOrchestrationCluster(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteOrchestrationClusterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteOrchestrationCluster(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteOrchestrationClusterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListEdgeSlms(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListEdgeSlmsRequest* request, ::google::cloud::telcoautomation::v1::ListEdgeSlmsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListEdgeSlms(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListEdgeSlmsRequest* request, ::google::cloud::telcoautomation::v1::ListEdgeSlmsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetEdgeSlm(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetEdgeSlmRequest* request, ::google::cloud::telcoautomation::v1::EdgeSlm* response, std::function<void(::grpc::Status)>) override;
      void GetEdgeSlm(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetEdgeSlmRequest* request, ::google::cloud::telcoautomation::v1::EdgeSlm* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateEdgeSlm(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateEdgeSlmRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateEdgeSlm(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateEdgeSlmRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteEdgeSlm(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteEdgeSlmRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteEdgeSlm(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteEdgeSlmRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateBlueprintRequest* request, ::google::cloud::telcoautomation::v1::Blueprint* response, std::function<void(::grpc::Status)>) override;
      void CreateBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateBlueprintRequest* request, ::google::cloud::telcoautomation::v1::Blueprint* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateBlueprintRequest* request, ::google::cloud::telcoautomation::v1::Blueprint* response, std::function<void(::grpc::Status)>) override;
      void UpdateBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateBlueprintRequest* request, ::google::cloud::telcoautomation::v1::Blueprint* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetBlueprintRequest* request, ::google::cloud::telcoautomation::v1::Blueprint* response, std::function<void(::grpc::Status)>) override;
      void GetBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetBlueprintRequest* request, ::google::cloud::telcoautomation::v1::Blueprint* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteBlueprintRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteBlueprintRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListBlueprints(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListBlueprintsRequest* request, ::google::cloud::telcoautomation::v1::ListBlueprintsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListBlueprints(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListBlueprintsRequest* request, ::google::cloud::telcoautomation::v1::ListBlueprintsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ApproveBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApproveBlueprintRequest* request, ::google::cloud::telcoautomation::v1::Blueprint* response, std::function<void(::grpc::Status)>) override;
      void ApproveBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApproveBlueprintRequest* request, ::google::cloud::telcoautomation::v1::Blueprint* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ProposeBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ProposeBlueprintRequest* request, ::google::cloud::telcoautomation::v1::Blueprint* response, std::function<void(::grpc::Status)>) override;
      void ProposeBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ProposeBlueprintRequest* request, ::google::cloud::telcoautomation::v1::Blueprint* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RejectBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RejectBlueprintRequest* request, ::google::cloud::telcoautomation::v1::Blueprint* response, std::function<void(::grpc::Status)>) override;
      void RejectBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RejectBlueprintRequest* request, ::google::cloud::telcoautomation::v1::Blueprint* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListBlueprintRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsRequest* request, ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListBlueprintRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsRequest* request, ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void SearchBlueprintRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsRequest* request, ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsResponse* response, std::function<void(::grpc::Status)>) override;
      void SearchBlueprintRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsRequest* request, ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void SearchDeploymentRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsRequest* request, ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsResponse* response, std::function<void(::grpc::Status)>) override;
      void SearchDeploymentRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsRequest* request, ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DiscardBlueprintChanges(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesRequest* request, ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesResponse* response, std::function<void(::grpc::Status)>) override;
      void DiscardBlueprintChanges(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesRequest* request, ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListPublicBlueprints(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListPublicBlueprintsRequest* request, ::google::cloud::telcoautomation::v1::ListPublicBlueprintsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListPublicBlueprints(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListPublicBlueprintsRequest* request, ::google::cloud::telcoautomation::v1::ListPublicBlueprintsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetPublicBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetPublicBlueprintRequest* request, ::google::cloud::telcoautomation::v1::PublicBlueprint* response, std::function<void(::grpc::Status)>) override;
      void GetPublicBlueprint(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetPublicBlueprintRequest* request, ::google::cloud::telcoautomation::v1::PublicBlueprint* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateDeploymentRequest* request, ::google::cloud::telcoautomation::v1::Deployment* response, std::function<void(::grpc::Status)>) override;
      void CreateDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateDeploymentRequest* request, ::google::cloud::telcoautomation::v1::Deployment* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateDeploymentRequest* request, ::google::cloud::telcoautomation::v1::Deployment* response, std::function<void(::grpc::Status)>) override;
      void UpdateDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateDeploymentRequest* request, ::google::cloud::telcoautomation::v1::Deployment* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetDeploymentRequest* request, ::google::cloud::telcoautomation::v1::Deployment* response, std::function<void(::grpc::Status)>) override;
      void GetDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetDeploymentRequest* request, ::google::cloud::telcoautomation::v1::Deployment* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RemoveDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RemoveDeploymentRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void RemoveDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RemoveDeploymentRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListDeployments(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListDeploymentsRequest* request, ::google::cloud::telcoautomation::v1::ListDeploymentsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListDeployments(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListDeploymentsRequest* request, ::google::cloud::telcoautomation::v1::ListDeploymentsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListDeploymentRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsRequest* request, ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListDeploymentRevisions(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsRequest* request, ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DiscardDeploymentChanges(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesRequest* request, ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesResponse* response, std::function<void(::grpc::Status)>) override;
      void DiscardDeploymentChanges(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesRequest* request, ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ApplyDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApplyDeploymentRequest* request, ::google::cloud::telcoautomation::v1::Deployment* response, std::function<void(::grpc::Status)>) override;
      void ApplyDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApplyDeploymentRequest* request, ::google::cloud::telcoautomation::v1::Deployment* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ComputeDeploymentStatus(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusRequest* request, ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusResponse* response, std::function<void(::grpc::Status)>) override;
      void ComputeDeploymentStatus(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusRequest* request, ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RollbackDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RollbackDeploymentRequest* request, ::google::cloud::telcoautomation::v1::Deployment* response, std::function<void(::grpc::Status)>) override;
      void RollbackDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RollbackDeploymentRequest* request, ::google::cloud::telcoautomation::v1::Deployment* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetHydratedDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetHydratedDeploymentRequest* request, ::google::cloud::telcoautomation::v1::HydratedDeployment* response, std::function<void(::grpc::Status)>) override;
      void GetHydratedDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetHydratedDeploymentRequest* request, ::google::cloud::telcoautomation::v1::HydratedDeployment* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListHydratedDeployments(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsRequest* request, ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListHydratedDeployments(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsRequest* request, ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateHydratedDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateHydratedDeploymentRequest* request, ::google::cloud::telcoautomation::v1::HydratedDeployment* response, std::function<void(::grpc::Status)>) override;
      void UpdateHydratedDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateHydratedDeploymentRequest* request, ::google::cloud::telcoautomation::v1::HydratedDeployment* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ApplyHydratedDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApplyHydratedDeploymentRequest* request, ::google::cloud::telcoautomation::v1::HydratedDeployment* response, std::function<void(::grpc::Status)>) override;
      void ApplyHydratedDeployment(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApplyHydratedDeploymentRequest* request, ::google::cloud::telcoautomation::v1::HydratedDeployment* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListOrchestrationClustersResponse>* AsyncListOrchestrationClustersRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListOrchestrationClustersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListOrchestrationClustersResponse>* PrepareAsyncListOrchestrationClustersRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListOrchestrationClustersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::OrchestrationCluster>* AsyncGetOrchestrationClusterRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetOrchestrationClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::OrchestrationCluster>* PrepareAsyncGetOrchestrationClusterRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetOrchestrationClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateOrchestrationClusterRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateOrchestrationClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateOrchestrationClusterRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateOrchestrationClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteOrchestrationClusterRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteOrchestrationClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteOrchestrationClusterRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteOrchestrationClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListEdgeSlmsResponse>* AsyncListEdgeSlmsRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListEdgeSlmsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListEdgeSlmsResponse>* PrepareAsyncListEdgeSlmsRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListEdgeSlmsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::EdgeSlm>* AsyncGetEdgeSlmRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetEdgeSlmRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::EdgeSlm>* PrepareAsyncGetEdgeSlmRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetEdgeSlmRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateEdgeSlmRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateEdgeSlmRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateEdgeSlmRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateEdgeSlmRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteEdgeSlmRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteEdgeSlmRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteEdgeSlmRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteEdgeSlmRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Blueprint>* AsyncCreateBlueprintRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateBlueprintRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Blueprint>* PrepareAsyncCreateBlueprintRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateBlueprintRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Blueprint>* AsyncUpdateBlueprintRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateBlueprintRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Blueprint>* PrepareAsyncUpdateBlueprintRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateBlueprintRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Blueprint>* AsyncGetBlueprintRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetBlueprintRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Blueprint>* PrepareAsyncGetBlueprintRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetBlueprintRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteBlueprintRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteBlueprintRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteBlueprintRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DeleteBlueprintRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListBlueprintsResponse>* AsyncListBlueprintsRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListBlueprintsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListBlueprintsResponse>* PrepareAsyncListBlueprintsRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListBlueprintsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Blueprint>* AsyncApproveBlueprintRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApproveBlueprintRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Blueprint>* PrepareAsyncApproveBlueprintRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApproveBlueprintRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Blueprint>* AsyncProposeBlueprintRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ProposeBlueprintRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Blueprint>* PrepareAsyncProposeBlueprintRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ProposeBlueprintRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Blueprint>* AsyncRejectBlueprintRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RejectBlueprintRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Blueprint>* PrepareAsyncRejectBlueprintRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RejectBlueprintRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsResponse>* AsyncListBlueprintRevisionsRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsResponse>* PrepareAsyncListBlueprintRevisionsRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsResponse>* AsyncSearchBlueprintRevisionsRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsResponse>* PrepareAsyncSearchBlueprintRevisionsRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsResponse>* AsyncSearchDeploymentRevisionsRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsResponse>* PrepareAsyncSearchDeploymentRevisionsRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesResponse>* AsyncDiscardBlueprintChangesRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesResponse>* PrepareAsyncDiscardBlueprintChangesRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListPublicBlueprintsResponse>* AsyncListPublicBlueprintsRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListPublicBlueprintsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListPublicBlueprintsResponse>* PrepareAsyncListPublicBlueprintsRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListPublicBlueprintsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::PublicBlueprint>* AsyncGetPublicBlueprintRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetPublicBlueprintRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::PublicBlueprint>* PrepareAsyncGetPublicBlueprintRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetPublicBlueprintRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Deployment>* AsyncCreateDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateDeploymentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Deployment>* PrepareAsyncCreateDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::CreateDeploymentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Deployment>* AsyncUpdateDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateDeploymentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Deployment>* PrepareAsyncUpdateDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateDeploymentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Deployment>* AsyncGetDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetDeploymentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Deployment>* PrepareAsyncGetDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetDeploymentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncRemoveDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RemoveDeploymentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncRemoveDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RemoveDeploymentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListDeploymentsResponse>* AsyncListDeploymentsRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListDeploymentsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListDeploymentsResponse>* PrepareAsyncListDeploymentsRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListDeploymentsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsResponse>* AsyncListDeploymentRevisionsRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsResponse>* PrepareAsyncListDeploymentRevisionsRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesResponse>* AsyncDiscardDeploymentChangesRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesResponse>* PrepareAsyncDiscardDeploymentChangesRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Deployment>* AsyncApplyDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApplyDeploymentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Deployment>* PrepareAsyncApplyDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApplyDeploymentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusResponse>* AsyncComputeDeploymentStatusRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusResponse>* PrepareAsyncComputeDeploymentStatusRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Deployment>* AsyncRollbackDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RollbackDeploymentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::Deployment>* PrepareAsyncRollbackDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::RollbackDeploymentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::HydratedDeployment>* AsyncGetHydratedDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetHydratedDeploymentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::HydratedDeployment>* PrepareAsyncGetHydratedDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::GetHydratedDeploymentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsResponse>* AsyncListHydratedDeploymentsRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsResponse>* PrepareAsyncListHydratedDeploymentsRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::HydratedDeployment>* AsyncUpdateHydratedDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateHydratedDeploymentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::HydratedDeployment>* PrepareAsyncUpdateHydratedDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::UpdateHydratedDeploymentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::HydratedDeployment>* AsyncApplyHydratedDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApplyHydratedDeploymentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::telcoautomation::v1::HydratedDeployment>* PrepareAsyncApplyHydratedDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::telcoautomation::v1::ApplyHydratedDeploymentRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListOrchestrationClusters_;
    const ::grpc::internal::RpcMethod rpcmethod_GetOrchestrationCluster_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateOrchestrationCluster_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteOrchestrationCluster_;
    const ::grpc::internal::RpcMethod rpcmethod_ListEdgeSlms_;
    const ::grpc::internal::RpcMethod rpcmethod_GetEdgeSlm_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateEdgeSlm_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteEdgeSlm_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateBlueprint_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateBlueprint_;
    const ::grpc::internal::RpcMethod rpcmethod_GetBlueprint_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteBlueprint_;
    const ::grpc::internal::RpcMethod rpcmethod_ListBlueprints_;
    const ::grpc::internal::RpcMethod rpcmethod_ApproveBlueprint_;
    const ::grpc::internal::RpcMethod rpcmethod_ProposeBlueprint_;
    const ::grpc::internal::RpcMethod rpcmethod_RejectBlueprint_;
    const ::grpc::internal::RpcMethod rpcmethod_ListBlueprintRevisions_;
    const ::grpc::internal::RpcMethod rpcmethod_SearchBlueprintRevisions_;
    const ::grpc::internal::RpcMethod rpcmethod_SearchDeploymentRevisions_;
    const ::grpc::internal::RpcMethod rpcmethod_DiscardBlueprintChanges_;
    const ::grpc::internal::RpcMethod rpcmethod_ListPublicBlueprints_;
    const ::grpc::internal::RpcMethod rpcmethod_GetPublicBlueprint_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateDeployment_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateDeployment_;
    const ::grpc::internal::RpcMethod rpcmethod_GetDeployment_;
    const ::grpc::internal::RpcMethod rpcmethod_RemoveDeployment_;
    const ::grpc::internal::RpcMethod rpcmethod_ListDeployments_;
    const ::grpc::internal::RpcMethod rpcmethod_ListDeploymentRevisions_;
    const ::grpc::internal::RpcMethod rpcmethod_DiscardDeploymentChanges_;
    const ::grpc::internal::RpcMethod rpcmethod_ApplyDeployment_;
    const ::grpc::internal::RpcMethod rpcmethod_ComputeDeploymentStatus_;
    const ::grpc::internal::RpcMethod rpcmethod_RollbackDeployment_;
    const ::grpc::internal::RpcMethod rpcmethod_GetHydratedDeployment_;
    const ::grpc::internal::RpcMethod rpcmethod_ListHydratedDeployments_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateHydratedDeployment_;
    const ::grpc::internal::RpcMethod rpcmethod_ApplyHydratedDeployment_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists OrchestrationClusters in a given project and location.
    virtual ::grpc::Status ListOrchestrationClusters(::grpc::ServerContext* context, const ::google::cloud::telcoautomation::v1::ListOrchestrationClustersRequest* request, ::google::cloud::telcoautomation::v1::ListOrchestrationClustersResponse* response);
    // Gets details of a single OrchestrationCluster.
    virtual ::grpc::Status GetOrchestrationCluster(::grpc::ServerContext* context, const ::google::cloud::telcoautomation::v1::GetOrchestrationClusterRequest* request, ::google::cloud::telcoautomation::v1::OrchestrationCluster* response);
    // Creates a new OrchestrationCluster in a given project and location.
    virtual ::grpc::Status CreateOrchestrationCluster(::grpc::ServerContext* context, const ::google::cloud::telcoautomation::v1::CreateOrchestrationClusterRequest* request, ::google::longrunning::Operation* response);
    // Deletes a single OrchestrationCluster.
    virtual ::grpc::Status DeleteOrchestrationCluster(::grpc::ServerContext* context, const ::google::cloud::telcoautomation::v1::DeleteOrchestrationClusterRequest* request, ::google::longrunning::Operation* response);
    // Lists EdgeSlms in a given project and location.
    virtual ::grpc::Status ListEdgeSlms(::grpc::ServerContext* context, const ::google::cloud::telcoautomation::v1::ListEdgeSlmsRequest* request, ::google::cloud::telcoautomation::v1::ListEdgeSlmsResponse* response);
    // Gets details of a single EdgeSlm.
    virtual ::grpc::Status GetEdgeSlm(::grpc::ServerContext* context, const ::google::cloud::telcoautomation::v1::GetEdgeSlmRequest* request, ::google::cloud::telcoautomation::v1::EdgeSlm* response);
    // Creates a new EdgeSlm in a given project and location.
    virtual ::grpc::Status CreateEdgeSlm(::grpc::ServerContext* context, const ::google::cloud::telcoautomation::v1::CreateEdgeSlmRequest* request, ::google::longrunning::Operation* response);
    // Deletes a single EdgeSlm.
    virtual ::grpc::Status DeleteEdgeSlm(::grpc::ServerContext* context, const ::google::cloud::telcoautomation::v1::DeleteEdgeSlmRequest* request, ::google::longrunning::Operation* response);
    // Creates a blueprint.
    virtual ::grpc::Status CreateBlueprint(::grpc::ServerContext* context, const ::google::cloud::telcoautomation::v1::CreateBlueprintRequest* request, ::google::cloud::telcoautomation::v1::Blueprint* response);
    // Updates a blueprint.
    virtual ::grpc::Status UpdateBlueprint(::grpc::ServerContext* context, const ::google::cloud::telcoautomation::v1::UpdateBlueprintRequest* request, ::google::cloud::telcoautomation::v1::Blueprint* response);
    // Returns the requested blueprint.
    virtual ::grpc::Status GetBlueprint(::grpc::ServerContext* context, const ::google::cloud::telcoautomation::v1::GetBlueprintRequest* request, ::google::cloud::telcoautomation::v1::Blueprint* response);
    // Deletes a blueprint and all its revisions.
    virtual ::grpc::Status DeleteBlueprint(::grpc::ServerContext* context, const ::google::cloud::telcoautomation::v1::DeleteBlueprintRequest* request, ::google::protobuf::Empty* response);
    // List all blueprints.
    virtual ::grpc::Status ListBlueprints(::grpc::ServerContext* context, const ::google::cloud::telcoautomation::v1::ListBlueprintsRequest* request, ::google::cloud::telcoautomation::v1::ListBlueprintsResponse* response);
    // Approves a blueprint and commits a new revision.
    virtual ::grpc::Status ApproveBlueprint(::grpc::ServerContext* context, const ::google::cloud::telcoautomation::v1::ApproveBlueprintRequest* request, ::google::cloud::telcoautomation::v1::Blueprint* response);
    // Proposes a blueprint for approval of changes.
    virtual ::grpc::Status ProposeBlueprint(::grpc::ServerContext* context, const ::google::cloud::telcoautomation::v1::ProposeBlueprintRequest* request, ::google::cloud::telcoautomation::v1::Blueprint* response);
    // Rejects a blueprint revision proposal and flips it back to Draft state.
    virtual ::grpc::Status RejectBlueprint(::grpc::ServerContext* context, const ::google::cloud::telcoautomation::v1::RejectBlueprintRequest* request, ::google::cloud::telcoautomation::v1::Blueprint* response);
    // List blueprint revisions of a given blueprint.
    virtual ::grpc::Status ListBlueprintRevisions(::grpc::ServerContext* context, const ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsRequest* request, ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsResponse* response);
    // Searches across blueprint revisions.
    virtual ::grpc::Status SearchBlueprintRevisions(::grpc::ServerContext* context, const ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsRequest* request, ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsResponse* response);
    // Searches across deployment revisions.
    virtual ::grpc::Status SearchDeploymentRevisions(::grpc::ServerContext* context, const ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsRequest* request, ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsResponse* response);
    // Discards the changes in a blueprint and reverts the blueprint to the last
    // approved blueprint revision. No changes take place if a blueprint does not
    // have revisions.
    virtual ::grpc::Status DiscardBlueprintChanges(::grpc::ServerContext* context, const ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesRequest* request, ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesResponse* response);
    // Lists the blueprints in TNA's public catalog. Default page size = 20,
    // Max Page Size = 100.
    virtual ::grpc::Status ListPublicBlueprints(::grpc::ServerContext* context, const ::google::cloud::telcoautomation::v1::ListPublicBlueprintsRequest* request, ::google::cloud::telcoautomation::v1::ListPublicBlueprintsResponse* response);
    // Returns the requested public blueprint.
    virtual ::grpc::Status GetPublicBlueprint(::grpc::ServerContext* context, const ::google::cloud::telcoautomation::v1::GetPublicBlueprintRequest* request, ::google::cloud::telcoautomation::v1::PublicBlueprint* response);
    // Creates a deployment.
    virtual ::grpc::Status CreateDeployment(::grpc::ServerContext* context, const ::google::cloud::telcoautomation::v1::CreateDeploymentRequest* request, ::google::cloud::telcoautomation::v1::Deployment* response);
    // Updates a deployment.
    virtual ::grpc::Status UpdateDeployment(::grpc::ServerContext* context, const ::google::cloud::telcoautomation::v1::UpdateDeploymentRequest* request, ::google::cloud::telcoautomation::v1::Deployment* response);
    // Returns the requested deployment.
    virtual ::grpc::Status GetDeployment(::grpc::ServerContext* context, const ::google::cloud::telcoautomation::v1::GetDeploymentRequest* request, ::google::cloud::telcoautomation::v1::Deployment* response);
    // Removes the deployment by marking it as DELETING. Post which deployment and
    // it's revisions gets deleted.
    virtual ::grpc::Status RemoveDeployment(::grpc::ServerContext* context, const ::google::cloud::telcoautomation::v1::RemoveDeploymentRequest* request, ::google::protobuf::Empty* response);
    // List all deployments.
    virtual ::grpc::Status ListDeployments(::grpc::ServerContext* context, const ::google::cloud::telcoautomation::v1::ListDeploymentsRequest* request, ::google::cloud::telcoautomation::v1::ListDeploymentsResponse* response);
    // List deployment revisions of a given deployment.
    virtual ::grpc::Status ListDeploymentRevisions(::grpc::ServerContext* context, const ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsRequest* request, ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsResponse* response);
    // Discards the changes in a deployment and reverts the deployment to the last
    // approved deployment revision. No changes take place if a deployment does
    // not have revisions.
    virtual ::grpc::Status DiscardDeploymentChanges(::grpc::ServerContext* context, const ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesRequest* request, ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesResponse* response);
    // Applies the deployment's YAML files to the parent orchestration cluster.
    virtual ::grpc::Status ApplyDeployment(::grpc::ServerContext* context, const ::google::cloud::telcoautomation::v1::ApplyDeploymentRequest* request, ::google::cloud::telcoautomation::v1::Deployment* response);
    // Returns the requested deployment status.
    virtual ::grpc::Status ComputeDeploymentStatus(::grpc::ServerContext* context, const ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusRequest* request, ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusResponse* response);
    // Rollback the active deployment to the given past approved deployment
    // revision.
    virtual ::grpc::Status RollbackDeployment(::grpc::ServerContext* context, const ::google::cloud::telcoautomation::v1::RollbackDeploymentRequest* request, ::google::cloud::telcoautomation::v1::Deployment* response);
    // Returns the requested hydrated deployment.
    virtual ::grpc::Status GetHydratedDeployment(::grpc::ServerContext* context, const ::google::cloud::telcoautomation::v1::GetHydratedDeploymentRequest* request, ::google::cloud::telcoautomation::v1::HydratedDeployment* response);
    // List all hydrated deployments present under a deployment.
    virtual ::grpc::Status ListHydratedDeployments(::grpc::ServerContext* context, const ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsRequest* request, ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsResponse* response);
    // Updates a hydrated deployment.
    virtual ::grpc::Status UpdateHydratedDeployment(::grpc::ServerContext* context, const ::google::cloud::telcoautomation::v1::UpdateHydratedDeploymentRequest* request, ::google::cloud::telcoautomation::v1::HydratedDeployment* response);
    // Applies a hydrated deployment to a workload cluster.
    virtual ::grpc::Status ApplyHydratedDeployment(::grpc::ServerContext* context, const ::google::cloud::telcoautomation::v1::ApplyHydratedDeploymentRequest* request, ::google::cloud::telcoautomation::v1::HydratedDeployment* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListOrchestrationClusters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListOrchestrationClusters() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListOrchestrationClusters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOrchestrationClusters(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListOrchestrationClustersRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListOrchestrationClustersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListOrchestrationClusters(::grpc::ServerContext* context, ::google::cloud::telcoautomation::v1::ListOrchestrationClustersRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::telcoautomation::v1::ListOrchestrationClustersResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetOrchestrationCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetOrchestrationCluster() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetOrchestrationCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetOrchestrationCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetOrchestrationClusterRequest* /*request*/, ::google::cloud::telcoautomation::v1::OrchestrationCluster* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetOrchestrationCluster(::grpc::ServerContext* context, ::google::cloud::telcoautomation::v1::GetOrchestrationClusterRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::telcoautomation::v1::OrchestrationCluster>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateOrchestrationCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateOrchestrationCluster() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CreateOrchestrationCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateOrchestrationCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::CreateOrchestrationClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateOrchestrationCluster(::grpc::ServerContext* context, ::google::cloud::telcoautomation::v1::CreateOrchestrationClusterRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteOrchestrationCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteOrchestrationCluster() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_DeleteOrchestrationCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteOrchestrationCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::DeleteOrchestrationClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteOrchestrationCluster(::grpc::ServerContext* context, ::google::cloud::telcoautomation::v1::DeleteOrchestrationClusterRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListEdgeSlms : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListEdgeSlms() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_ListEdgeSlms() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEdgeSlms(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListEdgeSlmsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListEdgeSlmsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListEdgeSlms(::grpc::ServerContext* context, ::google::cloud::telcoautomation::v1::ListEdgeSlmsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::telcoautomation::v1::ListEdgeSlmsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetEdgeSlm : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetEdgeSlm() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_GetEdgeSlm() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEdgeSlm(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetEdgeSlmRequest* /*request*/, ::google::cloud::telcoautomation::v1::EdgeSlm* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetEdgeSlm(::grpc::ServerContext* context, ::google::cloud::telcoautomation::v1::GetEdgeSlmRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::telcoautomation::v1::EdgeSlm>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateEdgeSlm : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateEdgeSlm() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_CreateEdgeSlm() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEdgeSlm(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::CreateEdgeSlmRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateEdgeSlm(::grpc::ServerContext* context, ::google::cloud::telcoautomation::v1::CreateEdgeSlmRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteEdgeSlm : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteEdgeSlm() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_DeleteEdgeSlm() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEdgeSlm(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::DeleteEdgeSlmRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteEdgeSlm(::grpc::ServerContext* context, ::google::cloud::telcoautomation::v1::DeleteEdgeSlmRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateBlueprint() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_CreateBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::CreateBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateBlueprint(::grpc::ServerContext* context, ::google::cloud::telcoautomation::v1::CreateBlueprintRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::telcoautomation::v1::Blueprint>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateBlueprint() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_UpdateBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::UpdateBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateBlueprint(::grpc::ServerContext* context, ::google::cloud::telcoautomation::v1::UpdateBlueprintRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::telcoautomation::v1::Blueprint>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetBlueprint() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_GetBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetBlueprint(::grpc::ServerContext* context, ::google::cloud::telcoautomation::v1::GetBlueprintRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::telcoautomation::v1::Blueprint>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteBlueprint() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_DeleteBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::DeleteBlueprintRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteBlueprint(::grpc::ServerContext* context, ::google::cloud::telcoautomation::v1::DeleteBlueprintRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListBlueprints : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListBlueprints() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_ListBlueprints() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBlueprints(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListBlueprintsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListBlueprintsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListBlueprints(::grpc::ServerContext* context, ::google::cloud::telcoautomation::v1::ListBlueprintsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::telcoautomation::v1::ListBlueprintsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ApproveBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ApproveBlueprint() {
      ::grpc::Service::MarkMethodAsync(13);
    }
    ~WithAsyncMethod_ApproveBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApproveBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ApproveBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestApproveBlueprint(::grpc::ServerContext* context, ::google::cloud::telcoautomation::v1::ApproveBlueprintRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::telcoautomation::v1::Blueprint>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ProposeBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ProposeBlueprint() {
      ::grpc::Service::MarkMethodAsync(14);
    }
    ~WithAsyncMethod_ProposeBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ProposeBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ProposeBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestProposeBlueprint(::grpc::ServerContext* context, ::google::cloud::telcoautomation::v1::ProposeBlueprintRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::telcoautomation::v1::Blueprint>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RejectBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RejectBlueprint() {
      ::grpc::Service::MarkMethodAsync(15);
    }
    ~WithAsyncMethod_RejectBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RejectBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::RejectBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRejectBlueprint(::grpc::ServerContext* context, ::google::cloud::telcoautomation::v1::RejectBlueprintRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::telcoautomation::v1::Blueprint>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListBlueprintRevisions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListBlueprintRevisions() {
      ::grpc::Service::MarkMethodAsync(16);
    }
    ~WithAsyncMethod_ListBlueprintRevisions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBlueprintRevisions(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListBlueprintRevisions(::grpc::ServerContext* context, ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SearchBlueprintRevisions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SearchBlueprintRevisions() {
      ::grpc::Service::MarkMethodAsync(17);
    }
    ~WithAsyncMethod_SearchBlueprintRevisions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchBlueprintRevisions(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsRequest* /*request*/, ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchBlueprintRevisions(::grpc::ServerContext* context, ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SearchDeploymentRevisions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SearchDeploymentRevisions() {
      ::grpc::Service::MarkMethodAsync(18);
    }
    ~WithAsyncMethod_SearchDeploymentRevisions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchDeploymentRevisions(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsRequest* /*request*/, ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchDeploymentRevisions(::grpc::ServerContext* context, ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DiscardBlueprintChanges : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DiscardBlueprintChanges() {
      ::grpc::Service::MarkMethodAsync(19);
    }
    ~WithAsyncMethod_DiscardBlueprintChanges() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DiscardBlueprintChanges(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesRequest* /*request*/, ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDiscardBlueprintChanges(::grpc::ServerContext* context, ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListPublicBlueprints : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListPublicBlueprints() {
      ::grpc::Service::MarkMethodAsync(20);
    }
    ~WithAsyncMethod_ListPublicBlueprints() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPublicBlueprints(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListPublicBlueprintsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListPublicBlueprintsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPublicBlueprints(::grpc::ServerContext* context, ::google::cloud::telcoautomation::v1::ListPublicBlueprintsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::telcoautomation::v1::ListPublicBlueprintsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetPublicBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetPublicBlueprint() {
      ::grpc::Service::MarkMethodAsync(21);
    }
    ~WithAsyncMethod_GetPublicBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPublicBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetPublicBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::PublicBlueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetPublicBlueprint(::grpc::ServerContext* context, ::google::cloud::telcoautomation::v1::GetPublicBlueprintRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::telcoautomation::v1::PublicBlueprint>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(21, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateDeployment() {
      ::grpc::Service::MarkMethodAsync(22);
    }
    ~WithAsyncMethod_CreateDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::CreateDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::Deployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateDeployment(::grpc::ServerContext* context, ::google::cloud::telcoautomation::v1::CreateDeploymentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::telcoautomation::v1::Deployment>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(22, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateDeployment() {
      ::grpc::Service::MarkMethodAsync(23);
    }
    ~WithAsyncMethod_UpdateDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::UpdateDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::Deployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateDeployment(::grpc::ServerContext* context, ::google::cloud::telcoautomation::v1::UpdateDeploymentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::telcoautomation::v1::Deployment>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(23, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetDeployment() {
      ::grpc::Service::MarkMethodAsync(24);
    }
    ~WithAsyncMethod_GetDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::Deployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetDeployment(::grpc::ServerContext* context, ::google::cloud::telcoautomation::v1::GetDeploymentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::telcoautomation::v1::Deployment>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(24, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RemoveDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RemoveDeployment() {
      ::grpc::Service::MarkMethodAsync(25);
    }
    ~WithAsyncMethod_RemoveDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RemoveDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::RemoveDeploymentRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRemoveDeployment(::grpc::ServerContext* context, ::google::cloud::telcoautomation::v1::RemoveDeploymentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(25, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListDeployments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListDeployments() {
      ::grpc::Service::MarkMethodAsync(26);
    }
    ~WithAsyncMethod_ListDeployments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDeployments(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListDeploymentsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListDeploymentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListDeployments(::grpc::ServerContext* context, ::google::cloud::telcoautomation::v1::ListDeploymentsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::telcoautomation::v1::ListDeploymentsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(26, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListDeploymentRevisions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListDeploymentRevisions() {
      ::grpc::Service::MarkMethodAsync(27);
    }
    ~WithAsyncMethod_ListDeploymentRevisions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDeploymentRevisions(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListDeploymentRevisions(::grpc::ServerContext* context, ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(27, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DiscardDeploymentChanges : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DiscardDeploymentChanges() {
      ::grpc::Service::MarkMethodAsync(28);
    }
    ~WithAsyncMethod_DiscardDeploymentChanges() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DiscardDeploymentChanges(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesRequest* /*request*/, ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDiscardDeploymentChanges(::grpc::ServerContext* context, ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(28, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ApplyDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ApplyDeployment() {
      ::grpc::Service::MarkMethodAsync(29);
    }
    ~WithAsyncMethod_ApplyDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApplyDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ApplyDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::Deployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestApplyDeployment(::grpc::ServerContext* context, ::google::cloud::telcoautomation::v1::ApplyDeploymentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::telcoautomation::v1::Deployment>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(29, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ComputeDeploymentStatus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ComputeDeploymentStatus() {
      ::grpc::Service::MarkMethodAsync(30);
    }
    ~WithAsyncMethod_ComputeDeploymentStatus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ComputeDeploymentStatus(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusRequest* /*request*/, ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestComputeDeploymentStatus(::grpc::ServerContext* context, ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(30, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RollbackDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RollbackDeployment() {
      ::grpc::Service::MarkMethodAsync(31);
    }
    ~WithAsyncMethod_RollbackDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RollbackDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::RollbackDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::Deployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRollbackDeployment(::grpc::ServerContext* context, ::google::cloud::telcoautomation::v1::RollbackDeploymentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::telcoautomation::v1::Deployment>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(31, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetHydratedDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetHydratedDeployment() {
      ::grpc::Service::MarkMethodAsync(32);
    }
    ~WithAsyncMethod_GetHydratedDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetHydratedDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetHydratedDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::HydratedDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetHydratedDeployment(::grpc::ServerContext* context, ::google::cloud::telcoautomation::v1::GetHydratedDeploymentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::telcoautomation::v1::HydratedDeployment>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(32, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListHydratedDeployments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListHydratedDeployments() {
      ::grpc::Service::MarkMethodAsync(33);
    }
    ~WithAsyncMethod_ListHydratedDeployments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListHydratedDeployments(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListHydratedDeployments(::grpc::ServerContext* context, ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(33, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateHydratedDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateHydratedDeployment() {
      ::grpc::Service::MarkMethodAsync(34);
    }
    ~WithAsyncMethod_UpdateHydratedDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateHydratedDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::UpdateHydratedDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::HydratedDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateHydratedDeployment(::grpc::ServerContext* context, ::google::cloud::telcoautomation::v1::UpdateHydratedDeploymentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::telcoautomation::v1::HydratedDeployment>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(34, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ApplyHydratedDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ApplyHydratedDeployment() {
      ::grpc::Service::MarkMethodAsync(35);
    }
    ~WithAsyncMethod_ApplyHydratedDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApplyHydratedDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ApplyHydratedDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::HydratedDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestApplyHydratedDeployment(::grpc::ServerContext* context, ::google::cloud::telcoautomation::v1::ApplyHydratedDeploymentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::telcoautomation::v1::HydratedDeployment>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(35, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListOrchestrationClusters<WithAsyncMethod_GetOrchestrationCluster<WithAsyncMethod_CreateOrchestrationCluster<WithAsyncMethod_DeleteOrchestrationCluster<WithAsyncMethod_ListEdgeSlms<WithAsyncMethod_GetEdgeSlm<WithAsyncMethod_CreateEdgeSlm<WithAsyncMethod_DeleteEdgeSlm<WithAsyncMethod_CreateBlueprint<WithAsyncMethod_UpdateBlueprint<WithAsyncMethod_GetBlueprint<WithAsyncMethod_DeleteBlueprint<WithAsyncMethod_ListBlueprints<WithAsyncMethod_ApproveBlueprint<WithAsyncMethod_ProposeBlueprint<WithAsyncMethod_RejectBlueprint<WithAsyncMethod_ListBlueprintRevisions<WithAsyncMethod_SearchBlueprintRevisions<WithAsyncMethod_SearchDeploymentRevisions<WithAsyncMethod_DiscardBlueprintChanges<WithAsyncMethod_ListPublicBlueprints<WithAsyncMethod_GetPublicBlueprint<WithAsyncMethod_CreateDeployment<WithAsyncMethod_UpdateDeployment<WithAsyncMethod_GetDeployment<WithAsyncMethod_RemoveDeployment<WithAsyncMethod_ListDeployments<WithAsyncMethod_ListDeploymentRevisions<WithAsyncMethod_DiscardDeploymentChanges<WithAsyncMethod_ApplyDeployment<WithAsyncMethod_ComputeDeploymentStatus<WithAsyncMethod_RollbackDeployment<WithAsyncMethod_GetHydratedDeployment<WithAsyncMethod_ListHydratedDeployments<WithAsyncMethod_UpdateHydratedDeployment<WithAsyncMethod_ApplyHydratedDeployment<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListOrchestrationClusters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListOrchestrationClusters() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::ListOrchestrationClustersRequest, ::google::cloud::telcoautomation::v1::ListOrchestrationClustersResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::telcoautomation::v1::ListOrchestrationClustersRequest* request, ::google::cloud::telcoautomation::v1::ListOrchestrationClustersResponse* response) { return this->ListOrchestrationClusters(context, request, response); }));}
    void SetMessageAllocatorFor_ListOrchestrationClusters(
        ::grpc::MessageAllocator< ::google::cloud::telcoautomation::v1::ListOrchestrationClustersRequest, ::google::cloud::telcoautomation::v1::ListOrchestrationClustersResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::ListOrchestrationClustersRequest, ::google::cloud::telcoautomation::v1::ListOrchestrationClustersResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListOrchestrationClusters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOrchestrationClusters(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListOrchestrationClustersRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListOrchestrationClustersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListOrchestrationClusters(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListOrchestrationClustersRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListOrchestrationClustersResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetOrchestrationCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetOrchestrationCluster() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::GetOrchestrationClusterRequest, ::google::cloud::telcoautomation::v1::OrchestrationCluster>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::telcoautomation::v1::GetOrchestrationClusterRequest* request, ::google::cloud::telcoautomation::v1::OrchestrationCluster* response) { return this->GetOrchestrationCluster(context, request, response); }));}
    void SetMessageAllocatorFor_GetOrchestrationCluster(
        ::grpc::MessageAllocator< ::google::cloud::telcoautomation::v1::GetOrchestrationClusterRequest, ::google::cloud::telcoautomation::v1::OrchestrationCluster>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::GetOrchestrationClusterRequest, ::google::cloud::telcoautomation::v1::OrchestrationCluster>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetOrchestrationCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetOrchestrationCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetOrchestrationClusterRequest* /*request*/, ::google::cloud::telcoautomation::v1::OrchestrationCluster* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetOrchestrationCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetOrchestrationClusterRequest* /*request*/, ::google::cloud::telcoautomation::v1::OrchestrationCluster* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateOrchestrationCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateOrchestrationCluster() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::CreateOrchestrationClusterRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::telcoautomation::v1::CreateOrchestrationClusterRequest* request, ::google::longrunning::Operation* response) { return this->CreateOrchestrationCluster(context, request, response); }));}
    void SetMessageAllocatorFor_CreateOrchestrationCluster(
        ::grpc::MessageAllocator< ::google::cloud::telcoautomation::v1::CreateOrchestrationClusterRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::CreateOrchestrationClusterRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateOrchestrationCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateOrchestrationCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::CreateOrchestrationClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateOrchestrationCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::CreateOrchestrationClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteOrchestrationCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteOrchestrationCluster() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::DeleteOrchestrationClusterRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::telcoautomation::v1::DeleteOrchestrationClusterRequest* request, ::google::longrunning::Operation* response) { return this->DeleteOrchestrationCluster(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteOrchestrationCluster(
        ::grpc::MessageAllocator< ::google::cloud::telcoautomation::v1::DeleteOrchestrationClusterRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::DeleteOrchestrationClusterRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteOrchestrationCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteOrchestrationCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::DeleteOrchestrationClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteOrchestrationCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::DeleteOrchestrationClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListEdgeSlms : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListEdgeSlms() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::ListEdgeSlmsRequest, ::google::cloud::telcoautomation::v1::ListEdgeSlmsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::telcoautomation::v1::ListEdgeSlmsRequest* request, ::google::cloud::telcoautomation::v1::ListEdgeSlmsResponse* response) { return this->ListEdgeSlms(context, request, response); }));}
    void SetMessageAllocatorFor_ListEdgeSlms(
        ::grpc::MessageAllocator< ::google::cloud::telcoautomation::v1::ListEdgeSlmsRequest, ::google::cloud::telcoautomation::v1::ListEdgeSlmsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::ListEdgeSlmsRequest, ::google::cloud::telcoautomation::v1::ListEdgeSlmsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListEdgeSlms() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEdgeSlms(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListEdgeSlmsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListEdgeSlmsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListEdgeSlms(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListEdgeSlmsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListEdgeSlmsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetEdgeSlm : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetEdgeSlm() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::GetEdgeSlmRequest, ::google::cloud::telcoautomation::v1::EdgeSlm>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::telcoautomation::v1::GetEdgeSlmRequest* request, ::google::cloud::telcoautomation::v1::EdgeSlm* response) { return this->GetEdgeSlm(context, request, response); }));}
    void SetMessageAllocatorFor_GetEdgeSlm(
        ::grpc::MessageAllocator< ::google::cloud::telcoautomation::v1::GetEdgeSlmRequest, ::google::cloud::telcoautomation::v1::EdgeSlm>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::GetEdgeSlmRequest, ::google::cloud::telcoautomation::v1::EdgeSlm>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetEdgeSlm() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEdgeSlm(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetEdgeSlmRequest* /*request*/, ::google::cloud::telcoautomation::v1::EdgeSlm* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetEdgeSlm(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetEdgeSlmRequest* /*request*/, ::google::cloud::telcoautomation::v1::EdgeSlm* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateEdgeSlm : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateEdgeSlm() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::CreateEdgeSlmRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::telcoautomation::v1::CreateEdgeSlmRequest* request, ::google::longrunning::Operation* response) { return this->CreateEdgeSlm(context, request, response); }));}
    void SetMessageAllocatorFor_CreateEdgeSlm(
        ::grpc::MessageAllocator< ::google::cloud::telcoautomation::v1::CreateEdgeSlmRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::CreateEdgeSlmRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateEdgeSlm() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEdgeSlm(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::CreateEdgeSlmRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateEdgeSlm(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::CreateEdgeSlmRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteEdgeSlm : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteEdgeSlm() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::DeleteEdgeSlmRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::telcoautomation::v1::DeleteEdgeSlmRequest* request, ::google::longrunning::Operation* response) { return this->DeleteEdgeSlm(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteEdgeSlm(
        ::grpc::MessageAllocator< ::google::cloud::telcoautomation::v1::DeleteEdgeSlmRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::DeleteEdgeSlmRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteEdgeSlm() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEdgeSlm(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::DeleteEdgeSlmRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteEdgeSlm(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::DeleteEdgeSlmRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateBlueprint() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::CreateBlueprintRequest, ::google::cloud::telcoautomation::v1::Blueprint>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::telcoautomation::v1::CreateBlueprintRequest* request, ::google::cloud::telcoautomation::v1::Blueprint* response) { return this->CreateBlueprint(context, request, response); }));}
    void SetMessageAllocatorFor_CreateBlueprint(
        ::grpc::MessageAllocator< ::google::cloud::telcoautomation::v1::CreateBlueprintRequest, ::google::cloud::telcoautomation::v1::Blueprint>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::CreateBlueprintRequest, ::google::cloud::telcoautomation::v1::Blueprint>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::CreateBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateBlueprint(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::CreateBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateBlueprint() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::UpdateBlueprintRequest, ::google::cloud::telcoautomation::v1::Blueprint>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::telcoautomation::v1::UpdateBlueprintRequest* request, ::google::cloud::telcoautomation::v1::Blueprint* response) { return this->UpdateBlueprint(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateBlueprint(
        ::grpc::MessageAllocator< ::google::cloud::telcoautomation::v1::UpdateBlueprintRequest, ::google::cloud::telcoautomation::v1::Blueprint>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::UpdateBlueprintRequest, ::google::cloud::telcoautomation::v1::Blueprint>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::UpdateBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateBlueprint(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::UpdateBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetBlueprint() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::GetBlueprintRequest, ::google::cloud::telcoautomation::v1::Blueprint>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::telcoautomation::v1::GetBlueprintRequest* request, ::google::cloud::telcoautomation::v1::Blueprint* response) { return this->GetBlueprint(context, request, response); }));}
    void SetMessageAllocatorFor_GetBlueprint(
        ::grpc::MessageAllocator< ::google::cloud::telcoautomation::v1::GetBlueprintRequest, ::google::cloud::telcoautomation::v1::Blueprint>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::GetBlueprintRequest, ::google::cloud::telcoautomation::v1::Blueprint>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetBlueprint(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteBlueprint() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::DeleteBlueprintRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::telcoautomation::v1::DeleteBlueprintRequest* request, ::google::protobuf::Empty* response) { return this->DeleteBlueprint(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteBlueprint(
        ::grpc::MessageAllocator< ::google::cloud::telcoautomation::v1::DeleteBlueprintRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::DeleteBlueprintRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::DeleteBlueprintRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteBlueprint(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::DeleteBlueprintRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListBlueprints : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListBlueprints() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::ListBlueprintsRequest, ::google::cloud::telcoautomation::v1::ListBlueprintsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::telcoautomation::v1::ListBlueprintsRequest* request, ::google::cloud::telcoautomation::v1::ListBlueprintsResponse* response) { return this->ListBlueprints(context, request, response); }));}
    void SetMessageAllocatorFor_ListBlueprints(
        ::grpc::MessageAllocator< ::google::cloud::telcoautomation::v1::ListBlueprintsRequest, ::google::cloud::telcoautomation::v1::ListBlueprintsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::ListBlueprintsRequest, ::google::cloud::telcoautomation::v1::ListBlueprintsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListBlueprints() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBlueprints(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListBlueprintsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListBlueprintsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListBlueprints(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListBlueprintsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListBlueprintsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ApproveBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ApproveBlueprint() {
      ::grpc::Service::MarkMethodCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::ApproveBlueprintRequest, ::google::cloud::telcoautomation::v1::Blueprint>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::telcoautomation::v1::ApproveBlueprintRequest* request, ::google::cloud::telcoautomation::v1::Blueprint* response) { return this->ApproveBlueprint(context, request, response); }));}
    void SetMessageAllocatorFor_ApproveBlueprint(
        ::grpc::MessageAllocator< ::google::cloud::telcoautomation::v1::ApproveBlueprintRequest, ::google::cloud::telcoautomation::v1::Blueprint>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(13);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::ApproveBlueprintRequest, ::google::cloud::telcoautomation::v1::Blueprint>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ApproveBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApproveBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ApproveBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ApproveBlueprint(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ApproveBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ProposeBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ProposeBlueprint() {
      ::grpc::Service::MarkMethodCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::ProposeBlueprintRequest, ::google::cloud::telcoautomation::v1::Blueprint>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::telcoautomation::v1::ProposeBlueprintRequest* request, ::google::cloud::telcoautomation::v1::Blueprint* response) { return this->ProposeBlueprint(context, request, response); }));}
    void SetMessageAllocatorFor_ProposeBlueprint(
        ::grpc::MessageAllocator< ::google::cloud::telcoautomation::v1::ProposeBlueprintRequest, ::google::cloud::telcoautomation::v1::Blueprint>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(14);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::ProposeBlueprintRequest, ::google::cloud::telcoautomation::v1::Blueprint>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ProposeBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ProposeBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ProposeBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ProposeBlueprint(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ProposeBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RejectBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RejectBlueprint() {
      ::grpc::Service::MarkMethodCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::RejectBlueprintRequest, ::google::cloud::telcoautomation::v1::Blueprint>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::telcoautomation::v1::RejectBlueprintRequest* request, ::google::cloud::telcoautomation::v1::Blueprint* response) { return this->RejectBlueprint(context, request, response); }));}
    void SetMessageAllocatorFor_RejectBlueprint(
        ::grpc::MessageAllocator< ::google::cloud::telcoautomation::v1::RejectBlueprintRequest, ::google::cloud::telcoautomation::v1::Blueprint>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(15);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::RejectBlueprintRequest, ::google::cloud::telcoautomation::v1::Blueprint>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RejectBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RejectBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::RejectBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RejectBlueprint(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::RejectBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListBlueprintRevisions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListBlueprintRevisions() {
      ::grpc::Service::MarkMethodCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsRequest, ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsRequest* request, ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsResponse* response) { return this->ListBlueprintRevisions(context, request, response); }));}
    void SetMessageAllocatorFor_ListBlueprintRevisions(
        ::grpc::MessageAllocator< ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsRequest, ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(16);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsRequest, ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListBlueprintRevisions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBlueprintRevisions(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListBlueprintRevisions(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_SearchBlueprintRevisions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SearchBlueprintRevisions() {
      ::grpc::Service::MarkMethodCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsRequest, ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsRequest* request, ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsResponse* response) { return this->SearchBlueprintRevisions(context, request, response); }));}
    void SetMessageAllocatorFor_SearchBlueprintRevisions(
        ::grpc::MessageAllocator< ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsRequest, ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(17);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsRequest, ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SearchBlueprintRevisions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchBlueprintRevisions(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsRequest* /*request*/, ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchBlueprintRevisions(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsRequest* /*request*/, ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_SearchDeploymentRevisions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SearchDeploymentRevisions() {
      ::grpc::Service::MarkMethodCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsRequest, ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsRequest* request, ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsResponse* response) { return this->SearchDeploymentRevisions(context, request, response); }));}
    void SetMessageAllocatorFor_SearchDeploymentRevisions(
        ::grpc::MessageAllocator< ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsRequest, ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(18);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsRequest, ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SearchDeploymentRevisions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchDeploymentRevisions(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsRequest* /*request*/, ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchDeploymentRevisions(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsRequest* /*request*/, ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DiscardBlueprintChanges : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DiscardBlueprintChanges() {
      ::grpc::Service::MarkMethodCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesRequest, ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesRequest* request, ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesResponse* response) { return this->DiscardBlueprintChanges(context, request, response); }));}
    void SetMessageAllocatorFor_DiscardBlueprintChanges(
        ::grpc::MessageAllocator< ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesRequest, ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(19);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesRequest, ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DiscardBlueprintChanges() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DiscardBlueprintChanges(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesRequest* /*request*/, ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DiscardBlueprintChanges(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesRequest* /*request*/, ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListPublicBlueprints : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListPublicBlueprints() {
      ::grpc::Service::MarkMethodCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::ListPublicBlueprintsRequest, ::google::cloud::telcoautomation::v1::ListPublicBlueprintsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::telcoautomation::v1::ListPublicBlueprintsRequest* request, ::google::cloud::telcoautomation::v1::ListPublicBlueprintsResponse* response) { return this->ListPublicBlueprints(context, request, response); }));}
    void SetMessageAllocatorFor_ListPublicBlueprints(
        ::grpc::MessageAllocator< ::google::cloud::telcoautomation::v1::ListPublicBlueprintsRequest, ::google::cloud::telcoautomation::v1::ListPublicBlueprintsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(20);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::ListPublicBlueprintsRequest, ::google::cloud::telcoautomation::v1::ListPublicBlueprintsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListPublicBlueprints() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPublicBlueprints(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListPublicBlueprintsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListPublicBlueprintsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPublicBlueprints(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListPublicBlueprintsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListPublicBlueprintsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetPublicBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetPublicBlueprint() {
      ::grpc::Service::MarkMethodCallback(21,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::GetPublicBlueprintRequest, ::google::cloud::telcoautomation::v1::PublicBlueprint>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::telcoautomation::v1::GetPublicBlueprintRequest* request, ::google::cloud::telcoautomation::v1::PublicBlueprint* response) { return this->GetPublicBlueprint(context, request, response); }));}
    void SetMessageAllocatorFor_GetPublicBlueprint(
        ::grpc::MessageAllocator< ::google::cloud::telcoautomation::v1::GetPublicBlueprintRequest, ::google::cloud::telcoautomation::v1::PublicBlueprint>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(21);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::GetPublicBlueprintRequest, ::google::cloud::telcoautomation::v1::PublicBlueprint>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetPublicBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPublicBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetPublicBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::PublicBlueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetPublicBlueprint(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetPublicBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::PublicBlueprint* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateDeployment() {
      ::grpc::Service::MarkMethodCallback(22,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::CreateDeploymentRequest, ::google::cloud::telcoautomation::v1::Deployment>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::telcoautomation::v1::CreateDeploymentRequest* request, ::google::cloud::telcoautomation::v1::Deployment* response) { return this->CreateDeployment(context, request, response); }));}
    void SetMessageAllocatorFor_CreateDeployment(
        ::grpc::MessageAllocator< ::google::cloud::telcoautomation::v1::CreateDeploymentRequest, ::google::cloud::telcoautomation::v1::Deployment>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(22);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::CreateDeploymentRequest, ::google::cloud::telcoautomation::v1::Deployment>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::CreateDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::Deployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateDeployment(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::CreateDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::Deployment* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateDeployment() {
      ::grpc::Service::MarkMethodCallback(23,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::UpdateDeploymentRequest, ::google::cloud::telcoautomation::v1::Deployment>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::telcoautomation::v1::UpdateDeploymentRequest* request, ::google::cloud::telcoautomation::v1::Deployment* response) { return this->UpdateDeployment(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateDeployment(
        ::grpc::MessageAllocator< ::google::cloud::telcoautomation::v1::UpdateDeploymentRequest, ::google::cloud::telcoautomation::v1::Deployment>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(23);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::UpdateDeploymentRequest, ::google::cloud::telcoautomation::v1::Deployment>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::UpdateDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::Deployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateDeployment(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::UpdateDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::Deployment* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetDeployment() {
      ::grpc::Service::MarkMethodCallback(24,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::GetDeploymentRequest, ::google::cloud::telcoautomation::v1::Deployment>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::telcoautomation::v1::GetDeploymentRequest* request, ::google::cloud::telcoautomation::v1::Deployment* response) { return this->GetDeployment(context, request, response); }));}
    void SetMessageAllocatorFor_GetDeployment(
        ::grpc::MessageAllocator< ::google::cloud::telcoautomation::v1::GetDeploymentRequest, ::google::cloud::telcoautomation::v1::Deployment>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(24);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::GetDeploymentRequest, ::google::cloud::telcoautomation::v1::Deployment>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::Deployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetDeployment(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::Deployment* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RemoveDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RemoveDeployment() {
      ::grpc::Service::MarkMethodCallback(25,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::RemoveDeploymentRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::telcoautomation::v1::RemoveDeploymentRequest* request, ::google::protobuf::Empty* response) { return this->RemoveDeployment(context, request, response); }));}
    void SetMessageAllocatorFor_RemoveDeployment(
        ::grpc::MessageAllocator< ::google::cloud::telcoautomation::v1::RemoveDeploymentRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(25);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::RemoveDeploymentRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RemoveDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RemoveDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::RemoveDeploymentRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RemoveDeployment(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::RemoveDeploymentRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListDeployments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListDeployments() {
      ::grpc::Service::MarkMethodCallback(26,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::ListDeploymentsRequest, ::google::cloud::telcoautomation::v1::ListDeploymentsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::telcoautomation::v1::ListDeploymentsRequest* request, ::google::cloud::telcoautomation::v1::ListDeploymentsResponse* response) { return this->ListDeployments(context, request, response); }));}
    void SetMessageAllocatorFor_ListDeployments(
        ::grpc::MessageAllocator< ::google::cloud::telcoautomation::v1::ListDeploymentsRequest, ::google::cloud::telcoautomation::v1::ListDeploymentsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(26);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::ListDeploymentsRequest, ::google::cloud::telcoautomation::v1::ListDeploymentsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListDeployments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDeployments(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListDeploymentsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListDeploymentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListDeployments(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListDeploymentsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListDeploymentsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListDeploymentRevisions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListDeploymentRevisions() {
      ::grpc::Service::MarkMethodCallback(27,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsRequest, ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsRequest* request, ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsResponse* response) { return this->ListDeploymentRevisions(context, request, response); }));}
    void SetMessageAllocatorFor_ListDeploymentRevisions(
        ::grpc::MessageAllocator< ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsRequest, ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(27);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsRequest, ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListDeploymentRevisions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDeploymentRevisions(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListDeploymentRevisions(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DiscardDeploymentChanges : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DiscardDeploymentChanges() {
      ::grpc::Service::MarkMethodCallback(28,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesRequest, ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesRequest* request, ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesResponse* response) { return this->DiscardDeploymentChanges(context, request, response); }));}
    void SetMessageAllocatorFor_DiscardDeploymentChanges(
        ::grpc::MessageAllocator< ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesRequest, ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(28);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesRequest, ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DiscardDeploymentChanges() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DiscardDeploymentChanges(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesRequest* /*request*/, ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DiscardDeploymentChanges(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesRequest* /*request*/, ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ApplyDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ApplyDeployment() {
      ::grpc::Service::MarkMethodCallback(29,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::ApplyDeploymentRequest, ::google::cloud::telcoautomation::v1::Deployment>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::telcoautomation::v1::ApplyDeploymentRequest* request, ::google::cloud::telcoautomation::v1::Deployment* response) { return this->ApplyDeployment(context, request, response); }));}
    void SetMessageAllocatorFor_ApplyDeployment(
        ::grpc::MessageAllocator< ::google::cloud::telcoautomation::v1::ApplyDeploymentRequest, ::google::cloud::telcoautomation::v1::Deployment>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(29);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::ApplyDeploymentRequest, ::google::cloud::telcoautomation::v1::Deployment>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ApplyDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApplyDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ApplyDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::Deployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ApplyDeployment(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ApplyDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::Deployment* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ComputeDeploymentStatus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ComputeDeploymentStatus() {
      ::grpc::Service::MarkMethodCallback(30,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusRequest, ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusRequest* request, ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusResponse* response) { return this->ComputeDeploymentStatus(context, request, response); }));}
    void SetMessageAllocatorFor_ComputeDeploymentStatus(
        ::grpc::MessageAllocator< ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusRequest, ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(30);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusRequest, ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ComputeDeploymentStatus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ComputeDeploymentStatus(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusRequest* /*request*/, ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ComputeDeploymentStatus(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusRequest* /*request*/, ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RollbackDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RollbackDeployment() {
      ::grpc::Service::MarkMethodCallback(31,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::RollbackDeploymentRequest, ::google::cloud::telcoautomation::v1::Deployment>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::telcoautomation::v1::RollbackDeploymentRequest* request, ::google::cloud::telcoautomation::v1::Deployment* response) { return this->RollbackDeployment(context, request, response); }));}
    void SetMessageAllocatorFor_RollbackDeployment(
        ::grpc::MessageAllocator< ::google::cloud::telcoautomation::v1::RollbackDeploymentRequest, ::google::cloud::telcoautomation::v1::Deployment>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(31);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::RollbackDeploymentRequest, ::google::cloud::telcoautomation::v1::Deployment>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RollbackDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RollbackDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::RollbackDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::Deployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RollbackDeployment(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::RollbackDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::Deployment* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetHydratedDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetHydratedDeployment() {
      ::grpc::Service::MarkMethodCallback(32,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::GetHydratedDeploymentRequest, ::google::cloud::telcoautomation::v1::HydratedDeployment>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::telcoautomation::v1::GetHydratedDeploymentRequest* request, ::google::cloud::telcoautomation::v1::HydratedDeployment* response) { return this->GetHydratedDeployment(context, request, response); }));}
    void SetMessageAllocatorFor_GetHydratedDeployment(
        ::grpc::MessageAllocator< ::google::cloud::telcoautomation::v1::GetHydratedDeploymentRequest, ::google::cloud::telcoautomation::v1::HydratedDeployment>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(32);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::GetHydratedDeploymentRequest, ::google::cloud::telcoautomation::v1::HydratedDeployment>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetHydratedDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetHydratedDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetHydratedDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::HydratedDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetHydratedDeployment(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetHydratedDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::HydratedDeployment* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListHydratedDeployments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListHydratedDeployments() {
      ::grpc::Service::MarkMethodCallback(33,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsRequest, ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsRequest* request, ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsResponse* response) { return this->ListHydratedDeployments(context, request, response); }));}
    void SetMessageAllocatorFor_ListHydratedDeployments(
        ::grpc::MessageAllocator< ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsRequest, ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(33);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsRequest, ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListHydratedDeployments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListHydratedDeployments(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListHydratedDeployments(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateHydratedDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateHydratedDeployment() {
      ::grpc::Service::MarkMethodCallback(34,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::UpdateHydratedDeploymentRequest, ::google::cloud::telcoautomation::v1::HydratedDeployment>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::telcoautomation::v1::UpdateHydratedDeploymentRequest* request, ::google::cloud::telcoautomation::v1::HydratedDeployment* response) { return this->UpdateHydratedDeployment(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateHydratedDeployment(
        ::grpc::MessageAllocator< ::google::cloud::telcoautomation::v1::UpdateHydratedDeploymentRequest, ::google::cloud::telcoautomation::v1::HydratedDeployment>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(34);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::UpdateHydratedDeploymentRequest, ::google::cloud::telcoautomation::v1::HydratedDeployment>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateHydratedDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateHydratedDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::UpdateHydratedDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::HydratedDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateHydratedDeployment(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::UpdateHydratedDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::HydratedDeployment* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ApplyHydratedDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ApplyHydratedDeployment() {
      ::grpc::Service::MarkMethodCallback(35,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::ApplyHydratedDeploymentRequest, ::google::cloud::telcoautomation::v1::HydratedDeployment>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::telcoautomation::v1::ApplyHydratedDeploymentRequest* request, ::google::cloud::telcoautomation::v1::HydratedDeployment* response) { return this->ApplyHydratedDeployment(context, request, response); }));}
    void SetMessageAllocatorFor_ApplyHydratedDeployment(
        ::grpc::MessageAllocator< ::google::cloud::telcoautomation::v1::ApplyHydratedDeploymentRequest, ::google::cloud::telcoautomation::v1::HydratedDeployment>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(35);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::telcoautomation::v1::ApplyHydratedDeploymentRequest, ::google::cloud::telcoautomation::v1::HydratedDeployment>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ApplyHydratedDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApplyHydratedDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ApplyHydratedDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::HydratedDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ApplyHydratedDeployment(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ApplyHydratedDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::HydratedDeployment* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListOrchestrationClusters<WithCallbackMethod_GetOrchestrationCluster<WithCallbackMethod_CreateOrchestrationCluster<WithCallbackMethod_DeleteOrchestrationCluster<WithCallbackMethod_ListEdgeSlms<WithCallbackMethod_GetEdgeSlm<WithCallbackMethod_CreateEdgeSlm<WithCallbackMethod_DeleteEdgeSlm<WithCallbackMethod_CreateBlueprint<WithCallbackMethod_UpdateBlueprint<WithCallbackMethod_GetBlueprint<WithCallbackMethod_DeleteBlueprint<WithCallbackMethod_ListBlueprints<WithCallbackMethod_ApproveBlueprint<WithCallbackMethod_ProposeBlueprint<WithCallbackMethod_RejectBlueprint<WithCallbackMethod_ListBlueprintRevisions<WithCallbackMethod_SearchBlueprintRevisions<WithCallbackMethod_SearchDeploymentRevisions<WithCallbackMethod_DiscardBlueprintChanges<WithCallbackMethod_ListPublicBlueprints<WithCallbackMethod_GetPublicBlueprint<WithCallbackMethod_CreateDeployment<WithCallbackMethod_UpdateDeployment<WithCallbackMethod_GetDeployment<WithCallbackMethod_RemoveDeployment<WithCallbackMethod_ListDeployments<WithCallbackMethod_ListDeploymentRevisions<WithCallbackMethod_DiscardDeploymentChanges<WithCallbackMethod_ApplyDeployment<WithCallbackMethod_ComputeDeploymentStatus<WithCallbackMethod_RollbackDeployment<WithCallbackMethod_GetHydratedDeployment<WithCallbackMethod_ListHydratedDeployments<WithCallbackMethod_UpdateHydratedDeployment<WithCallbackMethod_ApplyHydratedDeployment<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListOrchestrationClusters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListOrchestrationClusters() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListOrchestrationClusters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOrchestrationClusters(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListOrchestrationClustersRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListOrchestrationClustersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetOrchestrationCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetOrchestrationCluster() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetOrchestrationCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetOrchestrationCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetOrchestrationClusterRequest* /*request*/, ::google::cloud::telcoautomation::v1::OrchestrationCluster* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateOrchestrationCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateOrchestrationCluster() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CreateOrchestrationCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateOrchestrationCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::CreateOrchestrationClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteOrchestrationCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteOrchestrationCluster() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_DeleteOrchestrationCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteOrchestrationCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::DeleteOrchestrationClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListEdgeSlms : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListEdgeSlms() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_ListEdgeSlms() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEdgeSlms(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListEdgeSlmsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListEdgeSlmsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetEdgeSlm : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetEdgeSlm() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_GetEdgeSlm() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEdgeSlm(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetEdgeSlmRequest* /*request*/, ::google::cloud::telcoautomation::v1::EdgeSlm* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateEdgeSlm : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateEdgeSlm() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_CreateEdgeSlm() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEdgeSlm(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::CreateEdgeSlmRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteEdgeSlm : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteEdgeSlm() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_DeleteEdgeSlm() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEdgeSlm(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::DeleteEdgeSlmRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateBlueprint() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_CreateBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::CreateBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateBlueprint() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_UpdateBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::UpdateBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetBlueprint() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_GetBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteBlueprint() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_DeleteBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::DeleteBlueprintRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListBlueprints : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListBlueprints() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_ListBlueprints() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBlueprints(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListBlueprintsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListBlueprintsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ApproveBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ApproveBlueprint() {
      ::grpc::Service::MarkMethodGeneric(13);
    }
    ~WithGenericMethod_ApproveBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApproveBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ApproveBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ProposeBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ProposeBlueprint() {
      ::grpc::Service::MarkMethodGeneric(14);
    }
    ~WithGenericMethod_ProposeBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ProposeBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ProposeBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RejectBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RejectBlueprint() {
      ::grpc::Service::MarkMethodGeneric(15);
    }
    ~WithGenericMethod_RejectBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RejectBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::RejectBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListBlueprintRevisions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListBlueprintRevisions() {
      ::grpc::Service::MarkMethodGeneric(16);
    }
    ~WithGenericMethod_ListBlueprintRevisions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBlueprintRevisions(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SearchBlueprintRevisions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SearchBlueprintRevisions() {
      ::grpc::Service::MarkMethodGeneric(17);
    }
    ~WithGenericMethod_SearchBlueprintRevisions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchBlueprintRevisions(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsRequest* /*request*/, ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SearchDeploymentRevisions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SearchDeploymentRevisions() {
      ::grpc::Service::MarkMethodGeneric(18);
    }
    ~WithGenericMethod_SearchDeploymentRevisions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchDeploymentRevisions(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsRequest* /*request*/, ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DiscardBlueprintChanges : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DiscardBlueprintChanges() {
      ::grpc::Service::MarkMethodGeneric(19);
    }
    ~WithGenericMethod_DiscardBlueprintChanges() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DiscardBlueprintChanges(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesRequest* /*request*/, ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListPublicBlueprints : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListPublicBlueprints() {
      ::grpc::Service::MarkMethodGeneric(20);
    }
    ~WithGenericMethod_ListPublicBlueprints() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPublicBlueprints(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListPublicBlueprintsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListPublicBlueprintsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetPublicBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetPublicBlueprint() {
      ::grpc::Service::MarkMethodGeneric(21);
    }
    ~WithGenericMethod_GetPublicBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPublicBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetPublicBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::PublicBlueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateDeployment() {
      ::grpc::Service::MarkMethodGeneric(22);
    }
    ~WithGenericMethod_CreateDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::CreateDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::Deployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateDeployment() {
      ::grpc::Service::MarkMethodGeneric(23);
    }
    ~WithGenericMethod_UpdateDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::UpdateDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::Deployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetDeployment() {
      ::grpc::Service::MarkMethodGeneric(24);
    }
    ~WithGenericMethod_GetDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::Deployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RemoveDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RemoveDeployment() {
      ::grpc::Service::MarkMethodGeneric(25);
    }
    ~WithGenericMethod_RemoveDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RemoveDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::RemoveDeploymentRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListDeployments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListDeployments() {
      ::grpc::Service::MarkMethodGeneric(26);
    }
    ~WithGenericMethod_ListDeployments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDeployments(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListDeploymentsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListDeploymentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListDeploymentRevisions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListDeploymentRevisions() {
      ::grpc::Service::MarkMethodGeneric(27);
    }
    ~WithGenericMethod_ListDeploymentRevisions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDeploymentRevisions(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DiscardDeploymentChanges : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DiscardDeploymentChanges() {
      ::grpc::Service::MarkMethodGeneric(28);
    }
    ~WithGenericMethod_DiscardDeploymentChanges() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DiscardDeploymentChanges(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesRequest* /*request*/, ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ApplyDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ApplyDeployment() {
      ::grpc::Service::MarkMethodGeneric(29);
    }
    ~WithGenericMethod_ApplyDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApplyDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ApplyDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::Deployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ComputeDeploymentStatus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ComputeDeploymentStatus() {
      ::grpc::Service::MarkMethodGeneric(30);
    }
    ~WithGenericMethod_ComputeDeploymentStatus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ComputeDeploymentStatus(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusRequest* /*request*/, ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RollbackDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RollbackDeployment() {
      ::grpc::Service::MarkMethodGeneric(31);
    }
    ~WithGenericMethod_RollbackDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RollbackDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::RollbackDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::Deployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetHydratedDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetHydratedDeployment() {
      ::grpc::Service::MarkMethodGeneric(32);
    }
    ~WithGenericMethod_GetHydratedDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetHydratedDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetHydratedDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::HydratedDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListHydratedDeployments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListHydratedDeployments() {
      ::grpc::Service::MarkMethodGeneric(33);
    }
    ~WithGenericMethod_ListHydratedDeployments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListHydratedDeployments(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateHydratedDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateHydratedDeployment() {
      ::grpc::Service::MarkMethodGeneric(34);
    }
    ~WithGenericMethod_UpdateHydratedDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateHydratedDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::UpdateHydratedDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::HydratedDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ApplyHydratedDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ApplyHydratedDeployment() {
      ::grpc::Service::MarkMethodGeneric(35);
    }
    ~WithGenericMethod_ApplyHydratedDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApplyHydratedDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ApplyHydratedDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::HydratedDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListOrchestrationClusters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListOrchestrationClusters() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListOrchestrationClusters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOrchestrationClusters(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListOrchestrationClustersRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListOrchestrationClustersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListOrchestrationClusters(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetOrchestrationCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetOrchestrationCluster() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetOrchestrationCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetOrchestrationCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetOrchestrationClusterRequest* /*request*/, ::google::cloud::telcoautomation::v1::OrchestrationCluster* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetOrchestrationCluster(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateOrchestrationCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateOrchestrationCluster() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CreateOrchestrationCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateOrchestrationCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::CreateOrchestrationClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateOrchestrationCluster(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteOrchestrationCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteOrchestrationCluster() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_DeleteOrchestrationCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteOrchestrationCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::DeleteOrchestrationClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteOrchestrationCluster(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListEdgeSlms : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListEdgeSlms() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_ListEdgeSlms() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEdgeSlms(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListEdgeSlmsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListEdgeSlmsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListEdgeSlms(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetEdgeSlm : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetEdgeSlm() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_GetEdgeSlm() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEdgeSlm(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetEdgeSlmRequest* /*request*/, ::google::cloud::telcoautomation::v1::EdgeSlm* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetEdgeSlm(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateEdgeSlm : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateEdgeSlm() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_CreateEdgeSlm() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEdgeSlm(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::CreateEdgeSlmRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateEdgeSlm(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteEdgeSlm : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteEdgeSlm() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_DeleteEdgeSlm() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEdgeSlm(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::DeleteEdgeSlmRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteEdgeSlm(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateBlueprint() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_CreateBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::CreateBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateBlueprint(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateBlueprint() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_UpdateBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::UpdateBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateBlueprint(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetBlueprint() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_GetBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetBlueprint(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteBlueprint() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_DeleteBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::DeleteBlueprintRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteBlueprint(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListBlueprints : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListBlueprints() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_ListBlueprints() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBlueprints(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListBlueprintsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListBlueprintsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListBlueprints(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ApproveBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ApproveBlueprint() {
      ::grpc::Service::MarkMethodRaw(13);
    }
    ~WithRawMethod_ApproveBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApproveBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ApproveBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestApproveBlueprint(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ProposeBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ProposeBlueprint() {
      ::grpc::Service::MarkMethodRaw(14);
    }
    ~WithRawMethod_ProposeBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ProposeBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ProposeBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestProposeBlueprint(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RejectBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RejectBlueprint() {
      ::grpc::Service::MarkMethodRaw(15);
    }
    ~WithRawMethod_RejectBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RejectBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::RejectBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRejectBlueprint(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListBlueprintRevisions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListBlueprintRevisions() {
      ::grpc::Service::MarkMethodRaw(16);
    }
    ~WithRawMethod_ListBlueprintRevisions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBlueprintRevisions(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListBlueprintRevisions(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SearchBlueprintRevisions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SearchBlueprintRevisions() {
      ::grpc::Service::MarkMethodRaw(17);
    }
    ~WithRawMethod_SearchBlueprintRevisions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchBlueprintRevisions(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsRequest* /*request*/, ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchBlueprintRevisions(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SearchDeploymentRevisions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SearchDeploymentRevisions() {
      ::grpc::Service::MarkMethodRaw(18);
    }
    ~WithRawMethod_SearchDeploymentRevisions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchDeploymentRevisions(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsRequest* /*request*/, ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchDeploymentRevisions(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DiscardBlueprintChanges : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DiscardBlueprintChanges() {
      ::grpc::Service::MarkMethodRaw(19);
    }
    ~WithRawMethod_DiscardBlueprintChanges() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DiscardBlueprintChanges(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesRequest* /*request*/, ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDiscardBlueprintChanges(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListPublicBlueprints : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListPublicBlueprints() {
      ::grpc::Service::MarkMethodRaw(20);
    }
    ~WithRawMethod_ListPublicBlueprints() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPublicBlueprints(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListPublicBlueprintsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListPublicBlueprintsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPublicBlueprints(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetPublicBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetPublicBlueprint() {
      ::grpc::Service::MarkMethodRaw(21);
    }
    ~WithRawMethod_GetPublicBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPublicBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetPublicBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::PublicBlueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetPublicBlueprint(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(21, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateDeployment() {
      ::grpc::Service::MarkMethodRaw(22);
    }
    ~WithRawMethod_CreateDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::CreateDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::Deployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateDeployment(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(22, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateDeployment() {
      ::grpc::Service::MarkMethodRaw(23);
    }
    ~WithRawMethod_UpdateDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::UpdateDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::Deployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateDeployment(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(23, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetDeployment() {
      ::grpc::Service::MarkMethodRaw(24);
    }
    ~WithRawMethod_GetDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::Deployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetDeployment(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(24, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RemoveDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RemoveDeployment() {
      ::grpc::Service::MarkMethodRaw(25);
    }
    ~WithRawMethod_RemoveDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RemoveDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::RemoveDeploymentRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRemoveDeployment(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(25, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListDeployments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListDeployments() {
      ::grpc::Service::MarkMethodRaw(26);
    }
    ~WithRawMethod_ListDeployments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDeployments(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListDeploymentsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListDeploymentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListDeployments(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(26, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListDeploymentRevisions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListDeploymentRevisions() {
      ::grpc::Service::MarkMethodRaw(27);
    }
    ~WithRawMethod_ListDeploymentRevisions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDeploymentRevisions(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListDeploymentRevisions(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(27, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DiscardDeploymentChanges : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DiscardDeploymentChanges() {
      ::grpc::Service::MarkMethodRaw(28);
    }
    ~WithRawMethod_DiscardDeploymentChanges() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DiscardDeploymentChanges(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesRequest* /*request*/, ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDiscardDeploymentChanges(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(28, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ApplyDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ApplyDeployment() {
      ::grpc::Service::MarkMethodRaw(29);
    }
    ~WithRawMethod_ApplyDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApplyDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ApplyDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::Deployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestApplyDeployment(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(29, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ComputeDeploymentStatus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ComputeDeploymentStatus() {
      ::grpc::Service::MarkMethodRaw(30);
    }
    ~WithRawMethod_ComputeDeploymentStatus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ComputeDeploymentStatus(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusRequest* /*request*/, ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestComputeDeploymentStatus(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(30, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RollbackDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RollbackDeployment() {
      ::grpc::Service::MarkMethodRaw(31);
    }
    ~WithRawMethod_RollbackDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RollbackDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::RollbackDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::Deployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRollbackDeployment(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(31, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetHydratedDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetHydratedDeployment() {
      ::grpc::Service::MarkMethodRaw(32);
    }
    ~WithRawMethod_GetHydratedDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetHydratedDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetHydratedDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::HydratedDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetHydratedDeployment(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(32, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListHydratedDeployments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListHydratedDeployments() {
      ::grpc::Service::MarkMethodRaw(33);
    }
    ~WithRawMethod_ListHydratedDeployments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListHydratedDeployments(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListHydratedDeployments(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(33, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateHydratedDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateHydratedDeployment() {
      ::grpc::Service::MarkMethodRaw(34);
    }
    ~WithRawMethod_UpdateHydratedDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateHydratedDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::UpdateHydratedDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::HydratedDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateHydratedDeployment(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(34, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ApplyHydratedDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ApplyHydratedDeployment() {
      ::grpc::Service::MarkMethodRaw(35);
    }
    ~WithRawMethod_ApplyHydratedDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApplyHydratedDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ApplyHydratedDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::HydratedDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestApplyHydratedDeployment(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(35, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListOrchestrationClusters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListOrchestrationClusters() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListOrchestrationClusters(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListOrchestrationClusters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOrchestrationClusters(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListOrchestrationClustersRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListOrchestrationClustersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListOrchestrationClusters(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetOrchestrationCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetOrchestrationCluster() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetOrchestrationCluster(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetOrchestrationCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetOrchestrationCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetOrchestrationClusterRequest* /*request*/, ::google::cloud::telcoautomation::v1::OrchestrationCluster* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetOrchestrationCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateOrchestrationCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateOrchestrationCluster() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateOrchestrationCluster(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateOrchestrationCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateOrchestrationCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::CreateOrchestrationClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateOrchestrationCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteOrchestrationCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteOrchestrationCluster() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteOrchestrationCluster(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteOrchestrationCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteOrchestrationCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::DeleteOrchestrationClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteOrchestrationCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListEdgeSlms : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListEdgeSlms() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListEdgeSlms(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListEdgeSlms() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEdgeSlms(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListEdgeSlmsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListEdgeSlmsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListEdgeSlms(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetEdgeSlm : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetEdgeSlm() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetEdgeSlm(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetEdgeSlm() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEdgeSlm(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetEdgeSlmRequest* /*request*/, ::google::cloud::telcoautomation::v1::EdgeSlm* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetEdgeSlm(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateEdgeSlm : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateEdgeSlm() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateEdgeSlm(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateEdgeSlm() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEdgeSlm(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::CreateEdgeSlmRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateEdgeSlm(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteEdgeSlm : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteEdgeSlm() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteEdgeSlm(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteEdgeSlm() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEdgeSlm(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::DeleteEdgeSlmRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteEdgeSlm(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateBlueprint() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateBlueprint(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::CreateBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateBlueprint(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateBlueprint() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateBlueprint(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::UpdateBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateBlueprint(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetBlueprint() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetBlueprint(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetBlueprint(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteBlueprint() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteBlueprint(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::DeleteBlueprintRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteBlueprint(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListBlueprints : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListBlueprints() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListBlueprints(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListBlueprints() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBlueprints(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListBlueprintsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListBlueprintsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListBlueprints(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ApproveBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ApproveBlueprint() {
      ::grpc::Service::MarkMethodRawCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ApproveBlueprint(context, request, response); }));
    }
    ~WithRawCallbackMethod_ApproveBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApproveBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ApproveBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ApproveBlueprint(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ProposeBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ProposeBlueprint() {
      ::grpc::Service::MarkMethodRawCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ProposeBlueprint(context, request, response); }));
    }
    ~WithRawCallbackMethod_ProposeBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ProposeBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ProposeBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ProposeBlueprint(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RejectBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RejectBlueprint() {
      ::grpc::Service::MarkMethodRawCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RejectBlueprint(context, request, response); }));
    }
    ~WithRawCallbackMethod_RejectBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RejectBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::RejectBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RejectBlueprint(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListBlueprintRevisions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListBlueprintRevisions() {
      ::grpc::Service::MarkMethodRawCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListBlueprintRevisions(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListBlueprintRevisions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListBlueprintRevisions(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListBlueprintRevisions(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SearchBlueprintRevisions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SearchBlueprintRevisions() {
      ::grpc::Service::MarkMethodRawCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SearchBlueprintRevisions(context, request, response); }));
    }
    ~WithRawCallbackMethod_SearchBlueprintRevisions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchBlueprintRevisions(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsRequest* /*request*/, ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchBlueprintRevisions(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SearchDeploymentRevisions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SearchDeploymentRevisions() {
      ::grpc::Service::MarkMethodRawCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SearchDeploymentRevisions(context, request, response); }));
    }
    ~WithRawCallbackMethod_SearchDeploymentRevisions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchDeploymentRevisions(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsRequest* /*request*/, ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchDeploymentRevisions(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DiscardBlueprintChanges : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DiscardBlueprintChanges() {
      ::grpc::Service::MarkMethodRawCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DiscardBlueprintChanges(context, request, response); }));
    }
    ~WithRawCallbackMethod_DiscardBlueprintChanges() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DiscardBlueprintChanges(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesRequest* /*request*/, ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DiscardBlueprintChanges(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListPublicBlueprints : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListPublicBlueprints() {
      ::grpc::Service::MarkMethodRawCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListPublicBlueprints(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListPublicBlueprints() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPublicBlueprints(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListPublicBlueprintsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListPublicBlueprintsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPublicBlueprints(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetPublicBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetPublicBlueprint() {
      ::grpc::Service::MarkMethodRawCallback(21,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetPublicBlueprint(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetPublicBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPublicBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetPublicBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::PublicBlueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetPublicBlueprint(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateDeployment() {
      ::grpc::Service::MarkMethodRawCallback(22,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateDeployment(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::CreateDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::Deployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateDeployment(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateDeployment() {
      ::grpc::Service::MarkMethodRawCallback(23,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateDeployment(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::UpdateDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::Deployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateDeployment(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetDeployment() {
      ::grpc::Service::MarkMethodRawCallback(24,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetDeployment(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::Deployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetDeployment(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RemoveDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RemoveDeployment() {
      ::grpc::Service::MarkMethodRawCallback(25,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RemoveDeployment(context, request, response); }));
    }
    ~WithRawCallbackMethod_RemoveDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RemoveDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::RemoveDeploymentRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RemoveDeployment(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListDeployments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListDeployments() {
      ::grpc::Service::MarkMethodRawCallback(26,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListDeployments(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListDeployments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDeployments(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListDeploymentsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListDeploymentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListDeployments(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListDeploymentRevisions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListDeploymentRevisions() {
      ::grpc::Service::MarkMethodRawCallback(27,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListDeploymentRevisions(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListDeploymentRevisions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDeploymentRevisions(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListDeploymentRevisions(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DiscardDeploymentChanges : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DiscardDeploymentChanges() {
      ::grpc::Service::MarkMethodRawCallback(28,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DiscardDeploymentChanges(context, request, response); }));
    }
    ~WithRawCallbackMethod_DiscardDeploymentChanges() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DiscardDeploymentChanges(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesRequest* /*request*/, ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DiscardDeploymentChanges(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ApplyDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ApplyDeployment() {
      ::grpc::Service::MarkMethodRawCallback(29,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ApplyDeployment(context, request, response); }));
    }
    ~WithRawCallbackMethod_ApplyDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApplyDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ApplyDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::Deployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ApplyDeployment(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ComputeDeploymentStatus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ComputeDeploymentStatus() {
      ::grpc::Service::MarkMethodRawCallback(30,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ComputeDeploymentStatus(context, request, response); }));
    }
    ~WithRawCallbackMethod_ComputeDeploymentStatus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ComputeDeploymentStatus(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusRequest* /*request*/, ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ComputeDeploymentStatus(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RollbackDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RollbackDeployment() {
      ::grpc::Service::MarkMethodRawCallback(31,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RollbackDeployment(context, request, response); }));
    }
    ~WithRawCallbackMethod_RollbackDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RollbackDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::RollbackDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::Deployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RollbackDeployment(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetHydratedDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetHydratedDeployment() {
      ::grpc::Service::MarkMethodRawCallback(32,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetHydratedDeployment(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetHydratedDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetHydratedDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetHydratedDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::HydratedDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetHydratedDeployment(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListHydratedDeployments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListHydratedDeployments() {
      ::grpc::Service::MarkMethodRawCallback(33,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListHydratedDeployments(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListHydratedDeployments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListHydratedDeployments(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListHydratedDeployments(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateHydratedDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateHydratedDeployment() {
      ::grpc::Service::MarkMethodRawCallback(34,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateHydratedDeployment(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateHydratedDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateHydratedDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::UpdateHydratedDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::HydratedDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateHydratedDeployment(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ApplyHydratedDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ApplyHydratedDeployment() {
      ::grpc::Service::MarkMethodRawCallback(35,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ApplyHydratedDeployment(context, request, response); }));
    }
    ~WithRawCallbackMethod_ApplyHydratedDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApplyHydratedDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ApplyHydratedDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::HydratedDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ApplyHydratedDeployment(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListOrchestrationClusters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListOrchestrationClusters() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::telcoautomation::v1::ListOrchestrationClustersRequest, ::google::cloud::telcoautomation::v1::ListOrchestrationClustersResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::telcoautomation::v1::ListOrchestrationClustersRequest, ::google::cloud::telcoautomation::v1::ListOrchestrationClustersResponse>* streamer) {
                       return this->StreamedListOrchestrationClusters(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListOrchestrationClusters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListOrchestrationClusters(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListOrchestrationClustersRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListOrchestrationClustersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListOrchestrationClusters(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::telcoautomation::v1::ListOrchestrationClustersRequest,::google::cloud::telcoautomation::v1::ListOrchestrationClustersResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetOrchestrationCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetOrchestrationCluster() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::telcoautomation::v1::GetOrchestrationClusterRequest, ::google::cloud::telcoautomation::v1::OrchestrationCluster>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::telcoautomation::v1::GetOrchestrationClusterRequest, ::google::cloud::telcoautomation::v1::OrchestrationCluster>* streamer) {
                       return this->StreamedGetOrchestrationCluster(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetOrchestrationCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetOrchestrationCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetOrchestrationClusterRequest* /*request*/, ::google::cloud::telcoautomation::v1::OrchestrationCluster* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetOrchestrationCluster(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::telcoautomation::v1::GetOrchestrationClusterRequest,::google::cloud::telcoautomation::v1::OrchestrationCluster>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateOrchestrationCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateOrchestrationCluster() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::telcoautomation::v1::CreateOrchestrationClusterRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::telcoautomation::v1::CreateOrchestrationClusterRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateOrchestrationCluster(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateOrchestrationCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateOrchestrationCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::CreateOrchestrationClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateOrchestrationCluster(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::telcoautomation::v1::CreateOrchestrationClusterRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteOrchestrationCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteOrchestrationCluster() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::telcoautomation::v1::DeleteOrchestrationClusterRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::telcoautomation::v1::DeleteOrchestrationClusterRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteOrchestrationCluster(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteOrchestrationCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteOrchestrationCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::DeleteOrchestrationClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteOrchestrationCluster(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::telcoautomation::v1::DeleteOrchestrationClusterRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListEdgeSlms : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListEdgeSlms() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::telcoautomation::v1::ListEdgeSlmsRequest, ::google::cloud::telcoautomation::v1::ListEdgeSlmsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::telcoautomation::v1::ListEdgeSlmsRequest, ::google::cloud::telcoautomation::v1::ListEdgeSlmsResponse>* streamer) {
                       return this->StreamedListEdgeSlms(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListEdgeSlms() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListEdgeSlms(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListEdgeSlmsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListEdgeSlmsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListEdgeSlms(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::telcoautomation::v1::ListEdgeSlmsRequest,::google::cloud::telcoautomation::v1::ListEdgeSlmsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetEdgeSlm : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetEdgeSlm() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::telcoautomation::v1::GetEdgeSlmRequest, ::google::cloud::telcoautomation::v1::EdgeSlm>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::telcoautomation::v1::GetEdgeSlmRequest, ::google::cloud::telcoautomation::v1::EdgeSlm>* streamer) {
                       return this->StreamedGetEdgeSlm(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetEdgeSlm() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetEdgeSlm(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetEdgeSlmRequest* /*request*/, ::google::cloud::telcoautomation::v1::EdgeSlm* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetEdgeSlm(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::telcoautomation::v1::GetEdgeSlmRequest,::google::cloud::telcoautomation::v1::EdgeSlm>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateEdgeSlm : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateEdgeSlm() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::telcoautomation::v1::CreateEdgeSlmRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::telcoautomation::v1::CreateEdgeSlmRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateEdgeSlm(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateEdgeSlm() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateEdgeSlm(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::CreateEdgeSlmRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateEdgeSlm(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::telcoautomation::v1::CreateEdgeSlmRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteEdgeSlm : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteEdgeSlm() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::telcoautomation::v1::DeleteEdgeSlmRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::telcoautomation::v1::DeleteEdgeSlmRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteEdgeSlm(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteEdgeSlm() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteEdgeSlm(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::DeleteEdgeSlmRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteEdgeSlm(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::telcoautomation::v1::DeleteEdgeSlmRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateBlueprint() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::telcoautomation::v1::CreateBlueprintRequest, ::google::cloud::telcoautomation::v1::Blueprint>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::telcoautomation::v1::CreateBlueprintRequest, ::google::cloud::telcoautomation::v1::Blueprint>* streamer) {
                       return this->StreamedCreateBlueprint(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::CreateBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateBlueprint(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::telcoautomation::v1::CreateBlueprintRequest,::google::cloud::telcoautomation::v1::Blueprint>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateBlueprint() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::telcoautomation::v1::UpdateBlueprintRequest, ::google::cloud::telcoautomation::v1::Blueprint>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::telcoautomation::v1::UpdateBlueprintRequest, ::google::cloud::telcoautomation::v1::Blueprint>* streamer) {
                       return this->StreamedUpdateBlueprint(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::UpdateBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateBlueprint(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::telcoautomation::v1::UpdateBlueprintRequest,::google::cloud::telcoautomation::v1::Blueprint>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetBlueprint() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::telcoautomation::v1::GetBlueprintRequest, ::google::cloud::telcoautomation::v1::Blueprint>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::telcoautomation::v1::GetBlueprintRequest, ::google::cloud::telcoautomation::v1::Blueprint>* streamer) {
                       return this->StreamedGetBlueprint(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetBlueprint(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::telcoautomation::v1::GetBlueprintRequest,::google::cloud::telcoautomation::v1::Blueprint>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteBlueprint() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::telcoautomation::v1::DeleteBlueprintRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::telcoautomation::v1::DeleteBlueprintRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteBlueprint(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::DeleteBlueprintRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteBlueprint(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::telcoautomation::v1::DeleteBlueprintRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListBlueprints : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListBlueprints() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::telcoautomation::v1::ListBlueprintsRequest, ::google::cloud::telcoautomation::v1::ListBlueprintsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::telcoautomation::v1::ListBlueprintsRequest, ::google::cloud::telcoautomation::v1::ListBlueprintsResponse>* streamer) {
                       return this->StreamedListBlueprints(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListBlueprints() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListBlueprints(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListBlueprintsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListBlueprintsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListBlueprints(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::telcoautomation::v1::ListBlueprintsRequest,::google::cloud::telcoautomation::v1::ListBlueprintsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ApproveBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ApproveBlueprint() {
      ::grpc::Service::MarkMethodStreamed(13,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::telcoautomation::v1::ApproveBlueprintRequest, ::google::cloud::telcoautomation::v1::Blueprint>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::telcoautomation::v1::ApproveBlueprintRequest, ::google::cloud::telcoautomation::v1::Blueprint>* streamer) {
                       return this->StreamedApproveBlueprint(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ApproveBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ApproveBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ApproveBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedApproveBlueprint(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::telcoautomation::v1::ApproveBlueprintRequest,::google::cloud::telcoautomation::v1::Blueprint>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ProposeBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ProposeBlueprint() {
      ::grpc::Service::MarkMethodStreamed(14,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::telcoautomation::v1::ProposeBlueprintRequest, ::google::cloud::telcoautomation::v1::Blueprint>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::telcoautomation::v1::ProposeBlueprintRequest, ::google::cloud::telcoautomation::v1::Blueprint>* streamer) {
                       return this->StreamedProposeBlueprint(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ProposeBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ProposeBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ProposeBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedProposeBlueprint(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::telcoautomation::v1::ProposeBlueprintRequest,::google::cloud::telcoautomation::v1::Blueprint>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RejectBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RejectBlueprint() {
      ::grpc::Service::MarkMethodStreamed(15,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::telcoautomation::v1::RejectBlueprintRequest, ::google::cloud::telcoautomation::v1::Blueprint>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::telcoautomation::v1::RejectBlueprintRequest, ::google::cloud::telcoautomation::v1::Blueprint>* streamer) {
                       return this->StreamedRejectBlueprint(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RejectBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RejectBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::RejectBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::Blueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRejectBlueprint(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::telcoautomation::v1::RejectBlueprintRequest,::google::cloud::telcoautomation::v1::Blueprint>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListBlueprintRevisions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListBlueprintRevisions() {
      ::grpc::Service::MarkMethodStreamed(16,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsRequest, ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsRequest, ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsResponse>* streamer) {
                       return this->StreamedListBlueprintRevisions(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListBlueprintRevisions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListBlueprintRevisions(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListBlueprintRevisions(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::telcoautomation::v1::ListBlueprintRevisionsRequest,::google::cloud::telcoautomation::v1::ListBlueprintRevisionsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SearchBlueprintRevisions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SearchBlueprintRevisions() {
      ::grpc::Service::MarkMethodStreamed(17,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsRequest, ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsRequest, ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsResponse>* streamer) {
                       return this->StreamedSearchBlueprintRevisions(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SearchBlueprintRevisions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SearchBlueprintRevisions(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsRequest* /*request*/, ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSearchBlueprintRevisions(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsRequest,::google::cloud::telcoautomation::v1::SearchBlueprintRevisionsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SearchDeploymentRevisions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SearchDeploymentRevisions() {
      ::grpc::Service::MarkMethodStreamed(18,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsRequest, ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsRequest, ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsResponse>* streamer) {
                       return this->StreamedSearchDeploymentRevisions(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SearchDeploymentRevisions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SearchDeploymentRevisions(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsRequest* /*request*/, ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSearchDeploymentRevisions(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsRequest,::google::cloud::telcoautomation::v1::SearchDeploymentRevisionsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DiscardBlueprintChanges : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DiscardBlueprintChanges() {
      ::grpc::Service::MarkMethodStreamed(19,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesRequest, ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesRequest, ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesResponse>* streamer) {
                       return this->StreamedDiscardBlueprintChanges(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DiscardBlueprintChanges() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DiscardBlueprintChanges(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesRequest* /*request*/, ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDiscardBlueprintChanges(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::telcoautomation::v1::DiscardBlueprintChangesRequest,::google::cloud::telcoautomation::v1::DiscardBlueprintChangesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListPublicBlueprints : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListPublicBlueprints() {
      ::grpc::Service::MarkMethodStreamed(20,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::telcoautomation::v1::ListPublicBlueprintsRequest, ::google::cloud::telcoautomation::v1::ListPublicBlueprintsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::telcoautomation::v1::ListPublicBlueprintsRequest, ::google::cloud::telcoautomation::v1::ListPublicBlueprintsResponse>* streamer) {
                       return this->StreamedListPublicBlueprints(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListPublicBlueprints() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListPublicBlueprints(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListPublicBlueprintsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListPublicBlueprintsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListPublicBlueprints(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::telcoautomation::v1::ListPublicBlueprintsRequest,::google::cloud::telcoautomation::v1::ListPublicBlueprintsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetPublicBlueprint : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetPublicBlueprint() {
      ::grpc::Service::MarkMethodStreamed(21,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::telcoautomation::v1::GetPublicBlueprintRequest, ::google::cloud::telcoautomation::v1::PublicBlueprint>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::telcoautomation::v1::GetPublicBlueprintRequest, ::google::cloud::telcoautomation::v1::PublicBlueprint>* streamer) {
                       return this->StreamedGetPublicBlueprint(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetPublicBlueprint() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetPublicBlueprint(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetPublicBlueprintRequest* /*request*/, ::google::cloud::telcoautomation::v1::PublicBlueprint* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetPublicBlueprint(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::telcoautomation::v1::GetPublicBlueprintRequest,::google::cloud::telcoautomation::v1::PublicBlueprint>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateDeployment() {
      ::grpc::Service::MarkMethodStreamed(22,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::telcoautomation::v1::CreateDeploymentRequest, ::google::cloud::telcoautomation::v1::Deployment>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::telcoautomation::v1::CreateDeploymentRequest, ::google::cloud::telcoautomation::v1::Deployment>* streamer) {
                       return this->StreamedCreateDeployment(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::CreateDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::Deployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateDeployment(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::telcoautomation::v1::CreateDeploymentRequest,::google::cloud::telcoautomation::v1::Deployment>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateDeployment() {
      ::grpc::Service::MarkMethodStreamed(23,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::telcoautomation::v1::UpdateDeploymentRequest, ::google::cloud::telcoautomation::v1::Deployment>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::telcoautomation::v1::UpdateDeploymentRequest, ::google::cloud::telcoautomation::v1::Deployment>* streamer) {
                       return this->StreamedUpdateDeployment(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::UpdateDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::Deployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateDeployment(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::telcoautomation::v1::UpdateDeploymentRequest,::google::cloud::telcoautomation::v1::Deployment>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetDeployment() {
      ::grpc::Service::MarkMethodStreamed(24,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::telcoautomation::v1::GetDeploymentRequest, ::google::cloud::telcoautomation::v1::Deployment>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::telcoautomation::v1::GetDeploymentRequest, ::google::cloud::telcoautomation::v1::Deployment>* streamer) {
                       return this->StreamedGetDeployment(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::Deployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetDeployment(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::telcoautomation::v1::GetDeploymentRequest,::google::cloud::telcoautomation::v1::Deployment>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RemoveDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RemoveDeployment() {
      ::grpc::Service::MarkMethodStreamed(25,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::telcoautomation::v1::RemoveDeploymentRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::telcoautomation::v1::RemoveDeploymentRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedRemoveDeployment(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RemoveDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RemoveDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::RemoveDeploymentRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRemoveDeployment(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::telcoautomation::v1::RemoveDeploymentRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListDeployments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListDeployments() {
      ::grpc::Service::MarkMethodStreamed(26,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::telcoautomation::v1::ListDeploymentsRequest, ::google::cloud::telcoautomation::v1::ListDeploymentsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::telcoautomation::v1::ListDeploymentsRequest, ::google::cloud::telcoautomation::v1::ListDeploymentsResponse>* streamer) {
                       return this->StreamedListDeployments(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListDeployments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListDeployments(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListDeploymentsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListDeploymentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListDeployments(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::telcoautomation::v1::ListDeploymentsRequest,::google::cloud::telcoautomation::v1::ListDeploymentsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListDeploymentRevisions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListDeploymentRevisions() {
      ::grpc::Service::MarkMethodStreamed(27,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsRequest, ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsRequest, ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsResponse>* streamer) {
                       return this->StreamedListDeploymentRevisions(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListDeploymentRevisions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListDeploymentRevisions(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListDeploymentRevisions(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::telcoautomation::v1::ListDeploymentRevisionsRequest,::google::cloud::telcoautomation::v1::ListDeploymentRevisionsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DiscardDeploymentChanges : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DiscardDeploymentChanges() {
      ::grpc::Service::MarkMethodStreamed(28,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesRequest, ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesRequest, ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesResponse>* streamer) {
                       return this->StreamedDiscardDeploymentChanges(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DiscardDeploymentChanges() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DiscardDeploymentChanges(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesRequest* /*request*/, ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDiscardDeploymentChanges(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::telcoautomation::v1::DiscardDeploymentChangesRequest,::google::cloud::telcoautomation::v1::DiscardDeploymentChangesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ApplyDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ApplyDeployment() {
      ::grpc::Service::MarkMethodStreamed(29,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::telcoautomation::v1::ApplyDeploymentRequest, ::google::cloud::telcoautomation::v1::Deployment>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::telcoautomation::v1::ApplyDeploymentRequest, ::google::cloud::telcoautomation::v1::Deployment>* streamer) {
                       return this->StreamedApplyDeployment(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ApplyDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ApplyDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ApplyDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::Deployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedApplyDeployment(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::telcoautomation::v1::ApplyDeploymentRequest,::google::cloud::telcoautomation::v1::Deployment>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ComputeDeploymentStatus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ComputeDeploymentStatus() {
      ::grpc::Service::MarkMethodStreamed(30,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusRequest, ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusRequest, ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusResponse>* streamer) {
                       return this->StreamedComputeDeploymentStatus(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ComputeDeploymentStatus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ComputeDeploymentStatus(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusRequest* /*request*/, ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedComputeDeploymentStatus(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::telcoautomation::v1::ComputeDeploymentStatusRequest,::google::cloud::telcoautomation::v1::ComputeDeploymentStatusResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RollbackDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RollbackDeployment() {
      ::grpc::Service::MarkMethodStreamed(31,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::telcoautomation::v1::RollbackDeploymentRequest, ::google::cloud::telcoautomation::v1::Deployment>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::telcoautomation::v1::RollbackDeploymentRequest, ::google::cloud::telcoautomation::v1::Deployment>* streamer) {
                       return this->StreamedRollbackDeployment(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RollbackDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RollbackDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::RollbackDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::Deployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRollbackDeployment(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::telcoautomation::v1::RollbackDeploymentRequest,::google::cloud::telcoautomation::v1::Deployment>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetHydratedDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetHydratedDeployment() {
      ::grpc::Service::MarkMethodStreamed(32,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::telcoautomation::v1::GetHydratedDeploymentRequest, ::google::cloud::telcoautomation::v1::HydratedDeployment>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::telcoautomation::v1::GetHydratedDeploymentRequest, ::google::cloud::telcoautomation::v1::HydratedDeployment>* streamer) {
                       return this->StreamedGetHydratedDeployment(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetHydratedDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetHydratedDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::GetHydratedDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::HydratedDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetHydratedDeployment(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::telcoautomation::v1::GetHydratedDeploymentRequest,::google::cloud::telcoautomation::v1::HydratedDeployment>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListHydratedDeployments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListHydratedDeployments() {
      ::grpc::Service::MarkMethodStreamed(33,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsRequest, ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsRequest, ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsResponse>* streamer) {
                       return this->StreamedListHydratedDeployments(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListHydratedDeployments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListHydratedDeployments(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsRequest* /*request*/, ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListHydratedDeployments(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::telcoautomation::v1::ListHydratedDeploymentsRequest,::google::cloud::telcoautomation::v1::ListHydratedDeploymentsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateHydratedDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateHydratedDeployment() {
      ::grpc::Service::MarkMethodStreamed(34,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::telcoautomation::v1::UpdateHydratedDeploymentRequest, ::google::cloud::telcoautomation::v1::HydratedDeployment>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::telcoautomation::v1::UpdateHydratedDeploymentRequest, ::google::cloud::telcoautomation::v1::HydratedDeployment>* streamer) {
                       return this->StreamedUpdateHydratedDeployment(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateHydratedDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateHydratedDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::UpdateHydratedDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::HydratedDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateHydratedDeployment(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::telcoautomation::v1::UpdateHydratedDeploymentRequest,::google::cloud::telcoautomation::v1::HydratedDeployment>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ApplyHydratedDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ApplyHydratedDeployment() {
      ::grpc::Service::MarkMethodStreamed(35,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::telcoautomation::v1::ApplyHydratedDeploymentRequest, ::google::cloud::telcoautomation::v1::HydratedDeployment>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::telcoautomation::v1::ApplyHydratedDeploymentRequest, ::google::cloud::telcoautomation::v1::HydratedDeployment>* streamer) {
                       return this->StreamedApplyHydratedDeployment(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ApplyHydratedDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ApplyHydratedDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::telcoautomation::v1::ApplyHydratedDeploymentRequest* /*request*/, ::google::cloud::telcoautomation::v1::HydratedDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedApplyHydratedDeployment(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::telcoautomation::v1::ApplyHydratedDeploymentRequest,::google::cloud::telcoautomation::v1::HydratedDeployment>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListOrchestrationClusters<WithStreamedUnaryMethod_GetOrchestrationCluster<WithStreamedUnaryMethod_CreateOrchestrationCluster<WithStreamedUnaryMethod_DeleteOrchestrationCluster<WithStreamedUnaryMethod_ListEdgeSlms<WithStreamedUnaryMethod_GetEdgeSlm<WithStreamedUnaryMethod_CreateEdgeSlm<WithStreamedUnaryMethod_DeleteEdgeSlm<WithStreamedUnaryMethod_CreateBlueprint<WithStreamedUnaryMethod_UpdateBlueprint<WithStreamedUnaryMethod_GetBlueprint<WithStreamedUnaryMethod_DeleteBlueprint<WithStreamedUnaryMethod_ListBlueprints<WithStreamedUnaryMethod_ApproveBlueprint<WithStreamedUnaryMethod_ProposeBlueprint<WithStreamedUnaryMethod_RejectBlueprint<WithStreamedUnaryMethod_ListBlueprintRevisions<WithStreamedUnaryMethod_SearchBlueprintRevisions<WithStreamedUnaryMethod_SearchDeploymentRevisions<WithStreamedUnaryMethod_DiscardBlueprintChanges<WithStreamedUnaryMethod_ListPublicBlueprints<WithStreamedUnaryMethod_GetPublicBlueprint<WithStreamedUnaryMethod_CreateDeployment<WithStreamedUnaryMethod_UpdateDeployment<WithStreamedUnaryMethod_GetDeployment<WithStreamedUnaryMethod_RemoveDeployment<WithStreamedUnaryMethod_ListDeployments<WithStreamedUnaryMethod_ListDeploymentRevisions<WithStreamedUnaryMethod_DiscardDeploymentChanges<WithStreamedUnaryMethod_ApplyDeployment<WithStreamedUnaryMethod_ComputeDeploymentStatus<WithStreamedUnaryMethod_RollbackDeployment<WithStreamedUnaryMethod_GetHydratedDeployment<WithStreamedUnaryMethod_ListHydratedDeployments<WithStreamedUnaryMethod_UpdateHydratedDeployment<WithStreamedUnaryMethod_ApplyHydratedDeployment<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListOrchestrationClusters<WithStreamedUnaryMethod_GetOrchestrationCluster<WithStreamedUnaryMethod_CreateOrchestrationCluster<WithStreamedUnaryMethod_DeleteOrchestrationCluster<WithStreamedUnaryMethod_ListEdgeSlms<WithStreamedUnaryMethod_GetEdgeSlm<WithStreamedUnaryMethod_CreateEdgeSlm<WithStreamedUnaryMethod_DeleteEdgeSlm<WithStreamedUnaryMethod_CreateBlueprint<WithStreamedUnaryMethod_UpdateBlueprint<WithStreamedUnaryMethod_GetBlueprint<WithStreamedUnaryMethod_DeleteBlueprint<WithStreamedUnaryMethod_ListBlueprints<WithStreamedUnaryMethod_ApproveBlueprint<WithStreamedUnaryMethod_ProposeBlueprint<WithStreamedUnaryMethod_RejectBlueprint<WithStreamedUnaryMethod_ListBlueprintRevisions<WithStreamedUnaryMethod_SearchBlueprintRevisions<WithStreamedUnaryMethod_SearchDeploymentRevisions<WithStreamedUnaryMethod_DiscardBlueprintChanges<WithStreamedUnaryMethod_ListPublicBlueprints<WithStreamedUnaryMethod_GetPublicBlueprint<WithStreamedUnaryMethod_CreateDeployment<WithStreamedUnaryMethod_UpdateDeployment<WithStreamedUnaryMethod_GetDeployment<WithStreamedUnaryMethod_RemoveDeployment<WithStreamedUnaryMethod_ListDeployments<WithStreamedUnaryMethod_ListDeploymentRevisions<WithStreamedUnaryMethod_DiscardDeploymentChanges<WithStreamedUnaryMethod_ApplyDeployment<WithStreamedUnaryMethod_ComputeDeploymentStatus<WithStreamedUnaryMethod_RollbackDeployment<WithStreamedUnaryMethod_GetHydratedDeployment<WithStreamedUnaryMethod_ListHydratedDeployments<WithStreamedUnaryMethod_UpdateHydratedDeployment<WithStreamedUnaryMethod_ApplyHydratedDeployment<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace telcoautomation
}  // namespace cloud
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fcloud_2ftelcoautomation_2fv1_2ftelcoautomation_2eproto__INCLUDED
